<?php
	include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo_gesfaturacao.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/helpers.php';
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

	if ( hasPermission(['P0063']) == 1 ) {}
	else{
		header('Location: ../acces-refuse?redirectfrom=/frifacturation/articles&redirectto=/frifacturation');
	}
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1509,80,818,1233,1034,27,424,1565,1393,1175,1333,1599,1498,1643,173,174,1263);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<html>
	<title>Frifacturation | <?php echo $data[1509]['trad']; ?>  > <?php echo $data[80]['trad']; ?> </title>
	<head>
		<?php include('../base/css.php') ?>
		<!-- ADDED CSS -->
		<link rel="stylesheet" href="/js/vendors/bootstrap-select/bootstrap-select.min.css">
		<link rel="stylesheet" href="/js/vendors/bootstrap-datepicker/datepicker3.css">
		<!-- //ADDED CSS -->
	</head>
	<body>
		<?php include '../../modal_menu.php'; ?>
		<div class="container">
			<?php include '../menu.php'; ?>

			<div class="page-content">
				<div class="panel panel-white">
					<div class="panel-heading">
                        <div class="pull-right" >
							<a href="importer" class="btn btn-violet btn-outlined btn-square"><i class="fa fa-file-excel-o"></i>&nbsp;&nbsp;<?php echo $data[818]['trad']; ?></a>&nbsp;&nbsp;
							<a href="nouveau" class="btn btn-yellow btn-outlined btn-square"><i class="fa fa-plus"></i>&nbsp;&nbsp;<?php echo $data[1233]['trad']; ?></a>
						</div>
						<ol class="breadcrumb page-breadcrumb" style=" min-height: 35px; vertical-align: middle;">
							<li style="margin-top:5px;">
								<a><?php echo $data[1509]['trad']; ?></a>
							</li>
							<li class="active" style="margin-top:5px;"><?php echo $data[1034]['trad']; ?>
							</li>
						</ol>
                    </div>
					<div class="panel-body">
						<div class="row ptm">
							<div class="col-md-12 text-center">
								<button class="btns_filters_states btn btn-yellow btn-outlined btn-square active" type="button" data-value="1">
									<i class="fa fa-check"></i> <?php echo $data[27]['trad']; ?>
								</button>
								<button class="btns_filters_states btn btn-yellow btn-outlined btn-square" type="button" data-value="2">
									<i class="fa fa-ban"></i> <?php echo $data[424]['trad']; ?>
								</button>
								<button class="btns_filters_states btn btn-yellow btn-outlined btn-square" type="button" data-value="3">
									<i class="fa fa-list"></i> <?php echo $data[1565]['trad']; ?>
								</button>
							</div>
							<div class="col-md-12 ">
								<table class="table table-bordered table-striped" id="table_id" >
									<thead>
										<tr>
											<th style="width: 100px;"><?php echo $data[1393]['trad']; ?></th>
											<th style="width: 90px;"><?php echo $data[1393]['trad']; ?></th>
											<th><?php echo $data[1175]['trad']; ?></th>
											<th style="width: 10px;">T</th>
											<th style="width: 90px;"><?php echo $data[1333]['trad']; ?>&nbsp;&nbsp;</th>
											<th style="width: 50px;"><?php echo $data[1599]['trad']; ?></th>
											<th style="width: 50px;"><?php echo $data[1498]['trad']; ?></th>
											<th style="width: 30px;"><?php echo $data[1643]['trad']; ?></th>
											<th style="width: 70px;"><?php echo $data[173]['trad']; ?></th>
											<th style="width: 70px;"><?php echo $data[174]['trad']; ?></th>
											<th style="width: 100px;"><?php echo $data[1263]['trad']; ?></th>
											<th>Hidden</th>
											<th>Hidden</th>
										</tr>
									</thead>
									<tbody></tbody>
								</table>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		
		<?php include '../footer.php';	?>
		<?php include('../base/scripts.php') ?>

		<?php 
		if (!function_exists('get_trad')) {
			include $_SERVER["DOCUMENT_ROOT"]. "/translate.php";
		}
		$ids_list = array(1997,1998,1999,2000,2001,2002);
		if (isset($data)) {
			$data = $data + get_trad($ids_list);
		} else {
			$data = get_trad($ids_list);
		}	
	?>
		<script type="text/javascript">
			text1 = "<?php echo $data[1997]['trad']; ?>" ;
			text2 = "<?php echo $data[1998]['trad']; ?>" ;
			text3 = "<?php echo $data[1999]['trad']; ?>" ;
			text4 = "<?php echo $data[2000]['trad']; ?>" ;
			text5 = "<?php echo $data[2001]['trad']; ?>" ;
			text6 = "<?php echo $data[2002]['trad']; ?>" ;
		</script>

		<!-- ADDED SCRIPTS -->
		<script src="/js/vendors/bootstrap-select/bootstrap-select.min.js"></script>
		<script src="/js/vendors/bootstrap-select/defaults-pt_BR.min.js"></script>

		<script src="/js/vendors/DataTables/media/js/jquery.dataTables.js"></script>
		<script src="/js/vendors/DataTables/media/js/dataTables.bootstrap.js"></script>

		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.js"></script>
		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.pt.js"></script>
		<script src="/js/vendors/jquery-maskedinput/jquery-maskedinput.js"></script>
		<script src="/js/fnReload.js"></script>
		
		<script src="/js/autoNumeric.js"></script>

		<?php include('index_scripts.php');  ?>
		<?php include('../modals/stock_artigos.php');  ?>
		<!-- //ADDED SCRIPTS -->

		<script>
			$(".navbar-nav li.contabilidade").addClass("active");
			$(".navbar-nav li.contabilidade li.artigos_contabilidade").addClass("active");
		</script>
		<script type="text/javascript">
			$(document).ajaxStart(function() {
				$(".fullscreen").show();
			});
			$(document).ajaxComplete(function() {
				if ($.active == 1) {
	                $(".fullscreen").fadeOut();
	            }
	            //init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});
				$(".percentage").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : '  %',
					vMax : '100',
					mDec : 2,
					vMin:'0',
					pSign : 's'
				});
				//init elements
				$(".qtd").autoNumeric("init", {
					aSep : '',
					aDec : '.',
					aSign : '',
					pSign : 's',
					mDec : 3
				});
			});
			$(document).ready(function() {
				$(".fullscreen").fadeOut();

				//init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});

				$(".percentage").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : '  %',
					vMax : '100',
					mDec : 2,
					vMin:'0',
					pSign : 's'
				});
				//init elements
				$(".qtd").autoNumeric("init", {
					aSep : '',
					aDec : '.',
					aSign : '',
					pSign : 's',
					mDec : 3
				});
			});

			$(document).ready(function() {


				//init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});

				$(".percentage").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : '  %',
					vMax : '100',
					mDec : 2,
					vMin:'0',
					pSign : 's'
				});
				//init elements
				$(".qtd").autoNumeric("init", {
					aSep : '',
					aDec : '.',
					aSign : '',
					pSign : 's',
					mDec : 3
				});
			});
		</script>
	</body>
</html>