<?php 
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1639,1456);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<script type="text/javascript">
	/**
	 * Fill the categories
	 * @return select list
	 */
	function fill_categories(){
		var options = $("select#categoria_artigo");
		$(options).empty();
		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/artigos.php',
			data : {
				opcao : 1
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL001] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL002] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$(options).attr("disabled", true);

						} else {
							$(options).attr("disabled", false);

							$(options).append($('<option data-hidden="true"/>').val("").text("<?php echo $data[1456]['trad']; ?>"));
							
							var html_categorias = '';
							html_categorias += '<option value="0" selected>Sem Categoria</option>';
							
							var current_group = '';
							
							$.each(resposta.data, function() {
								html_categorias += '<option value="' + this.id + '">' + this.nome + '</option>';
							});

							$(options).html(html_categorias);
						}
					}
				}
			},
			complete : function() {
				$(options).val($("select#categoria_artigo option:eq(0)").val());
				$(options).trigger('change');
			}
		});
	}

	/**
	 * Fill the impostos
	 * @return select list
	 */
	function fill_impostos(){
		var options = $("select#imposto_artigo");
		$(options).empty();
		var idPredefinido = 0;
		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/artigos.php',
			data : {
				opcao : 2
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL001] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL002] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$(options).attr("disabled", true);

						} else {
							$(options).attr("disabled", false);

							$(options).append($('<option data-hidden="true"/>').val("").text("<?php echo $data[1456]['trad']; ?>"));
							$.each(resposta.data, function() {
								$(options).append( $("<option />").val(this.id).text(this.nome).attr('data-taxa', this.taxa) );
								if(this.predefinido == 1) idPredefinido = this.id;
							});
						}
					}
				}
			},
			complete : function() {
				if(idPredefinido > 0) $(options).val(idPredefinido);
				// $(options).val($("select#imposto_artigo option:eq(1)").val());
				$(options).trigger('change');
			}
		});
	}

	/**
	 * Fill the impostos
	 * @return select list
	 */
	function fill_impostosFornecedores(){
		var options = $("select#imposto_fornecedor_artigo");
		$(options).empty();
		var idPredefinido = 0;
		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/artigos.php',
			data : {
				opcao : 4
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL001] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL002] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$(options).attr("disabled", true);

						} else {
							$(options).attr("disabled", false);

							$(options).append($('<option data-hidden="true"/>').val("").text("<?php echo $data[1456]['trad']; ?>"));
							$.each(resposta.data, function() {
								$(options).append( $("<option />").val(this.id).text(this.nome).attr('data-taxa', this.taxa) );
								if(this.predefinido == 1) idPredefinido = this.id;
							});
						}
					}
				}
			},
			complete : function() {
				if(idPredefinido > 0) $(options).val(idPredefinido);
				// $(options).val($("select#imposto_fornecedor_artigo option:eq(1)").val());
				$(options).trigger('change');
			}
		});
	}

	/**
	 * Fill the unidades
	 * @return select list
	 */
	function fill_unidades(){
		var options = $("select#unidade_artigo");
		$(options).empty();
		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/artigos.php',
			data : {
				opcao : 3
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL001] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL002] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$(options).attr("disabled", true);

						} else {
							$(options).attr("disabled", false);

							$(options).append($('<option data-hidden="true"/>').val("").text("<?php echo $data[1456]['trad']; ?>"));
							$.each(resposta.data, function() {
								$(options).append($("<option />").val(this.id).text(this.nome));
							});
						}
					}
				}
			},
			complete : function() {
				$(options).val($("select#unidade_artigo option:eq(1)").val());
				$(options).trigger('change');
			}
		});
	}

	/**
	 * Calculate Price
	 * @return price pvp value
	 */
	function calculaPreco(){
		var taxa = $('select#imposto_artigo option:selected').attr('data-taxa');
		taxa = Number ( (taxa * 0.01)+1 );
		var preco_pvp = Number( $("#precoPVP_artigo").autoNumeric('get') );
		//calculate new
		var preco_final = (preco_pvp / taxa);
		$("#preco_artigo").autoNumeric('set', preco_final );
	}

	/**
	 * Calculate Price PVP
	 * @return price value
	 */
	function calculaPrecoPVP(){
		var taxa = $('select#imposto_artigo option:selected').attr('data-taxa');
		taxa = Number ( (taxa * 0.01)+1 );
		var preco = Number( $("#preco_artigo").autoNumeric('get') );
		//calculate new
		var preco_final = (preco * taxa);
		$("#precoPVP_artigo").autoNumeric('set', preco_final );
	}

	//load data
	function fill_comptes() {
		var options = $("select#plano_artigo");
		$(options).empty();

		var options2 = $("select#plano_2_artigo");
		$(options2).empty();

		var resp = null;
		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/plano_contas.php',
			data : {
				opcao : 3,
				defeito: 'artigo'
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL001] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL002] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$(options).attr("disabled", true);
							$(options2).attr("disabled", true);

						} else {
							resp = resposta;
							$(options).attr("disabled", false);
							$(options2).attr("disabled", false);

							$(options).append($('<option data-hidden="true"/>').val("").text("<?php echo $data[1456]['trad']; ?>"));
							$(options).append($('<option />').val("").text("<?php echo $data[1456]['trad']; ?>"));

							$(options2).append($('<option data-hidden="true"/>').val("").text("<?php echo $data[1456]['trad']; ?>"));
							$(options2).append($('<option />').val("").text("<?php echo $data[1456]['trad']; ?>"));

							$.each(resposta.data, function() {
								$(options).append($("<option />").val(this.codigo).html(this.descricao+''));
								$(options2).append($("<option />").val(this.codigo).html(this.descricao+''));
							});
						}
					}
				}
			},
			complete : function() {
				if(resp != null) {
					$(options).val(resp.planoDefeito.artigo_chiffre);
					$(options2).val(resp.planoDefeito.artigo_prealable);
				} else {
					$(options).val($("select#plano_artigo option:eq(1)").val());
					$(options2).val($("select#plano_2_artigo option:eq(1)").val());
				}

				$(options).trigger('change');
				$(options2).trigger('change');
			}
		});
	}
</script>