<?php
	include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo_gesfaturacao.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/helpers.php';
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

	if ( hasPermission(['P0090']) == 1 ) {}
	else{
		header('Location: ../../acces-refuse?redirectfrom=/frifacturation/mouvements&redirectto=/frifacturation');
	}

	if ($_SESSION['mod_Contabilidade'] == 0) {
		header('Location: ../../acces-fonctionnalites?redirectfrom=frifacturation&redirectto=/frifacturation');
	}
	if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1509,1223,1152,524,377,1146,1150,1265,1187,1300,1301,1456,262,427,562,564,67,535,94,406,706,705,404,370,1161,427,1263,186,214,1706,1633,1013,988,1403,1995);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<html>
	<title><?php echo $data[1509]['trad']; ?>: <?php echo $data[1223]['trad']; ?> | Frifacturation</title>
	<head>
		<?php include('../../base/css.php') ?>
		<!-- ADDED CSS -->
		<link rel="stylesheet" href="/js/vendors/bootstrap-select/bootstrap-select.min.css">
		<link rel="stylesheet" href="/js/vendors/bootstrap-datepicker/datepicker3.css">
		<!-- //ADDED CSS -->
	</head>
	<body>
		<?php include '../../../modal_menu.php'; ?>
		<div class="container">
			<?php include '../../menu.php'; ?>

			<div class="page-content">
				<div class="panel panel-white">
					<div class="panel-heading">
                        <div class="pull-right" >
							<a class="text-red only-ic" href="../mouvements"><i class="fa fa-times"></i></a>
						</div>
						<ol class="breadcrumb page-breadcrumb" style=" min-height: 35px; vertical-align: middle;">
							<li>
								<a href="../mouvements"><?php echo $data[1152]['trad']; ?></a>
							</li>
							<li class="active">
								<?php echo $data[1223]['trad']; ?>
							</li>
						</ol>
                    </div>
					<div class="panel-body">
						<div class="row mbxl">
							<div class="col-xs-12">
								<form id="form_new" class="form-validate">
									<div class="form-body">
										<div id="form_div">
											<h5 class="form-header">
												<legend class="form-legend">
													<?php echo $data[524]['trad']; ?>
												</legend>
											</h5>
											<div class="section-form">
												<div class="row">
													<div class="col-md-2">
														<div class="form-group">
															<label class="control-label"><?php echo $data[377]['trad']; ?><span class="require">*</span></label>
															<div class="input-buttons form-group">
																<input type="text" class="form-control datepicker today" data-provide="datepicker" name="data_movimento" id="data_movimento" data-date-format="dd/mm/yyyy">
																<div class="input-group-addon">
																	<span class="fa fa-calendar"></span>
																</div>
															</div>
														</div>
													</div>
													<!-- <div class="col-md-3">
														<div class="form-group">
															<label class="control-label">Type de mouvement<span class="require">*</span></label>
															<select class="form-control select2 show-tick" data-live-search="true"  data-header="<?php echo $data[1456]['trad']; ?>" id="tipo_movimento" name="tipo_movimento">
																<option value=""><?php echo $data[1456]['trad']; ?></option>
																<option value="D">Débit</option>
																<option value="C">Crédit</option>
															</select>
														</div>
													</div> -->
													<div class="col-md-2">
														<div class="form-group">
															<label class="control-label"><?php echo $data[1146]['trad']; ?><span class="require">*</span></label>
															<input type="text" class="form-control money" name="valor_movimento" id="valor_movimento" placeholder="0.00 CHF">
														</div>
													</div>
													<div class="col-md-4">
														<label><?php echo $data[1150]['trad']; ?>?</label><br>
														<label class="radio-inline padding-left-radio">
															<input id="tva_oui" type="radio" name="include_tva" value="1" class="default_radio"/>
															<?php echo $data[1265]['trad']; ?> ?
														</label>
														<label class="radio-inline padding-left-radio">
															<input id="tva_non" type="radio" name="include_tva" value="0" class="default_radio" checked/>
															<?php echo $data[1187]['trad']; ?> ?
														</label>
													</div>
												</div>
												<div class="row mtm">
													<div class="col-md-4">
														<div class="form-group">
															<label class="control-label"><?php echo $data[1301]['trad']; ?><span class="require">**</span></label>
															<select class="form-control select2 show-tick" data-live-search="true"  data-header="<?php echo $data[1456]['trad']; ?>" id="plano_movimento" name="plano_movimento">
																<option value="" data-hidden="true"><?php echo $data[1456]['trad']; ?></option>
															</select>
														</div>
													</div>
													<div class="col-md-4">
														<div class="form-group">
															<label class="control-label"><?php echo $data[1300]['trad']; ?><span class="require">**</span></label>
															<select class="form-control select2 show-tick" data-live-search="true"  data-header="<?php echo $data[1456]['trad']; ?>" id="plano_2_movimento" name="plano_2_movimento">
																<option value="" data-hidden="true"><?php echo $data[1456]['trad']; ?></option>
															</select>
														</div>
													</div>
													<div class="col-md-4">
														<div class="form-group">
															<label class="control-label"><?php echo $data[262]['trad']; ?></label>
															<select class="form-control select2 show-tick" data-live-search="true"  data-header="<?php echo $data[1456]['trad']; ?>" id="codetva_movimento" name="codetva_movimento">
																<option value="" data-hidden="true"><?php echo $data[1456]['trad']; ?></option>
															</select>
														</div>
													</div>
												</div>
												<div class="row mtm">
													<div class="col-xs-12">
														<div class="form-group">
															<label class="control-label"><?php echo $data[427]['trad']; ?><span class="require">*</span></label>
															<input type="text" class="form-control" id="descricao_movimento" name="descricao_movimento" placeholder="..." autofocus="true" />
														</div>
													</div>
												</div>
											</div>
										</div>
									</div>

									<div class="form-footer">
										<div class="mtxl pull-right">
											<button class="btn btn-yellow submit_button" type="submit" id="finishBTN">
												<i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?>
											</button>
											<button class="btn btn-green submit_button" type="submit" id="storeOnlyBTN">
												<i class="fa fa-floppy-o"></i> <?php echo $data[564]['trad']; ?>
											</button>
											<a  href="../mouvements" class="btn btn-default" type="button"> <?php echo $data[1995]['trad']; ?> </a>
										</div>
									</div>
								</form>
							</div>
						</div>

						<!-- MOUVEMENTS LISTE -->
						<hr>
						<form id="form_filters" class="form-validate mtxl">
							<div class="row">
								<div class="col-sm-3">
									<div class="form-group ">
										<label class="control-label"><?php echo $data[535]['trad']; ?></label>
										<select class="form-control select2 show-tick" data-live-search="true"  data-header="<?php echo $data[1456]['trad']; ?>" id="compte_de" name="compte_de">
											<option value="" ><?php echo $data[1456]['trad']; ?></option>
										</select>
									</div>
								</div>

								<div class="col-sm-3">
									<div class="form-group ">
										<label class="control-label"><?php echo $data[94]['trad']; ?></label>
										<select class="form-control select2 show-tick" data-live-search="true"  data-header="<?php echo $data[1456]['trad']; ?>" id="compte_au" name="compte_au">
											<option value="" ><?php echo $data[1456]['trad']; ?></option>
										</select>
									</div>
								</div>

								<div class="col-sm-2">
									<div class="form-group ">
										<label class="control-label"><?php echo $data[406]['trad']; ?><span class="require">*</span></label>
										<div class="input-buttons form-group">
											<input type="text" class="form-control datepicker today2" data-provide="datepicker" name="FiltroDataInicial" id="FiltroDataInicial" data-date-format="dd/mm/yyyy" required>
											<div class="input-group-addon">
												<span class="fa fa-calendar"></span>
											</div>
										</div>
									</div>
								</div>

								<div class="col-sm-2">
									<div class="form-group ">
										<label class="control-label"><?php echo $data[706]['trad']; ?><span class="require">*</span></label>
										<div class="input-buttons form-group">
											<input type="text" class="form-control datepicker today3" data-provide="datepicker" name="FiltroDataFinal" id="FiltroDataFinal" data-date-format="dd/mm/yyyy" required>
											<div class="input-group-addon">
												<span class="fa fa-calendar"></span>
											</div>
										</div>
									</div>
								</div>

								<div class="col-sm-2 form-group ">
										<label class="control-label">&nbsp;</label>
									<button class="btn btn-yellow submit_button btn-block" type="submit">
										<i class="fa fa-database"></i> <?php echo $data[705]['trad']; ?>
									</button>
								</div>
							</div>
						</form>

						<div class="row mtl ptm">
							<div class="col-md-12 ">
								<table class="table table-bordered table-striped" id="table_id" >
									<thead>
										<tr>
											<th style="width: 45px;"><?php echo $data[1161]['trad']; ?></th>
											<th style="width: 70px"><?php echo $data[377]['trad']; ?></th>
											<th style="width: 50px;"><?php echo $data[404]['trad']; ?></th>
											<th style="width: 50px;"><?php echo $data[370]['trad']; ?></th>
											<th><?php echo $data[427]['trad']; ?></th>
											<th style="width: 30px;">A|M</th>
											<th style="width: 90px;"><?php echo $data[1146]['trad']; ?>&nbsp;&nbsp;</th>
											<th style="width: 70px;"><?php echo $data[1263]['trad']; ?></th>
										</tr>
									</thead>
									<tbody></tbody>
								</table>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		
		<?php include '../../footer.php'; ?>
		<?php include('../../base/scripts.php') ?>

		<?php 
		if (!function_exists('get_trad')) {
			include $_SERVER["DOCUMENT_ROOT"]. "/translate.php";
		}
		$ids_list = array(1997,1998,1999,2000,2001,2002);
		if (isset($data)) {
			$data = $data + get_trad($ids_list);
		} else {
			$data = get_trad($ids_list);
		}	
	?>
		<script type="text/javascript">
			text1 = "<?php echo $data[1997]['trad']; ?>" ;
			text2 = "<?php echo $data[1998]['trad']; ?>" ;
			text3 = "<?php echo $data[1999]['trad']; ?>" ;
			text4 = "<?php echo $data[2000]['trad']; ?>" ;
			text5 = "<?php echo $data[2001]['trad']; ?>" ;
			text6 = "<?php echo $data[2002]['trad']; ?>" ;
		</script>

		<!-- ADDED SCRIPTS -->
		<script src="/js/vendors/bootstrap-select/bootstrap-select.min.js"></script>
		<script src="/js/vendors/bootstrap-select/defaults-pt_BR.min.js"></script>

		<script src="/js/vendors/DataTables/media/js/jquery.dataTables.js"></script>
		<script src="/js/vendors/DataTables/media/js/dataTables.bootstrap.js"></script>

		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.js"></script>
		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.pt.js"></script>
		<script src="/js/vendors/jquery-maskedinput/jquery-maskedinput.js"></script>
		<script src="/js/fnReload.js"></script>

		<script src="/js/autoNumeric.js"></script>
		<script src="/js/jquery.showmore.js"></script>

		<?php include('novo_scripts.php');  ?>
		<!-- //ADDED SCRIPTS -->

		<script>
			$(".navbar-nav li.comptab").addClass("active");
			$(".navbar-nav li.comptab li.mouvements_comptab").addClass("active");
		</script>
		<script type="text/javascript">
			var manterAqui = 0;
			var includeTva = 0;

			$(document).ajaxStart(function() {
				$(".fullscreen").show();
			});
			$(document).ajaxComplete(function() {
				if ($.active == 1) {
	                $(".fullscreen").fadeOut();
	            }
				//init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});
			});
			$(document).ready(function() {

				$(".fullscreen").fadeOut();

				//init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});

			});

			$(document).ready(function() {
				//datepicker init
				$('.datepicker').datepicker({
					autoclose : true,
					todayHighlight : true,
					toggleActive : true,
					format : 'dd/mm/yyyy',
					language : 'pt'
				});				
				$('.today').datepicker().datepicker("setDate", new Date());
				var FivethenDaysDate =  new Date( new Date().getTime()+(15*24*60*60*1000) );
				$('.15days').datepicker().datepicker("setDate", new Date());

				$( ".datepicker" ).datepicker("refresh");
				
				//init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});
				
				// iCheck ------------------------
				$('input:checkbox').attr("checked");
				$('input[type=checkbox]').iCheck({
					checkboxClass : 'icheckbox_flat-yellow',
					increaseArea : '20%' // optional
				});
				$('input[type=checkbox]').iCheck({
					checkboxClass : 'icheckbox_minimal-yellow',
					increaseArea : '20%' // optional
				});
				$('input[type=radio]').iCheck({
					radioClass : 'iradio_square-yellow',
					increaseArea : '20%' // optional
				});

				//init select2
				$("select#compte_de").select2({
					escapeMarkup: function(m) { return m; }, language: "fr", placeholder: "<?php echo $data[1456]['trad']; ?>", allowClear: true
				});
				$("select#compte_au").select2({
					escapeMarkup: function(m) { return m; }, language: "fr", placeholder: "<?php echo $data[1456]['trad']; ?>", allowClear: true
				});
				$("select#plano_movimento").select2({
					escapeMarkup: function(m) { return m; }, language: "fr", placeholder: "<?php echo $data[1456]['trad']; ?>",
				});
				$("select#plano_2_movimento").select2({
					escapeMarkup: function(m) { return m; }, language: "fr", placeholder: "<?php echo $data[1456]['trad']; ?>",
				});
				$("select#codetva_movimento").select2({
					escapeMarkup: function(m) { return m; }, language: "fr", placeholder: "<?php echo $data[1456]['trad']; ?>", allowClear: true
				});

				//fill necessary data
				fill_comptes();
				
				/* ----------- LISTNERS ----------- */
				$('input#tva_oui').on('ifChecked', function (event) {
					includeTva = 1;
				console.log(includeTva,'oui');
				});
				$('input#tva_non').on('ifChecked', function (event) {
					includeTva = 0;
				console.log(includeTva,'non');
				});
			});

			/* --------- LISTNERS INIT ---------- */
			function listnersInit(){
				/* ----------- LISTNERS ----------- */
				$('input#tva_oui').on('ifChecked', function (event) {
					includeTva = 1;
				console.log(includeTva,'oui2');
				});
				$('input#tva_non').on('ifChecked', function (event) {
					includeTva = 0;
				console.log(includeTva,'non2');
				});
				includeTva = 0;
				$('input#tva_non').iCheck('check');
				console.log(includeTva,'resume');
			}

			//change compte
			$("select#plano_movimento").on('change', function(event){
				//get id of taxe if exists
				var taxe = $("select#plano_movimento option:selected").attr('data-taxeid');
				
				//process
				if(taxe && taxe > 0){
					$("select#codetva_movimento").val(taxe);
					$("select#codetva_movimento").trigger('change');
					$('input#tva_oui').iCheck('check');
				}
			});

			//change compte 2
			$("select#plano_2_movimento").on('change', function(event){
				//get id of taxe if exists
				var taxe = $("select#plano_2_movimento option:selected").attr('data-taxeid');
				
				//process
				if(taxe && taxe > 0){
					$("select#codetva_movimento").val(taxe);
					$("select#codetva_movimento").trigger('change');
					$('input#tva_oui').iCheck('check');
				}
			});

			//change compte 2
			$("select#codetva_movimento").on('change', function(event){
				var taxe = $("select#codetva_movimento option:selected").val();
				if(taxe && taxe > 0) $('input#tva_oui').iCheck('check');
				else $('input#tva_non').iCheck('check');
				console.log(includeTva,'change');

			});

			$('#finishBTN').on('click', function(event){
				manterAqui = 1;
				// console.log(manterAqui);
			});

			$('#storeOnlyBTN').on('click', function(event){
				manterAqui = 0;
				// console.log(manterAqui);
			});
			
			//change doc tva
			$("select#documentoOrigem_rapport").on('change', function(event){
				var docID = $('option:selected', $("#documentoOrigem_rapport") ).val();
				var docType = $('option:selected', $("#documentoOrigem_rapport") ).attr('data-type');
				fill_origens_detalhes(docID, docType);
			});

			/**
			 * ----------------------------------------------------
			 * ----------------- FORM PROCESSING ------------------
			 * ----------------------------------------------------
			 */
			/**
			 * Validate Percentage
			 */
			val_form_new = $("#form_new").validate({
				ignore : "",
				rules : {
					data_movimento : {
						required : true
					},
					// tipo_movimento : {
					// 	required : true
					// },
					valor_movimento : {
						required : true
					},
					descricao_movimento : {
						required : true
					},
				},
				messages : {
					data_movimento : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
					// tipo_movimento : {
					// 	required : "<?php echo $data[186]['trad']; ?>"
					// },
					valor_movimento : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
					descricao_movimento : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
				},
				highlight : function(element, errorClass, validClass) {
					$(element).addClass(errorClass).removeClass(validClass);
				},
				unhighlight : function(element, errorClass, validClass) {
					$(element).removeClass(errorClass).addClass(validClass);
				},
				errorPlacement : function(error, element) {
					if (element.hasClass('select2')) {
						if (element.parent().hasClass("input-group"))
							error.insertAfter(element.parent());
						else
							error.insertAfter(element.next("div"));
					} else {
						error.insertAfter(element);
					}
				}
			});

			//check validation and upload foto
			$("#form_new").submit(function(e) {
				e.preventDefault();

				var valid = $("#form_new").valid();
				if (valid == false) {
					$.scojs_message("<?php echo $data[1403]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				} else {

					$("#form_new").find('.submit_button').attr("disabled", true);
					$("#form_new").find('.submit_button').html('<i class="fa fa-circle-o-notch fa-spin  fa-fw "></i> <?php echo $data[214]['trad']; ?> ...');

					//check if exists at least one plan
					var plan1 = $("#plano_movimento").val();
					var plan2 = $("#plano_2_movimento").val();
					if(plan1 < 1 && plan2 < 1){
						$("#plano_movimento").addClass('invalid');
						$("#plano_movimento").trigger('change');
						$("#plano_2_movimento").addClass('invalid');
						$("#plano_2_movimento").trigger('change');

						$.scojs_message("<?php echo $data[1706]['trad']; ?>", $.scojs_message.TYPE_ERROR);

						$("#form_new").find('.submit_button').attr("disabled", false);
						$("#form_new").find('#finishBTN').html('<i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?>');
						$("#form_new").find('#storeOnlyBTN').html('<i class="fa fa-floppy-o"></i> <?php echo $data[564]['trad']; ?>');
					}
					else{
						$("#plano_movimento").removeClass('invalid');
						$("#plano_movimento").trigger('change');
						$("#plano_2_movimento").removeClass('invalid');
						$("#plano_2_movimento").trigger('change');
						//submite the form
						$.ajax({
							type : 'POST',
							url : '/frifacturation/server/comptabilite/mouvements/inserir.php',
							dataType : 'json',
							data : {
								includeTva : includeTva,
								data_movimento : $("#data_movimento").val(),
								plano_movimento : $("#plano_movimento").val(),
								plano_2_movimento : $("#plano_2_movimento").val(),
								codetva_movimento : $("#codetva_movimento").val(),
								// tipo_movimento : $("#tipo_movimento").val(),
								valor_movimento : $("#valor_movimento").autoNumeric('get'),
								descricao_movimento : $("#descricao_movimento").val(),
							},
							success : function(resposta) {
								var resp = resposta;
								if (resposta == null)
									$.scojs_message("[FAT001] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
								else {
									if (resposta.errors) {
										$.scojs_message("[FAT002] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
									} else {
										$.scojs_message("<?php echo $data[1013]['trad']; ?>", $.scojs_message.TYPE_OK);
									}
								}
							},
							complete : function(resposta) {
								var resp = resposta;
								if (resp.responseJSON.errors) {
									if(resp.responseJSON.existe){
										$.scojs_message("[FAT003] <?php echo $data[988]['trad']; ?>", $.scojs_message.TYPE_ERROR);
									}
									else { 
										$.scojs_message("[FAT004] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
									}
								} else {
									$.scojs_message("<?php echo $data[1013]['trad']; ?>", $.scojs_message.TYPE_OK);

										//process page response
										if(manterAqui > 0 ) {
											// reset form and reload table
											$("#form_new")[0].reset();
											$("#form_filters").trigger('submit');

											// reset form remaining vars
											$('.today').datepicker().datepicker("setDate", new Date());
											$( ".datepicker" ).datepicker("refresh");

											var options = $("select#plano_movimento");
											var options2 = $("select#plano_2_movimento");
											var options3 = $("select#codetva_movimento");

											$(options).val($("select#plano_movimento option:eq(1)").val());
											$(options).trigger('change');

											$(options2).val($("select#plano_2_movimento option:eq(1)").val());
											$(options2).trigger('change');

											// $(options3).val(0);
											$(options3).val($("select#codetva_movimento option:eq(1)").val());
											$(options3).trigger('change');

											$('input[type=radio]').iCheck({
												radioClass : 'iradio_square-yellow',
												increaseArea : '20%' // optional
											});

											listnersInit();
										}else{
											//reload
											setTimeout(function() {
												window.location.href = "../mouvements";
											}, 1000);
										}

								}
								$("#form_new").find('.submit_button').attr("disabled", false);
								$("#form_new").find('#finishBTN').html('<i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?>');
								$("#form_new").find('#storeOnlyBTN').html('<i class="fa fa-floppy-o"></i> <?php echo $data[564]['trad']; ?>');
							}
						});
					}
				}
			});
		</script>

		<script type="text/javascript">
			$(document).ready(function() {
				//init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});

			/* ---------- Page Scripts ---------- */
				//datepicker plugin ----------------------
				$('.datepicker').datepicker({
					autoclose : true,
					todayHighlight : true,
					toggleActive : true,
					format : 'dd/mm/yyyy',
					language : 'pt'
				});

				var dInicial = new Date();
				dInicial.setMonth(0);
				dInicial.setDate(1);

				var dFinal = new Date();
				dFinal.setMonth(12);
				dFinal.setDate(0);

				$('#FiltroDataInicial').datepicker().datepicker("setDate", dInicial);
				$('#FiltroDataFinal').datepicker().datepicker("setDate", dFinal);

				$('[data-provide="datepicker-inline"]').mask("99/99/9999");
				$('[data-provide="datepicker"]').mask("99/99/9999");
				
				//init datatables
				reloadTableLines(null,null,$("#FiltroDataInicial").val(),$("#FiltroDataFinal").val(), true);
				fill_comptes_sels();
			});
			/* ---------------------------------- */
			
			val_form_new = $("#form_filters").validate({
				rules : {
					FiltroDataInicial : {
						required : true
					},
					FiltroDataFinal : {
						required : true
					},
				},
				messages : {
					FiltroDataInicial : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
					FiltroDataFinal : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
				},
				highlight : function(element, errorClass, validClass) {
					$(element).addClass(errorClass).removeClass(validClass);
				},
				unhighlight : function(element, errorClass, validClass) {
					$(element).removeClass(errorClass).addClass(validClass);
				}
			});

			$("#form_filters").submit(function(e) {
				e.preventDefault();
				//process
				// $("#FiltroDataInicial").val()
				// $("#FiltroDataFinal").val()
				var resp = null;
				var valid = $("#form_filters").valid();
				if (valid == false ) {
					$.scojs_message("<?php echo $data[1403]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				} else {
					//prepare vars
					var compteDe = $("#compte_de").val();
					var compteAu = $("#compte_au").val();

					var dateAccuel = $("#FiltroDataInicial").val();
					var dateFin = $("#FiltroDataFinal").val();

					reloadTableLines(compteDe,compteAu,dateAccuel,dateFin);
				}
				return false;
			});	
		</script>
	</body>
</html>