<?php 
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1639,1698,1633,1565,1472,1447,1702,1704,1503,1312,1310,421,1377,428,1125,729,1065,1093,563,904,67,1412,1505,624,88,857,305,979,961,1629,494,601,845,191,776,304,588,823,190,774,303,654,869,307);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<script type="text/javascript">
	table = $('#table_id').dataTable({
		"dom" : '<lfrtip><"clear">',
		"sRowSelect" : "os",
		"sRowSelector" : 'td:first-child',
		"lengthMenu" : [[25, 50, 100, -1], [25, 50, 100, "<?php echo $data[1565]['trad']; ?>"]],
		"iDisplayLength" : 100,
		"aaSorting" : [[0, "asc"]],
		"bProcessing" : true,
		"bServerSide" : true,
		"sAjaxSource" : "/frifacturation/server/datatable/contrats_achats.php",
		"oLanguage" : {
			"sLengthMenu" : "<?php echo $data[1472]['trad']; ?>",
			"sZeroRecords" : "<?php echo $data[1447]['trad']; ?>",
			"sInfo" : "<?php echo $data[1702]['trad']; ?>",
			"sInfoEmpty" : "<?php echo $data[1704]['trad']; ?>",
			"sProcessing" : "<div></div>",
			"sInfoFiltered" : "",
			"oPaginate" : {
				"sNext" : "<?php echo $data[1503]['trad']; ?>",
				"sFirst" : "<?php echo $data[1312]['trad']; ?>",
				"sPrevious" : "<?php echo $data[1310]['trad']; ?>",
				"sLast" : "<?php echo $data[421]['trad']; ?>"
			}
		},
		"aoColumns" : [null, null, null, null, null,  
		{
			"sClass" : "text-right",
		},
		{
			"sClass" : "text-center",
			"bVisible" : false,
		},
		{
			"bVisible" : true,
			"bSortable" : false,
			"bSearchable" : true,
			"sClass" : "text-center",
		},
		{
			"bVisible" : false,
			"bSortable" : false,
			"bSearchable" : true,
			"sClass" : "text-center",
		}
		],
		"aoColumnDefs" : [
		{
			"aTargets" : [0],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[6] == 'Rascunho') element = '<span style="color: orange;">---</span>';
				if(full[6] == 'Confirmado') element = '<span style="color: green;">'+full[0]+'</span>';
				if(full[6] == 'Aberto') element = '<span style="color: blue;">'+full[0]+'</span>';
				if(full[6] == 'Anulado') element = '<span style="color: black;">'+full[0]+'</span>';

				if(full[8]) element = '<span style="color: grey; font-weight: bold;">'+full[0]+'</span>';
				//else element = full[0];
				//return html
				return element;
			}
		},
		{
			"aTargets" : [1],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[1]) element = full[1];
				else element = '-';

				//return html
				return '<span class="ellipsis" data-size="28">'+element+'</span>';
			}
		},
		{
			"aTargets" : [2],
			"mRender" : function(data, type, full) {
				//return html
				raison = full[9];
				css = "";
				if(raison){
					raison = full[9].trim();
				}
				info = full[2]
				if(info){
					info = full[2].trim();
				}
				if( raison ){
					info = raison+' - '+info;
					css = "color:red;font-weight:bold;";
				}
				return '<span class="ellipsis" data-size="28" style="'+css+'">'+info+'</span>';
			}
		},
		{
			"aTargets" : [3],
			"mRender" : function(data, type, full) {
				var element = '';
				var tmp = full[3].split("-");
				var tmpNew = tmp[0]+'/'+tmp[1]+'/'+tmp[2];
				var tmpLBL = tmp[2]+'/'+tmp[1]+'/'+tmp[0];
				element = '<span id="data_achat_'+full[7]+'" data-normalizeDate="'+tmpNew+'">'+tmpLBL+'</span>';
				//return html
				return element;
			}
		},
		{
			"aTargets" : [4],
			"mRender" : function(data, type, full) {
				//return html
				return '<span class="ellipsis" data-size="28">'+full[4]+'</span>';
			}
		},
		{
			"aTargets" : [5],
			"mRender" : function(data, type, full) {
				var element = '';
				element ='<span class="money text-green">'+full[5]+'</span>';

				if(full[8]) element = '<span class="money " style="color: grey;">'+full[5]+'</span>';

				//init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>,
					vMin:'0'
				});

				return element;
			}
		},
		{
			"aTargets" : [6],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[6] == 'Rascunho') element = '<span class="label label-orange">'+full[6]+'</span>';
				if(full[6] == 'Confirmado') element = '<span class="label label-green">'+full[6]+'</span>';
				if(full[6] == 'Aberto') element = '<span class="label label-blue">'+full[6]+'</span>';
				if(full[6] == 'Anulado') element = '<span class="label label-red">'+full[6]+'</span>';
				//return html
				return element;
			}
		},
		{
			"aTargets" : [7],
			"mRender" : function(data, type, full) {
				var tmp = full[3].split("-");
				var tmpLBL = tmp[2]+'/'+tmp[1]+'/'+tmp[0];
				var docNumber = '';
				if(full[6] != 'Rascunho') docNumber = " - "+ full[0];
				var processedName = full[1].replace(/'/gi, " "); processedName = processedName.replace(/"/gi, " ");
				var nome = "'"+tmpLBL+ docNumber+" - " + processedName +"'";
				var datatermo = "''";
				if(full[8]) datatermo = "'" + full[8] +"'";
				
				var html = '';

				html += '<a href="details?achat='+ full[7] +'" class="options-link text-info"><i class="fa fa-eye" title="<?php echo $data[428]['trad']; ?>"></i></a>';

				//edition options
				if( full[6] != 'Rascunho' ){
					html += '<a href="modifier_lines?achat='+full[7]+'" class="options-link text-orange"><i class="fa fa-terminal" title="<?php echo $data[1125]['trad']; ?>"></i></a>';

					html += '<a class="options-link text-violet" onclick="gerarDocumento('+ full[7] +')" title="<?php echo $data[729]['trad']; ?>"><i class="fa fa-files-o"></i></a>';
					if( full[6] == 'Aberto' ){
						html += '<a class="options-link text-green" onclick="confirmarAchat('+ full[7] +','+nome+')" title="<?php echo $data[1065]['trad']; ?>"><i class="fa fa-check"></i></a>';
					}
				}else{
					html += '<a href="modifier?achat='+full[7]+'" class="options-link text-orange"><i class="fa fa-edit" title="<?php echo $data[1093]['trad']; ?>"></i></a>';
					
					html += '<a class="options-link text-green" onclick="finalizarAchat('+ full[7] +', '+nome+')" title="<?php echo $data[563]['trad']; ?>"><i class="fa fa-flag-checkered"></i></a>';
				}
				
				html += '<a href="/frifacturation/server/imprimer_pdf/exportar_contrat_achat.php?idDoc='+full[7]+'" target="_blank" class="options-link text-grey"><i class="fa fa-print" title="<?php echo $data[904]['trad']; ?>"></i></a>';
								
				if(full[6] != 'Rascunho' && full[6] != 'Anulado'){
					<?php if( adminCheckerFat($_SESSION['id_utilizador']) == 1 ){ ?>
						html += '<a class="options-link text-red" onclick="anularAchat('+ full[7] +', '+nome+')" title="<?php echo $data[67]['trad']; ?>"><i class="fa fa-times"></i></a>';
					<?php } ?>

					<?php if (hasPermission(['P0145']) == 1){ ?>
						html += '<a class="options-link text-dark-blue" onclick="termineContrat('+ full[7] +', '+nome+', '+datatermo+')" title="<?php echo $data[1412]['trad']; ?>"><i class="fa fa-ban"></i></a>';
					<?php } ?>
				}

				if(full[6] == 'Rascunho') {
					html += '<a class="options-link text-red" onclick="eliminarAchat('+ full[7] +', '+nome+')" title="<?php echo $data[1505]['trad']; ?>"><i class="fa fa-trash"></i></a>';
				}

				//return all html composed
				return html;
			}
		}],

		"fnRowCallback" : function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
			$(nRow).attr("dbID", aData[7]);

			if(aData[6] == 'Anulado') $(nRow).css("text-decoration", "line-through");

			return nRow;
		},
		"fnDrawCallback" : function(oSettings) {
			$(".ellipsis").ellipsis(); 
		},
	});

	$('#table_id').on('click', 'tbody td:not(.dataTables_empty)', function() {
		$('#table_id tbody tr').removeClass('selected');
		$(this).parent('tr').removeClass('DTTT_selected');
		$(this).parent('tr').addClass('selected');
	});

	$('#table_id_filter input').unbind();

	$('#table_id_filter').html('<label><div class="input-group input-group-sm mbs"><input type="search" class="form-control input-sm" placeholder="" aria-controls="table_id"><span class="input-group-btn"><button type="button" data-toggle="dropdown" class="btn btn-yellow dropdown-toggle" onclick="pesquisar()"><i class="fa fa-search"></i> <?php echo $data[1377]['trad']; ?></button></span></div></label>');

	$('#table_id_filter input').bind('keyup', function(e) {
		if (e.keyCode == 13) {
			table.fnFilter(this.value);
		}

	});
	function pesquisar() {
		table.fnFilter($('#table_id_filter input').val());
	}
	$('#table_id_filter input').bind('keyup', function(e) {
		if (($(this).val().length) == 0) {
			table.fnFilter('');
		}
	});
	function fnGetSelected(tabela) {
		var aReturn = new Array();
		var aTrs = tabela.fnGetNodes();
		for (var i = 0; i < aTrs.length; i++) {
			if ($(aTrs[i]).hasClass('row_selected')) {
				aReturn.push(aTrs[i]);
			}
		}
		return aReturn;
	}

	//END OF TABLE ---------------------------------------------
	
	function gerarDocumento(idDocument){
	<?php if (hasPermission(['P0144']) == 1) { ?>
		$('#idDoc_gerar').val('');
		$('#idDoc_gerar').val(idDocument);
		$('#modal-achats-gerar').modal("show");
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}

	//Terminé le Contrat
	function termineContrat(idDocument, name, datatermo){
	<?php if (hasPermission(['P0145']) == 1) { ?>
		$('#idDoc_Termo').val('');
		$('#doc_name').html('-');
		$('#data_termo').datepicker().datepicker("setDate", "<?php echo date('d/m/Y'); ?>");

		$('#idDoc_Termo').val(idDocument);
		$('#doc_name').html(name);
		if(datatermo && datatermo != '') $('#data_termo').datepicker().datepicker("setDate", datatermo);
		
		$( ".datepicker" ).datepicker("refresh");
		
		$('#modal-achats-termo').modal("show");
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}

	//finalizar
	function finalizarAchat(idAchat, nome){
	<?php if (hasPermission(['P0142']) == 1) { ?>
		var question = "<?php echo $data[624]['trad']; ?> \n" + nome + "?\n\n<?php echo $data[88]['trad']; ?>";
		
		if (confirm(question) == true) {
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/contrats/achats/finalizar.php',
				dataType : 'json',
				data : {
					idAchat : idAchat
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] <?php echo $data[857]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							$.scojs_message("[FAT002] <?php echo $data[857]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							$.scojs_message("<?php echo $data[305]['trad']; ?>", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					var resp = resposta
					if (resp.responseJSON.errors) {
						if(resp.responseJSON.referencia) {
							$.scojs_message("[FAT002] <?php echo $data[979]['trad']; ?>)", $.scojs_message.TYPE_ERROR);
						}else if(resp.responseJSON.data_superior) $.scojs_message("[FAT003] <?php echo $data[961]['trad']; ?> ("+resp.responseJSON.dataUltima+")", $.scojs_message.TYPE_ERROR);
						else $.scojs_message("[FAT004] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						//generate invoice
						generateDocumentAutomaticaly(idAchat)
						//reload
						// setTimeout(function() {
						// 	location.reload();
						// }, 1000);
					}
				}
			});
		} else { return false; }
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}

	<?php if (hasPermission(['P0142']) == 1) { ?>
	//generate automatique invoices
	function generateDocumentAutomaticaly(idDocumento){
		//submite the form
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/gerar_documentos/achat_gera_fatura.php',
			dataType : 'json',
			data : {
				idDocumento : idDocumento,
				firstTime : 1,
			},
			success : function(resposta) {
				var resp = resposta;
				if (resposta == null)
					$.scojs_message("[FAT001] <?php echo $data[1629]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				else {
					if (resposta.errors) {
						$.scojs_message("[FAT002] <?php echo $data[1629]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						$.scojs_message("<?php echo $data[494]['trad']; ?>", $.scojs_message.TYPE_OK);
					}
				}
			},
			complete : function(resposta) {
				var resp = resposta;
				if (resp.responseJSON.errors) {
					$.scojs_message("[FAT003] <?php echo $data[1629]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				} else {
					setTimeout(function() {
						location.reload();
					}, 1000);
				}
			}
		});
	}
	<?php } ?>

	//confirmar documento
	function confirmarAchat(idAchat, nome){
	<?php if (hasPermission(['P0142']) == 1) { ?>
		if (confirm("<?php echo $data[601]['trad']; ?> \n'" + nome + "' ?") == true) {
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/contrats/achats/confirmar.php',
				dataType : 'json',
				data : {
					idAchat : idAchat
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] <?php echo $data[845]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							if (resposta.bloqueada) {
								$.scojs_message("[FAT002] <?php echo $data[191]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							}else if (resposta.dependentes) {
								$.scojs_message("[FAT003] <?php echo $data[776]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							}
							else{
								$.scojs_message("[FAT004] <?php echo $data[845]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							}
						} else {
							$.scojs_message("<?php echo $data[304]['trad']; ?>", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					//reload
					if (resposta.responseJSON.errors) {
					}else{
						setTimeout(function() {
							location.reload();
						}, 1000);
					}
				}
			});
		} else { return false; }
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}

	//anular documento
	function anularAchat(idAchat, nome){
	<?php if (hasPermission(['P0142']) == 1) { ?>
		if (confirm("<?php echo $data[588]['trad']; ?> \n'" + nome + "' ?") == true) {
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/contrats/achats/anular.php',
				dataType : 'json',
				data : {
					idAchat : idAchat
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] <?php echo $data[823]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							if (resposta.bloqueada) {
								$.scojs_message("[FAT002] <?php echo $data[190]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							}else if (resposta.dependentes) {
								$.scojs_message("[FAT003] <?php echo $data[774]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							}
							else{
								$.scojs_message("[FAT004] <?php echo $data[823]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							}
						} else {
							$.scojs_message("<?php echo $data[303]['trad']; ?>", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					//reload
					if (resposta.responseJSON.errors) {
					}else{
						setTimeout(function() {
							location.reload();
						}, 1000);
					}
				}
			});
		} else { return false; }
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}
	
	//remover
	function eliminarAchat(idAchat, nome){
	<?php if (hasPermission(['P0141']) == 1) { ?>
		if (confirm("<?php echo $data[654]['trad']; ?> \n'" + nome + "' ?") == true) {
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/contrats/achats/apagar.php',
				dataType : 'json',
				data : {
					idAchat : idAchat
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] <?php echo $data[869]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							$.scojs_message("[FAT002] <?php echo $data[869]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							$.scojs_message("<?php echo $data[307]['trad']; ?>", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					//reload
					setTimeout(function() {
						location.reload();
					}, 1000);
				}
			});
		} else { return false; }
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}
</script>