<?php 
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1639,1698,1633,1565,1472,1447,1702,1704,1503,1312,1310,421,1377,145,286,1267,66,428,729,1065,1138,1093,563,570,904,67,1505,605,851,200,781,479,952,629,90,88,862,481,980,965,592,828,199,792,478,659,874,483,838,480);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<script type="text/javascript">
	table = $('#table_id').dataTable({
		"dom" : '<lfrtip><"clear">',
		"sRowSelect" : "os",
		"sRowSelector" : 'td:first-child',
		"lengthMenu" : [[25, 50, 100, -1], [25, 50, 100, "<?php echo $data[1565]['trad']; ?>"]],
		"iDisplayLength" : 100,
		"aaSorting" : [[0, "desc"]],
		"bProcessing" : true,
		"bServerSide" : true,
		"sAjaxSource" : "/frifacturation/server/datatable/devis.php",
		"oLanguage" : {
			"sLengthMenu" : "<?php echo $data[1472]['trad']; ?>",
			"sZeroRecords" : "<?php echo $data[1447]['trad']; ?>",
			"sInfo" : "<?php echo $data[1702]['trad']; ?>",
			"sInfoEmpty" : "<?php echo $data[1704]['trad']; ?>",
			"sProcessing" : "<div></div>",
			"sInfoFiltered" : "",
			"oPaginate" : {
				"sNext" : "<?php echo $data[1503]['trad']; ?>",
				"sFirst" : "<?php echo $data[1312]['trad']; ?>",
				"sPrevious" : "<?php echo $data[1310]['trad']; ?>",
				"sLast" : "<?php echo $data[421]['trad']; ?>"
			}
		},
		"aoColumns" : [null, null, null, null, 
		{
			"bVisible" : false,
		}, 
		null, null,
		{
			"sClass" : "text-right",
		},
		{
			"sClass" : "text-center",
			"bVisible" : true,
		},
		{
			"bVisible" : true,
			"bSortable" : false,
			"bSearchable" : true,
			"sClass" : "text-center",
		}
		],
		"aoColumnDefs" : [
		{
			"aTargets" : [0],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[8] == 'Rascunho') element = '<span style="color: orange;">---</span>';
				if(full[8] == 'Aberto') element = '<span style="color: blue;">'+full[0]+'</span>';
				if(full[8] == 'Confirmado') element = '<span style="color: green;">'+full[0]+'</span>';
				if(full[8] == 'Anulado') element = '<span style="color: black;">'+full[0]+'</span>';
				//else element = full[0];
				//return html
				return element;
			}
		},
		{
			"aTargets" : [1],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[1] == '' || full[1] == null) element = '----';
				else element = full[1];
				//return html
				return element;
			}
		},
		{
			"aTargets" : [2],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[2]) element = full[2];
				else element = '-';

				//return html
				return '<span class="ellipsis" data-size="35">'+element+'</span>';
			}
		},
		{
			"aTargets" : [3],
			"mRender" : function(data, type, full) {
				//return html
				raison = full[10];
				css = "";
				if(raison){
					raison = full[10].trim();
				}
				info = full[3]
				if(info){
					info = full[3].trim();
				}
				if( raison ){
					info = raison+' - '+info;
					css = "color:red;font-weight:bold;";
				}
				return '<span class="ellipsis" data-size="28" style="'+css+'">'+info+'</span>';
			}
		},
		{
			"aTargets" : [5],
			"mRender" : function(data, type, full) {
				var element = '';
				var tmp = full[5].split("-");
				var tmpNew = tmp[0]+'/'+tmp[1]+'/'+tmp[2];
				var tmpLBL = tmp[2]+'/'+tmp[1]+'/'+tmp[0];
				element = '<span id="data_fatura_'+full[9]+'" data-normalizeDate="'+tmpNew+'">'+tmpLBL+'</span>';
				//return html
				return element;
			}
		},
		{
			"aTargets" : [6],
			"mRender" : function(data, type, full) {
				var element = '';
				var tmp = full[6].split("-");
				var tmpNew = tmp[0]+'/'+tmp[1]+'/'+tmp[2];
				var tmpLBL = tmp[2]+'/'+tmp[1]+'/'+tmp[0];
				element = '<span id="data_fatura_'+full[9]+'" data-normalizeDate="'+tmpNew+'">'+tmpLBL+'</span>';
				//return html
				return element;
			}
		},
		{
			"aTargets" : [7],
			"mRender" : function(data, type, full) {
				var element = '';
				element ='<span class="money">'+full[7]+'</span>';

				//init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});

				return element;
			}
		},
		{
			"aTargets" : [8],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[8] == 'Rascunho') element = '<span class="label label-orange"><?php echo $data[145]['trad']; ?></span>';
				if(full[8] == 'Confirmado') element = '<span class="label label-green"><?php echo $data[286]['trad']; ?></span>';
				if(full[8] == 'Aberto') element = '<span class="label label-blue"><?php echo $data[1267]['trad']; ?></span>';
				if(full[8] == 'Anulado') element = '<span class="label label-red"><?php echo $data[66]['trad']; ?></span>';
				//return html
				return element;
			}
		},
		{
			"aTargets" : [9],
			"mRender" : function(data, type, full) {
				var tmp = full[5].split("-");
				var tmpLBL = tmp[2]+'/'+tmp[1]+'/'+tmp[0];
				var docNumber = '';
				if(full[8] != 'Rascunho') docNumber = " - "+ full[0];
				var processedName = full[3].replace(/'/gi, " "); processedName = processedName.replace(/"/gi, " ");
				var processedReference = full[2].replace(/'/gi, " "); processedName = processedName.replace(/"/gi, " ");
				var nome = "'"+tmpLBL+ docNumber+" - " + processedReference +": " + processedName +"'";
				var html = '';
				var typeDoc = "'DV'";

				html += '<a href="details?devis='+ full[9] +'" class="options-link text-info"><i class="fa fa-eye" title="<?php echo $data[428]['trad']; ?>"></i></a>';

				//edition options
				if( full[8] != 'Rascunho' ){
					html += '<a href="modifier_lines?devis='+full[9]+'" class="options-link text-orange"><i class="fa fa-terminal" title="<?php echo $data[1138]['trad']; ?>"></i></a>';

					html += '<a class="options-link text-violet" onclick="gerarDocumento('+ full[9] +')" title="<?php echo $data[729]['trad']; ?>"><i class="fa fa-files-o"></i></a>';

					if( full[8] == 'Aberto' ){
						html += '<a class="options-link text-green" onclick="confirmarDevis('+ full[9] +','+nome+')" title="<?php echo $data[1065]['trad']; ?>"><i class="fa fa-check"></i></a>';
					}
				}else{
					html += '<a href="modifier?devis='+full[9]+'" class="options-link text-orange"><i class="fa fa-edit" title="<?php echo $data[1093]['trad']; ?>"></i></a>';
					
					html += '<a class="options-link text-green" onclick="finalizarDevis('+ full[9] +', '+nome+')" title="<?php echo $data[563]['trad']; ?>"><i class="fa fa-flag-checkered"></i></a>';
				}

				if(full[8] != 'Rascunho' && full[8] != 'Anulado' ) {
					html += '<a class="options-link text-blue" onclick="enviarDevis('+ full[9] +', '+nome+')" title="<?php echo $data[570]['trad']; ?>"><i class="fa fa-paper-plane"></i></a>';
				}

				
				html += '<a href="/frifacturation/server/imprimer_pdf/exporter_devis.php?idDoc='+full[9]+'" target="_blank" class="options-link text-grey"><i class="fa fa-print" title="<?php echo $data[904]['trad']; ?>"></i></a>';

				if(full[8] == 'Aberto'){
					<?php if (hasPermission(['P0120']) == 1) {  ?>
						html += '<a class="options-link text-red" onclick="anularDevis('+ full[9] +', '+nome+')" title="<?php echo $data[67]['trad']; ?>"><i class="fa fa-times"></i></a>';
					<?php } ?>
				}

				if(full[8] == 'Rascunho') {
					html += '<a class="options-link text-red" onclick="eliminarDevis('+ full[9] +', '+nome+')" title="<?php echo $data[1505]['trad']; ?>"><i class="fa fa-trash"></i></a>';
				}

				//return all html composed
				return html;
			}
		}],

		"fnRowCallback" : function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
			$(nRow).attr("dbID", aData[9]);

			if(aData[8] == 'Anulado') $(nRow).css("text-decoration", "line-through");

			return nRow;
		},
		"fnDrawCallback" : function(oSettings) {
            $(".ellipsis").ellipsis(); 
		},

		"footerCallback" : function(row, data, start, end, display) {
            var api = this.api(), data;

            // Remove the formatting to get integer data for summation
            var intVal = function(i) {
                return typeof i === 'string' ? i.replace(/[\$,]/g, '') * 1 : typeof i === 'number' ? i : 0;
            };

            // Total current page
            var valorTotal = api.column(7, { page: 'current'}).data().reduce(function(a, b) {
                return intVal(a) + intVal(b);
            }, 0);

            //Por liquidar -> Used extra field to calculate already rounded for a better real value
			$('body').append( $("<span />").val(0).addClass('money').attr('id','valorDocTemp') );
			$(".money").autoNumeric("init", {
				aSep : '\'',
				aDec : '.',
				aSign : ' CHF',
				pSign : 's',
				//vMin:'0',
				mDec : <?php echo $numDecimais; ?>
			});
			
			$( "#valorDocTemp" ).autoNumeric('set', valorTotal);
			valorTotal = $( "#valorDocTemp" ).autoNumeric('get');

			$( "#valorDocTemp" ).remove();

            //final calculation
            //-------------------------------------------------------------------------------------
            
            $('.money').not(".table-menu > tbody > tr > td > span").html("");
            $('.money').not(".table-menu > tbody > tr > td > span").autoNumeric("set", 0);
            
            // Update footer
            $(api.column(7).footer()).html('<span class="money">' + valorTotal + '</span>');
        }

	});

	$('#table_id').on('click', 'tbody td:not(.dataTables_empty)', function() {
		$('#table_id tbody tr').removeClass('selected');
		$(this).parent('tr').removeClass('DTTT_selected');
		$(this).parent('tr').addClass('selected');
	});

	$('#table_id_filter input').unbind();

	$('#table_id_filter').html('<label><div class="input-group input-group-sm mbs"><input type="search" class="form-control input-sm" placeholder="" aria-controls="table_id"><span class="input-group-btn"><button type="button" data-toggle="dropdown" class="btn btn-yellow dropdown-toggle" onclick="pesquisar()"><i class="fa fa-search"></i> <?php echo $data[1377]['trad']; ?></button></span></div></label>');

	$('#table_id_filter input').bind('keyup', function(e) {
		if (e.keyCode == 13) {
			table.fnFilter(this.value);
		}

	});
	function pesquisar() {
		table.fnFilter($('#table_id_filter input').val());
	}
	$('#table_id_filter input').bind('keyup', function(e) {
		if (($(this).val().length) == 0) {
			table.fnFilter('');
		}
	});
	function fnGetSelected(tabela) {
		var aReturn = new Array();
		var aTrs = tabela.fnGetNodes();
		for (var i = 0; i < aTrs.length; i++) {
			if ($(aTrs[i]).hasClass('row_selected')) {
				aReturn.push(aTrs[i]);
			}
		}
		return aReturn;
	}

	//END OF TABLE ---------------------------------------------
	
	
	function gerarDocumento(idDocument){
	<?php if (hasPermission(['P0121']) == 1) { ?>
		$('#idDoc_gerar').val('');
		$('#idDoc_gerar').val(idDocument);
		$('#modal-devis-gerar').modal("show");
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}

	//confirmar documento
	function confirmarDevis(idDevis, nome){
	<?php if (hasPermission(['P0119']) == 1) { ?>
		if (confirm("<?php echo $data[605]['trad']; ?> \n'" + nome + "' ?") == true) {
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/devis/confirmar.php',
				dataType : 'json',
				data : {
					idDevis : idDevis
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] <?php echo $data[851]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							if (resposta.bloqueada) {
								$.scojs_message("[FAT002] <?php echo $data[200]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							}else if (resposta.dependentes) {
								$.scojs_message("[FAT003] <?php echo $data[781]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							}
							else{
								$.scojs_message("[FAT004] <?php echo $data[851]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							}
						} else {
							$.scojs_message("<?php echo $data[479]['trad']; ?>", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					//reload
					if (resposta.responseJSON.errors) {
					}else{
						setTimeout(function() {
							location.reload();
						}, 1000);
					}
				}
			});
		} else { return false; }
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}
	
	//check if selected date is bigger than today
	function checkDataBiggerThanToday(inputID){
		var result;

		var dt_Today = new Date();
		var dt_begin = new Date( $('#'+inputID).attr('data-normalizeDate') );
		console.log(dt_begin);
		//set hours, minutes and seconds to 0
		dt_Today.setHours(0);
		dt_Today.setMinutes(0);
		dt_Today.setSeconds(0);
		dt_begin.setHours(0);
		dt_begin.setMinutes(0);
		dt_begin.setSeconds(0);
		//check dates
		if ( Date.parse(dt_begin) > Date.parse(dt_Today)) {
			result = true;
		} else {
			result = false;
		}

	    return result;
	}

	//finalizar
	function finalizarDevis(idDevis, nome){
	<?php if (hasPermission(['P0119']) == 1) { ?>
		var inputID = 'data_fatura_'+idDevis;
		var result = checkDataBiggerThanToday(inputID);
		var dataFatura = $('#'+inputID).html();
		var question = '';
		if(result == true) question = "<?php echo $data[952]['trad']; ?>\n\n<?php echo $data[629]['trad']; ?>\n\n<?php echo $data[90]['trad']; ?> ["+dataFatura+"].";
		else question = "<?php echo $data[629]['trad']; ?> \n" + nome + "?\n\n<?php echo $data[88]['trad']; ?>";
		
		if (confirm(question) == true) {
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/devis/finalizar.php',
				dataType : 'json',
				data : {
					idDevis : idDevis
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] <?php echo $data[862]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							$.scojs_message("[FAT002] <?php echo $data[862]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							$.scojs_message("<?php echo $data[481]['trad']; ?>", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					var resp = resposta
					if (resp.responseJSON.errors) {
						if(resp.responseJSON.referencia) {
							$.scojs_message("[FAT002] <?php echo $data[980]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						}else if(resp.responseJSON.data_superior) $.scojs_message("[FAT003] <?php echo $data[965]['trad']; ?> ("+resp.responseJSON.dataUltima+")", $.scojs_message.TYPE_ERROR);
						else $.scojs_message("[FAT004] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						//reload
						setTimeout(function() {
							location.reload();
						}, 1000);
					}
				}
			});
		} else { return false; }
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}

	//anular documento
	function anularDevis(idDevis, nome){
	<?php if (hasPermission(['P0119']) == 1) { ?>
		if (confirm("<?php echo $data[592]['trad']; ?> \n'" + nome + "' ?") == true) {
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/devis/anular.php',
				dataType : 'json',
				data : {
					idDevis : idDevis
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] <?php echo $data[828]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							if (resposta.bloqueada) {
								$.scojs_message("[FAT002] <?php echo $data[199]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							}else if (resposta.dependentes) {
								$.scojs_message("[FAT003] <?php echo $data[792]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							}
							else{
								$.scojs_message("[FAT004] <?php echo $data[828]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							}
						} else {
							$.scojs_message("<?php echo $data[478]['trad']; ?>", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					//reload
					if (resposta.responseJSON.errors) {
					}else{
						setTimeout(function() {
							location.reload();
						}, 1000);
					}
				}
			});
		} else { return false; }
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}
	
	//remover
	function eliminarDevis(idDevis, nome){
	<?php if (hasPermission(['P0120']) == 1) { ?>
		if (confirm("<?php echo $data[659]['trad']; ?> \n'" + nome + "' ?") == true) {
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/devis/apagar.php',
				dataType : 'json',
				data : {
					idDevis : idDevis
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] <?php echo $data[874]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							$.scojs_message("[FAT002] <?php echo $data[874]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							$.scojs_message("<?php echo $data[483]['trad']; ?>", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					//reload
					setTimeout(function() {
						location.reload();
					}, 1000);
				}
			});
		} else { return false; }
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}

	//Enviar email
	function enviarDevis(idDevis, nome){
	<?php if (hasPermission(['P0117']) == 1) { ?>
		$('#document_iden').val('');
		$('#document_iden').val(idDevis);
		$('#confirmar_envio_detalhes').html('-');
		$('#confirmar_envio_detalhes').html(nome);
		fill_senderEmail(idDevis);
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}

	//confirm email sender
	function confirmDevisSender(idDevis, email_sender){
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/devis/email.php',
			dataType : 'json',
			data : {
				idDoc : idDevis,
				senderEmail : email_sender
			},
			success : function(resposta) {
				var resp = resposta;
				if (resposta == null)
					$.scojs_message("[FAT001] <?php echo $data[838]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				else {
					if (resposta.errors) {
						$.scojs_message("[FAT002] <?php echo $data[838]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						$.scojs_message("<?php echo $data[480]['trad']; ?>", $.scojs_message.TYPE_OK);
					}
				}
			},
			complete : function(resposta) {
				$.scojs_message("<?php echo $data[480]['trad']; ?>", $.scojs_message.TYPE_OK);
				//reload
				setTimeout(function() {
					location.reload();
				}, 1000);
			}
		});
	}
</script>