<?php 
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1639,1698,1633,1565,1472,1447,1702,1704,1503,1312,1310,421,1377,428,729,1138,1273,1375,563,904,907,570,67,1505,622,92,88,948,866,1707,983,957,584,832,201,796,832,682,648,887,687,839,683,1440,1442,582,581,821,502);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<script type="text/javascript">
	table = $('#table_id').dataTable({
		"dom" : '<lfrtip><"clear">',
		"sRowSelect" : "os",
		"sRowSelector" : 'td:first-child',
		"lengthMenu" : [[25, 50, 100, -1], [25, 50, 100, "<?php echo $data[1565]['trad']; ?>"]],
		"iDisplayLength" : 100,
		"aaSorting" : [[1, "desc"]],
		"bProcessing" : true,
		"bServerSide" : true,
		"sAjaxSource" : "/frifacturation/server/datatable/faturas.php",
		"oLanguage" : {
			"sLengthMenu" : "<?php echo $data[1472]['trad']; ?>",
			"sZeroRecords" : "<?php echo $data[1447]['trad']; ?>",
			"sInfo" : "<?php echo $data[1702]['trad']; ?>",
			"sInfoEmpty" : "<?php echo $data[1704]['trad']; ?>",
			"sProcessing" : "<div></div>",
			"sInfoFiltered" : "",
			"oPaginate" : {
				"sNext" : "<?php echo $data[1503]['trad']; ?>",
				"sFirst" : "<?php echo $data[1312]['trad']; ?>",
				"sPrevious" : "<?php echo $data[1310]['trad']; ?>",
				"sLast" : "<?php echo $data[421]['trad']; ?>"
			}
		},
		"aoColumns" : [
		{
			"bVisible" : true,
			"bSortable" : false,
			"bSearchable" : false,
			"sClass" : "text-center",
		}, null, null, null, null, null,
		{
			"sClass" : "text-right",
		},
		{
			"sClass" : "text-right",
		}, 
		{
			"bVisible" : true,
			"bSortable" : false,
			"bSearchable" : true,
			"sClass" : "text-center",
		},
		{
			"bVisible" : false,
		},
		{
			"bVisible" : false,
		},
		{
			"bVisible" : false,
		},
		{
			"bVisible" : false,
		},
		{
			"bVisible" : false,
		}],
		"aoColumnDefs" : [
		{
			"aTargets" : [0],
			"mRender" : function(data, type, full) {
				var tmp = full[4].split("-");
				var tmpLBL = tmp[2]+'/'+tmp[1]+'/'+tmp[0];
				var docNumber = '';
				var processedName = full[3].replace(/'/gi, " "); processedName = processedName.replace(/"/gi, " ");
				var nome = "'"+tmpLBL+ docNumber+" - " + processedName +"'";

				var html2 = '-';
				
				if(full[8] == 'Rascunho') {
					html2 = '<a class="options-link text-red" onclick="eliminarFatura('+ full[9] +', '+nome+')" title="<?php echo $data[1505]['trad']; ?>"><i class="fa fa-trash"></i></a>';

					html2 = '<input type="checkbox" name="row_checkbox_'+this.ID_Leitura+'" class="row_checkbox" id="row_checkbox_'+full[9]+'" data-id="'+full[9]+'" data-cliID="'+full[11]+'"/>';

					$("input#global_checkbox").iCheck("enable");
					$(".endBtns").attr("disabled", false);
				}
				return html2;
			}
		},
		{
			"aTargets" : [1],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[8] == 'Rascunho') element = '<span style="color: orange;">---</span>';
				if(full[8] == 'Pago') element = '<span style="color: green;">'+full[1]+'</span>';
				if(full[8] == 'Aberto') element = '<span style="color: blue;">'+full[1]+'</span>';
				if(full[8] == 'Anulado') element = '<span style="color: black;">'+full[1]+'</span>';
				//else element = full[1];
				//return html
				return element;
			}
		},
		{
			"aTargets" : [2],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[2]) element = full[2];
				else element = '-';

				//return html
				return '<span class="ellipsis" data-size="28">'+element+'</span>';
			}
		},
		{
			"aTargets" : [3],
			"mRender" : function(data, type, full) {
				raison = full[15];
				css = "";
				if(raison){
					raison = full[15].trim();
				}
				info = full[3]
				if(info){
					info = full[3].trim();
				}
				if( raison ){
					info = raison+' - '+info;
					css = "color:red;font-weight:bold;";
				}
				//return html
				return '<span class="ellipsis" data-size="24" style="'+css+'">'+info+'</span>';
			}
		},
		{
			"aTargets" : [4],
			"mRender" : function(data, type, full) {
				var element = '';
				
				var tmp = full[4].split("-");
				var tmpNew = tmp[0]+'/'+tmp[1]+'/'+tmp[2];
				var tmpLBL = tmp[2]+'/'+tmp[1]+'/'+tmp[0];
				element = '<span id="data_fatura_'+full[9]+'" data-normalizeDate="'+tmpNew+'">'+tmpLBL+'</span>';
				//return html
				return element;
			}
		},
		{
			"aTargets" : [5],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[5]){
				var tmp = full[5].split("-");
				var tmpNew = tmp[0]+'/'+tmp[1]+'/'+tmp[2];
				var tmpLBL = tmp[2]+'/'+tmp[1]+'/'+tmp[0];
				element = '<span id="data_fatura_'+full[9]+'" data-normalizeDate="'+tmpNew+'">'+tmpLBL+'</span>';
				} else {
					element = '<span id="data_fatura_'+full[9]+'" ">-</span>';
				}
				//return html
				return element;
			}
		},
		{
			"aTargets" : [6],
			"mRender" : function(data, type, full) {
				var element = '';
				element ='<span class="money">'+full[6]+'</span>';

				//init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});

				return element;
			}
		},
		{
			"aTargets" : [7],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[7] < 0) colorLabel = 'text-red';
            	else colorLabel = 'text-green';
				element ='<span class="money '+colorLabel+'">'+full[7]+'</span>';

				//init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});

				return element;
			}
		},
		{
			"aTargets" : [8],
			"mRender" : function(data, type, full) {
				var tmp = full[4].split("-");
				var tmpLBL = tmp[2]+'/'+tmp[1]+'/'+tmp[0];
				var docNumber = '';
				if(full[8] != 'Rascunho') docNumber = " - "+ full[1];
				var processedName = full[3].replace(/'/gi, " "); processedName = processedName.replace(/"/gi, " ");
				var nome = "'"+tmpLBL+ docNumber+" - " + processedName +"'";
				var html = '';
				var typeDoc = "'FA'";
				var processedRappel = full[14].replace(/'/gi, " "); processedRappel = processedRappel.replace(/"/gi, " ");
				processedRappel = "'"+processedRappel+"'";

				html += '<a href="details?facture='+ full[9] +'" class="options-link text-info"><i class="fa fa-eye" title="<?php echo $data[428]['trad']; ?>"></i></a>';

				//edition options
				
				if( full[8] == 'Pago' || full[8] == 'Anulado' ){
					html += '<a href="modifier_lines?facture='+full[9]+'" class="options-link text-orange"><i class="fa fa-terminal" title="<?php echo $data[1138]['trad']; ?>"></i></a>';
				}else{
					html += '<a href="modifier?facture='+full[9]+'" class="options-link text-orange"><i class="fa fa-edit" title="<?php echo $data[1093]['trad']; ?>"></i></a>';
				}
				
				if( full[8] != 'Rascunho' ){

					html += '<a class="options-link text-violet" onclick="gerarDocumento('+ full[9] +')" title="<?php echo $data[729]['trad']; ?>"><i class="fa fa-files-o"></i></a>';
					if( full[8] == 'Aberto' || full[8] == 'Pago' ){
						html += '<a class="options-link text-green" onclick="lancarPagamento('+ full[9] +','+typeDoc+')" title="<?php echo $data[1273]['trad']; ?>"><i class="fa fa-dollar"></i></a>';
					}
					html += '<a class="options-link text-blue" onclick="verPagamentos('+ full[9] +','+typeDoc+')" title="<?php echo $data[1375]['trad']; ?>"><i class="fa fa-list-ul"></i></a>';
				}else{
					
					html += '<a class="options-link text-green" onclick="finalizarFatura('+ full[9] +', '+nome+')" title="<?php echo $data[563]['trad']; ?>"><i class="fa fa-flag-checkered"></i></a>';
				}
				if(full[12] == 1){
					html += '<a href="#" class="options-link text-grey" onClick="enviarFaturaQR('+full[9]+','+nome+','+processedRappel+',\'full\',1)" title="<?php echo $data[904]['trad']; ?>"><i class="fa fa-print"></i></a>';
				} else {
					html += '<a onClick="enviarFaturaQR('+full[9]+','+nome+','+processedRappel+',\'full\',0)" class="options-link text-grey"><i class="fa fa-print" title="<?php echo $data[904]['trad']; ?>"></i></a>';
				}
				
				
				
				if( full[8] == 'Aberto' || full[8] == 'Pago'){
					//html += '<a class="options-link text-blue" onClick="enviarFaturaQR('+full[9]+','+nome+','+processedRappel+',\'mail\')" title="Envoyer"><i class="fa fa-paper-plane"></i></a>';
					if( full[10] != ''){
						//html += '<a onClick="enviarFaturaQR('+full[9]+','+nome+','+processedRappel+',\'slip\')" class="options-link text-grey"><i class="fa fa-file" title="<?php echo $data[907]['trad']; ?>"></i></a>';
						if(full[12] == 1){
							html += '<a class="options-link text-brown" href="#" onClick="enviarFaturaQR('+full[9]+','+nome+','+processedRappel+',\'slip\',1)" title="<?php echo $data[904]['trad']; ?>"><i class="fa fa-file" title="<?php echo $data[907]['trad']; ?>"></i></a>';
							html += '<a class="options-link text-blue" href="#" onClick="enviarFaturaQR('+full[9]+','+nome+','+processedRappel+',\'mail\',1)" title="<?php echo $data[570]['trad']; ?>"><i class="fa fa-paper-plane" title="<?php echo $data[570]['trad']; ?>"></i></a>';
						} else {
							html += '<a class="options-link text-brown" href="#" onClick="enviarFaturaQR('+full[9]+','+nome+','+processedRappel+',\'slip\',0)" title="<?php echo $data[904]['trad']; ?>"><i class="fa fa-file" title="<?php echo $data[907]['trad']; ?>"></i></a>';
							html += '<a class="options-link text-blue" href="#" onClick="enviarFaturaQR('+full[9]+','+nome+','+processedRappel+',\'mail\',0)" title="<?php echo $data[570]['trad']; ?>"><i class="fa fa-paper-plane" title="<?php echo $data[570]['trad']; ?>"></i></a>';
						}
					} 
				}

				if(full[8] == 'Aberto'){
					<?php //if( adminCheckerFat($_SESSION['id_utilizador']) == 1 ){ ?>
					<?php if (hasPermission(['P0027']) == 1) { ?>
						html += '<a class="options-link text-red" onclick="anularFatura('+ full[9] +', '+nome+')" title="<?php echo $data[67]['trad']; ?>"><i class="fa fa-times"></i></a>';
					<?php } ?>
				}

				if(full[8] == 'Rascunho') {
					html += '<a class="options-link text-red" onclick="eliminarFatura('+ full[9] +', '+nome+')" title="<?php echo $data[1505]['trad']; ?>"><i class="fa fa-trash"></i></a>';
				}

				//return all html composed
				return html;
			}
		}],

		"fnRowCallback" : function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
			$(nRow).attr("dbID", aData[10]);

			if(aData[8] == 'Anulado') $(nRow).css("text-decoration", "line-through");

			return nRow;
		},
		"fnDrawCallback" : function(oSettings) {
            $(".ellipsis").ellipsis(); 
		},

		"footerCallback" : function(row, data, start, end, display) {
            var api = this.api(), data;

            // Remove the formatting to get integer data for summation
            var intVal = function(i) {
                return typeof i === 'string' ? i.replace(/[\$,]/g, '') * 1 : typeof i === 'number' ? i : 0;
            };

            // Total current page
            var valorTotal = api.column(6, { page: 'current'}).data().reduce(function(a, b) {
                return intVal(a) + intVal(b);
            }, 0);
            // Total current page
            var valorSolde = api.column(7, { page: 'current'}).data().reduce(function(a, b) {
                return intVal(a) + intVal(b);
            }, 0);

            //Por liquidar -> Used extra field to calculate already rounded for a better real value
			$('body').append( $("<span />").val(0).addClass('money').attr('id','valorDocTemp') );
			$(".money").autoNumeric("init", {
				aSep : '\'',
				aDec : '.',
				aSign : ' CHF',
				pSign : 's',
				//vMin:'0',
				mDec : <?php echo $numDecimais; ?>
			});
			
			$( "#valorDocTemp" ).autoNumeric('set', valorTotal);
			valorTotal = $( "#valorDocTemp" ).autoNumeric('get');
			$( "#valorDocTemp" ).autoNumeric('set', valorSolde);
			valorSolde = $( "#valorDocTemp" ).autoNumeric('get');

			$( "#valorDocTemp" ).remove();

            //final calculation
            //-------------------------------------------------------------------------------------
            
            $('.money').not(".table-menu > tbody > tr > td > span").html("");
            $('.money').not(".table-menu > tbody > tr > td > span").autoNumeric("set", 0);

            if(valorSolde < 0) colorLabel = 'text-red';
            else colorLabel = 'text-green';
            // Update footer
            $(api.column(6).footer()).html('<span class="money">' + valorTotal + '</span>');
            $(api.column(7).footer()).html('<span class="money '+colorLabel+'">' + valorSolde + '</span>');
        }

	});

	$('#table_id').on('click', 'tbody td:not(.dataTables_empty)', function() {
		$('#table_id tbody tr').removeClass('selected');
		$(this).parent('tr').removeClass('DTTT_selected');
		$(this).parent('tr').addClass('selected');
	});

	$('#table_id_filter input').unbind();

	$('#table_id_filter').html('<label><div class="input-group input-group-sm mbs"><input type="search" class="form-control input-sm" placeholder="" aria-controls="table_id"><span class="input-group-btn"><button type="button" data-toggle="dropdown" class="btn btn-yellow dropdown-toggle" onclick="pesquisar()"><i class="fa fa-search"></i> <?php echo $data[1377]['trad']; ?></button></span></div></label>');

	$('#table_id_filter input').bind('keyup', function(e) {
		if (e.keyCode == 13) {
			table.fnFilter(this.value);
		}

	});
	function pesquisar() {
		table.fnFilter($('#table_id_filter input').val());
	}
	$('#table_id_filter input').bind('keyup', function(e) {
		if (($(this).val().length) == 0) {
			table.fnFilter('');
		}
	});
	function fnGetSelected(tabela) {
		var aReturn = new Array();
		var aTrs = tabela.fnGetNodes();
		for (var i = 0; i < aTrs.length; i++) {
			if ($(aTrs[i]).hasClass('row_selected')) {
				aReturn.push(aTrs[i]);
			}
		}
		return aReturn;
	}

	//END OF TABLE ---------------------------------------------
	
	
	
	function gerarDocumento(idDocument){
	<?php if (hasPermission(['P0029']) == 1) { ?>
		$('#idDoc_gerar').val('');
		$('#idDoc_gerar').val(idDocument);
		$('#modal-faturas-gerar').modal("show");
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}

	//Paiement
	function lancarPagamento(idDocument, typeDoc){
	<?php if (hasPermission(['P0030']) == 1) { ?>
		//call the init script
		fill_dados_pagamento(idDocument, typeDoc);
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}

	//ver recibos
	function verPagamentos(idDocument, typeDoc){
	<?php if (hasPermission(['P0030']) == 1) { ?>
		//call the init script
		fill_list_payments(idDocument, typeDoc);
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}
	
	//check if selected date is bigger than today
	function checkDataBiggerThanToday(inputID){
		var result;

		var dt_Today = new Date();
		var dt_begin = new Date( $('#'+inputID).attr('data-normalizeDate') );
		console.log(dt_begin);
		//set hours, minutes and seconds to 0
		dt_Today.setHours(0);
		dt_Today.setMinutes(0);
		dt_Today.setSeconds(0);
		dt_begin.setHours(0);
		dt_begin.setMinutes(0);
		dt_begin.setSeconds(0);
		//check dates
		if ( Date.parse(dt_begin) > Date.parse(dt_Today)) {
			result = true;
		} else {
			result = false;
		}

	    return result;
	}

	//finalizar
	function finalizarFatura(idFatura, nome){
	<?php if (hasPermission(['P0026']) == 1) { ?>
		var inputID = 'data_fatura_'+idFatura;
		var result = checkDataBiggerThanToday(inputID);
		var dataFatura = $('#'+inputID).html();
		var question = '';
		if(result == true) question = "<?php echo $data[948]['trad']; ?>\n\n<?php echo $data[622]['trad']; ?>\n\n<?php echo $data[92]['trad']; ?> ["+dataFatura+"].";
		else question = "<?php echo $data[622]['trad']; ?> \n" + nome + "?\n\n<?php echo $data[88]['trad']; ?>";
		
		if (confirm(question) == true) {
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/faturas/finalizar.php',
				dataType : 'json',
				data : {
					idFatura : idFatura
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] <?php echo $data[866]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							$.scojs_message("[FAT002] <?php echo $data[866]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							$.scojs_message("<?php echo $data[1707]['trad']; ?>", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					var resp = resposta
					if (resp.responseJSON.errors) {
						if(resp.responseJSON.referencia) {
							$.scojs_message("[FAT002] <?php echo $data[983]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						}else if(resp.responseJSON.data_superior) $.scojs_message("[FAT003] <?php echo $data[957]['trad']; ?> ("+resp.responseJSON.dataUltima+")", $.scojs_message.TYPE_ERROR);
						else $.scojs_message("[FAT004] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						//reload
						setTimeout(function() {
							location.reload();
						}, 1000);
					}
				}
			});
		} else { return false; }
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}

	//anular documento
	function anularFatura(idFatura, nome){
	<?php if (hasPermission(['P0026']) == 1) { ?>
		if (confirm("<?php echo $data[584]['trad']; ?> \n'" + nome + "' ?") == true) {
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/faturas/anular.php',
				dataType : 'json',
				data : {
					idFatura : idFatura
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] <?php echo $data[832]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							if (resposta.bloqueada) {
								$.scojs_message("[FAT002] <?php echo $data[201]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							}else if (resposta.dependentes) {
								$.scojs_message("[FAT003] <?php echo $data[796]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							}
							else{
								$.scojs_message("[FAT004] <?php echo $data[832]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							}
						} else {
							$.scojs_message("<?php echo $data[682]['trad']; ?>", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					//reload
					if (resposta.responseJSON.errors) {
					}else{
						setTimeout(function() {
							location.reload();
						}, 1000);
					}
				}
			});
		} else { return false; }
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}
	
	//remover
	function eliminarFatura(idFatura, nome){
	<?php if (hasPermission(['P0027']) == 1) { ?>
		if (confirm("<?php echo $data[648]['trad']; ?> \n'" + nome + "' ?") == true) {
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/faturas/apagar.php',
				dataType : 'json',
				data : {
					idFatura : idFatura
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] <?php echo $data[887]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							$.scojs_message("[FAT002] <?php echo $data[887]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							$.scojs_message("<?php echo $data[687]['trad']; ?>", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					//reload
					setTimeout(function() {
						location.reload();
					}, 1000);
				}
			});
		} else { return false; }
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}

	//Enviar email
	function enviarFatura(idFatura, nome){
	<?php if (hasPermission(['P0028']) == 1) { ?>
		$('#document_iden').val('');
		$('#document_iden').val(idFatura);
		$('#confirmar_envio_detalhes').html('-');
		$('#confirmar_envio_detalhes').html(nome);
		fill_senderEmail(idFatura);
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}

	//confirm email sender
	function confirmFaturaSender(idFatura, email_sender){
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/faturas/email.php',
			dataType : 'json',
			data : {
				idDoc : idFatura,
				senderEmail : email_sender
			},
			success : function(resposta) {
				var resp = resposta;
				if (resposta == null)
					$.scojs_message("[FAT001] <?php echo $data[839]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				else {
					if (resposta.errors) {
						$.scojs_message("[FAT002] <?php echo $data[839]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						$.scojs_message("<?php echo $data[683]['trad']; ?>", $.scojs_message.TYPE_OK);
					}
				}
			},
			complete : function(resposta) {
				$.scojs_message("<?php echo $data[683]['trad']; ?>", $.scojs_message.TYPE_OK);
				//reload
				setTimeout(function() {
					location.reload();
				}, 1000);
			}
		});
	}
	
	//email -- antigo
	// function enviarFatura(idFatura, nome){
	// 	if (confirm("Êtes-vous sûr de vouloir envoyer par courrier électronique la facture de \n'" + nome + "' ?") == true) {
	// 		$.ajax({
	// 			type : 'POST',
	// 			url : '/frifacturation/server/faturas/email.php',
	// 			dataType : 'json',
	// 			data : {
	// 				idDoc : idFatura
	// 			},
	// 			success : function(resposta) {
	// 				var resp = resposta;
	// 				if (resposta == null)
	// 					$.scojs_message("[FAT001] <?php echo $data[839]['trad']; ?>", $.scojs_message.TYPE_ERROR);
	// 				else {
	// 					if (resposta.errors) {
	// 						$.scojs_message("[FAT002] <?php echo $data[839]['trad']; ?>", $.scojs_message.TYPE_ERROR);
	// 					} else {
	// 						$.scojs_message("<?php echo $data[683]['trad']; ?>", $.scojs_message.TYPE_OK);
	// 					}
	// 				}
	// 			},
	// 			complete : function(resposta) {
	// 				//reload
					
	// 			}
	// 		});
	// 	} else { return false; }
	// }
	
	function enviarFaturaQR(idFatura, nome, rappel = '1º Rappel', action, type){
	<?php if (hasPermission(['P0028']) == 1) { ?>
		$('#document_iden_QR').val('');
		$('#document_iden_QR').val(idFatura);
		$('#confirmar_envio_detalhes_QR').html('-');
		$('#confirmar_envio_detalhes_QR').html(nome);
		$('#rappel_number_QR').val('');
		$('#rappel_number_QR').val(rappel);
		fill_senderEmailQR(idFatura, action, type);
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}

	//agregar
	function agregarDocumentos(){
	<?php if (hasPermission(['P0026']) == 1) { ?>
		
		//init vars
		var invalidCheck = true;
		var invalidIDCliente = false;
		var lastClientID = 0;
		var counterSelected = 0;
		var selectedItems = [];

		//check if exists any selected doc
		$(".row_checkbox").each(function(key, value) {
			if($(this).is(":checked")){
				invalidCheck = false;
				counterSelected++;
				
				//check client invalid
				if(lastClientID != Number($(this).attr('data-cliID')) && lastClientID != 0 ){
					invalidIDCliente = true;
				}

				lastClientID = Number($(this).attr('data-cliID'));
			}

			// $(this).iCheck('check');
			// console.log($(this).is(":checked"), $(this).attr('data-id'), $(this).attr('data-cliID'));
		});

		if(invalidCheck){
			alert("<?php echo $data[1440]['trad']; ?>");
			return false;
		}

		if(invalidIDCliente){
			alert("<?php echo $data[1442]['trad']; ?>");
			return false;
		}

		//confirm action
		// console.log(counterSelected);
		if(counterSelected > 1){
			var question = '<?php echo $data[582]['trad']; ?>';
			question = question.replace('%nbr%',counterSelected);
		}else{
			var question = '<?php echo $data[581]['trad']; ?>';
		}
		
		if (confirm(question) == true) {
			//get documentos selecionados
			$(".row_checkbox").each(function(key, value) {
				if($(this).is(":checked")){
					selectedItems.push($(this).attr('data-id'));
				}
			});
			// console.log(lastClientID, selectedItems);return false;


			//process request
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/agregar_documentos/fatura_agrega_faturas.php',
				dataType : 'json',
				data : {
					idsFaturas : JSON.stringify( selectedItems ),
					idCliente : lastClientID
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] <?php echo $data[821]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							$.scojs_message("[FAT002] <?php echo $data[821]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							$.scojs_message("<?php echo $data[502]['trad']; ?>", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					var resp = resposta
					if (resp.responseJSON.errors) {
						$.scojs_message("[FAT004] <?php echo $data[821]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						//reload
						setTimeout(function() {
							if(resp.responseJSON.idDocumento){
								window.location.href = "../factures/details?facture="+resp.responseJSON.idDocumento;
							}
							else location.reload();
						}, 1000);
					}
				}
			});
		} else { return false; }
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}
</script>