<?php 
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1639,1698,1633,2169,288,544,1219,442,708,67,186,1676,1403,1995,2170);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<div id="modal-confirmar-envio" tabindex="-1" role="dialog" aria-labelledby="modal-header-primary-label" data-backdrop="static" data-keyboard="false" aria-hidden="true" class="modal fade">
	<div class="modal-dialog modal-wide-width">
		<div class="modal-content">
			<div class="modal-header modal-header-orange">
				<button type="button" data-dismiss="modal" aria-hidden="true" class="close">
					&times;
				</button>
				<h4 id="modal-header-primary-label" class="modal-title"><?php echo $data[288]['trad']; ?></h4>
			</div>
			<div class="modal-body" style="overflow-y: visible;">
				<form id="form_confirmar_envio">
					<div id="form_div">
						<div class="row">
							<input type="hidden" id="document_iden" name="document_iden" />
							<div class="col-sm-12">
								<div class="form-group">
									<label class="control-label"><?php echo $data[442]['trad']; ?></label>
									<span id="confirmar_envio_detalhes" style="display: block"></span>
								</div>
							</div>
						</div>
						<div class="row mtl" style="display:none;">
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label"><?php echo $data[544]['trad']; ?></label>
									<span id="confirmar_envio_email" style="display: block"></span>
								</div>
							</div>
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label"><?php echo $data[1219]['trad']; ?></label>
									<input type="email" class="form-control" id="confirmar_envio_emailnovo" name="confirmar_envio_emailnovo" placeholder="..." />
								</div>
							</div>
						</div>
						<div class="row email_row" >
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label"><?php echo $data[2169]['trad']; ?></label><br>
									<select class="form-control select2 show-tick" name="liste_contacts" id="liste_contacts">
									</select>
								</div>
							</div>
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label"><?php echo $data[2170]['trad']; ?></label>
									<input type="email" class="form-control" id="email_contact" name="email_contact" placeholder="..." />
								</div>
							</div>
						</div>
					</div>
				</form>
			</div>
			<div class="modal-footer">
				<button type="button" class="btn btn-blue" id="confirmBtn-modal">
					<i class="fa fa-paper-plane"></i> <?php echo $data[708]['trad']; ?>
				</button>
				<button type="button" data-dismiss="modal" class="btn btn-default">
					<?php echo $data[1995]['trad']; ?>
				</button>
			</div>
		</div>
	</div>
</div>
<?php include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/modals/get_responsables_mails.php";?>
<script type="text/javascript">
	
	// FORM EMAIL VALIDATOR
	val_form_new = $("#form_confirmar_envio").validate({
		ignore : "",
		rules : {
			email_contact : {
				required : true,
			},
		},
		messages : {
			email_contact : {
				required : "<?php echo $data[186]['trad']; ?>",
				email : "<?php echo $data[1676]['trad']; ?>"
			},
		},
		highlight : function(element, errorClass, validClass) {
			$(element).addClass(errorClass).removeClass(validClass);
		},
		unhighlight : function(element, errorClass, validClass) {
			$(element).removeClass(errorClass).addClass(validClass);
		},
		errorPlacement : function(error, element) {
			if (element.hasClass('selectpicker')) {
				if (element.parent().hasClass("input-group"))
					error.insertAfter(element.parent());
				else
					error.insertAfter(element.next("div"));
			} else {
				error.insertAfter(element);
			}
		}
	});

	//prevent form submit
	$("#form_confirmar_envio").submit(function(e) {
		e.preventDefault();
	});

	//confirm sender
	$("#confirmBtn-modal").on('click', function(event){
		var valid = $("#form_confirmar_envio").valid();

		if(valid == false) {
			$.scojs_message("<?php echo $data[1403]['trad']; ?>", $.scojs_message.TYPE_ERROR);
		} else {
			var docIden = $("#document_iden").val();
			var emailSender = $("#email_contact").val();

			//call sender function
			confirmNotaSender(docIden, emailSender);
		}
	});

	/**
	 * Get email for sender
	 * @param  id
	 */
	function fill_senderEmail(idDocumento){
		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/faturas-comum/sender_email_notecredit.php',
			data : { 
				idDocumento : idDocumento
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL007] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL008] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							// console.log('nulo?');
						} else {
							var dados = resposta.data;
							// console.log(dados);
							//$('#confirmar_envio_email').html(dados.EmailSender);
							//$('#confirmar_envio_emailnovo').val(dados.EmailSender);
							fill_respEmail(dados.ID_Cliente);
						}
					}
				}
			},
			complete : function() {
				$('#modal-confirmar-envio').modal("show");
			}
		});
	}
</script>