<?php
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(740,1459,745,1585,1401,641,729,67,1629,1641,496,741,1995);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<div id="modal-rapports-gerar" tabindex="-1" role="dialog" aria-labelledby="modal-header-primary-label" data-backdrop="static" data-keyboard="false" aria-hidden="true" class="modal fade">
	<div class="modal-dialog modal-wide-width">
		<div class="modal-content">
			<div class="modal-header modal-header-orange">
				<button type="button" data-dismiss="modal" aria-hidden="true" class="close">
					&times;
				</button>
				<h4 id="modal-header-primary-label" class="modal-title"><i class="fa fa-clipboard"></i>&nbsp;<?php echo $data[740]['trad']; ?></h4>
			</div>
			<form id="form_new_document" class="form-validate" novalidate="novalidate">
				<input type="hidden" id="idDoc_gerar"/>
				<div class="modal-body">
					<div id="form_div">
						<h5 class="form-header">
							<legend class="form-legend">
								<?php echo $data[1459]['trad']; ?>
							</legend>
						</h5>
						<div class="section-form">
							<div class="row">
								<div class="col-sm-12">
									<div class="form-group">
									<div class="radio">
										<div class="row">
											<div class="col-xs-12 form-group">
												<label class="radio-inline padding-left-radio">
													<input id="gerar_fatura" type="radio" name="tipo_documento" value="1" class="default_radio" checked="checked"/>
													<?php echo $data[745]['trad']; ?>?
												</label>
												<p class="padding-left-radio"><small><b><?php echo $data[1401]['trad']; ?>:&nbsp;</b><?php echo $data[1585]['trad']; ?></small></p>
											</div>
											<div class="col-xs-12 form-group">
												<label class="radio-inline padding-left-radio">
													<input id="gerar_rapport" type="radio" name="tipo_documento" value="2" class="default_radio"/>
													<?php echo $data[741]['trad']; ?>?
												</label>
												<p class="padding-left-radio"><small><b><?php echo $data[1401]['trad']; ?>:&nbsp;</b><?php echo $data[1585]['trad']; ?></small></p>
											</div>
										</div>
									</div>
								</div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<div class="modal-footer">
					<button  class="btn btn-violet submit_button" type="submit">
						<i class="fa fa-clipboard"></i> <?php echo $data[729]['trad']; ?>
					</button>
					<button type="button" data-dismiss="modal" class="btn btn-default">
						<?php echo $data[1995]['trad']; ?>
					</button>

				</div>
			</form>
		</div>
	</div>
</div>
<script type="text/javascript">
	var decisionFlag = 1;
	$(document).ready(function() {
		// iCheck ------------------------
		$('input:checkbox').attr("checked");
		$('input[type=checkbox]').iCheck({
			checkboxClass : 'icheckbox_flat-yellow',
			increaseArea : '20%' // optional
		});
		$('input[type=checkbox]').iCheck({
			checkboxClass : 'icheckbox_minimal-yellow',
			increaseArea : '20%' // optional
		});
		$('input[type=radio]').iCheck({
			radioClass : 'iradio_square-yellow',
			increaseArea : '20%' // optional
		});

		/* ----------- LISTNERS ----------- */
		$('input#gerar_fatura').on('ifChecked', function (event) {
			decisionFlag = 1;
		});
		$('input#gerar_rapport').on('ifChecked', function (event) {
			decisionFlag = 2;
		});
	});
	// ----------------- FORM PROCESSING ------------------

	//check validation and submit the form
	$("#form_new_document").submit(function(e) {
		e.preventDefault();

		var url_file = '';
		if (decisionFlag == 1) {
			url_file = 'rapport_gera_fatura.php';
		} else {
			url_file = 'rapport_gera_rapport.php';
		}

		//submite the form
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/gerar_documentos/'+url_file,
			dataType : 'json',
			data : {
				idDocumento : $('#idDoc_gerar').val(),
			},
			success : function(resposta) {
				var resp = resposta;
				if (resposta == null)
					$.scojs_message("[FAT001] <?php echo $data[1629]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				else {
					if (resposta.errors) {
						if (resposta.associado) {
							$.scojs_message("[FAT002] <?php echo $data[1641]['trad']; ?> ["+resposta.fatura_associada+"]", $.scojs_message.TYPE_ERROR);
						}else{
							$.scojs_message("[FAT003] <?php echo $data[1629]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						}
					} else {
						$.scojs_message("<?php echo $data[496]['trad']; ?>", $.scojs_message.TYPE_OK);
					}
				}
			},
			complete : function(resposta) {
				var resp = resposta;
				if (resp.responseJSON.errors) {
					if (resp.responseJSON.associado) {
							$.scojs_message("[FAT002] <?php echo $data[1641]['trad']; ?> ["+resp.responseJSON.fatura_associada+"]", $.scojs_message.TYPE_ERROR);
						}else{
							$.scojs_message("[FAT003] <?php echo $data[1629]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						}
				} else {
					if(decisionFlag == 1) window.location.href = "../factures/details?facture="+resp.responseJSON.idDestino;
					else window.location.href = "../rapports-travail/details?rapport="+resp.responseJSON.idDestino;
				}
				$("#form_new_document").find('.submit_button').attr("disabled", false);
				$("#form_new_document").find('.submit_button').html('<i class="fa fa-clipboard"></i> <?php echo $data[729]['trad']; ?>');
			}
		});
	});
</script>