<?php
	include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo_gesfaturacao.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/helpers.php';
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

	if ( hasPermission(['P0110']) == 1 ) {}
	else{
		header('Location: ../acces-refuse?redirectfrom=/frifacturation/rapports-travail/&redirectto=/frifacturation');
	}

	if ($_SESSION['mod_Rapports'] == 0) {
		header('Location: ../acces-fonctionnalites?redirectfrom=rapports-travail&redirectto=/frifacturation');
	}
	if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1366,1479,1480,1476,1505,562,67,641,89,1403,214,1633,1013,1995);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<html>
	<title><?php echo $data[1366]['trad']; ?>: <?php echo $data[1479]['trad']; ?> | Frifacturation</title>
	<head>
		<?php include('../base/css.php') ?>
		<!-- ADDED CSS -->
		<link rel="stylesheet" href="/js/vendors/bootstrap-select/bootstrap-select.min.css">
		<link rel="stylesheet" href="/js/vendors/bootstrap-datepicker/datepicker3.css">

		<link rel="stylesheet" href="/js/vendors/signature-pad/assets/jquery.signaturepad.css">
		<!-- //ADDED CSS -->
		<style type="text/css">
			/*resume table*/
			.resume-table { border: 0px !important;}
			.resume-table * { font-size: 12px !important; background-color: #fff !important; border: 0px !important;}
			.resume-table .paddingRight { padding-right: 10px; }
			.resume-table .paddingLeft { padding-left: 10px; }
			.resume-table .textCell { min-width: 200px; border-right: 0px; font-weight: normal;}
			.resume-table .valueCell { min-width: 100px; border-left: 0px; font-weight: normal;}
			.linesTable input { padding: 6px 5px !important; }

			/*taxes table*/
			.taxes-table { border: 0px !important; float: left !important; min-width: 500px !important;}
			.taxes-table * { font-size: 12px !important; background-color: #fff !important; border: 0px !important;}
			.taxes-table .paddingRight { padding-right: 10px; }
			.taxes-table .paddingLeft { padding-left: 10px; }
			.taxes-table .textCell { min-width: 200px; border-right: 0px; font-weight: normal;}
			.taxes-table .valueCell { min-width: 100px; border-left: 0px; font-weight: normal;}

			/* STAUTS LABELS */
			.stamp-label-orange{ border: 1px solid #E9662C; }
			.stamp-label-blue{ border: 1px solid #428BCA; }
			.stamp-label-green{ border: 1px solid #488C6C; }
			.stamp-label-red{ border: 1px solid #BF4346; }
			span { word-wrap: break-word; }

			.sigPad { width: 600px; margin: auto; }
			.sigWrapper { height: 152px; width: 602px; }
			.sigPad button.btn-green:hover { background-color: #3a7157; color: #ffffff; border-color: #305d48; }
			.sigPad button.btn-green { background-color: #488c6c; color: #ffffff; border-color: #458567; }
		</style>
	</head>
	<body>
		<?php include '../../modal_menu.php'; ?>
		<div class="container">
			<?php include '../menu.php'; ?>

			<div class="page-content">
				<div class="panel panel-white">
					<div class="panel-heading">
                        <div class="pull-right" >
							<a class="text-red only-ic" href="../rapports-travail<?php if(isset($_GET['rapport'])) echo '/details?rapport='.$_GET['rapport'] ?>"><i class="fa fa-times"></i></a>
						</div>
						<ol class="breadcrumb page-breadcrumb" style=" min-height: 35px; vertical-align: middle;">
							<li>
								<a href="../rapports-travail"><?php echo $data[1366]['trad']; ?></a>
							</li>
							<li class="active">
								<?php echo $data[1480]['trad']; ?>
							</li>
						</ol>
                    </div>
					<div class="panel-body">
						<div class="row">
							<div class="col-xs-12">
								<div class="form-body">
									<div id="form_div">

										<h5 class="form-header mtl">
											<legend class="form-legend">
												<?php echo $data[1476]['trad']; ?>
											</legend>
										</h5>
										<div class="section-form">
											<div class="row">
												<div class="col-xs-12">
													<form method="" action="" class="sigPad">
														<!-- <label for="name">Print your name</label> -->
														<!-- <input type="text" name="name" id="name" class="name"> -->
														<!-- <p class="drawItDesc">Draw your signature</p> -->
														<ul class="sigNav">
															<!-- <li class="drawIt"><a href="#draw-it" >Draw It</a></li> -->
															<li class="clearButton"><a href="#clear"><i class="fa fa-eraser"></i>&nbsp;<?php echo $data[1505]['trad']; ?></a></li>
														</ul>
														<div class="sig sigWrapper">
															<div class="typed"></div>
															<canvas class="pad" width="600" height="150"></canvas>
															<input type="hidden" name="output" class="output">
														</div>
														<button type="button" id="submitAssinatura" class="btn btn-green pull-right"><i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?></button>
													</form>
												</div>
											</div>
										</div>
									</div>									
								</div>

								<div class="form-footer">
									<div class="mtxl pull-right" id="btns-wrapper">
										<a  href="../rapports-travail" class="btn btn-default" type="button"> <?php echo $data[1995]['trad']; ?> </a>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		
		<?php include '../footer.php';	?>
		<?php include('../base/scripts.php') ?>

		<?php 
		if (!function_exists('get_trad')) {
			include $_SERVER["DOCUMENT_ROOT"]. "/translate.php";
		}
		$ids_list = array(1997,1998,1999,2000,2001,2002);
		if (isset($data)) {
			$data = $data + get_trad($ids_list);
		} else {
			$data = get_trad($ids_list);
		}	
	?>
		<script type="text/javascript">
			text1 = "<?php echo $data[1997]['trad']; ?>" ;
			text2 = "<?php echo $data[1998]['trad']; ?>" ;
			text3 = "<?php echo $data[1999]['trad']; ?>" ;
			text4 = "<?php echo $data[2000]['trad']; ?>" ;
			text5 = "<?php echo $data[2001]['trad']; ?>" ;
			text6 = "<?php echo $data[2002]['trad']; ?>" ;
		</script>

		<!-- ADDED SCRIPTS -->
		<script src="/js/vendors/bootstrap-select/bootstrap-select.min.js"></script>
		<script src="/js/vendors/bootstrap-select/defaults-pt_BR.min.js"></script>

		<script src="/js/vendors/DataTables/media/js/jquery.dataTables.js"></script>
		<script src="/js/vendors/DataTables/media/js/dataTables.bootstrap.js"></script>

		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.js"></script>
		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.pt.js"></script>
		<script src="/js/vendors/jquery-maskedinput/jquery-maskedinput.js"></script>
		<script src="/js/fnReload.js"></script>
		
		<script src="/js/autoNumeric.js"></script>
		<script src="/js/jquery.showmore.js"></script>
		
		<script src="/js/vendors/signature-pad/assets/flashcanvas.js"></script>
		<script src="/js/vendors/signature-pad/jquery.signaturepad.js"></script>
		<script src="/js/vendors/signature-pad/assets/json2.min.js"></script>

		<script>
			$(document).ready(function() {
				var options = {
					defaultAction : 'drawIt',
					drawOnly : true,
					bgColour : '#eee', 
					lineTop : 100,
				};
				$('.sigPad').signaturePad(options);
			});
		</script>

		<!-- //ADDED SCRIPTS -->
		<?php //include('modal-gerar-doc.php');  ?>
		<?php //include('detalhes_scripts.php');  ?>

		<script>
			$(".navbar-nav li.faturacao").addClass("active");
			$(".navbar-nav li.faturacao li.rapports_travail_faturacao").addClass("active");
		</script>
		<script type="text/javascript">
			//define global vars

			$(document).ajaxStart(function() {
				$(".fullscreen").show();
			});
			$(document).ajaxComplete(function() {
				if ($.active == 1) {
	                $(".fullscreen").fadeOut();
	            }
			});
			$(document).ready(function() {
				$(".fullscreen").fadeOut();
			});

			$(document).ready(function() {
				
				var idDocument = getParameterByName('rapport');
				// fill_document(idDocument);
			});

			//get vars
			function getParameterByName(name, url) {
				if (!url)
					url = window.location.href;
				url = url.toLowerCase();
				// This is just to avoid case sensitiveness
				name = name.replace(/[\[\]]/g, "\\$&").toLowerCase();
				// This is just to avoid case sensitiveness for query parameter name
				var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"), results = regex.exec(url);
				if (!results)
					return null;
				if (!results[2])
					return '';
				return decodeURIComponent(results[2].replace(/\+/g, " "));
			}


			//store and close document
			$('#submitAssinatura').on('click', function(e){
				e.preventDefault();
				submeterAssinatura();
			});
			
			//FINISH THE DOCUMENT
			function submeterAssinatura(){
				var question = "<?php echo $data[641]['trad']; ?>\n\n<?php echo $data[89]['trad']; ?>";
				if (confirm(question) == true) {					
					$("form.sigPad").submit();
				} else { return false; }
			}

			//FORM SUBMIT ---------------------------
			$("form.sigPad").submit(function(e) {
				e.preventDefault();

				var idRapport = getParameterByName('rapport');
				var encImage = $('.sigPad').signaturePad().getSignatureString();

				var valid = $("form.sigPad").valid();
				if (valid == false) {
					$.scojs_message("<?php echo $data[1403]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				} else {

					$("form.sigPad").find('#submitAssinatura').attr("disabled", true);
					$("form.sigPad").find('#submitAssinatura').html('<i class="fa fa-circle-o-notch fa-spin  fa-fw "></i> <?php echo $data[214]['trad']; ?> ...');

					//submite the form
					$.ajax({
						type : 'POST',
						url : '/frifacturation/server/rapports-travail/assinar.php',
						dataType : 'json',
						data : {
							idRapport : idRapport,
							encImage : encImage,
						},
						success : function(resposta) {
							var resp = resposta;
							if (resposta == null){
								$.scojs_message("[FAT001] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							}
							else {
								if (resposta.errors) {
									$.scojs_message("[FAT002] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
								} else {
									$.scojs_message("<?php echo $data[1013]['trad']; ?>", $.scojs_message.TYPE_OK);
								}
							}
						},
						complete : function(resposta) {
							var resp = resposta;
							var idDoc = resp.responseJSON.rapport;
							if (resp.responseJSON.errors) {
								$.scojs_message("[FAT001] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							} else {
								$.scojs_message("<?php echo $data[1013]['trad']; ?>", $.scojs_message.TYPE_OK);

								//reload
								setTimeout(function() {
									window.location.href = "../rapports-travail/details?rapport="+resp.responseJSON.rapport;
								}, 1000);
								
							}
							$("form.sigPad").find('#submitAssinatura').attr("disabled", false);
							$("form.sigPad").find('#submitAssinatura').html('<i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?>');
						}
					});
				}
			});
		</script>
	</body>
</html>