<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idDados = $_POST['idArtigo'];

//SELECT ITEM (REMOVE ALL PREDEFINIDAS) ---------------------------------
$query = "SELECT Ativo, Codigo FROM faturacao_artigos WHERE ID_Artigo=?";

if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDados);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($estadoArtigo, $codigo);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($estadoArtigo == 1) $novoEstado = 0;
else $novoEstado = 1;
//-----------------------------------------------------------------------

//UPDATE DB -------------------------------------------------------------
$query = "UPDATE faturacao_artigos SET Ativo=? WHERE ID_Artigo=?";

if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dd", $novoEstado, $idDados );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS004";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//----------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Modification de l'état du produit (code: ".$codigo.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
die(json_encode($response));
?>