<?php
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$opcao = $_POST['opcao'];

$data = array();

switch ($opcao) {
	//Articles Select2
	case 1:
		//init vars
		$rowCounter = 0;
		$data = array();
		$stepSize = 25;
		$limitRange = '0,25';
		$searchIncluded = '';

		//prepare search if necessary
		if( isset($_POST['search_term']) ){
			$search_term = $_POST['search_term'];
			if($search_term != '' && $search_term != null ){
				$searchIncluded = ' AND ( Codigo LIKE "%'.$search_term.'%" OR Nome LIKE "%'.$search_term.'%" OR CodigoBarras LIKE "%'.$search_term.'%" OR SerialNumber LIKE "%'.$search_term.'%" OR (SELECT Nome AS Categoria FROM faturacao_artigos_categorias WHERE faturacao_artigos_categorias.ID_Categoria = faturacao_artigos.ID_Categoria) LIKE "%'.$search_term.'%" )';
			}
		}
		//is id is set
		else if( isset($_POST['search_idarticle']) ){
			$search_idarticle = $_POST['search_idarticle'];
			if($search_idarticle != '' && $search_idarticle != null ){
				$searchIncluded .= ' OR ID_Artigo = '.$search_idarticle;
			}
		}

		if( isset($_POST['page']) ){
			$currPage = $_POST['page'] - 1;

			$prevLimit = $currPage * $stepSize;
			$nextLimit = ( $currPage * $stepSize ) + $stepSize;
			$limitRange = $prevLimit.",".$nextLimit;
		}

		//getFiltered items totals
		$queryCount = "SELECT COUNT(*)
			FROM faturacao_artigos WHERE Ativo = 1 ".$searchIncluded." ORDER BY Nome ";
		if ($stmtCount = $sqli_connection -> prepare($queryCount)) {
			$result = $stmtCount -> execute();
			if (false === $result) {}
			$stmtCount -> bind_result( $rowCounter );
			$stmtCount -> fetch();
			$stmtCount -> close();
		} else {}

		//getFiltered items
		$query = "SELECT ID_Artigo, Nome, Codigo, CodigoBarras, SerialNumber,
			(SELECT Nome AS Categoria FROM faturacao_artigos_categorias WHERE faturacao_artigos_categorias.ID_Categoria = faturacao_artigos.ID_Categoria),
			Tipo
			FROM faturacao_artigos WHERE Ativo = 1 ".$searchIncluded." ORDER BY Nome LIMIT ".$limitRange." ";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {}
			$stmt -> bind_result(
			            $ID_Artigo,
						$Nome,
						$Codigo,
						$CodigoBarras,
						$SerialNumber,
						$Categoria,
						$Tipo
					);
			while ($stmt -> fetch()) {
				$data[$ID_Artigo] = array(
					"ID_Artigo" => $ID_Artigo,
					"Nome" => $Nome,
					"Codigo" => $Codigo,
					"CodigoBarras" => $CodigoBarras,
					"SerialNumber" => $SerialNumber,
					"Categoria" => $Categoria,
					"Tipo" => $Tipo
				);
			}
			$stmt -> close();
		} else {}

		//return final results
		// $response["query"] = $query;
		// $response["tp_tmp"] = $tp_tmp;
		// $response["tP"] = $tP;
		// $response["searchIncluded"] = $searchIncluded;
		$response["range"] = $limitRange;
		$response["results"] = $data;
		$response["count_filtered"] = $rowCounter;		
		die(json_encode($response));

		break;

	//Clientes Select2
	case 2:
		//init vars
		$rowCounter = 0;
		$data = array();
		$stepSize = 25;
		$limitRange = '0,25';
		$searchIncluded = '';
		$clientsIDsString = '';


		//prepare search if necessary
		if( isset($_POST['search_term']) ){
			$search_term = $_POST['search_term'];
			if($search_term != '' && $search_term != null ){
				$searchIncluded = ' AND ( Nome LIKE "%'.$search_term.'%" OR Apelido LIKE "%'.$search_term.'%" OR CONCAT(Nome," ",Apelido) LIKE "%'.$search_term.'%" OR Codigo LIKE "%'.$search_term.'%" OR Telefone LIKE "%'.$search_term.'%" OR Telemovel LIKE "%'.$search_term.'%" OR CONCAT(CodigoPostal," ",Cidade) LIKE "%'.$search_term.'%" OR Email LIKE "%'.$search_term.'%" )'.$clientsIDsString;
			}
		}
		//is id is set
		elseif( isset($_POST['search_idcliente']) ){
			$search_idcliente = $_POST['search_idcliente'];
			if($search_idcliente != '' && $search_idcliente != null && $search_idcliente != null ){
				$searchIncluded .= ' OR ID_Cliente = '.$search_idcliente;
			}
		}

		if( isset($_POST['page']) ){
			$currPage = $_POST['page'] - 1;

			$prevLimit = $currPage * $stepSize;
			$nextLimit = ( $currPage * $stepSize ) + $stepSize;
			$limitRange = $prevLimit.",".$nextLimit;
		}

		//getFiltered items totals
		$queryCount = "SELECT COUNT(*)
			FROM faturacao_clientes WHERE Role is not null And ID_Cliente > 0 ".$clientsIDsString." ".$searchIncluded." ORDER BY Nome ";
		if ($stmtCount = $sqli_connection -> prepare($queryCount)) {
			$result = $stmtCount -> execute();
			if (false === $result) {}
			$stmtCount -> bind_result( $rowCounter );
			$stmtCount -> fetch();
			$stmtCount -> close();
		} else {}

		//getFiltered items
		$query = "SELECT ID_Cliente, CONCAT(Nome,' ',Apelido), Nif, Codigo, CONCAT(CodigoPostal,' ',Cidade), Email, Telemovel, Suspendu FROM faturacao_clientes WHERE Role is not null And ID_Cliente > 0 ".$clientsIDsString." ".$searchIncluded." ORDER BY Nome LIMIT ".$limitRange." ";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {}
			$stmt -> bind_result( $ID_Cliente, $Nome, $Nif, $Codigo, $CodigoPostalCidade, $Email, $Telemovel, $Suspendu );
			while ($stmt -> fetch()) {
				$data[] = array(
					"ID_Cliente" => $ID_Cliente, "Nome" => $Nome, "Nif" => $Nif, "Codigo" => $Codigo, "CodigoPostalCidade" => $CodigoPostalCidade, "Email" => $Email, "Telemovel" => $Telemovel, "Suspendu" => $Suspendu
				);
			}
			$stmt -> close();
		} else {}

		//return final results
		// $response["query"] = $query;
		$response["range"] = $limitRange;
		$response["results"] = $data;
		$response["query"] = $query;
		$response["count_filtered"] = $rowCounter;		
		die(json_encode($response));

		break;

	//Centros Custo Select2
	case 3:
		//init vars
		$rowCounter = 0;
		$data = array();
		$stepSize = 25;
		$limitRange = '0,25';
		$searchIncluded = '';

		//prepare search if necessary
		if( isset($_POST['search_term']) ){
			$search_term = $_POST['search_term'];
			if($search_term != '' && $search_term != null ){
				$searchIncluded = ' AND ( Nome LIKE "%'.$search_term.'%" OR Descricao LIKE "%'.$search_term.'%" )';
			}
		}
		//is id is set
		elseif( isset($_POST['search_idcenter']) ){
			$search_idcenter = $_POST['search_idcenter'];
			if($search_idcenter != '' && $search_idcenter != null ){
				$searchIncluded .= ' OR ID_CentroCusto = '.$search_idcenter;
			}
		}

		if( isset($_POST['page']) ){
			$currPage = $_POST['page'] - 1;

			$prevLimit = $currPage * $stepSize;
			$nextLimit = ( $currPage * $stepSize ) + $stepSize;
			$limitRange = $prevLimit.",".$nextLimit;
		}

		//getFiltered items totals
		$queryCount = "SELECT COUNT(*)
			FROM faturacao_clientes WHERE Ativo = 1 ".$searchIncluded." ORDER BY Nome ";
		if ($stmtCount = $sqli_connection -> prepare($queryCount)) {
			$result = $stmtCount -> execute();
			if (false === $result) {}
			$stmtCount -> bind_result( $rowCounter );
			$stmtCount -> fetch();
			$stmtCount -> close();
		} else {}

		//getFiltered items
		$data[0] = array(
			"ID_CentroCusto" => 0, "Nome" => 'Non spécifié', "Descricao" => null
		);
		$query = "SELECT ID_CentroCusto, Nome, Descricao FROM faturacao_centros_custo WHERE Ativo = 1 ".$searchIncluded." ORDER BY Nome LIMIT ".$limitRange." ";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {}
			$stmt -> bind_result( $ID_CentroCusto, $Nome, $Descricao );
			while ($stmt -> fetch()) {
				$data[$ID_CentroCusto] = array(
					"ID_CentroCusto" => $ID_CentroCusto, "Nome" => $Nome, "Descricao" => $Descricao
				);
			}
			$stmt -> close();
		} else {}

		//return final results
		// $response["query"] = $query;
		$response["range"] = $limitRange;
		$response["results"] = $data;
		$response["count_filtered"] = $rowCounter;		
		die(json_encode($response));

		break;

	//Venders Select2
	case 4:
		//init vars
		$rowCounter = 0;
		$data = array();
		$stepSize = 25;
		$limitRange = '0,25';
		$searchIncluded = '';

		//prepare search if necessary
		if( isset($_POST['search_term']) ){
			$search_term = $_POST['search_term'];
			if($search_term != '' && $search_term != null ){
				$searchIncluded = ' AND ( Nome LIKE "%'.$search_term.'%" OR Codigo LIKE "%'.$search_term.'%" OR Codigo_Interno LIKE "%'.$search_term.'%" )';
			}
		}
		//is id is set
		elseif( isset($_POST['search_idvendedor']) ){
			$search_idvendedor = $_POST['search_idvendedor'];
			if($search_idvendedor != '' && $search_idvendedor != null ){
				$searchIncluded .= ' OR ID_Vendedor = '.$search_idvendedor;
			}
		}

		if( isset($_POST['page']) ){
			$currPage = $_POST['page'] - 1;

			$prevLimit = $currPage * $stepSize;
			$nextLimit = ( $currPage * $stepSize ) + $stepSize;
			$limitRange = $prevLimit.",".$nextLimit;
		}

		//getFiltered items totals
		$queryCount = "SELECT COUNT(*)
			FROM faturacao_vendedores WHERE ID_Vendedor > 0 ".$searchIncluded." ORDER BY Nome ";
		if ($stmtCount = $sqli_connection -> prepare($queryCount)) {
			$result = $stmtCount -> execute();
			if (false === $result) {}
			$stmtCount -> bind_result( $rowCounter );
			$stmtCount -> fetch();
			$stmtCount -> close();
		} else {}

		//getFiltered items
		$query = "SELECT ID_Vendedor, Nome, Codigo, Codigo_Interno FROM faturacao_vendedores WHERE ID_Vendedor > 0 ".$searchIncluded." ORDER BY Nome LIMIT ".$limitRange." ";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {}
			$stmt -> bind_result( $ID_Vendedor, $Nome, $Codigo, $Codigo_Interno );
			while ($stmt -> fetch()) {
				$data[] = array(
					"ID_Vendedor" => $ID_Vendedor, "Nome" => $Nome, "Codigo" => $Codigo, "Codigo_Interno" => $Codigo_Interno
				);
			}
			$stmt -> close();
		} else {}

		//return final results
		// $response["query"] = $query;
		$response["range"] = $limitRange;
		$response["results"] = $data;
		$response["count_filtered"] = $rowCounter;		
		die(json_encode($response));

		break;

	//Responsaveis Select2
	case 5:
		//init vars
		$rowCounter = 0;
		$data = array();
		$stepSize = 25;
		$limitRange = '0,25';
		$searchIncluded = '';

		//prepare search if necessary
		if( isset($_POST['search_term']) ){
			$search_term = $_POST['search_term'];
			if($search_term != '' && $search_term != null ){
				$searchIncluded = ' AND ( Nome LIKE "%'.$search_term.'%" OR Codigo LIKE "%'.$search_term.'%" OR Codigo_Interno LIKE "%'.$search_term.'%" )';
			}
		}
		//is id is set
		elseif( isset($_POST['search_idresponsavel']) ){
			$search_idresponsavel = $_POST['search_idresponsavel'];
			if($search_idresponsavel != '' && $search_idresponsavel != null ){
				$searchIncluded .= ' OR ID_RespContrato = '.$search_idresponsavel;
			}
		}

		if( isset($_POST['page']) ){
			$currPage = $_POST['page'] - 1;

			$prevLimit = $currPage * $stepSize;
			$nextLimit = ( $currPage * $stepSize ) + $stepSize;
			$limitRange = $prevLimit.",".$nextLimit;
		}

		//getFiltered items totals
		$queryCount = "SELECT COUNT(*)
			FROM faturacao_responsavel_contratos WHERE ID_RespContrato > 0 ".$searchIncluded." ORDER BY CAST(Codigo AS UNSIGNED) ";
		if ($stmtCount = $sqli_connection -> prepare($queryCount)) {
			$result = $stmtCount -> execute();
			if (false === $result) {}
			$stmtCount -> bind_result( $rowCounter );
			$stmtCount -> fetch();
			$stmtCount -> close();
		} else {}

		//getFiltered items
		$query = "SELECT ID_RespContrato, Nome, Codigo, Codigo_Interno FROM faturacao_responsavel_contratos WHERE ID_RespContrato > 0 ".$searchIncluded." ORDER BY CAST(Codigo AS UNSIGNED) LIMIT ".$limitRange." ";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {}
			$stmt -> bind_result( $ID_RespContrato, $Nome, $Codigo, $Codigo_Interno );
			while ($stmt -> fetch()) {
				$data[] = array(
					"ID_RespContrato" => $ID_RespContrato, "Nome" => $Nome, "Codigo" => $Codigo, "Codigo_Interno" => $Codigo_Interno
				);
			}
			$stmt -> close();
		} else {}

		//return final results
		// $response["query"] = $query;
		$response["range"] = $limitRange;
		$response["results"] = $data;
		$response["count_filtered"] = $rowCounter;		
		die(json_encode($response));

		break;

	//Techniciens Select2
	case 6:
		//init vars
		$rowCounter = 0;
		$data = array();
		$stepSize = 25;
		$limitRange = '0,25';
		$searchIncluded = '';

		//prepare search if necessary
		if( isset($_POST['search_term']) ){
			$search_term = $_POST['search_term'];
			if($search_term != '' && $search_term != null ){
				$searchIncluded = ' AND ( Nome LIKE "%'.$search_term.'%" OR Contacto LIKE "%'.$search_term.'%" OR Email LIKE "%'.$search_term.'%" )';
			}
		}
		//is id is set
		elseif( isset($_POST['search_idtecnico']) ){
			$search_idtecnico = $_POST['search_idtecnico'];
			if($search_idtecnico != '' && $search_idtecnico != null ){
				$searchIncluded .= ' OR ID_Tecnico = '.$search_idtecnico;
			}
		}

		if( isset($_POST['page']) ){
			$currPage = $_POST['page'] - 1;

			$prevLimit = $currPage * $stepSize;
			$nextLimit = ( $currPage * $stepSize ) + $stepSize;
			$limitRange = $prevLimit.",".$nextLimit;
		}

		//getFiltered items totals
		$queryCount = "SELECT COUNT(*)
			FROM faturacao_tecnicos WHERE ID_Tecnico > 0 ".$searchIncluded." ORDER BY Nome ";
		if ($stmtCount = $sqli_connection -> prepare($queryCount)) {
			$result = $stmtCount -> execute();
			if (false === $result) {}
			$stmtCount -> bind_result( $rowCounter );
			$stmtCount -> fetch();
			$stmtCount -> close();
		} else {}

		//getFiltered items
		$query = "SELECT ID_Tecnico, Nome, Contacto, Email FROM faturacao_tecnicos WHERE ID_Tecnico > 0 ".$searchIncluded." ORDER BY Nome LIMIT ".$limitRange." ";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {}
			$stmt -> bind_result( $ID_Tecnico, $Nome, $Contacto, $Email );
			while ($stmt -> fetch()) {
				$data[] = array(
		        	"ID_Tecnico" => $ID_Tecnico,
					"Nome" => $Nome,
					"Contacto" => $Contacto,
					"Email" => $Email,
				);
			}
			$stmt -> close();
		} else {}

		//return final results
		// $response["query"] = $query;
		$response["range"] = $limitRange;
		$response["results"] = $data;
		$response["count_filtered"] = $rowCounter;		
		die(json_encode($response));

		break;

	//Documentos de Origem Select2
	case 7:
		//init vars
		$rowCounter = 0;
		$data = array();
		$stepSize = 25;
		$limitRange = '0,25';
		$searchIncluded = '';
		$clientsIDsString = '';

		//vendas
		$numero=''; $dataFatura=''; $cliente=''; $valorTotal=''; $tipo=''; $id_document=''; $id_cliente=''; $totalLiqDocumento=''; $totalPorPagar=0;


		//prepare search if necessary
		if( isset($_POST['search_term']) ){
			$search_term = $_POST['search_term'];
			if($search_term != '' && $search_term != null ){
				$searchIncluded = ' AND ( CONCAT("FA ",(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie),"/",Numero ) LIKE "%'.$search_term.'%" OR Data LIKE "%'.$search_term.'%" OR (SELECT CONCAT(Nome," ",Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente) LIKE "%'.$search_term.'%" OR (SELECT Codigo FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente) LIKE "%'.$search_term.'%" OR (GrossTotal - TotalLiquidado) LIKE "%'.$search_term.'%" )'.$clientsIDsString;
			}
		}
		//is id is set
		elseif( isset($_POST['search_iddocorigem']) ){
			$search_iddocorigem = $_POST['search_iddocorigem'];
			if($search_iddocorigem != '' && $search_iddocorigem != null ){
				$searchIncluded .= ' OR ID_Fatura = '.$search_iddocorigem;
			}
		}

		if( isset($_POST['page']) ){
			$currPage = $_POST['page'] - 1;

			$prevLimit = $currPage * $stepSize;
			$nextLimit = ( $currPage * $stepSize ) + $stepSize;
			$limitRange = $prevLimit.",".$nextLimit;
		}

		//getFiltered items totals
		$queryCount = "SELECT COUNT(*)
			FROM faturacao_faturas WHERE Estado IN ('Aberto', 'Pago') ".$clientsIDsString." AND ( GrossTotal > TotalLiquidadoDocumento OR TotalExtra > TotalExtraLiquidado) ".$searchIncluded." ORDER BY InvoiceStatusDate DESC ";
		if ($stmtCount = $sqli_connection -> prepare($queryCount)) {
			$result = $stmtCount -> execute();
			if (false === $result) {}
			$stmtCount -> bind_result( $rowCounter );
			$stmtCount -> fetch();
			$stmtCount -> close();
		} else {}

		//getFiltered items
		$query = "SELECT CONCAT('FA ',(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie),'/',Numero ), Data, 
			(SELECT Nome FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente), (SELECT Codigo FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente), GrossTotal, InvoiceType, ID_Fatura, ID_Cliente, TotalLiquidadoDocumento, (TotalExtra - TotalExtraLiquidado) FROM faturacao_faturas WHERE Estado IN ('Aberto', 'Pago') ".$clientsIDsString." AND ( GrossTotal > TotalLiquidadoDocumento OR TotalExtra > TotalExtraLiquidado) ".$searchIncluded." ORDER BY InvoiceStatusDate DESC  LIMIT ".$limitRange." ";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {}
			$stmt -> bind_result( $numero, $dataFatura, $cliente, $Codigo, $valorTotal, $tipo, $id_document, $id_cliente, $totalLiqDocumento, $extraPorPagar );
			while ($stmt -> fetch()) {
				$totalPorPagar = $valorTotal - $totalLiqDocumento;
				$totalPorPagar = round($totalPorPagar, $numDecimais);
				$extraPorPagar2 = round($extraPorPagar, $numDecimais);
				// $totalPorPagar = round($totalPorPagar, 2);

				$ValorRegler = number_format($totalPorPagar, 2, '.', '\'' ).' CHF';
				$ValorRegler2 = number_format($extraPorPagar2, 2, '.', '\'' ).' CHF';

				$data[$id_document] = array("Numero" => $numero, "Data" => $dataFatura, "Cliente" => $cliente, "Codigo" => $Codigo, "Valor" => $totalPorPagar, "Tipo" => $tipo, "ID_Document" => $id_document, "idCliente" => $id_cliente, "extraPorPagar" => $extraPorPagar, "ValorRegler" => $ValorRegler, "ValorRegler2" => $ValorRegler2 );
			}
			$stmt -> close();
		} else {}

		//return final results
		// $response["query"] = $query;
		$response["range"] = $limitRange;
		$response["results"] = $data;
		$response["count_filtered"] = $rowCounter;		
		die(json_encode($response));

		break;

	//Faturas WebServices and Select2
	case 8:
		//init vars
		$rowCounter = 0;
		$data = array();
		$stepSize = 25;
		$limitRange = '0,25';
		$searchIncluded = '';
		$clientsIDsString = '';

		//vendas
		$numero=''; $dataFatura=''; $cliente=''; $valorTotal=''; $tipo=''; $id_document=''; $id_cliente=''; $totalLiqDocumento=''; $totalPorPagar=0;

		//prepare search if necessary
		if( isset($_POST['search_term']) ){
			$search_term = $_POST['search_term'];
			if($search_term != '' && $search_term != null ){
				$searchIncluded = ' AND ( CONCAT("FA ",(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie),"/",Numero ) LIKE "%'.$search_term.'%" OR Data LIKE "%'.$search_term.'%" OR Validade LIKE "%'.$search_term.'%" OR Referencia LIKE "%'.$search_term.'%" OR (SELECT CONCAT(Nome," ",Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente) LIKE "%'.$search_term.'%" OR (SELECT Codigo FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente) LIKE "%'.$search_term.'%" OR GrossTotal LIKE "%'.$search_term.'%" OR (GrossTotal - TotalLiquidado) LIKE "%'.$search_term.'%" )'.$clientsIDsString;
			}
		}
		//is id is set
		elseif( isset($_POST['search_idfatura']) ){
			$search_idfatura = $_POST['search_idfatura'];
			if($search_idfatura != '' && $search_idfatura != null ){
				$searchIncluded .= ' OR ID_Fatura = '.$search_idfatura;
			}
		}

		if( isset($_POST['page']) ){
			$currPage = $_POST['page'] - 1;

			$prevLimit = $currPage * $stepSize;
			$nextLimit = ( $currPage * $stepSize ) + $stepSize;
			$limitRange = $prevLimit.",".$nextLimit;
		}

		//getFiltered items totals
		$queryCount = "SELECT COUNT(*)
			FROM faturacao_faturas WHERE ID_Fatura > 0 ".$clientsIDsString." ".$searchIncluded." ORDER BY (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie) DESC, (CASE Numero WHEN 0 THEN 99999999 ELSE Numero END) DESC, InvoiceStatusDate DESC";
		if ($stmtCount = $sqli_connection -> prepare($queryCount)) {
			$result = $stmtCount -> execute();
			if (false === $result) {}
			$stmtCount -> bind_result( $rowCounter );
			$stmtCount -> fetch();
			$stmtCount -> close();
		} else {}

		//getFiltered items
		$query = "SELECT CONCAT('FA ',(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie),'/',Numero ) AS NDoc, Data, Validade, 
			(SELECT Nome FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente) AS NomeCliente, (SELECT Codigo FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente) AS CodigoCliente, GrossTotal, InvoiceType, ID_Fatura, ID_Cliente, TotalLiquidadoDocumento, (TotalLiquidadoDocumento - GrossTotal) AS Solde, TotalExtra, TotalExtraLiquidado, (TotalExtraLiquidado - TotalExtra) AS SoldeExtra, Estado FROM faturacao_faturas WHERE ID_Fatura > 0 ".$clientsIDsString." ".$searchIncluded." ORDER BY (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie) DESC, (CASE Numero WHEN 0 THEN 99999999 ELSE Numero END) DESC, InvoiceStatusDate DESC LIMIT ".$limitRange." ";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {}
			$stmt -> bind_result( $numero, $dataFatura, $validadeFatura, $cliente, $Codigo, $valorTotal, $tipo, $id_document, $id_cliente, $totalLiqDocumento, $solde, $extraTotal, $extraLiquidado, $extraPorPagar, $estadoDocument );
			while ($stmt -> fetch()) {
				//process estado
				$estadoString = '';
				switch ($estadoDocument) {
					case 'Rascunho': $estadoString = 'Brouillon'; break;
					case 'Aberto': $estadoString = 'Ouvert'; break;
					case 'Pago': $estadoString = 'Payé'; break;
					case 'Anulado': $estadoString = 'Annulé'; break;
					
					default: break;
				}

				//add to array
				$data[] = array(
					"ID_Document" => $id_document,
					"Number_Document" => $numero,
				    "Date" => $dataFatura, 
				    "Date_Expiry" => $validadeFatura, 
					"ID_Client" => $id_cliente, 
					"Code_Client" => $Codigo, 
					"Name_Client" => $cliente, 
					"Type" => $tipo == 'FT' ? 'FA' : $tipo,
					"GrossTotal" => $valorTotal, 
					"TotalPayed" => $totalLiqDocumento, 
					"Solde" => $solde, 
					"ExtraTotal" => $extraTotal,
					"ExtraTotalPayed" => $extraLiquidado,
					"ExtraSolde" => $extraPorPagar,
					"Status_Document" => $estadoString,

					"GrossTotal_Formated" => number_format($valorTotal, 2, '.', '\'' ).' CHF', 
					"TotalPayed_Formated" => number_format($totalLiqDocumento, 2, '.', '\'' ).' CHF', 
					"Solde_Formated" => number_format($solde, 2, '.', '\'' ).' CHF', 
					"ExtraTotal_Formated" => number_format($extraTotal, 2, '.', '\'' ).' CHF',
					"ExtraTotalPayed_Formated" => number_format($extraLiquidado, 2, '.', '\'' ).' CHF',
					"ExtraSolde_Formated" => number_format($extraPorPagar, 2, '.', '\'' ).' CHF',
				);
			}
			$stmt -> close();
		} else {}

		//return final results
		// $response["query"] = $query;
		$response["range"] = $limitRange;
		$response["results"] = $data;
		$response["count_filtered"] = $rowCounter;		
		die(json_encode($response));

		break;
	
	//Articles Webservices
	case 9:
		//PERMS VALIDATION-------------------------------------------------------
		if ( hasPermission(['P0063']) != 1 ) {
			$response["errors"] = true;
			$response["type"] = "permission";
			$response["line"] = "PERM001";
			$response["message"] = "Access is not allowed!";
			die(json_encode($response));
		}
		//------------------------------------------------------------------------

		//init vars
		$rowCounter = 0;
		$data = array();
		$stepSize = 25;
		$limitRange = '0,25';
		$searchIncluded = '';

		//prepare search if necessary
		if( isset($_POST['search_term']) ){
			$search_term = $_POST['search_term'];
			if($search_term != '' && $search_term != null ){
				$searchIncluded = ' AND ( Codigo LIKE "%'.$search_term.'%" OR Nome LIKE "%'.$search_term.'%" OR CodigoBarras LIKE "%'.$search_term.'%" OR SerialNumber LIKE "%'.$search_term.'%" OR (SELECT Nome AS Categoria FROM faturacao_artigos_categorias WHERE faturacao_artigos_categorias.ID_Categoria = faturacao_artigos.ID_Categoria) LIKE "%'.$search_term.'%" )';
			}
		}
		//is id is set
		else if( isset($_POST['search_idarticle']) ){
			$search_idarticle = $_POST['search_idarticle'];
			if($search_idarticle != '' && $search_idarticle != null ){
				$searchIncluded .= ' OR ID_Artigo = '.$search_idarticle;
			}
		}

		if( isset($_POST['page']) ){
			$currPage = $_POST['page'] - 1;

			$prevLimit = $currPage * $stepSize;
			$nextLimit = ( $currPage * $stepSize ) + $stepSize;
			$limitRange = $prevLimit.",".$nextLimit;
		}

		//getFiltered items totals
		$queryCount = "SELECT COUNT(*)
			FROM faturacao_artigos WHERE Ativo = 1 ".$searchIncluded." ORDER BY Nome ";
		if ($stmtCount = $sqli_connection -> prepare($queryCount)) {
			$result = $stmtCount -> execute();
			if (false === $result) {}
			$stmtCount -> bind_result( $rowCounter );
			$stmtCount -> fetch();
			$stmtCount -> close();
		} else {}

		//getFiltered items
		$query = "SELECT ID_Artigo, Nome, Codigo, CodigoBarras, SerialNumber,
			(SELECT Nome AS Categoria FROM faturacao_artigos_categorias WHERE faturacao_artigos_categorias.ID_Categoria = faturacao_artigos.ID_Categoria),
			Tipo
			FROM faturacao_artigos WHERE Ativo = 1 ".$searchIncluded." ORDER BY Nome LIMIT ".$limitRange." ";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {}
			$stmt -> bind_result(
			            $ID_Artigo,
						$Nome,
						$Codigo,
						$CodigoBarras,
						$SerialNumber,
						$Categoria,
						$Tipo
					);
			while ($stmt -> fetch()) {
				$data[$ID_Artigo] = array(
					"ID_Article" => $ID_Artigo,
					"Name" => $Nome,
					"Code" => $Codigo,
					"Barcode" => $CodigoBarras,
					"SerialNumber" => $SerialNumber,
					// "Categoria" => $Categoria,
					"Type" => $Tipo
				);
			}
			$stmt -> close();
		} else {}

		//return final results
		// $response["query"] = $query;
		// $response["tp_tmp"] = $tp_tmp;
		// $response["tP"] = $tP;
		// $response["searchIncluded"] = $searchIncluded;
		$response["range"] = $limitRange;
		$response["results"] = $data;
		$response["count_filtered"] = $rowCounter;		
		die(json_encode($response));

		break;

	//Clientes Select2
	case 10:
		//PERMS VALIDATION-------------------------------------------------------
		if ( hasPermission(['P0019']) != 1 ) {
			$response["errors"] = true;
			$response["type"] = "permission";
			$response["line"] = "PERM003";
			$response["message"] = "Access is not allowed!";
			die(json_encode($response));
		}

		if ($_SESSION['mod_Vendas'] == 0) {
			$response["errors"] = true;
			$response["type"] = "permission";
			$response["line"] = "PERM004";
			$response["message"] = "Access is not allowed!";
			$response["session"] = $_SESSION;
			die(json_encode($response));
		}
		//------------------------------------------------------------------------
		
		//init vars
		$rowCounter = 0;
		$data = array();
		$stepSize = 25;
		$limitRange = '0,25';
		$searchIncluded = '';
		$clientsIDsString = '';

		//prepare search if necessary
		if( isset($_POST['search_term']) ){
			$search_term = $_POST['search_term'];
			if($search_term != '' && $search_term != null ){
				$searchIncluded = ' AND ( Nome LIKE "%'.$search_term.'%" OR Apelido LIKE "%'.$search_term.'%" OR CONCAT(Nome," ",Apelido) LIKE "%'.$search_term.'%" OR Codigo LIKE "%'.$search_term.'%" OR Telefone LIKE "%'.$search_term.'%" OR Telemovel LIKE "%'.$search_term.'%" OR CONCAT(CodigoPostal," ",Cidade) LIKE "%'.$search_term.'%" OR Email LIKE "%'.$search_term.'%" )'.$clientsIDsString;
			}
		}
		//is id is set
		elseif( isset($_POST['search_idcliente']) ){
			$search_idcliente = $_POST['search_idcliente'];
			if($search_idcliente != '' && $search_idcliente != null && $search_idcliente != null ){
				$searchIncluded .= ' OR ID_Cliente = '.$search_idcliente;
			}
		}

		if( isset($_POST['page']) ){
			$currPage = $_POST['page'] - 1;

			$prevLimit = $currPage * $stepSize;
			$nextLimit = ( $currPage * $stepSize ) + $stepSize;
			$limitRange = $prevLimit.",".$nextLimit;
		}

		//getFiltered items totals
		$queryCount = "SELECT COUNT(*)
			FROM faturacao_clientes WHERE ID_Cliente > 0 ".$clientsIDsString." ".$searchIncluded." ORDER BY Nome ";
		if ($stmtCount = $sqli_connection -> prepare($queryCount)) {
			$result = $stmtCount -> execute();
			if (false === $result) {}
			$stmtCount -> bind_result( $rowCounter );
			$stmtCount -> fetch();
			$stmtCount -> close();
		} else {}

		//getFiltered items
		$query = "SELECT ID_Cliente, CONCAT(Nome,' ',Apelido), Nif, Codigo, Endereco, CodigoPostal, Cidade, Email, Telemovel FROM faturacao_clientes WHERE ID_Cliente > 0 ".$clientsIDsString." ".$searchIncluded." ORDER BY Nome LIMIT ".$limitRange." ";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {}
			$stmt -> bind_result( $ID_Cliente, $Nome, $Nif, $Codigo, $Endereco, $CodigoPostal, $Cidade, $Email, $Telemovel );
			while ($stmt -> fetch()) {
				$data[] = array(
					"ID_Client" => $ID_Cliente, "Name" => $Nome, "Code" => $Codigo, "Address" => $Endereco, "PostalCode" => $CodigoPostal, "Localite" => $Cidade, "Email" => $Email, "Phone" => $Telemovel
				);
			}
			$stmt -> close();
		} else {}

		//return final results
		// $response["query"] = $query;
		$response["range"] = $limitRange;
		$response["results"] = $data;
		$response["count_filtered"] = $rowCounter;		
		die(json_encode($response));

		break;
}

?>