<?php 
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/Bvr.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idAchat = $_POST['idAchat'];
$cliente = $_POST['cliente'];
$endereco_cliente_descarga = $_POST['endereco_cliente_descarga'];
$endereco_cliente_descarga_2 = $_POST['endereco_cliente_descarga_2'];
$codigopostal_cliente_descarga = $_POST['codigopostal_cliente_descarga'];
$regiao_cliente_descarga = $_POST['regiao_cliente_descarga'];
$cidade_cliente_descarga = $_POST['cidade_cliente_descarga'];
$pais_cliente_descarga = $_POST['pais_cliente_descarga'];
$numero = $_POST['numero'];
$data = $_POST['data'];
$debut = $_POST['debut'];
// $facturation = $_POST['facturation'];
$facturation = "mensuellement";
$prix_achat = $_POST['prix_achat'];
$prix_installation = $_POST['prix_installation'];
$prix_preparation = $_POST['prix_preparation'];
$prix_taxeantecipee = $_POST['prix_taxeantecipee'];

$pagamento = $_POST['pagamento'];
$referencia = $_POST['referencia'];
$remarque = $_POST['remarque'];
$vendeur_1 = $_POST['vendeur_1'];
$vendeur_2 = $_POST['vendeur_2'];
$resp_client_1 = $_POST['resp_client_1'];
$resp_client_2 = $_POST['resp_client_2'];

$linhas = $_POST['linhas'];
$finalizarDocumento = $_POST['finalizarDocumento'];

$nome2 = $_POST['nome2'];
$apelido2 = $_POST['apelido2'];

//SYSTEM FIELDS --------------------------------------------------------
$timestamp = microtime(true);
$dataCriacao = date("d/m/Y H:i:s");
$dataAtualizacao = date("d/m/Y H:i:s");
$utilizadorCriacao = $id_utilizador;
$utilizadorAtualizacao = $id_utilizador;
$estado = 'Rascunho';
$NumeroAchat = 0;
//------------------------------------------------------------------------

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idAchat == '' || $cliente == '' || $data == '' || $facturation == '' || $debut == '' || $prix_achat == '' || $prix_installation == '' || $prix_preparation == '' || $prix_taxeantecipee == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}

if( sizeof($linhas) < 1){
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000B";
	die(json_encode($response));
}

if($vendeur_1 == $vendeur_2){
	// $vendeur_2 = 0;
}
//------------------------------------------------------------------------

//CHECK LINES
if(!is_array($linhas) || empty($linhas)){
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000x";
	$response["lines_empty"] = true;
	$response["message"] = "";
	die(json_encode($response));
}
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

	//GET CLIENT DATA --------------------------------------------------------
	$query = "SELECT Nif, Endereco, CodigoPostal, Cidade, Regiao, Pais, Email, Codigo, Titulo, Nome, Apelido, Vencimento FROM faturacao_clientes WHERE ID_Cliente = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $cliente);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($Nif, $Endereco, $CodigoPostal, $Cidade, $Regiao, $Pais, $Email, $CodigoCliente, $Titulo, $Nome, $Apelido, $vencimento );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//process fields
	if( trim($Endereco) == '' ) $Endereco = '-';
	if( trim($CodigoPostal) == '' ) $CodigoPostal = '-';
	if( trim($Cidade) == '' ) $Cidade = '-';
	if( trim($Regiao) == '' ) $Regiao = '-';
	if( trim($Pais) == '' ) $Pais = '-';

	if( trim($endereco_cliente_descarga) == '' ) $endereco_cliente_descarga = '-';
	if( trim($endereco_cliente_descarga_2) == '' ) $endereco_cliente_descarga_2 = '-';
	if( trim($codigopostal_cliente_descarga) == '' ) $codigopostal_cliente_descarga = '-';
	if( trim($regiao_cliente_descarga) == '' ) $regiao_cliente_descarga = '-';
	if( trim($cidade_cliente_descarga) == '' ) $cidade_cliente_descarga = '-';
	if( trim($pais_cliente_descarga) == '' ) $pais_cliente_descarga = '-';

	if( trim($Titulo) == '' ) $Titulo = NULL;
	if( trim($Nome) == '' ) $Nome = NULL;
	if( trim($Apelido) == '' ) $Apelido = NULL;

	if( trim($nome2) == '' ) $nome2 = NULL;
	if( trim($apelido2) == '' ) $apelido2 = NULL;
	$pagamento = $vencimento;
	//------------------------------------------------------------------------

	//INSERT NEW DOCUMENT ----------------------------------------------------

	//prepare some fields
	$duree_final = $duree." ".$duree_type;

	//updating
	$query = "UPDATE faturacao_contrats_achats SET 
			ID_Cliente=?, 
			EnderecoCliente=?, 
			CodigoPostalCliente=?, 
			CidadeCliente=?, 
			RegiaoCliente=?, 
			EmailCliente=?, 
			EmailClienteDescarga=?, 
			PaisCliente=?, 
			EnderecoClienteDescarga=?, 
			EnderecoCliente2Descarga=?, 
			CodigoPostalClienteDescarga=?, 
			CidadeClienteDescarga=?, 
			RegiaoClienteDescarga=?, 
			PaisClienteDescarga=?, 
			ID_Vendedor_Primeiro=?, 
			ID_Vendedor_Segundo=?, 
			Data=?, 
			Debut=?, 
			Facturation=?, 
			Paiment=?, 
			Referencia=?, 
			Remarque=?, 
			PrixAchat=?, 
			PrixInstallation=?, 
			PrixPreparation=?, 
			PrixTaxeAntecipe=?, 
			Estado=?, 
			DataAtualizacao=?, 
			ID_Utilizador_Atualizacao=?, 
			ID_ResponsavelPrimeiro=?, 
			ID_ResponsavelSegundo=?,
			TituloCliente=?,
			NomeCliente=?,
			ApelidoCliente=?,
			NomeCliente2=?,
			ApelidoCliente2=?
		WHERE ID_Achat=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param(
			"dsssssssssssssddssssssssssssdddsssssd", 
			$cliente,
			$Endereco,
			$CodigoPostal,
			$Cidade,
			$Regiao,
			$Email,
			$Email,
			$Pais,
			$endereco_cliente_descarga,
			$endereco_cliente_descarga_2,
			$codigopostal_cliente_descarga,
			$cidade_cliente_descarga,
			$regiao_cliente_descarga,
			$pais_cliente_descarga,
			$vendeur_1,
			$vendeur_2,
			$data,
			$debut,
			$facturation,
			$pagamento,
			$referencia,
			$remarque,
			$prix_achat,
			$prix_installation,
			$prix_preparation,
			$prix_taxeantecipee,
			$estado,
			$dataAtualizacao,
			$utilizadorAtualizacao,
			$resp_client_1,
			$resp_client_2,
			$Titulo,
			$Nome,
			$Apelido,
			$nome2,
			$apelido2,
			$idAchat
		);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA010";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA011";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//------------------------------------------------------------------------
	
	//CLEAN ALL LINES --------------------------------------------------------
	$query = "DELETE FROM faturacao_contrats_achats_linhas WHERE ID_Achat=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idAchat );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA012";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA013";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//PROCESS LINES ----------------------------------------------------------
	$numLinha = 1;
	foreach ($linhas as $linha) {
		//init vars
		$ProductCode = '';
		$SerialNumber = '';
		$Quantidade = 1;

		//GET ARTICLE DATA ---------------------------------------------------
		$query = "SELECT  Codigo, SerialNumber FROM faturacao_artigos WHERE ID_Artigo = ?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $linha['artigo']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA015";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
			$stmt -> bind_result($ProductCode, $SerialNumber);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA016";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		//--------------------------------------------------------------------

		//INSERT INTO DB -----------------------------------------------------
		$query = "INSERT INTO faturacao_contrats_achats_linhas (ID_Achat, ID_Artigo, 
			NumeroLinha, ProductCode, ProductDescription, SerialNumber, Quantidade ) 
			VALUES (?,?,?,?,?,?,?)";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("dddsssd", $idAchat, $linha['artigo'], $numLinha, $ProductCode, $linha['descricao'], $SerialNumber, $Quantidade );
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA019";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA020";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		//--------------------------------------------------------------------
		
		$numLinha++;

		//BLOCK ARTICLE ------------------------------------------------------
		$query = "UPDATE faturacao_artigos SET Usado=1 WHERE ID_Artigo=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $linha['artigo']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA020A";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA020B";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		//--------------------------------------------------------------------
	}
	//------------------------------------------------------------------------

	//CLOSE THE DOCUMENT -----------------------------------------------------
	if( $finalizarDocumento > 0 ){
		//prepare vars
		$dataAtualizacao = date("d/m/Y H:i:s");
		$utilizadorAtualizacao = $id_utilizador;
		$estadoUpdate = 'Confirmado';

		// DEFINE NEW NUMBER
		$queryStmt = "SELECT MAX(Numero) AS NumeroMax FROM faturacao_contrats_achats;";
		$maxID = getMaxNumberDocument($queryStmt);
		$initNumber = 900000 + getInitNumber("NumeroInicial_CACH","faturacao_personalizar_documentos", "", 0);
		if($nextID < $initNumber && $maxID < 1){
			$query = "UPDATE faturacao_contrats_achats SET Numero = ".$initNumber.", Estado=?, ID_Utilizador_Atualizacao=?, DataAtualizacao=? WHERE ID_Achat = ?";
		}else{
			$query = "UPDATE faturacao_contrats_achats SET Numero = (CASE WHEN (SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_contrats_achats) AS SubNumeroMaxP) > 0 THEN (SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_contrats_achats) AS SubNumeroMaxS) + 1 ELSE 900001 END), Estado=?, ID_Utilizador_Atualizacao=?, DataAtualizacao=? WHERE ID_Achat = ?";
		}
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("sdsd", $estadoUpdate, $utilizadorAtualizacao, $dataAtualizacao, $idAchat);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA025";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA026";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}

		//GET DOCUMENT NUMBER
		$query = "SELECT Numero FROM faturacao_contrats_achats  WHERE ID_Achat = ?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("s", $idAchat);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA012";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($NumeroAchat);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA013";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		if( $idAchat < 1){
			$response["errors"] = true;
			$response["type"] = "FTGA014";
			$response["message"] = "Contrat de achats invalid";
			die(json_encode($response));
		}
		//------------------------------------------------------------------------

		//log sistema - processo
		$descricao_log ="Édition et finalisation de contrat de achat (id: ".$idAchat." - ".$NumeroAchat.")";
		insert_log(0,"Editar",$descricao_log,$sqli_connection);
		
		$response["achat"] = $idAchat;
	}else{
		$response["achat"] = $idAchat;

		//log sistema - processo
		$descricao_log ="Édition de contrat de achat (id: ".$idAchat." - ".$NumeroAchat.")";
		insert_log(0,"Editar",$descricao_log,$sqli_connection);
	}
	//------------------------------------------------------------------------

	//BLOCK CLIENT -----------------------------------------------------------
	$query = "UPDATE faturacao_clientes SET Usado=1 WHERE ID_Cliente=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $cliente);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA027";
			$response["message"] = $stmt -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA028";
		$response["message"] = $sqli_connection -> error;
		$sqli_connection->rollback();
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	// Save all querys on DB
	$sqli_connection->commit();
} catch (Exception $e) {
	$sqli_connection->rollback();

	$response["errors"] = true;
	$response["type"] = "transaction";
	$response["line"] = "DB001";
	$response["message"] = $e->getMessage();
	die(json_encode($response));
}

//response
$response["errors"] = false;
die(json_encode($response));

?>