<?php
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo_gesfaturacao.php";
/*Control user*/
/*
 * Script:    DataTables server-side script for PHP and MySQL
 * Copyright: 2010 - Allan Jardine
 * License:   GPL v2 or BSD (3-point)
 * Edited by Pedro Gomes
 */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Easy set variables
 */

/* Database connection information */
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection_mysql.php";

/* Array of database columns which should be read and sent back to DataTables. Use a space where
 * you want to insert a non-database field (for example a counter or static image)
 */
$aColumns = array(
    'CONCAT(InvoiceType," ",(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas_recibo.ID_Serie),"/",Numero)',
    '(SELECT Nome FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas_recibo.ID_Cliente)',
    '(SELECT Nif FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas_recibo.ID_Cliente)',
    'STR_TO_DATE( Data,  "%d/%m/%Y" )',
    'STR_TO_DATE( Validade,  "%d/%m/%Y" )',
    'TotalLiquidado',
    'TotalPagar',
    'GrossTotal',
    'Estado',
    'ID_FaturaRecibo'
);

/* Column to filter*/
$fFilter = array(
    'CONCAT(InvoiceType," ",(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas_recibo.ID_Serie),"/",Numero)',
    '(SELECT Nome FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas_recibo.ID_Cliente)',
    '(SELECT Nif FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas_recibo.ID_Cliente)',
    'Data',
    'Validade',
    'TotalLiquidado',
    'TotalPagar',
    'GrossTotal',
    'Estado',
    'ID_FaturaRecibo'
);

/* Indexed column (used for fast and accurate table cardinality) */
$sIndexColumn = "faturacao_faturas_recibo.ID_FaturaRecibo";

/* DB table to use */
$sTable = "faturacao_faturas_recibo";

/*DB Table to count*/
$cTable = "faturacao_faturas_recibo";

/*LEFT JOIN Table*/
$sLeft="";

/*Join Table*/
$sJoin = "ID_FaturaRecibo > 0";


include 'commun.php';
?>