<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/PHPExcel/PHPExcel.php";

$ids_list = array(244,671,550,394,395,1954,1955,186,1403,102,1599,403,10,1167,241,383,386,1713,1559,801,672,673,694);
	if(isset($data)){
		$data = $data + get_trad($ids_list);
	} else {
		$data = get_trad($ids_list);
	}
// ini_set('memory_limit', '128M');
// ini_set('max_execution_time', 300);

// ENV VARS
$id_utilizador = $_SESSION['id_utilizador'];

// die('THIS IS BLOCKED');

//INIT VARS
//process filters and related
$dateAccuel = "01/01/".date("Y");
$dateFin = "31/12/".date("Y");

$dateAccuelR = date("Y")."-01-01";
$dateFinR = date("Y")."-12-31";
if(isset( $_GET['dateAccuel']) ) {
	$tempDate = DateTime::createFromFormat('d/m/Y', $_GET['dateAccuel']);
	$dateAccuelR = $tempDate->format('Y-m-d');
}
if(isset( $_GET['dateFin']) ) {
	$tempDate = DateTime::createFromFormat('d/m/Y', $_GET['dateFin']);
	$dateFinR = $tempDate->format('Y-m-d');
}

if(isset( $_GET['dateAccuel']) ) $dateAccuel = $_GET['dateAccuel'];
if(isset( $_GET['dateFin']) ) $dateFin = $_GET['dateFin'];
$GLOBALS['dateAccuel'] = $dateAccuel;
$GLOBALS['dateFin'] = $dateFin;

//VALIDATE DATA
if(!$dateAccuel || $dateAccuel == '' || !$dateFin || $dateFin == ''){
	header('Content-Type: application/json; charset=UTF-8');
	header('HTTP/1.1 404 Aucune donnée reçue.');
	header('Location: ../../../404?redirectfrom=/frifacturation/comptabilite/clients/extrait_documents&redirectto=/frifacturation/comptabilite/clients/extrait_documents');
}

//START PROCESSING QUERIES
try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

	//log sistema - processo
	$descricao_log =$data[671]['trad'].": ".$data[244]['trad'];
	insert_log(0,"Editar",$descricao_log,$sqli_connection);

	//COMPANY INFO - - - - - - - - - - - - - - - - - - - - - -
	$query = "SELECT  Designacao, Nif, RegistoComercial, Endereco1, Endereco2, CodigoPostal, Cidade, Email, Website, CapitalSocial, Conservatoria, Telefone, Fax, Logotipo, NormaContabilistica, CAE_Principal  from faturacao_empresa_dados LIMIT 1";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$result = $stmt -> execute();

		if (false === $result) {
			$response["errors"] = true;
			$response["message"] = $stmt -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($designacao, $nif, $registo_comercial, $endereco1, $endereco2, $codigo_postal, $cidade, $email, $website, $capital_social, $conservatoria, $telefone, $fax, $logotipo, $norma_contabilistica, $cae_principal);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["message"] = $sqli_connection -> error;
		$sqli_connection->rollback();
		die(json_encode($response));
	}
	$GLOBALS['Designacao'] = $designacao;
	$GLOBALS['Nif'] = $nif;
	$GLOBALS['RegistoComercial'] = $registo_comercial;
	$GLOBALS['Endereco1'] = $endereco1;
	$GLOBALS['Endereco2'] = $endereco2;
	$GLOBALS['CodigoPostal'] = $codigo_postal;
	$GLOBALS['Cidade'] = $cidade;
	$GLOBALS['Email'] = $email;
	$GLOBALS['Website'] = $website;
	$GLOBALS['CapitalSocial'] = $capital_social;
	$GLOBALS['Conservatoria'] = $conservatoria;
	$GLOBALS['Telefone'] = $telefone;
	$GLOBALS['Fax'] = $fax;
	$GLOBALS['Logotipo'] = $logotipo;
	$GLOBALS['NormaContabilistica'] = $norma_contabilistica;
	$GLOBALS['CAE_Principal'] = $cae_principal;

	//DOC INFO - - - - - - - - - - - - - - - - - - - - - -
	$clientsInfos = array();
	$docsFinaisInfo = array();
	$query = "SELECT ID_Cliente, Codigo, CONCAT(Nome,' ',Apelido) AS NomeCliente, Endereco, CodigoPostal, Cidade, 

	(SELECT COUNT(*) FROM faturacao_recibos WHERE Estado IN ('Aberto','Pago') AND faturacao_recibos.CustomerID = faturacao_clientes.Codigo AND (
					STR_TO_DATE(TransactionDate, '%Y-%m-%d') BETWEEN STR_TO_DATE('".$dateAccuelR."', '%Y-%m-%d') AND STR_TO_DATE('".$dateFinR."', '%Y-%m-%d') 
				) ) AS TotRecibos, PlanoContas, (SELECT Descricao FROM faturacao_plano_conta WHERE faturacao_plano_conta.Codigo = faturacao_clientes.PlanoContas) AS PlanoContasDescricao
	FROM faturacao_clientes ORDER BY CAST(Codigo AS UNSIGNED)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		// $stmt -> bind_param("ss", $dateAccuel, $dateFin);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($ID_Cliente, $Codigo, $NomeCliente, $Endereco, $CodigoPostal, $Cidade, $TotRecibos, $PlanoContas, $PlanoContasDescricao);
		while($stmt->fetch()){
			//print($query);
			if( $TotRecibos > 0){
				$clientsInfos[] = array(
					"ID_Cliente" => $ID_Cliente,
					"Codigo" => $Codigo,
					"NomeCliente" => $NomeCliente,
					"Endereco" => $Endereco,
					"CodigoPostal" => $CodigoPostal,
					"Cidade" => $Cidade,
					"TotRecibos" => $TotRecibos,
					"PlanoContas" => $PlanoContas,
					"PlanoContasDescricao" => $PlanoContasDescricao,
					"Documentos" => array(),
					"Solde" => 0,
				);
			}
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//print($query);
	//var_dump($clientsInfos);die();
	/*
	//PROCESS CLIENTS
	foreach($clientsInfos as $index => $cliente) {
		//INIT VARS
		$documentosCliente = array();
		$soldeTotal = 0;

		//FATURAS
		$ID_Fatura = null;
		$DataFatura = null;
		$NumeroFatura = null;
		$ReferenciaFatura = null;
		$GrossTotalFatura = null;
		$NetTotalFatura = null;
		$TaxPayableFatura = null;
		$InvoiceDateFatura = null;
		$SerieOrdenacaoFatura = null;
		$NumOrdenacaoFatura = null;

		//GET DOCS FOR THIS CLIENT
		$query1 = "SELECT ID_Fatura, Data, CONCAT('FA ', (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie),'/', faturacao_faturas.Numero) AS NumeroFatura, Referencia, GrossTotal, NetTotal, TaxPayable, InvoiceDate, (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie) AS Serie, faturacao_faturas.Numero As Numero,
		(SELECT TransactionDate from faturacao_recibos WHERE faturacao_recibos.ID_DocumentoMain = faturacao_faturas.ID_Fatura AND faturacao_recibos.Estado = 'Pago' AND faturacao_faturas.Estado = 'Pago' order by TransactionDate desc limit 1)
			FROM faturacao_faturas WHERE Estado IN ('Aberto','Pago') AND ID_Cliente = ? 
				AND (
					STR_TO_DATE((SELECT TransactionDate from faturacao_recibos WHERE faturacao_recibos.ID_DocumentoMain = faturacao_faturas.ID_Fatura AND faturacao_recibos.Estado = 'Pago' AND faturacao_faturas.Estado = 'Pago' order by TransactionDate desc limit 1), '%Y-%m-%d') BETWEEN STR_TO_DATE('".$dateAccuel."', '%d/%m/%Y') AND STR_TO_DATE('".$dateFin."', '%d/%m/%Y') 
				) ";
		if ($stmt1 = $sqli_connection -> prepare($query1)) {
			$stmt1 -> bind_param("d", $cliente['ID_Cliente']);
			$result1 = $stmt1 -> execute();

			if (false === $result1) {
				$response["errors"] = true;
				$response["message"] = $stmt1 -> error;
				die(json_encode($response));
			}
			$stmt1 -> store_result();
			$stmt1 -> bind_result($ID_Fatura, $DataFatura, $NumeroFatura, $ReferenciaFatura, $GrossTotalFatura, $NetTotalFatura, $TaxPayableFatura, $InvoiceDateFatura, $SerieOrdenacaoFatura, $NumOrdenacaoFatura, $Paiement);
			while($stmt1->fetch()){
				//prepare 2nd column for order
				// if($NumOrdenacaoFatura < 10) $NumeroOrdenacao = $SerieOrdenacaoFatura.'/0'.$NumOrdenacaoFatura;
				// else $NumeroOrdenacao = $SerieOrdenacaoFatura.'/'.$NumOrdenacaoFatura;
				$Paye = DateTime::createFromFormat('Y-m-d', $Paiement);
				if($Paye){
					$Paye = $Paye->format('d/m/Y');
				} else {
					$Paye = null;
				}

				$tmpArrayFA = array(
					"ID_Documento" => $ID_Fatura,
					"DataDocumento" => $DataFatura,
					"NumeroDocumento" => $NumeroFatura,
					"ReferenciaDocumento" => $ReferenciaFatura,
					"GrossTotalDocumento" => $GrossTotalFatura,
					"NetTotalDocumento" => $NetTotalFatura,
					"TaxPayableDocumento" => $TaxPayableFatura,
					"InvoiceDate" => $InvoiceDateFatura,
					"Tipo" => 'FA',
					"DesignacaoCliente" => $cliente['NomeCliente'],
					"SerieOrdenacao" => $SerieOrdenacaoFatura,
					"NumOrdenacao" => $NumOrdenacaoFatura,
					"Paiement" => $Paye
					// "NumeroOrdenacaoProcessado" => $NumeroOrdenacao,
				);

				$documentosCliente[] = $tmpArrayFA;
				$docsFinaisInfo[] = $tmpArrayFA;

				//add to solde total
				$soldeTotal = $soldeTotal + $GrossTotalFatura;
			}
			$stmt1 -> close();
		} else {
			$response["errors"] = true;
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		//FATURAS
		$ID_NotaCredito = null;
		$DataNotaCredito = null;
		$NumeroNotaCredito = null;
		$ReferenciaNotaCredito = null;
		$GrossTotalNotaCredito = null;
		$NetTotalNotaCredito = null;
		$TaxPayableNotaCredito = null;
		$InvoiceDateNotaCredito = null;
		$SerieOrdenacaoNotaCredito = null;
		$NumOrdenacaoNotaCredito = null;

		//GET DOCS FOR THIS CLIENT
		$query2 = "SELECT ID_NotaCredito, Data, CONCAT('NC ', (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_notas_credito.ID_Serie),'/', faturacao_notas_credito.Numero) AS NumeroNotaCredito, Referencia, GrossTotal, NetTotal, TaxPayable, InvoiceDate, (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_notas_credito.ID_Serie) AS Serie, faturacao_notas_credito.Numero As Numero
			FROM faturacao_notas_credito WHERE Estado IN ('Aberto','Pago') AND ID_Cliente = ? 
				AND (
					STR_TO_DATE(Data, '%d/%m/%Y') BETWEEN STR_TO_DATE('".$dateAccuel."', '%d/%m/%Y') AND STR_TO_DATE('".$dateFin."', '%d/%m/%Y') 
				) ";
		if ($stmt2 = $sqli_connection -> prepare($query2)) {
			$stmt2 -> bind_param("d", $cliente['ID_Cliente']);
			$result1 = $stmt2 -> execute();

			if (false === $result1) {
				$response["errors"] = true;
				$response["message"] = $stmt2 -> error;
				die(json_encode($response));
			}
			$stmt2 -> store_result();
			$stmt2 -> bind_result($ID_NotaCredito, $DataNotaCredito, $NumeroNotaCredito, $ReferenciaNotaCredito, $GrossTotalNotaCredito, $NetTotalNotaCredito, $TaxPayableNotaCredito, $InvoiceDateNotaCredito, $SerieOrdenacaoNotaCredito, $NumOrdenacaoNotaCredito);
			while($stmt2->fetch()){
				//prepare 2nd column for order
				// if($NumOrdenacaoNotaCredito < 10) $NumeroOrdenacao = $SerieOrdenacaoNotaCredito.'/0'.$NumOrdenacaoNotaCredito;
				// else $NumeroOrdenacao = $SerieOrdenacaoNotaCredito.'/'.$NumOrdenacaoNotaCredito;
				
				

				$tmpArrayNC = array(
					"ID_Documento" => $ID_NotaCredito,
					"DataDocumento" => $DataNotaCredito,
					"NumeroDocumento" => $NumeroNotaCredito,
					"ReferenciaDocumento" => $ReferenciaNotaCredito,
					"GrossTotalDocumento" => $GrossTotalNotaCredito * (-1),
					"NetTotalDocumento" => $NetTotalNotaCredito * (-1),
					"TaxPayableDocumento" => $TaxPayableNotaCredito * (-1),
					"InvoiceDate" => $InvoiceDateNotaCredito,
					"Tipo" => 'NC',
					"DesignacaoCliente" => $cliente['NomeCliente'],
					"SerieOrdenacao" => $SerieOrdenacaoNotaCredito,
					"NumOrdenacao" => $NumOrdenacaoNotaCredito,
					// "NumeroOrdenacaoProcessado" => $NumeroOrdenacao,
				);

				$documentosCliente[] = $tmpArrayNC;
				$docsFinaisInfo[] = $tmpArrayNC;

				//add to solde total
				$soldeTotal = $soldeTotal + ( $GrossTotalNotaCredito * (-1) );
			}
			$stmt2 -> close();
		} else {
			$response["errors"] = true;
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		

		//organize Dates
		// usort($documentosCliente,'sortMovimentosDateHelper2');

		//add this to client info
		$clientsInfos[$index]['Documentos'] = $documentosCliente;
		$clientsInfos[$index]['Solde'] = $soldeTotal;
	}*/
	//var_dump($clientsInfos); die();
	$documentosCliente = array();// Il faut faire comme de l'autre 
foreach($clientsInfos as $index => $cliente) {
	//INIT VARS
	$documentosCliente = array();
	$soldeTotal = 0;

	//FATURAS
	$ID_Recibo = null;
	$DataRecibo = null;
	$NumeroRecibo = null;
	$ReferenciaRecibo = null;
	$GrossTotalRecibo = null;
	$TransactionDate = null;

	//GET DOCS FOR THIS CLIENT
	//Ajouter comme condition si on veut pas les paiements à 0 = AND GrossTotal > 0
	$query1 = "SELECT ID_Recibo, TransactionDate, CONCAT('RG ', (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_recibos.ID_Serie),'/', faturacao_recibos.Numero) AS NumeroRecibo, 
		(SELECT CONCAT('FA ', (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie),'/', faturacao_faturas.Numero) AS NumeroFatura FROM faturacao_faturas WHERE faturacao_faturas.ID_Fatura = faturacao_recibos.ID_DocumentoMain) AS ReferenciaRecibo, 
		GrossTotal, TransactionDate, TaxPayable, NetTotal
		FROM faturacao_recibos WHERE Estado IN ('Pago') AND CustomerID=? 
			AND (
				STR_TO_DATE(TransactionDate, '%Y-%m-%d') BETWEEN STR_TO_DATE('".$dateAccuelR."', '%Y-%m-%d') AND STR_TO_DATE('".$dateFinR."', '%Y-%m-%d') 
				) ";
	if ($stmt1 = $sqli_connection -> prepare($query1)) {
		$stmt1 -> bind_param("d", $cliente['Codigo']);
		$result1 = $stmt1 -> execute();

		if (false === $result1) {
			$response["errors"] = true;
			$response["message"] = $stmt1 -> error;
			die(json_encode($response));
		}
		$stmt1 -> store_result();
		$stmt1 -> bind_result($ID_Recibo, $DataRecibo, $NumeroRecibo, $ReferenciaRecibo, $GrossTotalRecibo, $TransactionDate, $TaxPayable, $NetTotal);
		while($stmt1->fetch()){
			//process date
			$tempDateT = DateTime::createFromFormat('Y-m-d', $DataRecibo);
			$DataReciboNova = $tempDateT->format('d/m/Y');

			$documentosCliente[] = array(
				"ID_Documento" => $ID_Recibo,
				"DataDocumento" => $DataReciboNova,
				"NumeroDocumento" => $NumeroRecibo,
				"ReferenciaDocumento" => $ReferenciaRecibo,
				"GrossTotalDocumento" => $GrossTotalRecibo,
				"TaxPayableDocumento" => $TaxPayable,
				"NetTotalDocumento" => $NetTotal,
				"InvoiceDate" => $TransactionDate,
				"Tipo" => 'RG',
			);

			//add to solde total
			$soldeTotal = $soldeTotal + $GrossTotalRecibo;
		}
		$stmt1 -> close();
	} else {
		$response["errors"] = true;
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//organize Dates
	usort($documentosCliente,'sortMovimentosDateHelper2');

	//add this to client info
	$clientsInfos[$index]['Documentos'] = $documentosCliente;
	$clientsInfos[$index]['Solde'] = $soldeTotal;
	//var_dump($cliente['ID_Cliente']);
}
//var_dump($clientsInfos);die();
	//organize Dates
	//usort($docsFinaisInfo,'sortMovimentosDateHelper2');

	// var_dump($docsFinaisInfo);die();

	$sqli_connection->commit();
} catch (Exception $e) {
	header('Content-Type: application/json; charset=UTF-8');
	header('HTTP/1.1 403 Opération refusée.');
	header('Location: ../../../404?redirectfrom=/frifacturation/comptabilite/clients/extrait_documents&redirectto=/frifacturation/comptabilite/clients/extrait_documents');
}

//START PROCESSING EXCEL
$objPHPExcel = new PHPExcel();

//SET HEADER
$firstSheetLine = $data[550]['trad'].': ' . date('d/m/Y H:i:s') . ' | ' . $GLOBALS['Designacao'] . '. - '.$data[1599]['trad'].': ' . $GLOBALS['Nif'];
$objPHPExcel->getActiveSheet()->mergeCells('A1:G1')->setCellValue('A1',$firstSheetLine);
$objPHPExcel->getActiveSheet()->mergeCells('A2:G2')->setCellValue('A2','');

$secondSheetLine = $data[403]['trad'].': ' . $dateAccuel . ' | '.$data[10]['trad'].': ' . $dateFin;
$objPHPExcel->getActiveSheet()->mergeCells('A3:G3')->setCellValue('A3',$secondSheetLine);
$objPHPExcel->getActiveSheet()->mergeCells('A4:G4')->setCellValue('A4','');

$styleHeader = array(
	'borders' => array(
		'allborders' => array(
			'style' => PHPExcel_Style_Border::BORDER_MEDIUM,
			'color' => array('rgb' => '000000')
		)
	),
    'alignment' => array(
        'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,
        'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
    )
);
$objPHPExcel->getActiveSheet()->getStyle("A1:G1")->applyFromArray($styleHeader);
$objPHPExcel->getActiveSheet()->getStyle('A1:G1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setARGB('FFE0E0E0');
$objPHPExcel->getActiveSheet()->getStyle("A3:G3")->applyFromArray($styleHeader);
$objPHPExcel->getActiveSheet()->getStyle('A3:G3')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setARGB('FFE0E0E0');

//SET DOCS HEADER LINE
$objPHPExcel->getActiveSheet()->setCellValue('A5',$data[1167]['trad']);
$objPHPExcel->getActiveSheet()->setCellValue('B5',$data[241]['trad']);
$objPHPExcel->getActiveSheet()->setCellValue('C5',$data[383]['trad']);
$objPHPExcel->getActiveSheet()->setCellValue('D5',$data[386]['trad']);
$objPHPExcel->getActiveSheet()->setCellValue('E5',$data[1713]['trad']);
$objPHPExcel->getActiveSheet()->setCellValue('F5',$data[1599]['trad']);
$objPHPExcel->getActiveSheet()->setCellValue('G5',$data[1559]['trad']);
// $objPHPExcel->getActiveSheet()->mergeCells('C5:F5')->setCellValue('C5','...');

$styleDocHeader = array(
	'borders' => array(
		'allborders' => array(
			'style' => PHPExcel_Style_Border::BORDER_THIN,
			'color' => array('rgb' => '000000')
		)
	),
    'alignment' => array(
        'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,
        'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
    )
);

$objPHPExcel->getActiveSheet()->getStyle("A5:G5")->applyFromArray($styleDocHeader);
$objPHPExcel->getActiveSheet()->getStyle('A5:G5')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID)->getStartColor()->setARGB('FFE0E0E0');

//PROCESS ROWS ===================================================
$styleDocLine = array(
	'borders' => array(
		'allborders' => array(
			'style' => PHPExcel_Style_Border::BORDER_THIN,
			'color' => array('rgb' => '000000')
		)
	),
    'alignment' => array(
        'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,
        'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
    )
);

//INIT LINE
$posInit = 6;
$total = 0;
//SIZE DOCS
$docsFinaisInfo = $clientsInfos;
$tamDocs = sizeof($docsFinaisInfo);
if($tamDocs < 1) {
	$noDocsLabel = $data[801]['trad'];
	$objPHPExcel->getActiveSheet()->mergeCells('A7:G7')->setCellValue('A7',$noDocsLabel);
	
	$styleEmpty = array(
	    'alignment' => array(
	        'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,
	        'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER,
	    )
	);
	$objPHPExcel->getActiveSheet()->getStyle("A7:G7")->applyFromArray($styleEmpty);
}else{
	//process docs main
	for ($i = 0; $i < $tamDocs; $i++) {
		$numDocs = sizeof($docsFinaisInfo[$i]["Documentos"]);
		for ($j = 0; $j < $numDocs; $j++) {
			//var_dump($docsFinaisInfo[$i]);die();
			//process doc
			$totIncidencia = round($docsFinaisInfo[$i]["Documentos"][$j]['NetTotalDocumento'],2);
			$totIva = round($docsFinaisInfo[$i]["Documentos"][$j]['TaxPayableDocumento'], 2);
			$totTotal = round($docsFinaisInfo[$i]["Documentos"][$j]['GrossTotalDocumento'], 2);
			$total += $docsFinaisInfo[$i]["Documentos"][$j]['GrossTotalDocumento'];
			// //ranges
			// $rangeCli = 'C'.$posInit.':F'.$posInit;
			// $rangeInc = 'G'.$posInit.':H'.$posInit;
			// $rangeIva = 'I'.$posInit.':J'.$posInit;
			// $rangeTot = 'K'.$posInit.':F'.$posInit;
			// $objPHPExcel->getActiveSheet()->mergeCells($rangeCli)->setCellValue('C'.$posInit,$docsFinaisInfo[$i]['DataDocumento']);

			$objPHPExcel->getActiveSheet()->setCellValue('A'.$posInit,$docsFinaisInfo[$i]["Documentos"][$j]['ReferenciaDocumento']);
			$objPHPExcel->getActiveSheet()->setCellValue('B'.$posInit,$docsFinaisInfo[$i]['NomeCliente']);
			$objPHPExcel->getActiveSheet()->setCellValue('C'.$posInit,str_replace("/",".",$docsFinaisInfo[$i]["Documentos"][$j]['DataDocumento']));
			$objPHPExcel->getActiveSheet()->setCellValue('D'.$posInit,str_replace("/",".",$docsFinaisInfo[$i]["Documentos"][$j]['DataDocumento']));
			$objPHPExcel->getActiveSheet()->setCellValue('E'.$posInit,$totIncidencia);
			$objPHPExcel->getActiveSheet()->setCellValue('F'.$posInit,$totIva);
			$objPHPExcel->getActiveSheet()->setCellValue('G'.$posInit,$totTotal);

			$objPHPExcel->getActiveSheet()->getStyle('A'.$posInit.':G'.$posInit)->applyFromArray($styleDocLine);
			// $objPHPExcel->getActiveSheet()->getStyle('F'.$posInit.':F'.$posInit)->applyFromArray($styleDocLineVals);
					
			//position next line
			$objPHPExcel->getActiveSheet()->getRowDimension($posInit)->setRowHeight(20);
			$posInit++;
		}
		// $objPHPExcel->getActiveSheet()->mergeCells('A'.$posInit.':F'.$posInit)->setCellValue('A'.$posInit,'');
		// $objPHPExcel->getActiveSheet()->getRowDimension($posInit)->setRowHeight(10);
		// $posInit++;
	}
}
//================================================================
//$objPHPExcel->getActiveSheet()->setCellValue('G'.$posInit,$total);
//AUTO SET COLS
$objPHPExcel->getActiveSheet()->getColumnDimension('A')->setAutoSize(false)->setWidth(15);
$objPHPExcel->getActiveSheet()->getColumnDimension('B')->setAutoSize(false)->setWidth(80);
$objPHPExcel->getActiveSheet()->getColumnDimension('C')->setAutoSize(false)->setWidth(18);
$objPHPExcel->getActiveSheet()->getColumnDimension('D')->setAutoSize(false)->setWidth(18);
$objPHPExcel->getActiveSheet()->getColumnDimension('E')->setAutoSize(false)->setWidth(20);
$objPHPExcel->getActiveSheet()->getColumnDimension('F')->setAutoSize(false)->setWidth(20);
$objPHPExcel->getActiveSheet()->getColumnDimension('G')->setAutoSize(false)->setWidth(20);
$objPHPExcel->getActiveSheet()->getRowDimension('1')->setRowHeight(20);
$objPHPExcel->getActiveSheet()->getRowDimension('2')->setRowHeight(10);
$objPHPExcel->getActiveSheet()->getRowDimension('3')->setRowHeight(20);
$objPHPExcel->getActiveSheet()->getRowDimension('4')->setRowHeight(10);
$objPHPExcel->getActiveSheet()->getRowDimension('5')->setRowHeight(30);

//SHEET LABEL TITLE
$objPHPExcel->getActiveSheet()->setTitle( $data[694]['trad'] );

//FINISH AND OUTPUT FILE
$filename = $data[673]['trad'].$id_utilizador.".xlsx";
$filename2 = $data[672]['trad'].date("Y_m_d_H_i_s").".xlsx";
$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
$objWriter->save(str_replace(__FILE__,$_SERVER['DOCUMENT_ROOT'] .'/docs/frifacturation/excel/'.$filename,__FILE__));

//FORCE DOWNLOAD
header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
header('Content-Disposition: attachment;filename="'.$filename2.'"');
header('Cache-Control: max-age=0'); 
$objWriter->save('php://output');


/**
 * ==================================
 * HELPER FUNCTIONS
 * ==================================
 */

/* Compare 2 arrays by value of Date 
 * ASCENDENT
 */
function sortMovimentosDateHelper2($item1,$item2) {
	if ($item1['InvoiceDate'] == $item2['InvoiceDate']) {
		//processa por tipo
		if($item1['Tipo'] != $item2['Tipo']){
			return ($item1['Tipo'] == 'FA') ? -1 : 1;
		}else{
			if($item1['SerieOrdenacao'] != $item2['SerieOrdenacao']){
				return ($item1['SerieOrdenacao'] > $item2['SerieOrdenacao']) ? 1 : -1;
			}else{
				return ($item1['NumOrdenacao'] > $item2['NumOrdenacao']) ? 1 : -1;
			}
		}
    }
    return ($item1['InvoiceDate'] > $item2['InvoiceDate']) ? 1 : -1;
}

/* Compare 2 arrays by value of Date 
 * DESCENDENT
 */
function sortMovimentosHelper($item1,$item2) {
	if ($item1['InvoiceDate'] == $item2['InvoiceDate']) {
		return ($item1['Tipo'] == 'FA') ? -1 : 1;
        // return 0;
    }
    return ($item1['InvoiceDate'] < $item2['InvoiceDate']) ? 1 : -1;
}
?>