<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

// GET NECESSARY DATA ----------------------------------------------------
$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET $_GET VARS ---------------------------------------------------------
$idCliente = $_POST['idCliente'];

//DEFINE VARS ------------------------------------------------------------
$objectData = array();
$objectData3 = array();

$query = "SELECT Email, Concat(Nome, ' ', Apelido)	FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente=? limit 1";

if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idCliente);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($objectData3["Mail"], $objectData3["Nom"]);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
$objectData[] = $objectData3;

//GET THE PROCESS --------------------------------------------------------
$query = "SELECT 
	faturacao_responsaveis.Email AS EmailCliente, Concat(faturacao_responsaveis.Prenom,' ',faturacao_responsaveis.Nome)
	FROM faturacao_clientes inner join faturacao_responsavel_entidades on 
	faturacao_clientes.ID_Cliente = faturacao_responsavel_entidades.ID_Cliente
	inner join faturacao_responsaveis on 
	faturacao_responsavel_entidades.ID_Responsavel = faturacao_responsaveis.ID_Responsavel WHERE faturacao_clientes.ID_Cliente=?";

if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idCliente);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result( $mail, $nom);
	while ($stmt -> fetch()) {
		$objectData[] = array("Mail" => $mail, "Nom" => $nom);
	}
	$stmt -> fetch();
	$stmt -> close();
	
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

// var_dump($objectData);die();
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));

?>