<?php 
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1639,1698,1633,729);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idDocumento = $_POST['idDocumento'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idDocumento == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//VERIFICA SE PODE SER GERADO --------------------------------------------
$query = 'SELECT Estado, (SELECT CONCAT("FA ",(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie),"/",Numero) FROM faturacao_faturas WHERE faturacao_faturas.Tipo_Doc_Origem = "RT" AND faturacao_faturas.ID_Doc_Origem = faturacao_rapports_travail.ID_Rapport ORDER BY ID_Fatura DESC LIMIT 1) FROM faturacao_rapports_travail WHERE ID_Rapport=?';
if ( $stmt = $sqli_connection->prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDocumento);
	//result single
	$result = $stmt->execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Estado, $ID_FaturaAssociada);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if($Estado == 'Rascunho' ) {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003";
	$response["message"] = "Documento inválido para clonar!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
if( $ID_FaturaAssociada ) {
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS003B";
	$response["associado"] = true;
	$response["fatura_associada"] = $ID_FaturaAssociada;
	$response["message"] = "Já está associado à fatura!";
	$response["estado"] = $Estado;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//DEFINE VARS -----------------------------------------------------------
$objectData = array();

//OBTEM OS DADOS --------------------------------------------------------
$query = "SELECT ID_Rapport, 
		ID_Cliente, 
		EnderecoCliente, 
		CodigoPostalCliente, 
		CidadeCliente, 
		RegiaoCliente, 
		EmailCliente, 
		PaisCliente, 
		TelefoneCliente, 
		EnderecoClienteDescarga, 
		EnderecoCliente2Descarga, 
		CodigoPostalClienteDescarga, 
		RegiaoClienteDescarga, 
		CidadeClienteDescarga, 
		PaisClienteDescarga,
		Tecnico,
		TecnicoSegundo,
		ID_Tecnico,
		ID_TecnicoSegundo,
		Impressora,
		NumImpressora, 
		CompteurNB,
		CompteurCoul,  
		Numero, 
		Data, 
		Duree, 
		Referencia, 
		Remarque, 
		Estado, 
		ID_Utilizador_Criacao, 
		ID_Utilizador_Atualizacao, 
		DataAtualizacao,
		Tipo_Documento_Origem,
		ID_Documento_Origem,
		Reference,
		DateDebut,
		DateFin,
		Data_Documento_Origem,
		TaxPayable,
		NetTotal,
		GrossTotal,
		TotalPagar,
		(SELECT SUM(SettlementAmount) FROM faturacao_rapports_travail_linhas WHERE faturacao_rapports_travail_linhas.ID_Rapport = faturacao_rapports_travail.ID_Rapport) AS Desconto,
		(SELECT SUM(TotalLinhaSIVA+SettlementAmount) FROM faturacao_rapports_travail_linhas WHERE faturacao_rapports_travail_linhas.ID_Rapport = faturacao_rapports_travail.ID_Rapport) AS TotalSDesconto
		FROM faturacao_rapports_travail WHERE ID_Rapport=?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDocumento);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	        	$objectData['ID_Rapport'],
	        	$objectData['ID_Cliente'],
	        	$objectData['EnderecoCliente'],
	        	$objectData['CodigoPostalCliente'],
	        	$objectData['CidadeCliente'],
	        	$objectData['RegiaoCliente'],
	        	$objectData['EmailCliente'],
	        	$objectData['PaisCliente'],
	        	$objectData['TelefoneCliente'],
	        	$objectData['EnderecoClienteDescarga'],
	        	$objectData['EnderecoCliente2Descarga'],
	        	$objectData['CodigoPostalClienteDescarga'],
	        	$objectData['RegiaoClienteDescarga'],
	        	$objectData['CidadeClienteDescarga'],
	        	$objectData['PaisClienteDescarga'],
	        	$objectData['Tecnico'],
	        	$objectData['TecnicoSegundo'],
	        	$objectData['ID_Tecnico'],
	        	$objectData['ID_TecnicoSegundo'],
	        	$objectData['Impressora'],
	        	$objectData['NumImpressora'],
	        	$objectData['CompteurNB'],
	        	$objectData['CompteurCoul'],
	        	$objectData['Numero'],
	        	$objectData['Data'],
	        	$objectData['Duree'],
	        	$objectData['Referencia'],
	        	$objectData['Remarque'],
	        	$objectData['Estado'],
	        	$objectData['ID_Utilizador'],
	        	$objectData['ID_UtilizadorAtualizacao'],
	        	$objectData['DataAtualizacao'],
	        	$objectData['Tipo_Documento_Origem'],
	        	$objectData['ID_Documento_Origem'],
	        	$objectData['Reference'],
	        	$objectData['DateDebut'],
	        	$objectData['DateFin'],
	        	$objectData['Data_Documento_Origem'],
	        	$objectData['TaxPayable'],
	        	$objectData['NetTotal'],
	        	$objectData['GrossTotal'],
	        	$objectData['TotalPagar'],
	        	$objectData['Desconto'],
				$objectData['TotalSDesconto']
			);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//NEW FIELDS PLANO CONTAS
$PlanoContasCliente = getPlanoCode("PlanoContas", "faturacao_clientes", "ID_Cliente", $objectData['ID_Cliente']);
$dadosCliente = getClientData($objectData['ID_Cliente']);
if($dadosCliente['ID_Banco'] != 0)
$PlanoContasBanco = getPlanoCode("PlanoContas", "faturacao_bancos", "ID_Banco", $dadosCliente['ID_Banco']);

//PREPARE VARS ----------------------------------------------------------
$timestamp = microtime(true);
$systemEntryDate = date("Y-m-d H:i:s");
$systemEntryDate = str_replace (' ','T',$systemEntryDate);
$numeroNew = 0;
$dataNew = date("d/m/Y");

$dateProcessed = date('Y-m-d', strtotime(" + ".$dadosCliente['Vencimento']." days"));
$validadeNew = DateTime::createFromFormat('Y-m-d', $dateProcessed);
$validadeNew = $validadeNew->format('d/m/Y');

$invoiceTypeNew = 'FT';
$invoiceTypeOrigem = 'RT';
$totalLiquidadoDocumento = 0;
$totalLiquidado = 0;
$estadoNovo = 'Rascunho';
$idDocOrigem = $idDocumento;
$referenceDocOrigem = 'RT '.$objectData['Numero'];
$idMoeda = 1;
$taxaMoeda = 1;
$vendedorFatura = $_SESSION['username'];
$EACCode = '0';
$PercentagemDesconto = 0;
$TotaRetencao = 0;
$TaxPointDate = date("Y-m-d");
$DebitAmount = 0;
$ValorRetencao = 0;
$PercentagemRetencao = 0;
$objectData['GrossTotal'] = roundPriceUp($objectData['GrossTotal']);
//-----------------------------------------------------------------------
// var_dump($objectData, $dadosCliente, $validadeNew);
// die();
//-----------------------------------------------------------------------

//INSERT OPEN DOCUMENT --------------------------------------------------
$query = "INSERT INTO faturacao_faturas( 
		ID_Cliente,
		EnderecoCliente,
		CodigoPostalCliente,
		CidadeCliente,
		RegiaoCliente,
		EmailCliente,
		PaisCliente,
		ID_Moeda,
		TaxaMoeda,
		Vendedor,
		Vencimento,
		EnderecoCarga,
		CodigoPostalCarga,
		CidadeCarga,
		RegiaoCarga,
		ID_Serie,
		Numero,
		Data,
		Validade,
		Referencia,
		Observacoes,
		TaxPayable,
		NetTotal,
		GrossTotal,
		SystemEntryDate,
		TimeStampDate,
		Desconto,
		PercentagemDesconto,
		TotaRetencao,
		TotalSDesconto,
		InvoiceType,
		EACCode,
		CustomerID,
		TotalLiquidadoDocumento,
		TotalLiquidado,
		TotalPagar,
		MetodoPagamento,
		ID_Banco,
		Estado,
		ID_Utilizador,
		Tipo_Doc_Origem,
		ID_Doc_Origem,
		Reference,
		Data_Doc_Origem,
		PlanoContas,
		PlanoContasBanco
	)VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dssssssdsssssssddssssssssssssssssssssdsdsdssss",
	            $objectData['ID_Cliente'],
	            $objectData['EnderecoCliente'],
	            $objectData['CodigoPostalCliente'],
	            $objectData['CidadeCliente'],
	            $objectData['RegiaoCliente'],
	            $objectData['EmailCliente'],
	            $objectData['PaisCliente'],
	            $idMoeda,
	            $taxaMoeda,
	            $vendedorFatura,
	            $dadosCliente['Vencimento'],
	            $objectData['EnderecoCliente'],
	            $objectData['CodigoPostalCliente'],
	            $objectData['CidadeCliente'],
	            $objectData['RegiaoCliente'],
	            $dadosCliente['ID_Serie'],
	            $numeroNew,
	            $dataNew,
	            $validadeNew,
	            $objectData['Referencia'],
	            $objectData['Remarque'],
	            $objectData['TaxPayable'],
	            $objectData['NetTotal'],
	            $objectData['GrossTotal'],
	            $systemEntryDate,
	            $timestamp,
	            $objectData['Desconto'],
	            $PercentagemDesconto,
	            $TotaRetencao,
	            $objectData['TotalSDesconto'],
	            $invoiceTypeNew,
	            $EACCode,
	            $dadosCliente['Codigo'],
	            $totalLiquidadoDocumento,
	            $totalLiquidado,
	            $objectData['GrossTotal'],
	            $dadosCliente['MetPagamento'],
	            $dadosCliente['ID_Banco'],
	            $estadoNovo,
	            $id_utilizador,
	            $invoiceTypeOrigem,
	            $idDocOrigem,
	            $referenceDocOrigem,
	            $objectData['Data'],
	            $PlanoContasCliente,
	            $PlanoContasBanco
	    	);
	$result = $stmt -> execute();
	$idFaturaNova = $stmt->insert_id;
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS006";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS007";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if( $idFaturaNova < 1){
	$response["errors"] = true;
	$response["type"] = "FATS010";
	$response["message"] = "Rapport invalid";
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//OBTEM AS LINHAS DO RAPPORT --------------------------------------------
$query = "SELECT ID_Rapport,
		ID_Artigo,
		NumeroLinha,
		ProductCode,
		ProductDescription,
		SerialNumber,
		Quantidade,
		UnidadeMedida,
		PrecoUnitario,
		Descricao,
		ID_Imposto,
		TaxType,
		TaxCountryRegion,
		TaxCode,
		TaxPercentage,
		TaxExemptionReason,
		TaxExemptionCode,
		TotalLinha,
		TotalLinhaSIVA,
		DescontoLinha,
		SettlementAmount
		FROM faturacao_rapports_travail_linhas WHERE ID_Rapport=? ORDER BY NumeroLinha";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDocumento);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		deleteRecord($idFaturaNova);
		die(json_encode($response));
	}
	$stmt -> bind_result(
			$ID_Rapport, 
			$ID_Artigo, 
			$NumeroLinha, 
			$ProductCode, 
			$ProductDescription, 
			$SerialNumber, 
			$Quantidade, 
			$UnidadeMedida, 
			$PrecoUnitario, 
			$Descricao, 
			$ID_Imposto, 
			$TaxType, 
			$TaxCountryRegion, 
			$TaxCode, 
			$TaxPercentage, 
			$TaxExemptionReason, 
			$TaxExemptionCode, 
			$TotalLinha, 
			$TotalLinhaSIVA, 
			$DescontoLinha, 
			$SettlementAmount
		);
	while ($stmt -> fetch()) {
		$dataLinhas[] = array(
		        	"ID_Rapport" => $ID_Rapport,
		        	"ID_Artigo" => $ID_Artigo,
		        	"NumeroLinha" => $NumeroLinha,
		        	"ProductCode" => $ProductCode,
		        	"ProductDescription" => $ProductDescription,
		        	"SerialNumber" => $SerialNumber,
		        	"Quantidade" => $Quantidade,
		        	"UnidadeMedida" => $UnidadeMedida,
		        	"PrecoUnitario" => $PrecoUnitario,
		        	"Descricao" => $Descricao,
		        	"ID_Imposto" => $ID_Imposto,
		        	"TaxType" => $TaxType,
		        	"TaxCountryRegion" => $TaxCountryRegion,
		        	"TaxCode" => $TaxCode,
		        	"TaxPercentage" => $TaxPercentage,
		        	"TaxExemptionReason" => $TaxExemptionReason,
		        	"TaxExemptionCode" => $TaxExemptionCode,
		        	"TotalLinha" => $TotalLinha,
		        	"TotalLinhaSIVA" => $TotalLinhaSIVA,
		        	"DescontoLinha" => $DescontoLinha,
		        	"SettlementAmount" => $SettlementAmount,
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	deleteRecord($idFaturaNova);
	die(json_encode($response));
}
//add lines to object
$objectData['linhas'] = $dataLinhas;
// var_dump($objectData['linhas']);

//INSERT THE LINES
foreach ($objectData['linhas'] as $linha) {
	// NEW FIELDS PLANO CONTAS
	$PlanoContasArtigo = getPlanoCode("PlanoContas", "faturacao_artigos", "ID_Artigo", $linha['ID_Artigo']);
	$PlanoContasTVA = getPlanoCode("PlanoContas", "faturacao_impostos", "ID_Imposto", $linha['ID_Imposto']);
	// -------------------------------------------------------------------

	//INSERT INTO DB -----------------------------------------------------
	$query = "INSERT INTO faturacao_faturas_linhas (
		ID_Fatura, 
		NumeroLinha,
		ID_Artigo,
		ProductCode,
		ProductDescription,
		Quantidade,
		UnidadeMedida,
		PrecoUnitario,
		TaxPointDate,
		Descricao,
		SerialNumber,
		ID_Imposto,
		TaxType,
		TaxCountryRegion,
		TaxCode,
		TaxPercentage,
		TaxExemptionReason,
		TaxExemptionCode,
		DescontoLinha,
		CreditAmount,
		DebitAmount,
		SettlementAmount,
		ValorRetencao,
		PercentagemRetencao,
		TotalLinha,
		TotalLinhaSIVA,
		PlanoContas,
		PlanoContasTVA
		) 
		VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dddssssssssdssssssssssssssss", 
		            $idFaturaNova, 
					$linha['NumeroLinha'],
					$linha['ID_Artigo'],
					$linha['ProductCode'],
					$linha['ProductDescription'],
					$linha['Quantidade'],
					$linha['UnidadeMedida'],
					$linha['PrecoUnitario'],
					$TaxPointDate,
					$linha['Descricao'],
					$linha['SerialNumber'],
					$linha['ID_Imposto'],
					$linha['TaxType'],
					$linha['TaxCountryRegion'],
					$linha['TaxCode'],
					$linha['TaxPercentage'],
					$linha['TaxExemptionReason'],
					$linha['TaxExemptionCode'],
					$linha['DescontoLinha'],
					$linha['TotalLinhaSIVA'],
					$DebitAmount,
					$linha['SettlementAmount'],
					$ValorRetencao,
					$PercentagemRetencao,
					$linha['TotalLinha'],
					$linha['TotalLinhaSIVA'],
					$PlanoContasArtigo,
					$PlanoContasTVA
				);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS013";
			$response["message"] = $stmt -> error;
			deleteRecord($idFaturaNova);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS014";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idFaturaNova);
		die(json_encode($response));
	}
}
//-----------------------------------------------------------------------

// var_dump($objectData, $idFaturaNova);

//log sistema - processo
$descricao_log = $data[729]['trad'].": Rapport de Travail (id: ".$idDocumento.") -- Facture (id: ".$idFaturaNova.")";
insert_log(0,"Inserir",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
$response["idDestino"] = $idFaturaNova;
die(json_encode($response));

//remove inserted Enregistrer if gives an error
function deleteRecord($idObject){
	global $sqli_connection;

	//DELETE DB -------------------------------------------------------------
	$query = "DELETE FROM faturacao_faturas WHERE ID_Fatura=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//LINHAS
	$query = "DELETE FROM faturacao_faturas_linhas WHERE ID_Fatura=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
}
//---------------------------------------------------------------------------

//get dados cliente
function getClientData($idClient){
	global $sqli_connection;
	
	$clienteData = array();

	//SELECT DB -------------------------------------------------------------
	$query = "SELECT Nome, MetPagamento, Vencimento, Codigo FROM faturacao_clientes WHERE ID_Cliente = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idClient );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "SEL001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result(
			$clienteData['Nome'],
			$clienteData['MetPagamento'],
			$clienteData['Vencimento'],
			$clienteData['Codigo']
		);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "SEL002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//SELECT DB -------------------------------------------------------------
	$query = "SELECT ID_Banco FROM faturacao_bancos WHERE Ativo = 1 ORDER BY ID_Banco LIMIT 1";
	if ($stmt = $sqli_connection -> prepare($query)) {
		// $stmt -> bind_param("d", $idClient );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "SEL003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result(
			$clienteData['ID_Banco']
		);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "SEL004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//SELECT DB -------------------------------------------------------------
	$query = "SELECT ID_Serie FROM faturacao_series WHERE Predefinida = 1 ORDER BY ID_Serie DESC LIMIT 1";
	if ($stmt = $sqli_connection -> prepare($query)) {
		// $stmt -> bind_param("d", $idClient );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "SEL005";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result(
			$clienteData['ID_Serie']
		);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "SEL006";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	return $clienteData;
}
//----------------------------------------------------------------------
?>