<?php
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo_gesfaturacao.php";
/*Control user*/
/*
 * Script:    DataTables server-side script for PHP and MySQL
 * Copyright: 2010 - Allan Jardine
 * License:   GPL v2 or BSD (3-point)
 * Edited by Pedro Gomes
 */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Easy set variables
 */

/* Database connection information */
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection_mysql.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";

include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

/* Array of database columns which should be read and sent back to DataTables. Use a space where
 * you want to insert a non-database field (for example a counter or static image)
 */
$aColumns = array(
    "CASE WHEN datediff('".date('Y-m-d')."',STR_TO_DATE( Validade,  '%d/%m/%Y' )) <= 0 THEN '' WHEN datediff('".date('Y-m-d')."',STR_TO_DATE( Validade,  '%d/%m/%Y' )) <= 10 THEN '1º Rappel' ELSE '2º Rappel' END",
    'CONCAT("FA ",(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie),"/",Numero)',
    '(SELECT Codigo FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente)',
    '(SELECT Nome FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente)',
	'(SELECT Apelido FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente)', //(4)
    'STR_TO_DATE( Data,  "%d/%m/%Y" )',
    'STR_TO_DATE( Validade,  "%d/%m/%Y" )',
    'GrossTotal',
    '(GrossTotal - TotalLiquidado)',
    'Estado',
    'ID_Fatura',
	'CASE Tipo_Doc_Origem WHEN "CL" THEN (SELECT Cotisation from faturacao_locations where faturacao_faturas.ID_Doc_Origem = faturacao_locations.ID_Location) ELSE null END',
	'(SELECT Suspendu FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente)'
	
);

/* Column to filter*/
$fFilter = array(
    //'CASE WHEN datediff("'.date('Y-m-d').'",STR_TO_DATE( Validade,  "%d/%m/%Y" )) < 30 THEN "1º Rappel" ELSE "2º Rappel" END',
    'CONCAT("FA ",(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie),"/",Numero)',
    //'(SELECT Codigo FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente)',
    '(SELECT Nome FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente)',
    //'Data',
    //'Validade',
    //'GrossTotal',
    //'(TotalLiquidado - GrossTotal)',
    //'Estado',
    //'ID_Fatura'
);

/* Indexed column (used for fast and accurate table cardinality) */
$sIndexColumn = "faturacao_faturas.ID_Fatura";

/* DB table to use */
$sTable = "faturacao_faturas";

/*DB Table to count*/
$cTable = "faturacao_faturas";

/*LEFT JOIN Table*/
$sLeft="";

/*Join Table*/
$todayDate = date("d/m/Y");
$sJoin = "Estado IN ('Aberto') AND datediff('".date('Y-m-d')."',STR_TO_DATE( Validade,  '%d/%m/%Y' )) > 0";

$_GET['Rappel_sorted'] = 2;
if ( isVendedor() == 1 ) {
    $clientsIDs = getVendedorClients();
    // $sJoin = "ID_Cliente IN (".$clientsIDs.")";
    $sJoin = "Estado IN ('Aberto') AND ID_Cliente IN (".$clientsIDs.") AND datediff('".date('Y-m-d')."',STR_TO_DATE( Validade,  '%d/%m/%Y' )) > 0 ";
}else{
    $sJoin = "Estado IN ('Aberto') AND datediff('".date('Y-m-d')."',STR_TO_DATE( Validade,  '%d/%m/%Y' )) > 0";
}
$innerJoin = " inner join faturacao_clientes on faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente ";

include 'commun.php';
?>