<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/Bvr.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idGuia = $_POST['idGuia'];
$referencia = $_POST['referencia'];
$observacoes = $_POST['observacoes'];

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $idGuia == '' || $idGuia < 1) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}

//INSERT OPEN DOCUMENT ---------------------------------------------------
$query = "UPDATE faturacao_guias_transporte SET Referencia=?, Observacoes=? WHERE ID_GuiaTransporte=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("ssd", $referencia, $observacoes, $idGuia );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA010";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA011";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

$response["guia"] = $idGuia;

//log sistema - processo
$descricao_log ="Édition du bulletin de livraison - Référence et Remarques (id: ".$idGuia.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);
//------------------------------------------------------------------------

//response
$response["errors"] = false;
die(json_encode($response));
?>