<?php 
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/tcpdf/tcpdf.php";
// include "../../../../resources/tcpdf/tcpdf.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1639,1698,1633,766,294,543,550,103,1599,1542,1269,1726,1373,1292,10,403,377,911,1167,1542);
if(isset($data2)){
	$data2 = $data2 + get_trad($ids_list);
} else {
	$data2 = get_trad($ids_list);
}
$GLOBALS['Trad'] = $data2;
// setlocale(LC_MONETARY, 'fr_CH.UTF-8');

$data_inicio = $_GET["FiltroDataInicial"];
$data_fim = $_GET["FiltroDataFinal"];
// $data_inicio = "19/08/2017";
// $data_fim = "29/08/2017";

//log sistema - processo
$descricao_log ="Impression du document: Récapitulatif TVA";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

/**
 * |---------------------------------------------------------------------------
 * |	Informações Globais
 * | ------------------------
 * |
 * | @Tamanho da Page PDF - 267 Horizontal
 * | @Tamanho da Page PDF - 160 Vertical
 * | MultiCell -> $width, $height, $txt, $border=0, $align='J/R/L/C', $fill=false, $ln=1, $x='', $y='', $reseth=true, $stretch=0, $ishtml=false, $autopadding=true, $maxh=0, $valign='T', $fitcell=false
 * | Line -> $x1, $y1, $x2, $y2, $style=array()
 * |---------------------------------------------------------------------------
 */


//COMPANY INFO - - - - - - - - - - - - - - - - - - - - - -
$query = "SELECT  Designacao, Nif, RegistoComercial, Endereco1, Endereco2, CodigoPostal, Cidade, Email, Website, CapitalSocial, Conservatoria, Telefone, Fax, Logotipo, NormaContabilistica, CAE_Principal  from faturacao_empresa_dados LIMIT 1";
if ($stmt = $sqli_connection -> prepare($query)) {
	$result = $stmt -> execute();

	if (false === $result) {
		$response["errors"] = true;
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result($designacao, $nif, $registo_comercial, $endereco1, $endereco2, $codigo_postal, $cidade, $email, $website, $capital_social, $conservatoria, $telefone, $fax, $logotipo, $norma_contabilistica, $cae_principal);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));

}
$GLOBALS['Designacao'] = $designacao;
$GLOBALS['Nif'] = $nif;
$GLOBALS['RegistoComercial'] = $registo_comercial;
$GLOBALS['Endereco1'] = $endereco1;
$GLOBALS['Endereco2'] = $endereco2;
$GLOBALS['CodigoPostal'] = $codigo_postal;
$GLOBALS['Cidade'] = $cidade;
$GLOBALS['Email'] = $email;
$GLOBALS['Website'] = $website;
$GLOBALS['CapitalSocial'] = $capital_social;
$GLOBALS['Conservatoria'] = $conservatoria;
$GLOBALS['Telefone'] = $telefone;
$GLOBALS['Fax'] = $fax;
$GLOBALS['Logotipo'] = $logotipo;
$GLOBALS['NormaContabilistica'] = $norma_contabilistica;
$GLOBALS['CAE_Principal'] = $cae_principal;

$faturas = array();
//DOC INFO - - - - - - - - - - - - - - - - - - - - - -
$query = "SELECT ID_Fatura, Data, (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie) AS Serie, Numero, InvoiceType FROM faturacao_faturas WHERE Estado IN ('Aberto', 'Pago') AND STR_TO_DATE(InvoiceDate, '%Y-%m-%d') BETWEEN STR_TO_DATE(?, '%d/%m/%Y') AND STR_TO_DATE(?, '%d/%m/%Y')";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("ss", $data_inicio, $data_fim);
	$result = $stmt -> execute();

	if (false === $result) {
		$response["errors"] = true;
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result($invoiceID, $dataFatura, $serieFatura, $numFatura, $invoiceType);
	while($stmt->fetch()){
		$faturas[] = array('ID_Fatura' => $invoiceID, 'Data' => $dataFatura, 'Serie' => $serieFatura, 'Numero' => $numFatura, 'InvoiceType' => 'FA');
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));

}


foreach($faturas as $index => $fatura) {
	$totalLinhas = 0; $totalLinhasSIVA = 0; $total = 0;
	$faturas[$index]['totalLinhas'] = 0;
	$faturas[$index]['totalLinhasSIVA'] = 0;
	$faturas[$index]['total'] = 0;

	if($fatura['ID_Fatura'] > 0){
		$query1 = "SELECT SUM(TotalLinha), SUM(TotalLinhaSIVA), (SUM(TotalLinha) - SUM(TotalLinhaSIVA)) FROM faturacao_faturas_linhas WHERE ID_Fatura = ?";
		if ($stmt1 = $sqli_connection -> prepare($query1)) {
			$stmt1 -> bind_param("d", $fatura['ID_Fatura']);
			$result1 = $stmt1 -> execute();

			if (false === $result1) {
				$response["errors"] = true;
				$response["message"] = $stmt1 -> error;
				die(json_encode($response));
			}
			$stmt1 -> store_result();
			$stmt1 -> bind_result($totalLinhas, $totalLinhasSIVA, $total);
			$stmt1 -> fetch();
			
			$faturas[$index]['totalLinhas'] = $totalLinhas;
			$faturas[$index]['totalLinhasSIVA'] = $totalLinhasSIVA;
			$faturas[$index]['total'] = $total;
			
			$stmt1 -> close();
		} else {
			$response["errors"] = true;
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		//------------------------------------------------------------------------
	}else{
		$faturas[$index]['totalLinhas'] = $totalLinhas;
		$faturas[$index]['totalLinhasSIVA'] = $totalLinhasSIVA;
		$faturas[$index]['total'] = $total;
	}
}

//-----------------------------------------------------------------------
$compras = array();
//DOC INFO - - - - - - - - - - - - - - - - - - - - - -
$query = "SELECT ID_Compra, Data, (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_compras.ID_Serie) AS Serie, Numero FROM faturacao_compras WHERE Estado IN ('Aberto', 'Pago') AND STR_TO_DATE(Data, '%d/%m/%Y') BETWEEN STR_TO_DATE(?, '%d/%m/%Y') AND STR_TO_DATE(?, '%d/%m/%Y')";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("ss", $data_inicio, $data_fim);
	$result = $stmt -> execute();

	if (false === $result) {
		$response["errors"] = true;
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result($invoiceID, $dataFatura, $serieFatura, $numFatura);
	while($stmt->fetch()){
		$compras[] = array('ID_Compra' => $invoiceID, 'Data' => $dataFatura, 'Serie' => $serieFatura, 'Numero' => $numFatura, 'InvoiceType' => 'PY');
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));

}


foreach($compras as $index => $fatura) {
	$totalLinhas = 0; $totalLinhasSIVA = 0; $total = 0;
	$compras[$index]['totalLinhas'] = 0;
	$compras[$index]['totalLinhasSIVA'] = 0;
	$compras[$index]['total'] = 0;

	if($fatura['ID_Compra'] > 0){
		$query1 = "SELECT SUM(TotalLinha), SUM(TotalLinhaSIVA), (SUM(TotalLinha) - SUM(TotalLinhaSIVA)) FROM faturacao_compras_linhas WHERE ID_Compra = ?";
		if ($stmt1 = $sqli_connection -> prepare($query1)) {
			$stmt1 -> bind_param("d", $fatura['ID_Compra']);
			$result1 = $stmt1 -> execute();

			if (false === $result1) {
				$response["errors"] = true;
				$response["message"] = $stmt1 -> error;
				die(json_encode($response));
			}
			$stmt1 -> store_result();
			$stmt1 -> bind_result($totalLinhas, $totalLinhasSIVA, $total);
			$stmt1 -> fetch();
			
			$compras[$index]['totalLinhas'] = $totalLinhas * -1;
			$compras[$index]['totalLinhasSIVA'] = $totalLinhasSIVA * -1;
			$compras[$index]['total'] = $total * -1;
			
			$stmt1 -> close();
		} else {
			$response["errors"] = true;
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		//------------------------------------------------------------------------
	}else{
		$compras[$index]['totalLinhas'] = $totalLinhas * -1;
		$compras[$index]['totalLinhasSIVA'] = $totalLinhasSIVA * -1;
		$compras[$index]['total'] = $total * -1;
	}
}
//------------------------------------------------------

$notasCredito = array();
//DOC INFO - - - - - - - - - - - - - - - - - - - - - -
$query = "SELECT ID_NotaCredito, Data, (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_notas_credito.ID_Serie) AS Serie, Numero, InvoiceType, Data_Documento_Origem, Reference, Reason_Origem FROM faturacao_notas_credito WHERE Estado IN ('Aberto', 'Pago') AND STR_TO_DATE(InvoiceDate, '%Y-%m-%d') BETWEEN STR_TO_DATE(?, '%d/%m/%Y') AND STR_TO_DATE(?, '%d/%m/%Y')";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("ss", $data_inicio, $data_fim);
	$result = $stmt -> execute();

	if (false === $result) {
		$response["errors"] = true;
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result($invoiceNCID, $dataNC, $serieNC, $numNC, $invoiceTypeNC, $dataOrigemNC, $referNC, $reasonNC);
	while($stmt->fetch()){
		$notasCredito[] = array('ID_NotaCredito' => $invoiceNCID, 'Data' => $dataNC, 'Serie' => $serieNC, 'Numero' => $numNC, 'InvoiceType' => $invoiceTypeNC, 'Data_Documento_Origem' => $dataOrigemNC, 'Reference' => $referNC, 'Reason_Origem' => $reasonNC);
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));

}
foreach($notasCredito as $index => $notaCredito) {
	$totalLinhas = 0; $totalLinhasSIVA = 0; $total = 0;
	$notasCredito[$index]['totalLinhas'] = 0;
	$notasCredito[$index]['totalLinhasSIVA'] = 0;
	$notasCredito[$index]['total'] = 0;

	if($notaCredito['ID_NotaCredito'] > 0){
		$query1 = "SELECT SUM(TotalLinha), SUM(TotalLinhaSIVA), (SUM(TotalLinha) - SUM(TotalLinhaSIVA)) FROM faturacao_notas_credito_linhas WHERE ID_NotaCredito = ?";
		if ($stmt1 = $sqli_connection -> prepare($query1)) {
			$stmt1 -> bind_param("d", $notaCredito['ID_NotaCredito']);
			$result1 = $stmt1 -> execute();

			if (false === $result1) {
				$response["errors"] = true;
				$response["message"] = $stmt1 -> error;
				die(json_encode($response));
			}
			$stmt1 -> store_result();
			$stmt1 -> bind_result($totalLinhas, $totalLinhasSIVA, $total);
			$stmt1 -> fetch();
			
			$notasCredito[$index]['totalLinhas'] = $totalLinhas;
			$notasCredito[$index]['totalLinhasSIVA'] = $totalLinhasSIVA;
			$notasCredito[$index]['total'] = $total;
			
			$stmt1 -> close();
		} else {
			$response["errors"] = true;
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		//------------------------------------------------------------------------
	}else{
		$notasCredito[$index]['totalLinhas'] = $totalLinhas;
		$notasCredito[$index]['totalLinhasSIVA'] = $totalLinhasSIVA;
		$notasCredito[$index]['total'] = $total;
	}
}

/**
 * |----------------------------------------------------
 * |				BASE CLASS
 * |----------------------------------------------------
 */
class MYPDF extends TCPDF {
	//Page header
	public function Header() {
		$data2 = $GLOBALS['Trad'];
		$half_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/2;
		$third_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/3;
		$fourth_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/4;
		$fifth_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/5;
		$six_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/6;
		$seven_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/7;
		$eigth_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/8;
		$nine_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/9;
		$ten_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/10;
		$eleven_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/11;
		$twelve_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/12;

		$fourth_touch_right = ($this -> getPageWidth() - PDF_MARGIN_RIGHT - $fourth_page);

		$destX = $third_page + $third_page ;
		$typeImg = explode('.', $GLOBALS["Logotipo"]);
		$typeImg = end($typeImg);
		$typeImg = strtoupper($typeImg);
		// var_dump($GLOBALS["Logotipo"],$typeImg);

		// Image method signature:
		// Image($file, $x='', $y='', $w=0, $h=0, $type='', $link='', $align='', $resize=false, $dpi=300, $palign='', $ismask=false, $imgmask=false, $border=0, $fitbox=false, $hidden=false, $fitonpage=false)
		$this -> Image($_SERVER["DOCUMENT_ROOT"] . "/uploads/faturacao/".$GLOBALS["Logotipo"], 0, 3, 0, 24, $typeImg, '', 'C', false, 300, 'L', false, false, 0, false, false, false);

		// $this -> SetFont('opensans', '', 8, '', true);
		$this -> setY(27);

		
		//Left
		$this -> SetFont('opensans', 'B', 8, '', true);
		$this -> MultiCell($third_page, '', $GLOBALS["Designacao"],   0, 'L', false, 1, '', '', true, 0, false, true, 0, 'T', false);
		$this -> SetFont('opensans', '', 8, '', true);
		//Left
		$this -> MultiCell($third_page, '', $GLOBALS["Endereco1"],    0, 'L', false, 1, '', '', true, 0, false, true, 0, 'T', false);
		//Left
		$this -> MultiCell($third_page, '', $GLOBALS["CodigoPostal"] . " " . $GLOBALS["Cidade"] , 0, 'L', false, 1, '', '', true, 0, false, true, 0, 'T', false);
		//Left
		$this -> SetFont('opensans', 'B', 8, '', true);
		$this -> MultiCell($twelve_page, '', $data2[766]['trad'].': ', 0, 'L', false, 0, '', '', false, 0, false, true, 0, 'T', false);
		$this -> SetFont('opensans', '', 8, '', true);
		$this -> MultiCell($third_page-3, '', $GLOBALS["Nif"], 0, 'R', false, 1, '', '', true, 0, false, true, 0, 'T', false);
		//Left
		$this -> SetFont('opensans', 'B', 8, '', true);
		$this -> MultiCell($twelve_page, '', $data2[294]['trad'].': ', 0, 'L', false, 0, '', '', false, 0, false, true, 0, 'T', false);
		$this -> SetFont('opensans', '', 8, '', true);
		$this -> MultiCell($third_page-3, '', $GLOBALS["Telefone"], 0, 'R', false, 1, '', '', true, 0, false, true, 0, 'T', false);
		//Left
		$this -> SetFont('opensans', 'B', 8, '', true);
		$this -> MultiCell($twelve_page, '', $data2[543]['trad'].':', 0, 'L', false, 0, '', '', false, 0, false, true, 0, 'T', false);
		$this -> SetFont('opensans', '', 8, '', true);
		$this -> MultiCell($third_page-3, '', $GLOBALS["Email"], 0, 'R', false, 1, '', '', true, 0, false, true, 0, 'T', false);
		//line
		$this -> Line(PDF_MARGIN_LEFT, $this->GetY()+2, $third_page+$seven_page, $this->GetY()+2, array('width' => 0.1, 'cap' => 'butt', 'join' => 'miter', 'dash' => 0, 'color' => array(150, 150, 150)));
	}

	// Page footer
	public function Footer() {
		$data2 = $GLOBALS['Trad'];
		$line1 = '<p>'.$data2[550]['trad'].': ' . date('d/m/Y H:i:s') . '<br>' . $GLOBALS['Designacao'] . '. - '.$data2[1599]['trad'].': ' . $GLOBALS['Nif'] . '</p>';

		$right_marg = $this -> getPageWidth() - PDF_MARGIN_RIGHT;
		$paginationX = $this -> getPageWidth() - PDF_MARGIN_LEFT - 4;

		// Position at 20 mm from bottom
		$this -> SetY(-18);
		$lineY = $this->GetY();
		// Set font
		$this -> SetFont('opensans', '', 8);
		$this -> Line(PDF_MARGIN_LEFT, $this->GetY()-2, $right_marg, $this->GetY()-2, array('width' => 0.1, 'cap' => 'butt', 'join' => 'miter', 'dash' => 0, 'color' => array(150, 150, 150)));

		$this -> writeHTMLCell(0, 5, '', $this->GetY(), $line1, 0, 1, 0, true, 'C', false);
		
		/*$this -> SetFont('opensans', '', 7);
		$this -> SetY(-15);
		$this -> Cell($paginationX, 10, 'Page ' . $this -> getAliasNumPage() . '/' . $this -> getAliasNbPages(), 0, 0, 'R', 0, '', 0, false, 'T', 'M');*/
	}
}

//=====================================================+
// 					START FILE
//=====================================================+

$pdf = new MYPDF('P', PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);

$pdf -> SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, PDF_HEADER_TITLE . ' 001', PDF_HEADER_STRING, array(0, 64, 255), array(0, 64, 128));
$pdf -> setFooterData(array(0, 64, 0), array(0, 64, 128));

$pdf -> setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
$pdf -> setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

$pdf -> SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

$pdf -> SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
$pdf -> SetHeaderMargin(PDF_MARGIN_HEADER);
$pdf -> SetFooterMargin(PDF_MARGIN_FOOTER);

$pdf -> SetAutoPageBreak(TRUE, 0);
$pdf -> setImageScale(PDF_IMAGE_SCALE_RATIO);

$tagvs = array('p' => array(0 => array('h' => 0, 'n' => 0), 1 => array('h' => 0, 'n'=> 0)), 'div' => array(0 => array('h' => 0, 'n' => 0), 1 => array('h' => 0, 'n'=> 0)), 'ul' => array(0 => array('h' => 0, 'n' => 0), 1 => array('h' => 0, 'n'=> 0)), 'br' => array(0 => array('h' => 0.2, 'n' => 1), 1 => array('h' => 0.2, 'n'=> 1)));
$pdf->setHtmlVSpace($tagvs);

// Add a page
$pdf -> setPrintHeader(false);
$pdf -> setPrintFooter(true);

$pdf -> setFillColor(255, 255, 255);

//Defs
$full_page = $pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT;
$half_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/2;
$third_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/3;
$fourth_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/4;
$fifth_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/5;
$six_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/6;
$seven_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/7;
$eigth_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/8;
$nine_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/9;
$ten_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/10;
$eleven_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/11;
$twelve_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/12;

//Defs2
$border_bottom = array('B' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_full = array('TLRB' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_lr = array('LR' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_lt = array('LT' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_rt = array('RT' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_lrt = array('LRT' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_lrb = array('LRB' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_lb = array('LB' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_rb = array('RB' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_tb = array('TB' => array('width' => 0.1, 'color' => array(0, 0, 0)));

$border_r = array('R' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_l = array('L' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_b = array('B' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_t = array('T' => array('width' => 0.1, 'color' => array(0, 0, 0)));

$style_line = array('width' => 0.1, 'cap' => 'butt', 'join' => 'miter', 'dash' => 0, 'color' => array(0, 0, 0));
$style_bold_line = array('width' => 0.5, 'cap' => 'butt', 'join' => 'miter', 'dash' => 0, 'color' => array(0, 0, 0));
$style_light_line = array('width' => 0.1, 'cap' => 'butt', 'join' => 'miter', 'dash' => 0, 'color' => array(150, 150, 150));

$right_marg = $pdf -> getPageWidth() - PDF_MARGIN_RIGHT;

//--------------- First Page ---------------
// $pdf -> startPageGroup();
$pdf -> AddPage();

// Início do conteudo (Y)
$startContentY = $pdf -> getPageHeight() / 4;

$pdf -> Header();

$resto = $full_page - ($ten_page  + $seven_page + $seven_page + $seven_page);

cabecalho($pdf);

cabecalho_tabela($pdf);

$totalLinhasSIVAFinal = 0;
$totalFinal = 0;
$totalLinhasFinal = 0;

// Linhas de Fatura
$pdf -> SetFont('opensans', '', 8);
foreach ($faturas as $linha) {
	if($pdf -> getY() >= 260) {
		//page break ---------------------------------------------------------------------------------------------------
		$pdf -> AddPage();
		cabecalho_tabela($pdf);
		$pdf -> setY($pdf -> getY() );
	}

	$a = $pdf->getStringHeight($ten_page, $linha['Data']);
	$b = $pdf->getStringHeight($resto, $linha['InvoiceType'].' '.$linha['Serie'].'/'.$linha['Numero']);
	$e = $pdf->getStringHeight($seven_page, number_format($linha['totalLinhasSIVA'], $numDecimais, '.', '\'' ));
	// $f = $pdf->getStringHeight($eigth_page, number_format(0, $numDecimais, '.', '\'' ));
	$g = $pdf->getStringHeight($seven_page, number_format($linha['total'], $numDecimais, '.', '\'' ));
	// $h = $pdf->getStringHeight($eigth_page, number_format(0, $numDecimais, '.', '\'' ));
	$i = $pdf->getStringHeight($seven_page, number_format($linha['totalLinhas'], $numDecimais, '.', '\'' ));
	$height = calcHeightProd([$a, $b, $c, $e, $f, $g, $h, $i]);

	$pdf -> Line(PDF_MARGIN_LEFT, $pdf->GetY(), $right_marg, $pdf->GetY(), $style_light_line);
	$pdf -> MultiCell($ten_page, $height, $linha['Data'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	$pdf -> MultiCell($resto, $height, $linha['InvoiceType'].' '.$linha['Serie'].'/'.$linha['Numero'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	$pdf -> MultiCell($seven_page, $height, number_format($linha['totalLinhasSIVA'], $numDecimais, '.', '\'' ),  0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	// $pdf -> MultiCell($eigth_page,	$height, number_format(0, $numDecimais, '.', '\'' ), 0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	$pdf -> MultiCell($seven_page, $height, number_format($linha['total'], $numDecimais, '.', '\'' ), 0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	// $pdf -> MultiCell($eigth_page, $height, number_format(0, $numDecimais, '.', '\'' ), 0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	$pdf -> MultiCell($seven_page, $height, number_format($linha['totalLinhas'], $numDecimais, '.', '\'' ), 0, 'R', false, 1, '', '', true, 0, false, false, 0, 'T', true);

	$totalLinhasSIVAFinal += $linha['totalLinhasSIVA'];
	$totalFinal += $linha['total'];
	$totalLinhasFinal += $linha['totalLinhas'];
}

$pdf -> SetFont('opensans', '', 8);
foreach ($compras as $linha) {
	if($pdf -> getY() >= 260) {
		//page break ---------------------------------------------------------------------------------------------------
		$pdf -> AddPage();
		cabecalho_tabela($pdf);
		$pdf -> setY($pdf -> getY() );
	}

	$a = $pdf->getStringHeight($ten_page, $linha['Data']);
	$b = $pdf->getStringHeight($resto, $linha['InvoiceType'].' '.$linha['Serie'].'/'.$linha['Numero']);
	$e = $pdf->getStringHeight($seven_page, number_format($linha['totalLinhasSIVA'], $numDecimais, '.', '\'' ));
	// $f = $pdf->getStringHeight($eigth_page, number_format(0, $numDecimais, '.', '\'' ));
	$g = $pdf->getStringHeight($seven_page, number_format($linha['total'], $numDecimais, '.', '\'' ));
	// $h = $pdf->getStringHeight($eigth_page, number_format(0, $numDecimais, '.', '\'' ));
	$i = $pdf->getStringHeight($seven_page, number_format($linha['totalLinhas'], $numDecimais, '.', '\'' ));
	$height = calcHeightProd([$a, $b, $c, $e, $f, $g, $h, $i]);

	$pdf -> Line(PDF_MARGIN_LEFT, $pdf->GetY(), $right_marg, $pdf->GetY(), $style_light_line);
	$pdf -> MultiCell($ten_page, $height, $linha['Data'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	$pdf -> MultiCell($resto, $height, $linha['InvoiceType'].' '.$linha['Serie'].'/'.$linha['Numero'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	$pdf -> MultiCell($seven_page, $height, number_format($linha['totalLinhasSIVA'], $numDecimais, '.', '\'' ),  0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	// $pdf -> MultiCell($eigth_page,	$height, number_format(0, $numDecimais, '.', '\'' ), 0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	$pdf -> MultiCell($seven_page, $height, number_format($linha['total'], $numDecimais, '.', '\'' ), 0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	// $pdf -> MultiCell($eigth_page, $height, number_format(0, $numDecimais, '.', '\'' ), 0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	$pdf -> MultiCell($seven_page, $height, number_format($linha['totalLinhas'], $numDecimais, '.', '\'' ), 0, 'R', false, 1, '', '', true, 0, false, false, 0, 'T', true);

	$totalLinhasSIVAFinal += $linha['totalLinhasSIVA'];
	$totalFinal += $linha['total'];
	$totalLinhasFinal += $linha['totalLinhas'];
}
$pdf -> SetFont('opensans', '', 8);

foreach ($notasCredito as $linha) {
	if($pdf -> getY() >= 260) {
		//page break ---------------------------------------------------------------------------------------------------
		$pdf -> AddPage();
		cabecalho_tabela($pdf);
		$pdf -> setY($pdf -> getY() );
	}

	$a = $pdf->getStringHeight($ten_page, $linha['Data']);
	$b = $pdf->getStringHeight($resto, $linha['InvoiceType'].' '.$linha['Serie'].'/'.$linha['Numero'].'  ['.$linha['Reference'].' '.$linha['Data_Documento_Origem'].' ('.$linha['Reason_Origem'].')]');
	$e = $pdf->getStringHeight($seven_page, number_format(0 - $linha['totalLinhasSIVA'], $numDecimais, '.', '\'' ));
	// $f = $pdf->getStringHeight($eigth_page, number_format(0, $numDecimais, '.', '\'' ));
	$g = $pdf->getStringHeight($seven_page, number_format(0 - $linha['total'], $numDecimais, '.', '\'' ));
	// $h = $pdf->getStringHeight($eigth_page, number_format(0, $numDecimais, '.', '\'' ));
	$i = $pdf->getStringHeight($seven_page, number_format(0 - $linha['totalLinhas'], $numDecimais, '.', '\'' ));
	$height = calcHeightProd([$a, $b, $c, $e, $f, $g, $h, $i]);

	$pdf -> Line(PDF_MARGIN_LEFT, $pdf->GetY(), $right_marg, $pdf->GetY(), $style_light_line);
	$pdf -> MultiCell($ten_page, $height, $linha['Data'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	$pdf -> MultiCell($resto, $height, $linha['InvoiceType'].' '.$linha['Serie'].'/'.$linha['Numero'].'  ['.$linha['Reference'].' '.$linha['Data_Documento_Origem'].' ('.$linha['Reason_Origem'].')]',  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	$pdf -> MultiCell($seven_page, $height, number_format(0 - $linha['totalLinhasSIVA'], $numDecimais, '.', '\'' ),  0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	// $pdf -> MultiCell($eigth_page,	$height, number_format(0, $numDecimais, '.', '\'' ), 0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	$pdf -> MultiCell($seven_page, $height, number_format(0 - $linha['total'], $numDecimais, '.', '\'' ), 0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	// $pdf -> MultiCell($eigth_page, $height, number_format(0, $numDecimais, '.', '\'' ), 0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	$pdf -> MultiCell($seven_page, $height, number_format(0 - $linha['totalLinhas'], $numDecimais, '.', '\'' ), 0, 'R', false, 1, '', '', true, 0, false, false, 0, 'T', true);

	$totalLinhasSIVAFinal -= $linha['totalLinhasSIVA'];
	$totalFinal -= $linha['total'];
	$totalLinhasFinal -= $linha['totalLinhas'];
}

$pdf -> Line(PDF_MARGIN_LEFT, $pdf->GetY(), $right_marg, $pdf->GetY(), $style_line);

$pdf -> SetFont('opensans', 'B', 8, '', true);
$pdf -> MultiCell($ten_page + $resto, '', $data2[1542]['trad'].': ',  0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
$pdf -> MultiCell($seven_page, '', number_format($totalLinhasSIVAFinal, $numDecimais, '.', '\'' ).' CHF',  0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
// $pdf -> MultiCell($eigth_page,	'', number_format(0, $numDecimais, '.', '\'' ), 0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
$pdf -> MultiCell($seven_page, '', number_format($totalFinal, $numDecimais, '.', '\'' ).' CHF', 0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
// $pdf -> MultiCell($eigth_page, '', number_format(0, $numDecimais, '.', '\'' ), 0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
$pdf -> MultiCell($seven_page, '', number_format($totalLinhasFinal, $numDecimais, '.', '\'' ).' CHF', 0, 'R', false, 1, '', '', true, 0, false, false, 0, 'T', true);
$pdf -> SetFont('opensans', '', 8, '', true);

$pdf -> Ln();

	// Line -> $x1, $y1, $x2, $y2, $style=array()
	// MultiCell -> $width, $height, $txt, $border=0, $align='J/R/L/C', $fill=false, $ln=1, $x='', $y='', $reseth=true, $stretch=0, $ishtml=false, $autopadding=true, $maxh=0, $valign='T', $fitcell=false

// ----------- Paginação e colocação de 'Originale', 'Duplicata', 'Triplé' e 'Quadruplé' -----------
$max = $pdf -> PageNo();

// ----------------- Page Numbers -----------------------------
$paginationX = $right_marg - PDF_MARGIN_RIGHT;
$pages = $pdf -> getNumPages();
for($i = 1; $i <= $pages; ){
	for($k = 1; $k <= $max; $k++, $i++){
		$pdf -> setPage($i);

		$pdf -> SetFont('opensans', '', 7);
		$pdf -> SetY(-10);
		$pdf -> Cell($paginationX, 0, $data2[1269]['trad'].' ' . $k . '/' . $max, 0, 0, 'R', 0, '', 0, false, 'B', 'B');

	}
}
// ----------------------------------------------------------

// ------------- Certificação Vertical Lado Esquerdo -------- 
$total_pages = $pdf -> getNumPages();
for ($i = 1; $i <= $total_pages; $i++) {
    $pdf -> setPage($i);

    // $myPageWidth = $pdf -> getPageWidth();
    $myPageHeight = $pdf -> getPageHeight();

    $myX = PDF_MARGIN_LEFT / 2 + 2;
    $myY = $myPageHeight - 35;

    $pdf -> SetAlpha(0.5);

    $pdf -> StartTransform();
    $pdf -> Rotate(90, $myX, $myY);
    $pdf -> SetFont('opensans', '', 7);
    $pdf -> SetTextColor(0, 0, 0);

    $pdf -> Text($myX, $myY, ' ');
    $pdf -> StopTransform();

    // Reset the transparency to default
    $pdf -> SetAlpha(1);
}

// Close and output PDF document
// This method has several options, check the source code documentation for more information.
$pdf -> Output($data2[1726]['trad'].str_replace('/','', $data_inicio).'_'.str_replace('/','', $data_fim).'.pdf', 'I');

//=====================================================+
// 					END OF FILE
//=====================================================+

//DOC HEADER - - - - - - - - - - - - - - - - - - -
function cabecalho($pdf){
	$data2 = $GLOBALS['Trad'];
	global $full_page;
	global $half_page;
	global $third_page;
	global $fourth_page;
	global $fifth_page;
	global $six_page;
	global $seven_page;
	global $eigth_page;
	global $nine_page;
	global $ten_page;
	global $eleven_page;
	global $twelve_page;

	global $style_line;
	global $style_bold_line;
	global $style_light_line;

	global $right_marg;
	global $startContentY;

	global $data_inicio;
	global $data_fim;
	global $stringLabelPeriod;

	
	$pdf -> SetFont('opensans', 'B', 10);
	$pdf -> MultiCell($half_page, '', $data2[1373]['trad'].' ', 0, 'L',  false, 1, '', $startContentY, false, 0, false, true, 0, 'T', false);
	
	$pdf -> Line(PDF_MARGIN_LEFT, $pdf->GetY(), $right_marg, $pdf->GetY(), $style_bold_line);

	$pdf -> SetFont('opensans', '', 8);
	$pdf -> Ln();

	$pdf -> SetFont('opensans', 'B', 8);
	$pdf -> MultiCell($fourth_page, '', $data2[1292]['trad'], 0, 'L', false, 1, '', '', false, 0, false, true, 0, 'T', false);
	// $pdf -> MultiCell($fourth_page, '', 'Monnaie', 0, 'L', false, 1, PDF_MARGIN_LEFT + $half_page + $fourth_page, '', false, 0, false, true, 0, 'T', false);

	$pdf -> Line(PDF_MARGIN_LEFT, $pdf->GetY(), PDF_MARGIN_LEFT + $half_page - 4, $pdf->GetY(), $style_line);
	// $pdf -> Line(PDF_MARGIN_LEFT + $half_page, $pdf->GetY(), PDF_MARGIN_LEFT + $half_page + $fourth_page - 4, $pdf->GetY(), $style_line);
	// $pdf -> Line(PDF_MARGIN_LEFT + $half_page + $fourth_page, $pdf->GetY(), $right_marg, $pdf->GetY(), $style_line);

	$pdf -> SetFont('opensans', '', 8);
	$pdf -> MultiCell($fourth_page, '', $data2[403]['trad'].': '.$data_inicio, 0, 'L', false, 0, '', '', false, 0, false, true, 0, 'T', false);
	$pdf -> MultiCell($fourth_page, '', $data2[10]['trad'].': '.$data_fim, 0, 'L', false, 1, PDF_MARGIN_LEFT + $fourth_page, '', false, 0, false, true, 0, 'T', false);
	// $pdf -> MultiCell($fourth_page, '', $GLOBALS['NifCliente'], 0, 'L', false, 0, PDF_MARGIN_LEFT + $half_page, '', false, 0, false, true, 0, 'T', false);
	// $pdf -> MultiCell($fourth_page, '', 'Franc Suisse (CHF)', 0, 'L', false, 1, PDF_MARGIN_LEFT + $half_page + $fourth_page, '', false, 0, false, true, 0, 'T', false);

	$pdf -> Ln();

	$pdf -> SetFont('opensans', 'B', 8);

	$pdf -> Ln();
	$pdf -> Ln();

}

//LINES HEADER - - - - - - - - - - - - - - - - - - -
function cabecalho_tabela($pdf){
	$data2 = $GLOBALS['Trad'];
	global $right_marg;

	global $style_line;
	global $style_bold_line;

	global $fourth_page;
	global $six_page;
	global $seven_page;
	global $eigth_page;
	global $ten_page;
	global $eleven_page;
	global $twelve_page;

	global $resto;
	
	$pdf -> SetFont('opensans', 'B', 8);
	$pdf -> Line(PDF_MARGIN_LEFT, $pdf->GetY(), $right_marg, $pdf->GetY(), $style_bold_line);
	$pdf -> setFillColor(230, 230, 230);

	$pdf -> MultiCell($ten_page, '', $data2[377]['trad'], 			0, 'L', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> MultiCell($resto - 5, '', $data2[1167]['trad'], 		0, 'L', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> MultiCell($seven_page + 5, '', $data2[911]['trad'], 	0, 'R', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	// $pdf -> MultiCell($eigth_page, '', 'Incid. IVA Cx', 			0, 'R', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> MultiCell($seven_page, '', $data2[1599]['trad'], 			0, 'R', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	// $pdf -> MultiCell($eigth_page, '', 'IVA de Caixa', 		0, 'R', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> MultiCell($seven_page, '', $data2[1542]['trad'], 		0, 'R', true, 1, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> Line(PDF_MARGIN_LEFT, $pdf->GetY(), $right_marg, $pdf->GetY(), $style_line);
	$pdf -> setFillColor(255, 255, 255);
	$pdf -> SetFont('opensans', '', 8);
}


// Calculate Min Height of Line
function calcHeightProd($strHeight){
	return max($strHeight) + 1;
}

 ?>