<?php
// die('NOT IMPLEMENTED');

//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$usarContrato = $_POST['usarContrato'];
$idRapport = $_POST['idRapport'];
$docOrigem = $_POST['docOrigem'];
$docType = $_POST['docType'];
$cliente = $_POST['cliente'];
$numero = $_POST['numero'];
$data = $_POST['data'];
// $horas = $_POST['horas'];
// $tecnico = $_POST['tecnico'];
// $tecnico = $_SESSION['nome_utilizador'];
$id_tecnico = $_POST['id_tecnico'];
$id_tecnico2 = $_POST['id_tecnico2'];
$compteur_nb = $_POST['compteur_nb'];
$compteur_coul = $_POST['compteur_coul'];
$referencia = $_POST['referencia'];
$observacoes = $_POST['remarque'];
$impressora = $_POST['impressora'];
$num_impressora = $_POST['num_impressora'];
$linhas = $_POST['linhas'];
$finalizarDocumento = $_POST['finalizarDocumento'];
$data_rapport_debut = $_POST['data_rapport_debut'];
$data_rapport_fin = $_POST['data_rapport_fin'];

$endereco_cliente_descarga = $_POST['endereco_cliente_descarga'];
$endereco_cliente_descarga_2 = $_POST['endereco_cliente_descarga_2'];
$codigopostal_cliente_descarga = $_POST['codigopostal_cliente_descarga'];
$regiao_cliente_descarga = $_POST['regiao_cliente_descarga'];
$cidade_cliente_descarga = $_POST['cidade_cliente_descarga'];
$pais_cliente_descarga = $_POST['pais_cliente_descarga'];

//New Emplacement Fields
$nome_emp_cliente = $_POST['nome_emp_cliente'];
$apelido_emp_cliente = $_POST['apelido_emp_cliente'];
$titulo_emp_cliente = $_POST['titulo_emp_cliente'];
$telefone_emp_cliente_rapport = $_POST['telefone_emp_cliente_rapport'];
$email_emp_cliente_rapport = $_POST['email_emp_cliente_rapport'];

//REMAIN FIELDS ----------------------------------------------------------
$estado = 'Rascunho';
$taxPayable = 0;
$netTotal = 0;
$grossTotal = 0;
$timestamp = 0;
$horas = 0;
$nome_tecnico = '';
$nome_tecnico2 = '';

//NEW FIELDS FATURAS -----------------------------------------------------
$totalPagar = 0;

//usar contrato
if($usarContrato == 0){
	$docOrigem = 0;
	$docType = 'CC';
}

//PROCESS ORIGIN
$fieldIdName = '';
$tableName = '';
switch ($docType) {
	case 'CC':
		$fieldIdName = 'ID_Consommable';
		$tableName = 'faturacao_consommables';
		break;
	
	default:
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS0000AA";
		$response["message"] = 'Tipo inválido!';
		die(json_encode($response));
		break;
}

//VERIFICA SE HA NULOS ---------------------------------------------------
if($usarContrato == 0){
	if ( $cliente == '' || $numero == '' || $data == '' || $id_tecnico == '' || $data_rapport_debut == '' || $data_rapport_fin == '' ) 
	{
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FATS0000A";
		die(json_encode($response));
	}
}else{
// if ( $docOrigem == '' || $docType == '' || $cliente == '' || $numero == '' || $data == '' || $id_tecnico == '' || $compteur_nb == '' || $compteur_coul == '' || $impressora == '' || $num_impressora == '' ) 
	if ( $docOrigem == '' || $docType == '' || $cliente == '' || $numero == '' || $data == '' || $id_tecnico == '' || $data_rapport_debut == '' || $data_rapport_fin == '' ) 
	{
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FATS0000A";
		die(json_encode($response));
	}
}
if($compteur_nb == '') $compteur_nb = 0;
if($compteur_coul == '') $compteur_coul = 0;
//------------------------------------------------------------------------

//CHECK LINES
if(!is_array($linhas) || empty($linhas)){
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000x";
	$response["lines_empty"] = true;
	$response["message"] = "";
	die(json_encode($response));
}
//-----------------------------------------------------------------------
// recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName);die();

//GET TECNICOS NAMES -----------------------------------------------------
$query = "SELECT Nome FROM faturacao_tecnicos WHERE ID_Tecnico=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $id_tecnico);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTSP001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($nome_tecnico );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTSP001";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

$query = "SELECT Nome FROM faturacao_tecnicos WHERE ID_Tecnico=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $id_tecnico2);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTSP001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($nome_tecnico2 );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTSP001";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

try {
	// Turn off AUTOCOMMIT and begin Transaction
	mysqli_autocommit($sqli_connection, FALSE);
	$sqli_connection->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);

	//usar contrato
	if($usarContrato != 0){
		//GET REMAINING FIELDS FROM ORIGIN DOC -----------------------------------
		$query = "SELECT Numero, Data, ID_Cliente, Estado FROM ".$tableName." WHERE ".$fieldIdName."=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $docOrigem);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS0000C";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
			$stmt -> bind_result($numeroOrigin, $dataOrigin, $idClienteOrigin, $estadoOrigem );
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS0000D";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		//contruct final reference
		$referenceOrigin = /*"D'entretien ".*/$numeroOrigin;
		//------------------------------------------------------------------------

		//CHECK IF IS THE SAME CLIENT AND STATUS ALLOWED -------------------------
		if( $idClienteOrigin != $cliente )
		{
			$response["errors"] = true;
			$response["type"] = "var";
			$response["line"] = "FATS0000E";
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		if( $estadoOrigem != 'Aberto' && $estadoOrigem != 'Pago' && $estadoOrigem != 'Confirmado' )
		{
			$response["errors"] = true;
			$response["type"] = "var";
			$response["line"] = "FATS0000F";
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		//------------------------------------------------------------------------
	}else{
		$numeroOrigin = 0;
		$dataOrigin = '';
		$idClienteOrigin = 0;
		$estadoOrigem = '';
		$referenceOrigin = $numeroOrigin;
	}

	//GET CLIENT DATA --------------------------------------------------------
	$query = "SELECT Endereco, CodigoPostal, Cidade, Regiao, Pais, Email, Codigo, Telemovel FROM faturacao_clientes WHERE ID_Cliente = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $cliente);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA001";
			$response["message"] = $stmt -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		$stmt -> bind_result($Endereco, $CodigoPostal, $Cidade, $Regiao, $Pais, $Email, $CodigoCliente, $Telemovel );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA002";
		$response["message"] = $sqli_connection -> error;
		$sqli_connection->rollback();
		die(json_encode($response));
	}
	//process fields
	if( trim($Endereco) == '' ) $Endereco = '-';
	if( trim($CodigoPostal) == '' ) $CodigoPostal = '-';
	if( trim($Cidade) == '' ) $Cidade = '-';
	if( trim($Regiao) == '' ) $Regiao = '-';
	if( trim($Pais) == '' ) $Pais = '-';

	if( trim($endereco_cliente_descarga) == '' ) $endereco_cliente_descarga = '-';
	if( trim($endereco_cliente_descarga_2) == '' ) $endereco_cliente_descarga_2 = '-';
	if( trim($codigopostal_cliente_descarga) == '' ) $codigopostal_cliente_descarga = '-';
	if( trim($regiao_cliente_descarga) == '' ) $regiao_cliente_descarga = '-';
	if( trim($cidade_cliente_descarga) == '' ) $cidade_cliente_descarga = '-';
	if( trim($pais_cliente_descarga) == '' ) $pais_cliente_descarga = '-';
	//------------------------------------------------------------------------

	$timestamp = microtime(true);
	$dataCriacao = date("d/m/Y H:i:s");

	//INSERT OPEN DOCUMENT ---------------------------------------------------
	$query = "UPDATE faturacao_rapports_travail SET ID_Cliente=?, EnderecoCliente=?, CodigoPostalCliente=?, CidadeCliente=?, RegiaoCliente=?, EmailCliente=?, PaisCliente=?, TelefoneCliente=?, Data=?, Duree=?, Referencia=?, Remarque=?, TimeStamp_Rapport=?, Estado=?, ID_Utilizador_Criacao=?, Impressora=?, NumImpressora=?, CompteurNB=?, CompteurCoul=?, DataCriacao=?, ID_Documento_Origem=?, Tipo_Documento_Origem=?, Data_Documento_Origem=?, Reference=?, Tecnico=?, DateDebut=?, DateFin=?, EnderecoClienteDescarga=?, EnderecoCliente2Descarga=?, CodigoPostalClienteDescarga=?, CidadeClienteDescarga=?, RegiaoClienteDescarga=?, PaisClienteDescarga=?, TecnicoSegundo=?, ID_Tecnico=?, ID_TecnicoSegundo=?, NomeEmplacement=?, ApelidoEmplacement=?, TituloEmplacement=?, ContactoEmplacement=?, EmailEmplacement=? WHERE ID_Rapport=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dsssssssssssssdsssssdssssssssssssssssssssd", $cliente, $Endereco, $CodigoPostal, $Cidade, $Regiao, $Email, $Pais, $Telemovel, $data, $horas, $referencia, $observacoes, $timestamp, $estado, $id_utilizador, $impressora, $num_impressora, $compteur_nb, $compteur_coul, $dataCriacao, $docOrigem, $docType, $dataOrigin, $referenceOrigin, $nome_tecnico, $data_rapport_debut, $data_rapport_fin, $endereco_cliente_descarga, $endereco_cliente_descarga_2, $codigopostal_cliente_descarga, $cidade_cliente_descarga, $regiao_cliente_descarga, $pais_cliente_descarga, $nome_tecnico2, $id_tecnico, $id_tecnico2, $nome_emp_cliente, $apelido_emp_cliente, $titulo_emp_cliente, $telefone_emp_cliente_rapport, $email_emp_cliente_rapport , $idRapport );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA010";
			$response["message"] = $stmt -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA011";
		$response["message"] = $sqli_connection -> error;
		$sqli_connection->rollback();
		die(json_encode($response));
	}
	//CLEAN ALL LINES --------------------------------------------------------
	$query = "DELETE FROM faturacao_rapports_travail_linhas WHERE ID_Rapport=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idRapport );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA012";
			$response["message"] = $stmt -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA013";
		$response["message"] = $sqli_connection -> error;
		$sqli_connection->rollback();
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//PROCESS LINES ----------------------------------------------------------
	$numLinha = 1;
	foreach ($linhas as $linha) {
		//init vars
		$ProductDescription = '';
		$ProductCode = '';
		$SerialNumber = '';
		$TaxType = '';
		$TaxCountryRegion = '';
		$TaxCode = '';
		$TaxPercentage = '';
		$impostoUsed = '';
		$TaxExemptionCode = '';
		$TaxExemptionReason = '';

		//GET ARTICLE DATA ---------------------------------------------------
		if(is_numeric($linha["artigo"]) && $linha["artigo"] > 0) {
			$query = "SELECT  Nome, Codigo, SerialNumber, (SELECT Sigla FROM faturacao_unidades WHERE faturacao_unidades.ID_Unidade = faturacao_artigos.ID_Unidade) AS Unidade FROM faturacao_artigos WHERE ID_Artigo = ?";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("d", $linha['artigo']);
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "FTGA015D";
					$response["message"] = $stmt -> error;
					$sqli_connection->rollback();
					die(json_encode($response));
				}
				$stmt -> bind_result($ProductDescription, $ProductCode, $SerialNumber, $Unidade);
				$stmt -> fetch();
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "FTGA016";
				$response["message"] = $sqli_connection -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
		} else {
			$ProductDescription = $linha["descricao"];
			$ProductCode = '';
			$SerialNumber = '';
			$Unidade = '';
		}
		//--------------------------------------------------------------------
	
		//GET TAXES DATA -----------------------------------------------------
		$query = "SELECT  Tipo, Regiao, Subclasse, Valor FROM faturacao_impostos WHERE ID_Imposto = ?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $linha['imposto']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA017";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
			$stmt -> bind_result($TaxType, $TaxCountryRegion, $TaxCode, $TaxPercentage);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA018";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		//VERIFICAR SE IMPOSTO JÁ BLOQUEADO -------------------------------------
		$query = "SELECT COUNT(*) FROM faturacao_impostos_usados WHERE ID_Imposto=?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $linha['imposto']);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA018A";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
			$stmt -> bind_result($impostoUsed);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA018B";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		if($impostoUsed < 1){
			//INSERT DB --------------------------------------------------
			$query = "INSERT INTO faturacao_impostos_usados(ID_Imposto) VALUES (?)";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("d", $linha['imposto'] );
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FTGA018C";
					$response["message"] = $stmt -> error;
					$sqli_connection->rollback();
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA018D";
				$response["message"] = $sqli_connection -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
			//------------------------------------------------------------
		}

		//CASO SEJA TIPO ISE
		// if( $TaxCode == 'ISE' ){
		/*if( $TaxCode == 'ISENTO' ){
			if( $linha['motivo'] < 1){
				$response["errors"] = true;
				$response["type"] = "var";
				$response["line"] = "FTGA018E";
				$response["message"] = "Motivo de isenção inválido";
				$sqli_connection->rollback();
				die(json_encode($response));
			}else{
				$query = "SELECT  Codigo, Descricao FROM faturacao_motivos_isencao WHERE ID_Motivo = ?";
				if ($stmt = $sqli_connection -> prepare($query)) {
					$stmt -> bind_param("d", $linha['motivo']);
					$result = $stmt -> execute();
					if (false === $result) {
						$response["errors"] = true;
						$response["type"] = "FTGA018F";
						$response["message"] = $stmt -> error;
						$sqli_connection->rollback();
						die(json_encode($response));
					}
					$stmt -> bind_result($TaxExemptionCode, $TaxExemptionReason);
					$stmt -> fetch();
					$stmt -> close();
				} else {
					$response["errors"] = true;
					$response["type"] = "FTGA018G";
					$response["message"] = $sqli_connection -> error;
					$sqli_connection->rollback();
					die(json_encode($response));
				}
			}

		}*/
		//--------------------------------------------------------------------
		
		//check if vals are smaller than 0
		if( $linha['qtd'] <= 0 ){
			$response["errors"] = true;
			$response["type"] = "FTGA018H";
			$response["message"] = 'Valores das linhas menores que 0';
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		if( $linha['preco'] < 0 ){
			$response["errors"] = true;
			$response["type"] = "FTGA018I";
			$response["message"] = 'Valores das linhas menores que 0';
			$sqli_connection->rollback();
			die(json_encode($response));
		}
	
		//TOTALS
		$totalSIVA = 0;
		$totalLinha = 0;
		$settelementAmount = 0;

		$linhaDesconto = $linha['desconto'] * 0.01;
		$descontoProcessed = $desconto * 0.01;
		$taxaIVA = $TaxPercentage * 0.01;
		$ivaProcessed = $taxaIVA + 1 ;

		$totalSIVA = $linha['qtd'] * $linha['preco'];
		$desconto1 = $totalSIVA * $linhaDesconto; //calcula desconto 1
		$totalSIVA = $totalSIVA - ($totalSIVA * $linhaDesconto); //calcula descunto linha
		
		$settelementAmount = $desconto1;

		$totalLinha = $totalSIVA * $ivaProcessed;

		//TOTALS DOCUMENT
		$taxPayable = $taxPayable + ($totalSIVA * $taxaIVA);
		$netTotal = $netTotal + $totalSIVA;
		$grossTotal = $taxPayable + $netTotal;
		// $grossTotal = round($grossTotal,2);

		//INSERT INTO DB -----------------------------------------------------
		$query = "INSERT INTO faturacao_rapports_travail_linhas (ID_Rapport, NumeroLinha, 
			ID_Artigo, ProductCode, ProductDescription, Quantidade, UnidadeMedida, PrecoUnitario, Descricao, SerialNumber, 
			ID_Imposto, TaxType, TaxCountryRegion, TaxCode, TaxPercentage, TaxExemptionReason, TaxExemptionCode, 
			TotalLinha, TotalLinhaSIVA, DescontoLinha, SettlementAmount) 
			VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("dddsssssssdssssssssss", $idRapport, $numLinha, $linha['artigo'], $ProductCode, $ProductDescription, $linha['qtd'], $Unidade, $linha['preco'], $linha['descricao'], $SerialNumber, $linha['imposto'], $TaxType, $TaxCountryRegion, $TaxCode, $TaxPercentage, $TaxExemptionReason, $TaxExemptionCode, $totalLinha, $totalSIVA, $linha['desconto'], $settelementAmount );
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA019";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA020";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		//--------------------------------------------------------------------
	
		$numLinha++;

		//BLOCK ARTICLE ------------------------------------------------------
		$query = "UPDATE faturacao_artigos SET Usado=1 WHERE ID_Artigo=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $linha['artigo']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA020A";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA020B";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		//--------------------------------------------------------------------
	}
	//------------------------------------------------------------------------

	//UPDATES TOTALS ---------------------------------------------------------
	$taxPayable = round($taxPayable,$numDecimais);
	$netTotal = round($netTotal,$numDecimais);
	$grossTotal = round($grossTotal,$numDecimais);
	$grossTotal = roundPriceUp($grossTotal);
	$totalPagar = $grossTotal;

	$query = "UPDATE faturacao_rapports_travail SET TaxPayable=?, NetTotal=?, GrossTotal=?, TotalPagar=? WHERE ID_Rapport=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("ssssd", $taxPayable, $netTotal, $grossTotal, $totalPagar, $idRapport);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA021C";
			$response["message"] = $stmt -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA022";
		$response["message"] = $sqli_connection -> error;
		$sqli_connection->rollback();
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	//CLOSE THE DOCUMENT -----------------------------------------------------
	if( $finalizarDocumento > 0 ){

		$dataNew = $data;
		$dataAtualizacao = date("d/m/Y H:i:s");
		
		// DEFINE NEW NUMBER
		$queryStmt = "SELECT MAX(Numero) AS NumeroMax FROM faturacao_rapports_travail;";
		$maxID = getMaxNumberDocument($queryStmt);
		$initNumber = getInitNumber("NumeroInicial_RT","faturacao_personalizar_documentos", "", 0);
		if($nextID < $initNumber && $maxID < 1){
			$query = "UPDATE faturacao_rapports_travail SET Numero = ".$initNumber.", Data=?, ID_Utilizador_Atualizacao=?, DataAtualizacao=?, Estado='Confirmado' WHERE ID_Rapport = ?";
		}else{
			$query = "UPDATE faturacao_rapports_travail SET Numero = ((SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_rapports_travail) AS SubNumeroMax) + 1), Data=?, ID_Utilizador_Atualizacao=?, DataAtualizacao=?, Estado='Confirmado' WHERE ID_Rapport = ?";
		}
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("sdsd", $dataNew, $id_utilizador, $dataAtualizacao, $idRapport);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA025";
				$response["message"] = $stmt -> error;
				$sqli_connection->rollback();
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA026";
			$response["message"] = $sqli_connection -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}


		//log sistema - processo
		$descricao_log ="Édition et finalisation du rapport de travail (id: ".$idRapport.")";
		insert_log(0,"Editar",$descricao_log,$sqli_connection);
		
		$response["rapport"] = $idRapport;
	}else{
		$response["rapport"] = $idRapport;

		//log sistema - processo
		$descricao_log ="Édition du rapport de travail (id: ".$idRapport.")";
		insert_log(0,"Editar",$descricao_log,$sqli_connection);
	}
	//------------------------------------------------------------------------

	//BLOCK CLIENT ----------------------------------------------------------
	$query = "UPDATE faturacao_clientes SET Usado=1 WHERE ID_Cliente=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $cliente);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA027";
			$response["message"] = $stmt -> error;
			$sqli_connection->rollback();
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA028";
		$response["message"] = $sqli_connection -> error;
		$sqli_connection->rollback();
		die(json_encode($response));
	}
	//------------------------------------------------------------------------

	// Save all querys on DB
	$sqli_connection->commit();
} catch (Exception $e) {
	$sqli_connection->rollback();

	$response["errors"] = true;
	$response["type"] = "transaction";
	$response["line"] = "DB001";
	$response["message"] = $e->getMessage();
	die(json_encode($response));
}

//response
$response["errors"] = false;
die(json_encode($response));

//remove inserted Enregistrer if gives an error
function restoreRecord($idRapport){
	global $sqli_connection;

	// DEFINE NEW NUMBER
	$query = "UPDATE faturacao_rapports_travail SET Numero = 0, ID_UtilizadorAtualizacao=0, DataAtualizacao='', Estado='Rascunho' WHERE ID_Rapport = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idRapport);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM000";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM001";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	// UPDATE REMAIN FIELDS
	$query = "UPDATE faturacao_rapports_travail SET InvoiceStatusDate='', SourceID='', Hash='', HashControl='', Hash_Print='', Period='', InvoiceDate='', MovementEndTime='', MovementStartTime='' WHERE ID_Rapport = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idRapport );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM002";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM003";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	// UPDATE REMAIN FIELDS LINES
	$query = "UPDATE faturacao_rapports_travail_linhas SET TaxPointDate='' WHERE ID_Rapport = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idRapport );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM004";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM004A";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
}

//Recalculate Totals for origin Document
function recalculateTotalsOrigin($docOrigem, $docType, $tableName, $fieldIdName){
	global $sqli_connection;
	$totalLiqGeralNew = 0;
	$totalLiqDocNew = 0;
	//GET ORIGIN DOC TOTALS AND UPDATE THEM ------------------------------
	$query = "SELECT TotalPagar, GrossTotal, Estado FROM ".$tableName." WHERE ".$fieldIdName."=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $docOrigem);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM005";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($totalPagarOrigem, $totalGrossOrigem, $estadoOrigem );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM006";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//last check on estado
	if( $estadoOrigem != 'Aberto' && $estadoOrigem != 'Pago' )
	{
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "REM007";
		die(json_encode($response));
	}else{
		//GET NC TOTALS -----------------------------
		$query = "SELECT SUM(GrossTotal) FROM faturacao_rapports_travail WHERE ID_Documento_Origem=? AND Tipo_Documento_Origem=? AND Estado IN ('Aberto','Pago')";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ds", $docOrigem, $docType);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM008";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($sumGrossNC );
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM009A";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//-------------------------------------------
		//GET RECEIPTS LINES TOTALS -----------------
		$query = "SELECT SUM(faturacao_recibos_linhas.CreditAmount), SUM(faturacao_recibos_linhas.valorIVA) 
			FROM faturacao_recibos_linhas, faturacao_recibos 
			WHERE faturacao_recibos.ID_Recibo = faturacao_recibos_linhas.ID_Recibo AND ID_Documento=? AND TipoDocumento=? AND faturacao_recibos.Estado IN ('Pago')";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ds", $docOrigem, $docType);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM008";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($linesCreditSUM, $linesIvaSUM );
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM009B";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//-------------------------------------------
		//GET RECEIPTS TOTALS -----------------
		$query = "SELECT SUM(GrossTotal), SUM(ValorRetencao) 
			FROM faturacao_recibos 
			WHERE ID_DocumentoMain=? AND Tipo_DocumentoMain=? AND faturacao_recibos.Estado IN ('Pago')";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ds", $docOrigem, $docType);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM008";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($recTotalSUM, $recRetencaoSUM );
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM009C";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//-------------------------------------------
		//totals
		$totalLiqDocNew = $sumGrossNC + ($linesCreditSUM + $linesIvaSUM); //document total payed
		$totalLiqGeralNew = $recTotalSUM + $recRetencaoSUM; //general total payed

		//round numbers
		$totalLiqDocNew = round($totalLiqDocNew,$numDecimais);
		$totalLiqGeralNew = round($totalLiqGeralNew,$numDecimais);

		if($totalLiqDocNew > $totalGrossOrigem){
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM010A";
			$response["message"] = "Valores Inválidos";
			die(json_encode($response));
		}

		$estadoNovo = 'Aberto';
		if( $totalLiqGeralNew < $totalPagarOrigem){
			$estadoNovo = 'Aberto';
		}elseif( $totalLiqGeralNew = $totalPagarOrigem){
			$estadoNovo = 'Pago';
		}else{
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM010B";
			$response["message"] = "Valores Inválidos";
			die(json_encode($response));
		}

		$query = "UPDATE ".$tableName." SET TotalLiquidadoDocumento=?, TotalLiquidado=?, Estado=? WHERE ".$fieldIdName."=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("sssd", $totalLiqDocNew, $totalLiqGeralNew, $estadoNovo, $docOrigem);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "REM011";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM012";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
	}
	//--------------------------------------------------------------------
}
?>