<?php
/**
 * |-----------------------------------------------------------------------
 * |
 * |						Profile Actions - API
 * |
 * |-----------------------------------------------------------------------
 */

//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/auth/controltoken.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/resources/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/resources/helpers.php";

// var_dump($_GET);die();

//GET POST VARS ---------------------------------------------------------
if ( isset($_GET['user_id']) || isset($_GET['username']) ) {
	//prepare vars
	$userID = null;
	$userNome = null;
	$userEmail = null;
	$userName = null;
	$CreatedAt = null;
	$UpdatedAt = null;
	$conditions = '';

	if( isset($_GET['user_id']) && $_GET['user_id'] != '') $conditions = ' AND faturacao_utilizadores_webservices.ID_UtilizadorWebservice = "'.$_GET['user_id'].'"';
	elseif( isset($_GET['username']) && $_GET['username'] != '' ) $conditions = ' AND faturacao_utilizadores_webservices.Username = "'.$_GET['username'].'"';
	else{
		//cancel the request
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 403 Forbidden.');
		$response["errors"] = true;
		$response["type"] = "validation";
		$response["line"] = "WAPI_VAL001";
		$response["message"] = 'Invalid params. Please provide a valid user_id/username.';
		die(json_encode($response));
	}

	//process the request
	$query = "SELECT ID_UtilizadorWebservice, utilizador.Nome, utilizador.Username, utilizador.Email, faturacao_utilizadores_webservices.Created, faturacao_utilizadores_webservices.Updated  FROM utilizador, faturacao_utilizadores_webservices WHERE faturacao_utilizadores_webservices.Username = utilizador.Username ".$conditions;
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		// $stmt -> bind_param("s", $TokenRec);
		//result
		$result = $stmt -> execute();
		if (false === $result) {
			header('Content-Type: application/json; charset=UTF-8');
			header('HTTP/1.1 500 Internal Server Error.');
			$response["errors"] = true;
			$response["type"] = "sql_query";
			$response["line"] = "WAPI_SQLQ001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result($userID, $userNome, $userEmail, $userName, $CreatedAt, $UpdatedAt);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 500 Internal Server Error.');
		$response["errors"] = true;
		$response["type"] = "sql_conn";
		$response["line"] = "WAPI_SQLC001";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	if($userID > 0){
		//---------------------------------
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 200 Ok.');
		$response["errors"] = false;
		$response["type"] = "-";
		$response["line"] = "-";
		$response["message"] = "Profile found successfully!";
		$response["user"] = array(
			'user_id' => $userID,
			'name' => $userNome,
			'email' => $userEmail,
			'username' => $userName,
			'created_at' => $CreatedAt,
			'updated_at' => $UpdatedAt,
		);
		die(json_encode($response));
	}else{
		//not found
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 404 Not Found.');
		$response["errors"] = true;
		$response["type"] = "connection";
		$response["line"] = "WAPI_CONN001";
		$response["message"] = 'Could not find any matching profile.';
		die(json_encode($response));
	}
}else{
	//cancel the request
	header('Content-Type: application/json; charset=UTF-8');
	header('HTTP/1.1 400 Bad Request.');
	$response["errors"] = true;
	$response["type"] = "connection";
	$response["line"] = "WAPI_CONN001";
	$response["message"] = 'Missing user_id/username. Please provide a valid user_id/username.';
	die(json_encode($response));
}