<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";

//GET $_GET VARS ---------------------------------------------------------
$correctedDocs = 0;
$noEmailDocs = 0;
$totalDocs = 0;
die('THIS IS BLOCKED...');


//SET SOME VARS -------------------------------------------------------
$data_invoice = null;
$data1 = null;
$data2 = null;
$data3 = null;
$data4 = null;

//GET THE DATA --------------------------------------------------------
$queryRecords1 ="SELECT ID_Movimento, Descricao, Data FROM faturacao_movimentos_contabilisticos WHERE Descricao LIKE 'Facture (Annulation) -%' ORDER BY ID_Movimento";
$data1 = getRecordsToEdit( $queryRecords1 );

//LOOP 1
foreach ($data1 as $key => $movimento) {
	// ============================================================
	// DETAILS MOVEMENT
	if ($movimento['ID_Movimento'] > 0) {
		//init vars
		$newDateMovement = "";
		$labelSplitHalf = "Facture (Annulation) - ";

		$DescSplit = explode(" - ", $movimento['DescricaoMovimento']);
		// $ref = explode(" ", $DescSplit[1]);
		$refDocument = $DescSplit[1];

		//get origin ref to rebuild description label
		$concatField = "Data ";
		$tableName = "faturacao_faturas";
		$whereClause = "CONCAT((SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie),'/',faturacao_faturas.Numero) = '".$refDocument."' LIMIT 1";
		$newDateMovement = getOriginDocumentDate($concatField, $tableName, $whereClause);

		//process date
		if($movimento['DataMovimento'] && $movimento['DataMovimento'] != '') {
			$newDateMovement = $newDateMovement.' '.explode(" ", $movimento['DataMovimento'])[1];
		}else{
			$newDateMovement = $newDateMovement.' '.date('H:i:s');
		}

		// var_dump($refDocument, $refOrigin, $newDateMovement);
		// echo '<br>';
		// var_dump('FT --- MOVEMENT ID: '. $movimento['ID_Movimento'].' --- ('.$movimento['DataMovimento'].' --> '.$newDateMovement.' | '.$refDocument.')');
		// echo '<br><br>';

		//INSERT PAYMENT LINE ---------------------------------------------------
		$obs_system = 'Système';
		$query = "UPDATE faturacao_movimentos_contabilisticos SET Data = ? WHERE ID_Movimento=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ss", $newDateMovement, $movimento['ID_Movimento']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS003";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS004";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		//ADD TO PROCESSED INVOICES
		$data_invoice[] = array(
			"MOVEMENT" => 'ID '.$movimento['ID_Movimento'].' | '.$movimento['DataMovimento'].' --> '.$newDateMovement,
		);
		
		// var_dump('--- MOVEMENT ID: '. $movimento['ID_Movimento'].' --- ('.$newDateMovement.')');
		// echo '<br><br>';
		$correctedDocs++;
	} else {
		$noEmailDocs++;
	}

	$totalDocs++;
	// ============================================================
}
//---------------------------------------------------------------------

//GET THE DATA --------------------------------------------------------
$queryRecords2 ="SELECT ID_Movimento, Descricao, Data FROM faturacao_movimentos_contabilisticos WHERE Descricao LIKE 'Achat (Annulé) -%' ORDER BY ID_Movimento";
$data2 = getRecordsToEdit( $queryRecords2 );

//LOOP 2
foreach ($data2 as $key => $movimento) {
	// ============================================================
	// DETAILS MOVEMENT
	if ($movimento['ID_Movimento'] > 0) {
		//init vars
		$newDateMovement = "";
		$labelSplitHalf = "Achat (Annulé) - ";

		$DescSplitNew = explode($labelSplitHalf, $movimento['DescricaoMovimento']);
		$DescSplit = explode(" - ", $movimento['DescricaoMovimento']);
		// $ref = explode(" ", $DescSplit[1]);
		$refDocument = $DescSplit[1];

		//get origin ref to rebuild description label
		$concatField = "Data ";
		$tableName = "faturacao_compras";
		$whereClause = "Numero = '".$refDocument."' LIMIT 1";
		$newDateMovement = getOriginDocumentDate($concatField, $tableName, $whereClause);

		//process date
		if($movimento['DataMovimento'] && $movimento['DataMovimento'] != '') {
			$newDateMovement = $newDateMovement.' '.explode(" ", $movimento['DataMovimento'])[1];
		}else{
			$newDateMovement = $newDateMovement.' '.date('H:i:s');
		}

		// var_dump($refDocument, $refOrigin, $newDateMovement);
		// echo '<br>';
		// var_dump('AC --- MOVEMENT ID: '. $movimento['ID_Movimento'].' --- ('.$movimento['DataMovimento'].' --> '.$newDateMovement.' | '.$refDocument.')');
		// echo '<br><br>';


		//INSERT PAYMENT LINE ---------------------------------------------------
		$obs_system = 'Système';
		$query = "UPDATE faturacao_movimentos_contabilisticos SET Data = ? WHERE ID_Movimento=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ss", $newDateMovement, $movimento['ID_Movimento']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS003";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS004";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		//ADD TO PROCESSED INVOICES
		$data_invoice[] = array(
			"MOVEMENT" => 'ID '.$movimento['ID_Movimento'].' | '.$movimento['DataMovimento'].' --> '.$newDateMovement,
		);
		
		// var_dump('--- MOVEMENT ID: '. $movimento['ID_Movimento'].' --- ('.$newDateMovement.')');
		// echo '<br><br>';
		$correctedDocs++;
	} else {
		$noEmailDocs++;
	}

	$totalDocs++;
	// ============================================================
}
//---------------------------------------------------------------------

//GET THE DATA --------------------------------------------------------
$queryRecords3 ="SELECT ID_Movimento, Descricao, Data FROM faturacao_movimentos_contabilisticos WHERE Descricao LIKE 'Paiement (Annulation) -%' ORDER BY ID_Movimento";
$data3 = getRecordsToEdit( $queryRecords3 );

//LOOP 4
foreach ($data3 as $key => $movimento) {
	// ============================================================
	// DETAILS MOVEMENT
	if ($movimento['ID_Movimento'] > 0) {
		//init vars
		$newDateMovement = "";
		$labelSplitHalf = "Paiement (Annulation) - ";

		$DescSplitNew = explode($labelSplitHalf, $movimento['DescricaoMovimento']);
		$DescSplit = explode(" - ", $movimento['DescricaoMovimento']);
		// $ref = explode(" ", $DescSplit[1]);
		$refDocument = $DescSplit[1];

		//get origin ref to rebuild description label
		$concatField = "TransactionDate ";
		$tableName = "faturacao_recibos";
		$whereClause = "CONCAT((SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_recibos.ID_Serie),'/',faturacao_recibos.Numero) = '".$refDocument."' LIMIT 1";
		$newDateMovement = getOriginDocumentDate($concatField, $tableName, $whereClause);

		//process date
		$tmpDateProcess = DateTime::createFromFormat('Y-m-d', $newDateMovement);
		$newDateMovement = $tmpDateProcess->format('d/m/Y');
		if($movimento['DataMovimento'] && $movimento['DataMovimento'] != '') {
			$newDateMovement = $newDateMovement.' '.explode(" ", $movimento['DataMovimento'])[1];
		}else{
			$newDateMovement = $newDateMovement.' '.date('H:i:s');
		}

		// var_dump($refDocument, $refOrigin, $newDateMovement);
		// echo '<br>';
		// var_dump('RG --- MOVEMENT ID: '. $movimento['ID_Movimento'].' --- ('.$movimento['DataMovimento'].' --> '.$newDateMovement.' | '.$refDocument.')');
		// echo '<br><br>';

		//INSERT PAYMENT LINE ---------------------------------------------------
		$obs_system = 'Système';
		$query = "UPDATE faturacao_movimentos_contabilisticos SET Data = ? WHERE ID_Movimento=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ss", $newDateMovement, $movimento['ID_Movimento']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS003";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS004";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		//ADD TO PROCESSED INVOICES
		$data_invoice[] = array(
			"MOVEMENT" => 'ID '.$movimento['ID_Movimento'].' | '.$movimento['DataMovimento'].' --> '.$newDateMovement,
		);
		
		// var_dump('--- MOVEMENT ID: '. $movimento['ID_Movimento'].' --- ('.$newDateMovement.')');
		// echo '<br><br>';
		$correctedDocs++;
	} else {
		$noEmailDocs++;
	}

	$totalDocs++;
	// ============================================================
}
//---------------------------------------------------------------------

//GET THE DATA --------------------------------------------------------
$queryRecords4 ="SELECT ID_Movimento, Descricao, Data, Total_PVP FROM faturacao_movimentos_contabilisticos WHERE Descricao LIKE 'Élimination du paiement (Achat) -%' ORDER BY ID_Movimento";
$data4 = getRecordsToEdit2( $queryRecords4 );

//LOOP 4
foreach ($data4 as $key => $movimento) {
	// ============================================================
	// DETAILS MOVEMENT
	if ($movimento['ID_Movimento'] > 0) {
		//init vars
		$newDateMovement = "";
		$labelSplitHalf = "Élimination du paiement (Achat) - ";

		$DescSplitNew = explode($labelSplitHalf, $movimento['DescricaoMovimento']);
		$DescSplit = explode(" - ", $movimento['DescricaoMovimento']);
		// $ref = explode(" ", $DescSplit[1]);
		$refDocument = $DescSplit[1];

		//get origin ref to rebuild description label
		$concatField = "Data ";
		$tableName = "faturacao_movimentos_contabilisticos";
		$whereClause = "Descricao LIKE 'Paiement (Achat) - ".$refDocument."%' AND Total_PVP LIKE '".$movimento['Total_PVPMovimento']."' ORDER BY ID_Movimento DESC LIMIT 1";
		$newDateMovement = getOriginDocumentDate($concatField, $tableName, $whereClause);

		//process date
		if($newDateMovement){
			$tmpDateProcess = DateTime::createFromFormat('d/m/Y H:i:s', $newDateMovement);
			$newDateMovement = $tmpDateProcess->format('d/m/Y');
			if($movimento['DataMovimento'] && $movimento['DataMovimento'] != '') {
				$newDateMovement = $newDateMovement.' '.explode(" ", $movimento['DataMovimento'])[1];
			}else{
				$newDateMovement = $newDateMovement.' '.date('H:i:s');
			}

			// var_dump($refDocument, $refOrigin, $newDateMovement);
			// echo '<br>';
			// var_dump('ACRG --- MOVEMENT ID: '. $movimento['ID_Movimento'].' --- ('.$movimento['DataMovimento'].' --> '.$newDateMovement.' | '.$refDocument.')');
			// echo '<br><br>';

			//INSERT PAYMENT LINE ---------------------------------------------------
			$obs_system = 'Système';
			$query = "UPDATE faturacao_movimentos_contabilisticos SET Data = ? WHERE ID_Movimento=?";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("ss", $newDateMovement, $movimento['ID_Movimento']);
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FATS003";
					$response["message"] = $stmt -> error;
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS004";
				$response["message"] = $sqli_connection -> error;
				die(json_encode($response));
			}

			//ADD TO PROCESSED INVOICES
			$data_invoice[] = array(
				"MOVEMENT" => 'ID '.$movimento['ID_Movimento'].' | '.$movimento['DataMovimento'].' --> '.$newDateMovement,
			);
			
			// var_dump('--- MOVEMENT ID: '. $movimento['ID_Movimento'].' --- ('.$newDateMovement.')');
			// echo '<br><br>';
			$correctedDocs++;
		}
	} else {
		$noEmailDocs++;
	}

	$totalDocs++;
	// ============================================================
}
//---------------------------------------------------------------------


$response["errors"] = false;
$response["data"] = $data_invoice;
// $response["total_documentos_enviados"] = $correctedDocs;
// $response["total_documentos_sem_email"] = $noEmailDocs;
// $response["total_documentos"] = $totalDocs;
// $response["resultados_totais"] = $resultAll;
die(json_encode($response));


//get records from table
function getRecordsToEdit($queryToSelect){
	global $sqli_connection;

	//init vars
	$data = null;

	//get document
	$query = $queryToSelect;
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		// $stmt -> bind_param("d", $idFatura);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "RES000A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($ID_Movimento, $DescricaoMovimento, $DataMovimento );
		while ($stmt -> fetch()) {
			$data[] = array(
		        	"ID_Movimento" => $ID_Movimento,
					"DescricaoMovimento" => $DescricaoMovimento,
					"DataMovimento" => $DataMovimento,
		        );
		}
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "RES000B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//response
	return $data;
}

//get records from table
function getRecordsToEdit2($queryToSelect){
	global $sqli_connection;

	//init vars
	$data = null;

	//get document
	$query = $queryToSelect;
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		// $stmt -> bind_param("d", $idFatura);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "RES000A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($ID_Movimento, $DescricaoMovimento, $DataMovimento, $Total_PVPMovimento );
		while ($stmt -> fetch()) {
			$data[] = array(
		        	"ID_Movimento" => $ID_Movimento,
					"DescricaoMovimento" => $DescricaoMovimento,
					"DataMovimento" => $DataMovimento,
					"Total_PVPMovimento" => $Total_PVPMovimento,
		        );
		}
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "RES000B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//response
	return $data;
}


//get origin record from table
function getOriginDocumentDate($concatField, $tableName, $whereClause){
	global $sqli_connection;

	//init vars
	$documentOriginRef = null;

	//get document
	$query = "SELECT ".$concatField." FROM ".$tableName." WHERE ".$whereClause;
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		// $stmt -> bind_param("d", $idref);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "RES001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result( $documentOriginRef );
		$stmt -> fetch();
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "RES002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//response
	return $documentOriginRef;
}
?>