<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";

//GET $_GET VARS ---------------------------------------------------------
$correctedDocs = 0;
$noEmailDocs = 0;
$totalDocs = 0;
// die('THIS IS BLOCKED...');


//SET SOME VARS -------------------------------------------------------
$data_invoice = null;
$data1 = null;
$data2 = null;
$data3 = null;
$data4 = null;

//GET THE DATA --------------------------------------------------------
$queryRecords1 ="SELECT ID_Movimento, Descricao, Data, Total_PVP, PlanoContas_Debito, PlanoContas_Credito FROM faturacao_movimentos_contabilisticos WHERE Descricao LIKE '%- TVA -%' AND ID_ImpostoTVA < 1 ORDER BY ID_Movimento";
$data1 = getRecordsToEdit( $queryRecords1 );

//LOOP 1
foreach ($data1 as $key => $movimento) {
	// ============================================================
	// DETAILS MOVEMENT
	if ($movimento['ID_Movimento'] > 0) {
		//init vars
		$newTvaInfo = null;
		$processUpdate = false;
		$labelSplitHalf = " - TVA - ";

		// $DescSplit = explode(" - ", $movimento['DescricaoMovimento']);
		$DescSplit = explode($labelSplitHalf, $movimento['DescricaoMovimento']);
		// $ref = explode(" ", $DescSplit[1]);
		// $refDocument = $DescSplit[1];
		$refTVA = explode(":", $DescSplit[1]);
		$percentTVA = explode("%", $refTVA[1])[0];
		$percentTVA = round($percentTVA, 2);
		// var_dump($refTVA[0], $percentTVA);


		//get origin ref to rebuild description label
		$concatField = "ID_Imposto, Valor ";
		$tableName = "faturacao_impostos";
		$whereClause = " Nome = '".trim($refTVA[0])."' LIMIT 1";
		$newTvaInfo = getOriginInfo($concatField, $tableName, $whereClause);

		//process date
		if(isset($newTvaInfo['ID_Imposto']) && $newTvaInfo['ID_Imposto'] > 0) {
			$newTvaInfo['IncludeTVA'] = 1;
			$newTvaInfo['Total_TVA'] = $movimento['Total_PVPMovimento'];

			$processUpdate = true;
		}else{}

		// var_dump($processUpdate);
		echo '<br>';
		var_dump('FT --- MOVEMENT ID: '. $movimento['ID_Movimento'].' --- ('.$refTVA[0].' : '.$percentTVA.' | '.$newTvaInfo['ID_Imposto'].' --> '.$newTvaInfo['Percentagem'].'% --> '.$newTvaInfo['Total_TVA'].' --> '.$newTvaInfo['IncludeTVA'].')');
		echo '<br><br>';

		//INSERT PAYMENT LINE ---------------------------------------------------
		$obs_system = 'Système';
		if($processUpdate){
			$query = "UPDATE faturacao_movimentos_contabilisticos SET ID_ImpostoTVA = ?, PercentageTVA = ?, IncludeTVA = ?, Total_TVA = Total_PVP WHERE ID_Movimento=?";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("ssss", $newTvaInfo['ID_Imposto'], $newTvaInfo['Percentagem'], $newTvaInfo['IncludeTVA'], $movimento['ID_Movimento']);
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FATS003";
					$response["message"] = $stmt -> error;
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS004";
				$response["message"] = $sqli_connection -> error;
				die(json_encode($response));
			}

			//ADD TO PROCESSED INVOICES
			$data_invoice[] = array(
				"MOVEMENT" => 'ID '.$movimento['ID_Movimento'].' | '.$movimento['DataMovimento'].' --> '.$newTvaInfo,
			);
			
			// var_dump('--- MOVEMENT ID: '. $movimento['ID_Movimento'].' --- ('.$newTvaInfo.')');
			// echo '<br><br>';

			$correctedDocs++;
		}
	} else {
		$noEmailDocs++;
	}

	$totalDocs++;
	// ============================================================
}
//---------------------------------------------------------------------

//GET THE DATA --------------------------------------------------------
$queryRecords2 ="SELECT ID_Movimento, Descricao, Data, Total_PVP,PlanoContas_Debito, PlanoContas_Credito FROM faturacao_movimentos_contabilisticos WHERE Descricao LIKE '%- Article -%' AND ID_ImpostoTVA < 1 ORDER BY ID_Movimento";
$data2 = getRecordsToEdit( $queryRecords2 );

//LOOP 2
foreach ($data2 as $key => $movimento) {
	// ============================================================
	// DETAILS MOVEMENT
	if ($movimento['ID_Movimento'] > 0) {
		//init vars
		$newTvaInfo = null;
		$processUpdate = false;
		$labelSplitHalf = " - Article - ";

		// $DescSplit = explode(" - ", $movimento['DescricaoMovimento']);
		$DescSplit = explode($labelSplitHalf, $movimento['DescricaoMovimento']);
		// $ref = explode(" ", $DescSplit[1]);
		$refDocument = $DescSplit[1];
		// $refTVA = explode(":", $DescSplit[1]);
		// $percentTVA = explode("%", $refTVA[1])[0];
		// $percentTVA = round($percentTVA, 2);
		// var_dump($refDocument);


		//get origin ref to rebuild description label
		$concatField = "ID_Imposto, Valor ";
		$tableName = "faturacao_impostos";
		$whereClause = " ID_Imposto = (SELECT ID_Imposto FROM faturacao_artigos WHERE Codigo = '".$refDocument."' LIMIT 1) LIMIT 1";
		$newTvaInfo = getOriginInfo($concatField, $tableName, $whereClause);

		//process date
		if(isset($newTvaInfo['ID_Imposto']) && $newTvaInfo['ID_Imposto'] > 0) {
			$newTvaInfo['IncludeTVA'] = 1;
			$newTvaInfo['Total_TVA'] = $movimento['Total_PVPMovimento'];

			$processUpdate = true;
		}else{}

		var_dump($processUpdate);
		echo '<br>';
		var_dump('FT --- MOVEMENT ID: '. $movimento['ID_Movimento'].' --- ('.$refDocument.' | '.$newTvaInfo['ID_Imposto'].' --> '.$newTvaInfo['Percentagem'].'% )');
		echo '<br><br>';

		//INSERT PAYMENT LINE ---------------------------------------------------
		$obs_system = 'Système';
		if($processUpdate){
			$query = "UPDATE faturacao_movimentos_contabilisticos SET ID_ImpostoTVA = ?, PercentageTVA = ? WHERE ID_Movimento=?";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("sss", $newTvaInfo['ID_Imposto'], $newTvaInfo['Percentagem'], $movimento['ID_Movimento']);
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FATS003";
					$response["message"] = $stmt -> error;
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS004";
				$response["message"] = $sqli_connection -> error;
				die(json_encode($response));
			}

			//ADD TO PROCESSED INVOICES
			$data_invoice[] = array(
				"MOVEMENT" => 'ID '.$movimento['ID_Movimento'].' | '.$movimento['DataMovimento'].' --> '.$newTvaInfo,
			);
			
			// var_dump('--- MOVEMENT ID: '. $movimento['ID_Movimento'].' --- ('.$newTvaInfo.')');
			// echo '<br><br>';

			$correctedDocs++;
		}
	} else {
		$noEmailDocs++;
	}

	$totalDocs++;
	// ============================================================
}
//---------------------------------------------------------------------

$response["errors"] = false;
// $response["data"] = $data_invoice;
// $response["total_documentos_enviados"] = $correctedDocs;
// $response["total_documentos_sem_email"] = $noEmailDocs;
// $response["total_documentos"] = $totalDocs;
// $response["resultados_totais"] = $resultAll;
die(json_encode($response));


//get records from table
function getRecordsToEdit($queryToSelect){
	global $sqli_connection;

	//init vars
	$data = null;

	//get document
	$query = $queryToSelect;
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		// $stmt -> bind_param("d", $idFatura);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "RES000A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($ID_Movimento, $DescricaoMovimento, $DataMovimento, $Total_PVPMovimento, $PlanoContas_DebitoMovimento, $PlanoContas_CreditoMovimento );
		while ($stmt -> fetch()) {
			$data[] = array(
		        	"ID_Movimento" => $ID_Movimento,
					"DescricaoMovimento" => $DescricaoMovimento,
					"DataMovimento" => $DataMovimento,
					"Total_PVPMovimento" => $Total_PVPMovimento,
					"PlanoContas_Debito" => $PlanoContas_DebitoMovimento,
					"PlanoContas_Credito" => $PlanoContas_CreditoMovimento,

		        );
		}
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "RES000B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//response
	return $data;
}

//get origin record from table
function getOriginInfo($concatField, $tableName, $whereClause){
	global $sqli_connection;

	//init vars
	$originID = null;
	$originValue = null;
	$originData = null;

	//get document
	$query = "SELECT ".$concatField." FROM ".$tableName." WHERE ".$whereClause;
	// var_dump($query);
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		// $stmt -> bind_param("d", $idref);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "RES001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result( $originID, $originValue );
		$stmt -> fetch();
		$stmt -> fetch();
		$stmt -> close();

		$originData = array( "ID_Imposto" => $originID, "Percentagem" => $originValue);
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "RES002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//response
	return $originData;
}
?>