<?php
	include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo_gesfaturacao.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/helpers.php';
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

	if ($_SESSION['mod_Vendas'] == 0) {
		header('Location: ../acces-fonctionnalites?redirectfrom=frifacturation&redirectto=/frifacturation');
	}
?>
<html>
	<title>Clients: Grupos | Frifacturation</title>
	<head>
		<?php include('../base/css.php') ?>
		<!-- ADDED CSS -->
		<link rel="stylesheet" href="/js/vendors/bootstrap-select/bootstrap-select.min.css">
		<link rel="stylesheet" href="/js/vendors/bootstrap-datepicker/datepicker3.css">
		<!-- //ADDED CSS -->
	</head>
	<body>
		<?php include '../../modal_menu.php'; ?>
		<div class="container">
			<?php include '../menu.php'; ?>


			<!-- Novo Grupo -->
			<div id="modal-grupo" tabindex="-1" role="dialog" aria-labelledby="modal-header-primary-label" aria-hidden="true" class="modal fade">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header modal-header-orange">
							<button type="button" data-dismiss="modal" aria-hidden="true" class="close">
								&times;
							</button>
							<h4 id="modal-header-primary-label" class="modal-title">Novo Grupo</h4>
						</div>
						<form id="form_new_grupo" class="form-validate" novalidate="novalidate">
							<div class="modal-body" style="overflow-y: visible;">
								<div class="row">
									<div class="col-md-8">
										<div class="form-group">
											<label class="control-label">Nom<span class="require">*</span></label>
											<input type="text" class="form-control" name="nome_grupo" id="nome_grupo" autofocus="true">
										</div>
									</div>
									<div class="col-md-4">
										<div class="form-group">
											<label>Prédéfini</label>
											<div class="checkbox">
												<label>
													<input type="checkbox"  class="iCheck" name="predefinir_grupo" id="predefinir_grupo" checked>
													Grupo Par défaut ?
												</label>
											</div>
										</div>
									</div>
								</div>
								<div class="row mtm">
									<div class="col-md-12">
										<div class="form-group">
											<label class="control-label">Description</label>
											<textarea type="text" class="form-control" name="descricao_grupo" id="descricao_grupo" rows="2"></textarea>
										</div>
									</div>
								</div>
							</div>
							<div class="modal-footer">
								<button  class="btn btn-yellow submit_button" type="submit">
									<i class="fa fa-floppy-o"></i> Enregistrer
								</button>
								<button type="button" data-dismiss="modal" class="btn btn-default">
									Annuler
								</button>
							</div>
						</form>
					</div>
				</div>
			</div>

			<!-- Editar grupo -->
			<div id="modal-grupo-edit" tabindex="-1" role="dialog" aria-labelledby="modal-header-primary-label" aria-hidden="true" class="modal fade">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header modal-header-orange">
							<button type="button" data-dismiss="modal" aria-hidden="true" class="close">
								&times;
							</button>
							<h4 id="modal-header-primary-label" class="modal-title">Editar Grupo</h4>
						</div>
						<form id="form_new_grupoEditar" class="form-validate" novalidate="novalidate">
							<input type="hidden" value="" id="ModalEdit_ID_grupo" />
							<div class="modal-body" style="overflow-y: visible;">
								<div class="row">
									<div class="col-md-8">
										<div class="form-group">
											<label class="control-label">Nom<span class="require">*</span></label>
											<input type="text" class="form-control" name="ModalEdit_nome_grupo" id="ModalEdit_nome_grupo">
										</div>
									</div>
									<div class="col-md-4">
										<div class="form-group">
											<label>Prédéfini</label>
											<div class="checkbox">
												<label>
													<input type="checkbox"  class="iCheck" name="ModalEdit_predefinir_grupo" id="ModalEdit_predefinir_grupo" checked>
													Grupo Par défaut ?
												</label>
											</div>
										</div>
									</div>
								</div>
								<div class="row mtm">
									<div class="col-md-12">
										<div class="form-group">
											<label class="control-label">Description</label>
											<textarea type="text" class="form-control" name="ModalEdit_descricao_grupo" id="ModalEdit_descricao_grupo" rows="2"></textarea>
										</div>
									</div>
								</div>
							</div>
							<div class="modal-footer">
								<button  class="btn btn-yellow submit_button" type="submit">
									<i class="fa fa-floppy-o"></i> Enregistrer
								</button>
								<button type="button" data-dismiss="modal" class="btn btn-default">
									Annuler
								</button>
							</div>
						</form>
					</div>
				</div>
			</div>

			<div class="page-content">
				<div class="panel panel-white">
					<div class="panel-heading">
                        <div class="pull-right" >
							<button type="button" data-target="#modal-grupo" data-toggle="modal" class="btn btn-yellow btn-outlined btn-square"><i class="fa fa-plus"></i>&nbsp;&nbsp;Novo Grupo</button>
						</div>
						<ol class="breadcrumb page-breadcrumb" style=" min-height: 35px; vertical-align: middle;">
							<li>
								<a href="../clients">Clients</a>
							</li>
							<li class="active">
								Grupos de Clients
							</li>
						</ol>
                    </div>
					<div class="panel-body">
						<div class="row ptm">
							<div class="col-md-12 ">
								<table class="table table-bordered table-striped" id="table_id" >
									<thead>
										<tr>
											<th>Nom</th>
											<th style="width: 80px;">Nº Clientes</th>
											<th style="width: 90px;" class="text-center">Par défaut</th>
											<th style="width: 100px;">État</th>
											<th style="width: 80px;">Options</th>
										</tr>
									</thead>
									<tbody></tbody>
								</table>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		
		<?php include '../footer.php';	?>
		<?php include('../base/scripts.php') ?>

		<?php 
		if (!function_exists('get_trad')) {
			include $_SERVER["DOCUMENT_ROOT"]. "/translate.php";
		}
		$ids_list = array(1997,1998,1999,2000,2001,2002);
		if (isset($data)) {
			$data = $data + get_trad($ids_list);
		} else {
			$data = get_trad($ids_list);
		}	
	?>
		<script type="text/javascript">
			text1 = "<?php echo $data[1997]['trad']; ?>" ;
			text2 = "<?php echo $data[1998]['trad']; ?>" ;
			text3 = "<?php echo $data[1999]['trad']; ?>" ;
			text4 = "<?php echo $data[2000]['trad']; ?>" ;
			text5 = "<?php echo $data[2001]['trad']; ?>" ;
			text6 = "<?php echo $data[2002]['trad']; ?>" ;
		</script>

		<!-- ADDED SCRIPTS -->
		<script src="/js/vendors/bootstrap-select/bootstrap-select.min.js"></script>
		<script src="/js/vendors/bootstrap-select/defaults-pt_BR.min.js"></script>

		<script src="/js/vendors/DataTables/media/js/jquery.dataTables.js"></script>
		<script src="/js/vendors/DataTables/media/js/dataTables.bootstrap.js"></script>

		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.js"></script>
		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.pt.js"></script>
		<script src="/js/vendors/jquery-maskedinput/jquery-maskedinput.js"></script>
		<script src="/js/fnReload.js"></script>

		<?php include('grupos_scripts.php');  ?>
		<!-- //ADDED SCRIPTS -->

		<script>
			$(".navbar-nav li.clientes").addClass("active");
			$(".navbar-nav li.clientes li.grupos_clientes").addClass("active");
		</script>
		<script type="text/javascript">
			var flagPredefinir = 1;
			var flagPredefinirEdit = 0;

			$(document).ajaxStart(function() {
				$(".fullscreen").show();
			});
			$(document).ajaxComplete(function() {
				if ($.active == 1) {
	                $(".fullscreen").fadeOut();
	            }
			});
			$(document).ready(function() {

				$(".fullscreen").fadeOut();

			});

			$(document).ready(function() {
				$("#form_new_grupo")[0].reset();
				$("#form_new_grupoEditar")[0].reset();

				// iCheck ------------------------
				$('input:checkbox').attr("checked");
				$('input[type=checkbox]').iCheck({
					checkboxClass : 'icheckbox_flat-yellow',
					increaseArea : '20%' // optional
				});
			});

			//flag novo
			$(document).on('ifChanged', 'input#predefinir_grupo', function(event) {
				if( $('input#predefinir_grupo').is(":checked") ) flagPredefinir = 1;
				else flagPredefinir = 0;
			});
			//flag edit
			$(document).on('ifChanged', 'input#ModalEdit_predefinir_grupo', function(event) {
				if( $('input#ModalEdit_predefinir_grupo').is(":checked") ) flagPredefinirEdit = 1;
				else flagPredefinirEdit = 0;
			});

			// ----------------- FORM PROCESSING ------------------
			val_form_new = $("#form_new_grupo").validate({
				ignore : "",
				rules : {
					nome_grupo : {
						required : true
					},
				},
				messages : {
					nome_grupo : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
				},
				highlight : function(element, errorClass, validClass) {
					$(element).addClass(errorClass).removeClass(validClass);
				},
				unhighlight : function(element, errorClass, validClass) {
					$(element).removeClass(errorClass).addClass(validClass);
				},
				errorPlacement : function(error, element) {
					if (element.hasClass('selectpicker')) {
						if (element.parent().hasClass("input-group"))
							error.insertAfter(element.parent());
						else
							error.insertAfter(element.next("div"));
					} else {
						error.insertAfter(element);
					}
				}
			});

			//check validation and upload foto
			$("#form_new_grupo").submit(function(e) {
				e.preventDefault();

				var valid = $("#form_new_grupo").valid();
				if (valid == false) {
					$.scojs_message("<?php echo $data[1403]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				} else {

					$("#form_new_grupo").find('.submit_button').attr("disabled", true);
					$("#form_new_grupo").find('.submit_button').html('<i class="fa fa-circle-o-notch fa-spin  fa-fw "></i> Chargement ...');

					//submite the form
					$.ajax({
						type : 'POST',
						url : '/frifacturation/server/clientes/grupos_inserir.php',
						dataType : 'json',
						data : {
							nome_grupo : $("#nome_grupo").val(),
							descricao_grupo : $("#descricao_grupo").val(),
							flagPredefinir : flagPredefinir,
						},
						success : function(resposta) {
							var resp = resposta;
							if (resposta == null)
								$.scojs_message("[FAT001] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							else {
								if (resposta.errors) {
									$.scojs_message("[FAT002] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
								} else {
									$.scojs_message("<?php echo $data[1013]['trad']; ?>", $.scojs_message.TYPE_OK);
								}
							}
						},
						complete : function(resposta) {
							var resp = resposta;
							console.log(resp);
							if (resp.responseJSON.errors) {
								$.scojs_message("[FAT003] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							} else {
								$.scojs_message("<?php echo $data[1013]['trad']; ?>", $.scojs_message.TYPE_OK);
								//reload
								setTimeout(function() {
									location.reload();
								}, 1000);
							}
							$("#form_new_grupo").find('.submit_button').attr("disabled", false);
							$("#form_new_grupo").find('.submit_button').html('<i class="fa fa-floppy-o"></i> Enregistrer');
						}
					});
				}
			});

			/**
			 * -----------------------------------------
			 * 				EDITION FORM
			 * -----------------------------------------
			 */
			val_form_new2 = $("#form_new_grupoEditar").validate({
				ignore : "",
				rules : {
					ModalEdit_nome_grupo : {
						required : true
					},
				},
				messages : {
					ModalEdit_nome_grupo : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
				},
				highlight : function(element, errorClass, validClass) {
					$(element).addClass(errorClass).removeClass(validClass);
				},
				unhighlight : function(element, errorClass, validClass) {
					$(element).removeClass(errorClass).addClass(validClass);
				},
				errorPlacement : function(error, element) {
					if (element.hasClass('selectpicker')) {
						if (element.parent().hasClass("input-group"))
							error.insertAfter(element.parent());
						else
							error.insertAfter(element.next("div"));
					} else {
						error.insertAfter(element);
					}
				}
			});

			//check validation and upload foto
			$("#form_new_grupoEditar").submit(function(e) {
				e.preventDefault();

				var valid = $("#form_new_grupoEditar").valid();
				if (valid == false) {
					$.scojs_message("<?php echo $data[1403]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				} else {

					$("#form_new_grupoEditar").find('.submit_button').attr("disabled", true);
					$("#form_new_grupoEditar").find('.submit_button').html('<i class="fa fa-circle-o-notch fa-spin  fa-fw "></i> Chargement ...');

					//submite the form
					$.ajax({
						type : 'POST',
						url : '/frifacturation/server/clientes/grupos_editar.php',
						dataType : 'json',
						data : {
							id_grupo : $("#ModalEdit_ID_grupo").val(),
							nome_grupo : $("#ModalEdit_nome_grupo").val(),
							descricao_grupo : $("#ModalEdit_descricao_grupo").val(),
							flagPredefinirEdit : flagPredefinirEdit,
						},
						success : function(resposta) {
							var resp = resposta;
							if (resposta == null)
								$.scojs_message("[FAT001] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							else {
								if (resposta.errors) {
									$.scojs_message("[FAT002] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
								} else {
									$.scojs_message("Données mises à jour avec succès.", $.scojs_message.TYPE_OK);
								}
							}
						},
						complete : function(resposta) {
							var resp = resposta;
							console.log(resp);
							if (resp.responseJSON.errors) {
								$.scojs_message("[FAT003] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							} else {
								$.scojs_message("Données mises à jour avec succès.", $.scojs_message.TYPE_OK);
								//reload
								setTimeout(function() {
									location.reload();
								}, 1000);
							}
							$("#form_new_grupoEditar").find('.submit_button').attr("disabled", false);
							$("#form_new_grupoEditar").find('.submit_button').html('<i class="fa fa-floppy-o"></i> Enregistrer');
						}
					});
				}
			});
		</script>
	</body>
</html>