<?php
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1565,1472,1446,1702,1704,1503,1312,1310,421,1208,1377,1457,1639,1016);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<script type="text/javascript">
	table = $('#table_id').dataTable({
		"dom" : '<lfrtip><"clear">',
		"sRowSelect" : "os",
		"sRowSelector" : 'td:first-child',
		"lengthMenu" : [[25, 50, 100, -1], [25, 50, 100, "<?php echo $data[1565]['trad']; ?>"]],
		"iDisplayLength" : 100,
		"aaSorting" : [[3, "desc"]],
		"bProcessing" : true,
		"bServerSide" : true,
		"sAjaxSource" : "/frifacturation/server/datatable/faturas_ghost_arquivo.php",
		"oLanguage" : {
			"sLengthMenu" : "<?php echo $data[1472]['trad']; ?>",
			"sZeroRecords" : "<?php echo $data[1446]['trad']; ?>",
			"sInfo" : "<?php echo $data[1702]['trad']; ?>",
			"sInfoEmpty" : "<?php echo $data[1704]['trad']; ?>",
			"sProcessing" : "<div></div>",
			"sInfoFiltered" : "",
			"oPaginate" : {
				"sNext" : "<?php echo $data[1503]['trad']; ?>",
				"sFirst" : "<?php echo $data[1312]['trad']; ?>",
				"sPrevious" : "<?php echo $data[1310]['trad']; ?>",
				"sLast" : "<?php echo $data[421]['trad']; ?>"
			}
		},
		"aoColumns" : [
		{
			"bVisible" : true,
			"bSortable" : false,
			"sClass" : "text-center",
			"bSearchable" : true,
		}, null, null, null, 
		{
			"sClass" : "text-right",
		}, 
		/*{
			"sClass" : "text-center",
			"bVisible" : false,
		},*/
		/*{
			"bVisible" : true,
			"bSortable" : false,
			"bSearchable" : true,
			"sClass" : "text-center",
		},
		{
			"bVisible" : true,
			"bSortable" : false,
			"bSearchable" : true,
			"sClass" : "text-center",
		},
		{
			"bVisible" : true,
			"bSortable" : false,
			"bSearchable" : true,
			"sClass" : "text-center",
		},*/
		{
			"bVisible" : false,
		},
		{
			"bVisible" : false,
		}],
		"aoColumnDefs" : [
		{
			"aTargets" : [0],
			"mRender" : function(data, type, full) {
				return '<input type="checkbox" name="row_selector" class="row_selector" id="row_selector-' + full[6] + '" dbID="' + full[6] + '" />';
			}
		},
		{
			"aTargets" : [2],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[1] && full[1].length > 50) element = full[1].substr(0,50)+"...";
				else element = full[1];
				//return html
				return element;
			}
		},
		{
			"aTargets" : [1],
			"mRender" : function(data, type, full) {
				if(!full[2]) return '<span style="color: blue;"><?php echo $data[1208]['trad']; ?></span>';
				else return full[2];
			}
		},
		{
			"aTargets" : [3],
			"mRender" : function(data, type, full) {
				var element = '';
				var tmp = full[3].split("-");
				var tmpNew = tmp[0]+'/'+tmp[1]+'/'+tmp[2];
				var tmpLBL = tmp[2]+'/'+tmp[1]+'/'+tmp[0];
				element = '<span id="data_fatura_'+full[8]+'" data-normalizeDate="'+tmpNew+'">'+tmpLBL+'</span>';
				//return html
				return element;
			}
		},
		{
			"aTargets" : [4],
			"mRender" : function(data, type, full) {
				var element = '';
				element ='<span class="money">'+full[4]+'</span>';

				//init elements
				$(".money").autoNumeric("init", {
					aSep : '.',
					aDec : ',',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});

				return element;
			}
		},
		{
			"aTargets" : [5],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[5] == 'Rascunho') element = '<span class="label label-orange">'+full[5]+'</span>';
				if(full[5] == 'Pago') element = '<span class="label label-green">'+full[5]+'</span>';
				if(full[5] == 'Aberto') element = '<span class="label label-blue">'+full[5]+'</span>';
				if(full[5] == 'Anulado') element = '<span class="label label-red">'+full[5]+'</span>';
				//return html
				return element;
			}
		}/*,
		{
			"aTargets" : [6],
			"mRender" : function(data, type, full) {
				html = '<input type="radio" name="verificar_'+full[5]+'" value="1">';
				return html;
			}

		},
		{
			"aTargets" : [7],
			"mRender" : function(data, type, full) {
				html = '<input type="radio" name="verificar_'+full[5]+'" value="2">';
				return html;
			}

		},
		{
			"aTargets" : [8],
			"mRender" : function(data, type, full) {
				html = '<input type="radio" name="verificar_'+full[5]+'" value="0">';
				return html;
			}

		},
		{
			"aTargets" : [9],
			"mRender" : function(data, type, full) {

				html += '<input type="radio" name="verificar_'+full[5]+'" value="Vérifier"> Validar &nbsp;&nbsp; <input type="radio" name="verificar_'+full[5]+'" value="Archives"> Arquivar';

				//return all html composed
				return html;
			}
		}*/],

		"fnRowCallback" : function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
			$(nRow).attr("dbID", aData[9]);

			return nRow;
		},

	});

	$('#table_id').on('click', 'tbody td:not(.dataTables_empty)', function() {
		$('#table_id tbody tr').removeClass('selected');
		$(this).parent('tr').removeClass('DTTT_selected');
		$(this).parent('tr').addClass('selected');
	});

	$('#table_id_filter input').unbind();

	$('#table_id_filter').html('<label><div class="input-group input-group-sm mbs"><input type="search" class="form-control input-sm" placeholder="" aria-controls="table_id"><span class="input-group-btn"><button type="button" data-toggle="dropdown" class="btn btn-yellow dropdown-toggle" onclick="pesquisar()"><i class="fa fa-search"></i> <?php echo $data[1377]['trad']; ?></button></span></div></label>');

	$('#table_id_filter input').bind('keyup', function(e) {
		if (e.keyCode == 13) {
			table.fnFilter(this.value);
		}

	});
	function pesquisar() {
		table.fnFilter($('#table_id_filter input').val());
	}
	$('#table_id_filter input').bind('keyup', function(e) {
		if (($(this).val().length) == 0) {
			table.fnFilter('');
		}
	});
	function fnGetSelected(tabela) {
		var aReturn = new Array();
		var aTrs = tabela.fnGetNodes();
		for (var i = 0; i < aTrs.length; i++) {
			if ($(aTrs[i]).hasClass('row_selected')) {
				aReturn.push(aTrs[i]);
			}
		}
		return aReturn;
	}

	//END OF TABLE ---------------------------------------------
	function sendToInbox(){
		var ids_faturas = [];
		
		$('table tbody input[type=checkbox]:checked').each(function(){
			var id_fatura = $(this).attr('dbid');

			var verificar = $(this).val();

			ids_faturas.push(id_fatura);
		});
		if(ids_faturas.length == 0){
			alert('<?php echo $data[1457]['trad']; ?>');
		} else {
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/sincronizacao/recuperarInbox.php',
				data : {
					idsFaturas : ids_faturas
				},
				dataType : 'json',
				success : function(resposta) {
					if (resposta == null) {
						alert("<?php echo $data[1639]['trad']; ?>");
					} else {
						if (resposta.errors == true) {
							alert(resposta.message);
						} else {
							alert('<?php echo $data[1016]['trad']; ?>');
						}
					}
				},
				complete : function(resposta) {

					location.reload();
				}
			});
		}
	}

	function ToggleCheckboxes(){
		var checkboxes = $('table tbody input[type=checkbox]');
		checkboxes.prop('checked', !checkboxes.prop('checked'));
	}
</script>
