<?php
	include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo_gesfaturacao.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/helpers.php';
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

	if ( hasPermission(['P0065']) == 1 ) {}
	else{
		header('Location: ../../acces-refuse?redirectfrom=/frifacturation/banques&redirectto=/frifacturation');
	}
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1639,1698,1633,1509,1094,915,1429,269,1175,260,1684,1456,1299,1311,127,405,371,255,763,1709,272,273,1965,1978,562,67,1434,186,1403,1966,1967,1968,214,530,1309,1995);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<html>
	<title><?php echo $data[1509]['trad']; ?>: <?php echo $data[1094]['trad']; ?> | Frifacturation</title>
	<head>
		<?php include('../../base/css.php') ?>
		<!-- ADDED CSS -->
		<link rel="stylesheet" href="/js/vendors/bootstrap-select/bootstrap-select.min.css">
		<link rel="stylesheet" href="/js/vendors/bootstrap-datepicker/datepicker3.css">
		<!-- //ADDED CSS -->
	</head>
	<body>
		<?php include '../../../modal_menu.php'; ?>
		<div class="container">
			<?php include '../../menu.php'; ?>

			<div class="page-content">
				<div class="panel panel-white">
					<div class="panel-heading">
                        <div class="pull-right" >
							<a class="text-red only-ic" href="../banques"><i class="fa fa-times"></i></a>
						</div>
						<ol class="breadcrumb page-breadcrumb" style=" min-height: 35px; vertical-align: middle;">
							<li>
								<a href="../banques"><?php echo $data[1509]['trad']; ?></a>
							</li>
							<li class="active">
								<?php echo $data[1094]['trad']; ?>
							</li>
						</ol>
                    </div>
					<div class="panel-body">
						<div class="row">
							<div class="col-xs-12">
								<form id="form_new" class="form-validate">
									<div class="form-body">
										<div id="form_div">
											<h5 class="form-header">
												<legend class="form-legend">
													<?php echo $data[915]['trad']; ?>
												</legend>
											</h5>
											<div class="section-form">
												<div class="row hide">
													<div class="col-md-12 col-md-12">
														<div class="form-group">
															<label class="control-label"><?php echo $data[1429]['trad']; ?></label>
															<span id="sncbase_banco" style="display: block"></span>
														</div>
													</div>
												</div>
												<div class="row mtm">
													<div class="col-md-4 hide">
														<div class="form-group">
															<label class="control-label"><?php echo $data[269]['trad']; ?></label>
															<span id="conta_banco" style="display: block"></span>
														</div>
													</div>
													<div class="col-md-12">
														<div class="form-group">
															<label class="control-label"><?php echo $data[1175]['trad']; ?><span class="require">*</span></label>
															<input type="text" class="form-control" name="descricao_banco" id="descricao_banco" placeholder="...">
														</div>
													</div>
												</div>

												<div class="row mtm">
													<div class="col-sm-2">
														<div class="form-group">
															<label class="control-label"><?php echo $data[260]['trad']; ?><span class="require">*</span></label>
															<input type="text" class="form-control cpostal_field" id="codigopostal_banco" name="codigopostal_banco" placeholder="..." />
														</div>
													</div>
													<div class="col-sm-2">
														<div class="form-group">
															<label class="control-label"><?php echo $data[1684]['trad']; ?><span class="require">*</span></label>
															<div id="selectCidadeWrapper">
																<select class="form-control select2 show-tick" data-live-search="true"  data-header="<?php echo $data[1456]['trad']; ?>" id="cidade_banco" name="cidade_banco">
																</select>
															</div>
														</div>
													</div>	

													<div class="col-xs-12 col-md-4 <?php if($_SESSION['mod_Contabilidade'] == 0) echo 'hide'; ?>">
														<div class="form-group">
															<label class="control-label"><?php echo $data[1299]['trad']; ?><span class="require">*</span></label>
															<select class="form-control select2 show-tick" data-live-search="true"  data-header="<?php echo $data[1456]['trad']; ?>" id="plano_banco" name="plano_banco">
																<option value="" data-hidden="true"><?php echo $data[1456]['trad']; ?></option>
															</select>
														</div>
													</div>
													<div class="col-md-4">
														<div class="form-group">
															<label><?php echo $data[1311]['trad']; ?></label>
															<div class="checkbox">
																<label>
																	<input type="checkbox"  class="iCheck" name="predefinir_banco" id="predefinir_banco">
																	<?php echo $data[127]['trad']; ?> ?
																</label>
															</div>
														</div>
													</div>
												</div>
												<div class="row mtm">
													<div class="col-md-2">
														<div class="form-group">
															<label class="control-label"><?php echo $data[405]['trad']; ?><span class="require">*</span></label>
															<input type="text" class="form-control money" name="debito_banco" id="debito_banco" placeholder="0.00 CHF">
														</div>
													</div>
													<div class="col-md-2">
														<div class="form-group">
															<label class="control-label"><?php echo $data[371]['trad']; ?><span class="require">*</span></label>
															<input type="text" class="form-control money" name="credito_banco" id="credito_banco" placeholder="0.00 CHF">
														</div>
													</div>
													<div class="col-md-4 hidden">
														<div class="form-group">
															<label class="control-label"><?php echo $data[255]['trad']; ?></label>
															<input type="text" class="form-control" name="bvr_banco" id="bvr_banco" placeholder="...">
														</div>
													</div>
													<div class="col-md-4">
														<div class="form-group">
															<label class="control-label"><?php echo $data[763]['trad']; ?><span class="require">*</span></label>
															<input class="form-control" type="text" id="Iban" name="Iban" placeholder="" />
														</div>
													</div>
													<div class="col-md-4">
														<div class="form-group">
															<label class="control-label"><?php echo $data[1709]['trad']; ?><span class="require">*</span></label>
															<input class="form-control" type="text" id="QRIban" name="QRIban" placeholder="" />
														</div>
													</div>
												</div>
												<div class="row mtm hidden">
													<div class="col-md-4 hidden">
														<div class="form-group">
															<label class="control-label"><?php echo $data[272]['trad']; ?></label>
															<input class="form-control" type="text" id="compte_lapost1_banco" name="compte_lapost1_banco" placeholder="00-00000-0" />
														</div>
													</div>
													<div class="col-md-4 hidden">
														<div class="form-group">
															<label class="control-label"><?php echo $data[273]['trad']; ?></label>
															<input class="form-control" type="text" id="compte_lapost2_banco" name="compte_lapost2_banco" placeholder="010000001" />
														</div>
													</div>
													
												</div>
												<div class="row mtm">
													<div class="col-md-6">
														<div class="form-group">
															<label class="control-label"><?php echo $data[1965]['trad']; ?></label>
															<input class="form-control" type="text" id="escompte_banco" name="escompte_banco"/>
														</div>
													</div>
													<div class="col-md-6">
														<div class="form-group">
															<label><?php echo $data[1309]['trad']; ?></label>
															<div class="checkbox">
																<label>
																	<input type="checkbox"  class="iCheck" name="pourcent_banco" id="pourcent_banco">
																	<?php echo $data[1978]['trad']; ?>
																</label>
															</div>
														</div>
													</div>
												</div>
											</div>
										</div>
									</div>

									<div class="form-footer">
										<div class="mtxl pull-right">
											<button class="btn btn-yellow submit_button" type="submit">
												<i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?>
											</button>
											<a  href="../banques" class="btn btn-default" type="button"> <?php echo $data[1995]['trad']; ?> </a>
										</div>
									</div>
								</form>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		
		<?php include '../../footer.php'; ?>
		<?php include('../../base/scripts.php') ?>

		<?php 
		if (!function_exists('get_trad')) {
			include $_SERVER["DOCUMENT_ROOT"]. "/translate.php";
		}
		$ids_list = array(1997,1998,1999,2000,2001,2002);
		if (isset($data)) {
			$data = $data + get_trad($ids_list);
		} else {
			$data = get_trad($ids_list);
		}	
	?>
		<script type="text/javascript">
			text1 = "<?php echo $data[1997]['trad']; ?>" ;
			text2 = "<?php echo $data[1998]['trad']; ?>" ;
			text3 = "<?php echo $data[1999]['trad']; ?>" ;
			text4 = "<?php echo $data[2000]['trad']; ?>" ;
			text5 = "<?php echo $data[2001]['trad']; ?>" ;
			text6 = "<?php echo $data[2002]['trad']; ?>" ;
		</script>

		<!-- ADDED SCRIPTS -->
		<script src="/js/vendors/bootstrap-select/bootstrap-select.min.js"></script>
		<script src="/js/vendors/bootstrap-select/defaults-pt_BR.min.js"></script>

		<script src="/js/vendors/DataTables/media/js/jquery.dataTables.js"></script>
		<script src="/js/vendors/DataTables/media/js/dataTables.bootstrap.js"></script>

		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.js"></script>
		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.pt.js"></script>
		<script src="/js/vendors/jquery-maskedinput/jquery-maskedinput.js"></script>
		<script src="/js/fnReload.js"></script>

		<script src="/js/autoNumeric.js"></script>

		<?php include('editar_scripts.php');  ?>
		<!-- //ADDED SCRIPTS -->

		<script>
			$(".navbar-nav li.contabilidade").addClass("active");
			$(".navbar-nav li.contabilidade li.bancos_contabilidade").addClass("active");
		</script>
		<script type="text/javascript">
			var flagPredefinirEdit = 0;

			$(document).ajaxStart(function() {
				$(".fullscreen").show();
			});
			$(document).ajaxComplete(function() {
				if ($.active == 1) {
	                $(".fullscreen").fadeOut();
	            }
			});
			$(document).ready(function() {

				$(".fullscreen").fadeOut();

				//init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});

			});

			$(document).ready(function() {
				//init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});

				// iCheck ------------------------
				$('input:checkbox').attr("checked");
				$('input[type=checkbox]').iCheck({
					checkboxClass : 'icheckbox_flat-yellow',
					increaseArea : '20%' // optional
				});

				//init select2
				$("select#cidade_banco").select2({
					escapeMarkup: function(m) { return m; }, language: "fr", placeholder: "<?php echo $data[1456]['trad']; ?>",
				});
				$("select#plano_banco").select2({
					escapeMarkup: function(m) { return m; }, language: "fr", placeholder: "<?php echo $data[1456]['trad']; ?>",
				});

				var idBanco = getParameterByName('banque');
				//fill infos
				fill_bank(idBanco);

				$('#bvr_banco').mask('00000000000');
			});

			//get vars
			function getParameterByName(name, url) {
				if (!url)
					url = window.location.href;
				url = url.toLowerCase();
				// This is just to avoid case sensitiveness
				name = name.replace(/[\[\]]/g, "\\$&").toLowerCase();
				// This is just to avoid case sensitiveness for query parameter name
				var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"), results = regex.exec(url);
				if (!results)
					return null;
				if (!results[2])
					return '';
				return decodeURIComponent(results[2].replace(/\+/g, " "));
			}

			//flag novo
			$(document).on('ifChanged', 'input#predefinir_banco', function(event) {
				if( $('input#predefinir_banco').is(":checked") ) flagPredefinirEdit = 1;
				else flagPredefinirEdit = 0;
			});

			//Key Listner
			$("#codigopostal_banco").on('keyup', function(event){
				var npaInput = $(this).val();

				$("#selectCidadeWrapper").show(); 
				getLocaliteFromNpa(npaInput, 'cidade_banco');
			});

			//get localite
			function getLocaliteFromNpa(valueNPA,selectID, lastCity = null){
				var options = $("select#"+selectID);
				$(options).empty();
				//get data
				$.ajax({
					type : 'POST',
					url : '/frifacturation/server/npa_localite.php',
					data : { 
						npa : valueNPA
					},
					dataType : 'json',
					success : function(resposta) {
						if (resposta == null) {
							$.scojs_message("[SEL007] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);

						} else {
							if (resposta.errors == true) {
								$.scojs_message("[SEL008] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							} else {
								if (resposta.data == null) {
									$(options).attr("disabled", true);

								} else {
									$(options).attr("disabled", false);

									$(options).append($('<option data-hidden="true"/>').val("").text("<?php echo $data[1456]['trad']; ?>"));

									// $(options).append($("<option />").val(0).text('Aucune Ville'));
									if(resposta.data){
										$.each(resposta.data, function() {
											$(options).append($("<option />").val(this.Nome).text(this.Nome));
										});
									}
								}
							}
						}
					},
					complete : function() {
						if(lastCity != null) $("select#"+selectID).val(lastCity);
						else $(options).val( $("select#"+selectID+" option:eq(1)").val() ); //viana do castelo district
						$(options).trigger('change');
					}
				});
			}
			
		function checkIban(iban){
			var success;
			$.ajax({
				url: "https://api.fricode-developpement.ch:8443/v2/iban/validate", 
				contentType: "text/plain",
				data: iban,
				method: "POST",
				async: false,
				success: function(result){
					success = true;
				},
				error: function(result){
					success = false;
				}
			});
			return success;
		}
		
		function checkQRIban(iban){
			var success;
			$.ajax({
				url: "https://api.fricode-developpement.ch:8443/v2/qr-iban/validate",
				contentType: "text/plain",
				data: iban,
				method: "POST",
				async: false,
				success: function(result){
					success = true;
				},
				error: function(result){
					success = false;
				}
			});
			return success;
		}

			/**
			 * ----------------------------------------------------
			 * ----------------- FORM PROCESSING ------------------
			 * ----------------------------------------------------
			 */
			/**
			 * Validate Percentage
			 */
			$.validator.addMethod("verifyIban", function(value, element, regexpr) {
				result = false;
				iban = checkIban($('#Iban').val());
				qrIban = checkQRIban($('#Iban').val());
				result = iban && !qrIban;
				return result;
			}, "");
			
			$.validator.addMethod("verifyQRIban", function(value, element, regexpr) {
				result = false;
				result = checkQRIban($('#QRIban').val());
				return result;
			}, "");
			
			$.validator.addMethod("moneyValidation", function (value, element) {
				var valorInput = $(element).autoNumeric('get');
				if(valorInput >= 0 && valorInput != '') return true;
				else return false;
			}, "<?php echo $data[1434]['trad']; ?>");
			val_form_new = $("#form_new").validate({
				ignore : "",
				rules : {
					descricao_banco : {
						required : true
					},
					debito_banco : {
						required : true,
						moneyValidation : true
					},
					credito_banco : {
						required : true,
						moneyValidation : true
					},
					/*bvr_banco : {
						required : true
					},*/
					<?php if($_SESSION['mod_Contabilidade'] != 0) {?>
					plano_banco : {
						required : true
					},
					<?php } ?>
					/*compte_lapost1_banco : {
						required : true
					},
					compte_lapost2_banco : {
						required : true
					},*/
					codigopostal_banco : {
						required : true
					},
					cidade_banco : {
						required : true
					},
					Iban : {
						//verifyIban : true
					},
					QRIban : {
						//verifyQRIban : true
					},
				},
				messages : {
					descricao_banco : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
					debito_banco : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
					credito_banco : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
					/*bvr_banco : {
						required : "<?php echo $data[186]['trad']; ?>"
					},*/
					<?php if($_SESSION['mod_Contabilidade'] != 0) {?>
					plano_banco : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
					<?php } ?>
					/*compte_lapost1_banco : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
					compte_lapost2_banco : {
						required : "<?php echo $data[186]['trad']; ?>"
					},*/
					codigopostal_banco : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
					cidade_banco : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
					Iban : {
						//verifyIban : "Veuillez entrer un IBAN valide"
					},
					QRIban : {
						//verifyQRIban : "Veuillez entrer un QR-IBAN valide"
					},
				},
				highlight : function(element, errorClass, validClass) {
					$(element).addClass(errorClass).removeClass(validClass);
				},
				unhighlight : function(element, errorClass, validClass) {
					$(element).removeClass(errorClass).addClass(validClass);
				},
				errorPlacement : function(error, element) {
					if (element.hasClass('select2')) {
						if (element.parent().hasClass("input-group"))
							error.insertAfter(element.parent());
						else
							error.insertAfter(element.next("div"));
					} else {
						error.insertAfter(element);
					}
				}
			});

			//check validation and upload foto
			$("#form_new").submit(function(e) {
				e.preventDefault();

				var idBanco = getParameterByName('banque');

				var valid = $("#form_new").valid();
				if (valid == false) {
					$.scojs_message("<?php echo $data[1403]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				} else {
					var pourcent = "";
					if($('input#pourcent_banco').is(":checked")){
						pourcent = 1;
					} else {
						pourcent = 0;
					}
					var escompte = $("#escompte_banco").val();
					var checkescompte = 0;
					if(escompte != ""){
						checkescompte = 1;
					}
					var regex = /^\d*\,?\.?\d{0,2}$/g;
					if(!escompte.match(regex) && checkescompte == 1){
						alert("<?php echo $data[1966]['trad']; ?>");
						return ;
					}
					intescompte = parseFloat(escompte);
					if(pourcent == 1 && intescompte >= 100 && checkescompte == 1){
						alert("<?php echo $data[1967]['trad']; ?>");
						return;
					}
					if(intescompte*100 % 5 != 0 && checkescompte == 1 && pourcent == 0){
						alert("<?php echo $data[1968]['trad']; ?>");
						return ;
					}
					$("#form_new").find('.submit_button').attr("disabled", true);
					$("#form_new").find('.submit_button').html('<i class="fa fa-circle-o-notch fa-spin  fa-fw "></i> <?php echo $data[214]['trad']; ?> ...');

					//submite the form
					$.ajax({
						type : 'POST',
						url : '/frifacturation/server/contabilidade/bancos/editar.php',
						dataType : 'json',
						data : {
							idBanco : idBanco,
							descricao_banco : $("#descricao_banco").val(),
							bvr_banco : $("#bvr_banco").val(),
							compte_lapost1_banco : $("#compte_lapost1_banco").val(),
							compte_lapost2_banco : $("#compte_lapost2_banco").val(),
							debito_banco : $("#debito_banco").autoNumeric('get'),
							credito_banco : $("#credito_banco").autoNumeric('get'),
							flagPredefinirEdit : flagPredefinirEdit,
							plano_banco : $("#plano_banco").val(),
							iban : $("#Iban").val(),
							qriban : $("#QRIban").val(),
							pourcent : pourcent,
							escompte : escompte,
							
							codigopostal_banco: $("#codigopostal_banco").val(),
							cidade_banco: $("#cidade_banco").val(),
						},
						success : function(resposta) {
							var resp = resposta;
							if (resposta == null)
								$.scojs_message("[FAT001] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							else {
								if (resposta.errors) {
									$.scojs_message("[FAT002] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
								} else {
									$.scojs_message("<?php echo $data[530]['trad']; ?>", $.scojs_message.TYPE_OK);
								}
							}
						},
						complete : function(resposta) {
							var resp = resposta;
							if (resp.responseJSON.errors) {
								$.scojs_message("[FAT003] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							} else {
								$.scojs_message("<?php echo $data[530]['trad']; ?>", $.scojs_message.TYPE_OK);
								//reload
								setTimeout(function() {
									window.location.href = "../banques";
								}, 1000);
							}
							$("#form_new").find('.submit_button').attr("disabled", false);
							$("#form_new").find('.submit_button').html('<i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?>');
						}
					});
				}
			});
		</script>
	</body>
</html>