<?php
	include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo_gesfaturacao.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/helpers.php';
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

	if ( hasPermission(['P0068']) == 1 ) {}
	else{
		header('Location: ../../acces-refuse?redirectfrom=/frifacturation/banques_fournisseurs&redirectto=/frifacturation');
	}
	if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1509,130,132,1175,1278,35,1250,1045,1288,418,1263,1278);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<html>
	<title><?php echo $data[1509]['trad']; ?>: <?php echo $data[130]['trad']; ?> | Frifacturation</title>
	<head>
		<?php include('../../base/css.php') ?>
		<!-- ADDED CSS -->
		<link rel="stylesheet" href="/js/vendors/bootstrap-select/bootstrap-select.min.css">
		<link rel="stylesheet" href="/js/vendors/bootstrap-datepicker/datepicker3.css">
		<!-- //ADDED CSS -->
	</head>
	<body>
		<?php include '../../../modal_menu.php'; ?>
		<div class="container">
			<?php include '../../menu.php'; ?>

			<div class="page-content">
				<div class="panel panel-white">
					<div class="panel-heading">
                        <div class="pull-right" >
						</div>
						<ol class="breadcrumb page-breadcrumb" style=" min-height: 35px; vertical-align: middle;">
							<li>
								<?php echo $data[1509]['trad']; ?>
							</li>
							<li class="active">
								<?php echo $data[130]['trad']; ?>
							</li>
						</ol>
                    </div>
					<div class="panel-body">
						<div class="row ptm">
							<div class="col-md-12 ">
								<table class="table table-bordered table-striped" id="table_id" >
									<thead>
										<tr>
											<th style="width: 60px;"><?php echo $data[132]['trad']; ?></th>
											<th><?php echo $data[1175]['trad']; ?></th>
											<th style="width: 220px;"><?php echo $data[35]['trad']; ?></th>
											<th style="width: 200px;"><?php echo $data[1250]['trad']; ?>/<?php echo $data[1045]['trad']; ?></th>
											<th style="width: 100px;"><?php echo $data[1288]['trad']; ?></th>
											<th style="width: 60px;" class="text-center"><?php echo $data[1278]['trad']; ?></th>
											<th style="width: 60px;"><?php echo $data[1263]['trad']; ?></th>
										</tr>
									</thead>
									<tbody></tbody>
								</table>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		
		<?php include '../../footer.php';	?>
		<?php include('../../base/scripts.php') ?>

		<?php 
		if (!function_exists('get_trad')) {
			include $_SERVER["DOCUMENT_ROOT"]. "/translate.php";
		}
		$ids_list = array(1997,1998,1999,2000,2001,2002);
		if (isset($data)) {
			$data = $data + get_trad($ids_list);
		} else {
			$data = get_trad($ids_list);
		}	
	?>
		<script type="text/javascript">
			text1 = "<?php echo $data[1997]['trad']; ?>" ;
			text2 = "<?php echo $data[1998]['trad']; ?>" ;
			text3 = "<?php echo $data[1999]['trad']; ?>" ;
			text4 = "<?php echo $data[2000]['trad']; ?>" ;
			text5 = "<?php echo $data[2001]['trad']; ?>" ;
			text6 = "<?php echo $data[2002]['trad']; ?>" ;
		</script>

		<!-- ADDED SCRIPTS -->
		<script src="/js/vendors/bootstrap-select/bootstrap-select.min.js"></script>
		<script src="/js/vendors/bootstrap-select/defaults-pt_BR.min.js"></script>

		<script src="/js/vendors/DataTables/media/js/jquery.dataTables.js"></script>
		<script src="/js/vendors/DataTables/media/js/dataTables.bootstrap.js"></script>

		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.js"></script>
		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.pt.js"></script>
		<script src="/js/vendors/jquery-maskedinput/jquery-maskedinput.js"></script>
		<script src="/js/fnReload.js"></script>

		<script src="/js/autoNumeric.js"></script>
		<script src="/js/jquery.showmore.js"></script>
		
		<?php include('index_scripts.php');  ?>
		<!-- //ADDED SCRIPTS -->

		<script>
			$(".navbar-nav li.contabilidade").addClass("active");
			$(".navbar-nav li.contabilidade li.bancos_fornecedor_contabilidade").addClass("active");
		</script>
		<script type="text/javascript">
			var flagPredefinir = 1;
			var flagPredefinirEdit = 0;

			$(document).ajaxStart(function() {
				$(".fullscreen").show();
			});
			$(document).ajaxComplete(function() {
				if ($.active == 1) {
	                $(".fullscreen").fadeOut();
	            }
			});
			$(document).ready(function() {

				$(".fullscreen").fadeOut();

				//init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});

			});

			$(document).ready(function() {
				//init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});
			});
		</script>
	</body>
</html>