<?php
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1565,1472,1446,1702,1704,1503,1312,1310,421,1311,425,32,428,1377,1639,126,1698,1712);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<script type="text/javascript">
	table = $('#table_id').dataTable({
		"dom" : '<lfrtip><"clear">',
		"sRowSelect" : "os",
		"sRowSelector" : 'td:first-child',
		"lengthMenu" : [[25, 50, 100, -1], [25, 50, 100, "<?php echo $data[1565]['trad']; ?>"]],
		"iDisplayLength" : 100,
		"aaSorting" : [[0, "asc"]],
		"bProcessing" : true,
		"bServerSide" : true,
		"sAjaxSource" : "/frifacturation/server/datatable/bancos_fornecedores.php",
		"oLanguage" : {
			"sLengthMenu" : "<?php echo $data[1472]['trad']; ?>",
			"sZeroRecords" : "<?php echo $data[1446]['trad']; ?>",
			"sInfo" : "<?php echo $data[1702]['trad']; ?>",
			"sInfoEmpty" : "<?php echo $data[1704]['trad']; ?>",
			"sProcessing" : "<div></div>",
			"sInfoFiltered" : "",
			"oPaginate" : {
				"sNext" : "<?php echo $data[1503]['trad']; ?>",
				"sFirst" : "<?php echo $data[1312]['trad']; ?>",
				"sPrevious" : "<?php echo $data[1310]['trad']; ?>",
				"sLast" : "<?php echo $data[421]['trad']; ?>"
			}
		},
		"aoColumns" : [null,null,null,null,null,
		{
			"sClass" : "text-center",
		},
		{
			"bVisible" : true,
			"sClass" : "text-center",
			"bSortable" : false,
			"bSearchable" : false
		},{
			"bVisible" : false,
			"bSortable" : false,
			"bSearchable" : true
		}],
		"aoColumnDefs" : [
		{
			"aTargets" : [1],
			"mRender" : function(data, type, full) {
				//return html
				return '<span class="ellipsis" data-size="45">'+full[1]+'</span>';
			}
		},
		{
			"aTargets" : [2],
			"mRender" : function(data, type, full) {
				//return html
				return '<span class="ellipsis" data-size="30">'+full[2]+'</span>';
			}
		},
		{
			"aTargets" : [3],
			"mRender" : function(data, type, full) {
				//return html
				return '<span class="ellipsis" data-size="30">'+full[3]+'</span>';
			}
		},
		{
			"aTargets" : [4],
			"mRender" : function(data, type, full) {
				//return html
				element = full[4];
				if(full[4] == "Suisse"){
					element = "<?php echo $data[1712]['trad']; ?>";
				}
				return element;
			}
		},
		{
			"aTargets" : [5],
			"mRender" : function(data, type, full) {
				var element = '';
				//process icon
				if(full[5] == 1){
					element = '&nbsp;<i class="fa fa-check text-green" title="<?php echo $data[1278]['trad']; ?>"></i>';
				}else{
					element = '<a onClick="predefinirBanco('+full[6]+')" class="options-link text-red" title="<?php echo $data[1311]['trad']; ?>"><i class="fa fa-check-square-o"></i></a>';
				}
				return element;
			}
		},
		{
			"aTargets" : [6],
			"mRender" : function(data, type, full) {
				var processedName = full[1].replace(/'/gi, " "); processedName = processedName.replace(/"/gi, " ");
				var nome = "'"+processedName+"'";
				var html = '';

				//state options
				if(full[7] == 1){
					html += '<a onClick="alterState('+full[6]+')" class="options-link text-dark-blue" title="<?php echo $data[425]['trad']; ?>"><i class="fa fa-ban"></i></a>';
				}else{
					html += '<a onClick="alterState('+full[6]+')" class="options-link text-green" title="<?php echo $data[32]['trad']; ?>"><i class="fa fa-check-square-o"></i></a>';
				}
				
				html += '<a href="details?banque='+ full[6] +'" class="options-link text-info"><i class="fa fa-eye" title="<?php echo $data[428]['trad']; ?>"></i></a>';
				
				//return all html composed
				return html;
			}
		}],

		"fnRowCallback" : function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
			$(nRow).attr("dbID", aData[6]);

			return nRow;
		},
		"fnDrawCallback" : function(oSettings) {
            $(".ellipsis").ellipsis(); 
		},
	});

	$('#table_id').on('click', 'tbody td:not(.dataTables_empty)', function() {
		$('#table_id tbody tr').removeClass('selected');
		$(this).parent('tr').removeClass('DTTT_selected');
		$(this).parent('tr').addClass('selected');
	});

	$('#table_id_filter input').unbind();

	$('#table_id_filter').html('<label><div class="input-group input-group-sm mbs"><input type="search" class="form-control input-sm" placeholder="" aria-controls="table_id"><span class="input-group-btn"><button type="button" data-toggle="dropdown" class="btn btn-yellow dropdown-toggle" onclick="pesquisar()"><i class="fa fa-search"></i> <?php echo $data[1377]['trad']; ?></button></span></div></label>');

	$('#table_id_filter input').bind('keyup', function(e) {
		if (e.keyCode == 13) {
			table.fnFilter(this.value);
		}

	});
	function pesquisar() {
		table.fnFilter($('#table_id_filter input').val());
	}
	$('#table_id_filter input').bind('keyup', function(e) {
		if (($(this).val().length) == 0) {
			table.fnFilter('');
		}
	});
	function fnGetSelected(tabela) {
		var aReturn = new Array();
		var aTrs = tabela.fnGetNodes();
		for (var i = 0; i < aTrs.length; i++) {
			if ($(aTrs[i]).hasClass('row_selected')) {
				aReturn.push(aTrs[i]);
			}
		}
		return aReturn;
	}

	//END OF TABLE ---------------------------------------------
	
	//details for the bank
	function detalhesBanco(idBanco){

	}

	//change Prédéfini
	function predefinirBanco(idBanco){
	<?php if (hasPermission(['P0068']) == 1) { ?>
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/contabilidade/bancos_fornecedores/predefinir.php',
			dataType : 'json',
			data : {
				idBanco : idBanco
			},
			success : function(resposta) {
				var resp = resposta;
				if (resposta == null)
					$.scojs_message("[FAT001] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				else {
					if (resposta.errors) {
						$.scojs_message("[FAT002] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						$.scojs_message("<?php echo $data[126]['trad']; ?>", $.scojs_message.TYPE_OK);
					}
				}
			},
			complete : function(resposta) {
				location.reload();
			}
		});
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>.');
	<?php } ?>
	}

	//change Prédéfini
	function alterState(idBanco){
	<?php if (hasPermission(['P0068']) == 1) { ?>
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/contabilidade/bancos_fornecedores/estado.php',
			dataType : 'json',
			data : {
				idBanco : idBanco
			},
			success : function(resposta) {
				var resp = resposta;
				if (resposta == null)
					$.scojs_message("[FAT001] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				else {
					if (resposta.errors) {
						$.scojs_message("[FAT002] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						$.scojs_message("<?php echo $data[126]['trad']; ?>", $.scojs_message.TYPE_OK);
					}
				}
			},
			complete : function(resposta) {
				location.reload();
			}
		});
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>.');
	<?php } ?>
	}
</script>