<?php
	include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo_gesfaturacao.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/helpers.php';
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

	if ( hasPermission(['P0136']) == 1 ) {}
	else{
		header('Location: ../../acces-refuse?redirectfrom=/frifacturation/tableaux/code_postal_npa&redirectto=/frifacturation');
	}
	if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1509,260,1250,1210,427,562,67,1110,31,1639,1093,1505,642,786,1995,261,1698,1639,568,567,186,1403,214,1633,1013,532,1565,1472,1446,1702,1704,1312,1310,421,1377,1503,1263);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<html>
	<title><?php echo $data[1509]['trad']; ?>: <?php echo $data[260]['trad']; ?> (<?php echo $data[1250]['trad']; ?>) | Frifacturation</title>
	<head>
		<?php include('../../base/css.php') ?>
		<!-- ADDED CSS -->
		<link rel="stylesheet" href="/js/vendors/bootstrap-select/bootstrap-select.min.css">
		<link rel="stylesheet" href="/js/vendors/bootstrap-datepicker/datepicker3.css">
		<!-- //ADDED CSS -->
	</head>
	<body>
		<?php include '../../../modal_menu.php'; ?>
		<div class="container">
			<?php include '../../menu.php'; ?>
			
			<!-- Novo unidade -->
			<div id="modal-codepostal" tabindex="-1" role="dialog" aria-labelledby="modal-header-primary-label" aria-hidden="true" class="modal fade">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header modal-header-orange">
							<button type="button" data-dismiss="modal" aria-hidden="true" class="close">
								&times;
							</button>
							<h4 id="modal-header-primary-label" class="modal-title"><?php echo $data[1210]['trad']; ?> (<?php echo $data[1250]['trad']; ?>)</h4>
						</div>
						<form id="form_new_code" class="form-validate" novalidate="novalidate">
							<div class="modal-body" style="overflow-y: visible;">
								<div class="row">
									<div class="col-md-4">
										<div class="form-group">
											<label class="control-label"><?php echo $data[260]['trad']; ?><span class="require">*</span></label>
											<input type="text" class="form-control" name="code_codepostal" id="code_codepostal" >
										</div>
									</div>
									<div class="col-md-8">
										<div class="form-group">
											<label class="control-label"><?php echo $data[427]['trad']; ?><span class="require">*</span></label>
											<input type="text" class="form-control" name="descricao_codepostal" id="descricao_codepostal">
										</div>
									</div>
								</div>
							</div>
							<div class="modal-footer">
								<button  class="btn btn-yellow submit_button" type="submit">
									<i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?>
								</button>
								<button type="button" data-dismiss="modal" class="btn btn-default">
									<?php echo $data[1995]['trad']; ?>
								</button>
							</div>
						</form>
					</div>
				</div>
			</div>
			<!-- Editar unidade -->
			<div id="modal-codepostal-edit" tabindex="-1" role="dialog" aria-labelledby="modal-header-primary-label" aria-hidden="true" class="modal fade">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header modal-header-orange">
							<button type="button" data-dismiss="modal" aria-hidden="true" class="close">
								&times;
							</button>
							<h4 id="modal-header-primary-label" class="modal-title"><?php echo $data[1110]['trad']; ?> (<?php echo $data[1250]['trad']; ?>)</h4>
						</div>
						<form id="form_new_codeEditar" class="form-validate" novalidate="novalidate">
							<input type="hidden" value="" id="ModalEdit_id_codepostal" />
							<div class="modal-body" style="overflow-y: visible;">
								<div class="row">
									<div class="col-md-4">
										<div class="form-group">
											<label class="control-label"><?php echo $data[260]['trad']; ?><span class="require">*</span></label>
											<input type="text" class="form-control" name="ModalEdit_code_codepostal" id="ModalEdit_code_codepostal" >
										</div>
									</div>
									<div class="col-md-8">
										<div class="form-group">
											<label class="control-label"><?php echo $data[427]['trad']; ?><span class="require">*</span></label>
											<input type="text" class="form-control" name="ModalEdit_descricao_codepostal" id="ModalEdit_descricao_codepostal">
										</div>
									</div>
								</div>
							</div>
							<div class="modal-footer">
								<button  class="btn btn-yellow submit_button" type="submit">
									<i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?>
								</button>
								<button type="button" data-dismiss="modal" class="btn btn-default">
									<?php echo $data[1995]['trad']; ?>
								</button>
							</div>
						</form>
					</div>
				</div>
			</div>

			<div class="page-content">
				<div class="panel panel-white">
					<div class="panel-heading">
                        <div class="pull-right" >
							<?php if (hasPermission(['P0139']) == 1) { ?>
							<button type="button" data-target="#modal-codepostal" data-toggle="modal" class="btn btn-yellow btn-outlined btn-square"><i class="fa fa-plus"></i>&nbsp;&nbsp;<?php echo $data[1210]['trad']; ?></button>
							<?php } ?>
						</div>
						<ol class="breadcrumb page-breadcrumb" style=" min-height: 35px; vertical-align: middle;">
							<li>
								<?php echo $data[1509]['trad']; ?>
							</li>
							<li class="active" style="margin-top: 5px;">
								<?php echo $data[260]['trad']; ?> (<?php echo $data[1250]['trad']; ?>)
							</li>
						</ol>
                    </div>
					<div class="panel-body">
						<div class="row ptm ">
							<div class="col-md-12 ">
								<div class="form-body">
									<div id="form_div">
										<div class="row">
												<div class="col-md-12">
													<table class="table table-bordered table-striped" id="table_id">
														<thead>
															<tr>
																<th style="width: 120px;"><?php echo $data[260]['trad']; ?> (<?php echo $data[1250]['trad']; ?>)</th>
																<th><?php echo $data[427]['trad']; ?></th>
																<!-- <th style="width: 70px;" class="text-center">Actif</th> -->
																<th style="width: 70px;" class="text-center"><?php echo $data[1263]['trad']; ?></th>
															</tr>
														</thead>
														<tbody></tbody>
													</table>
												</div>
										</div>											
									</div>
								</div>
							</div>
						</div>
					</div>

				</div>
			</div>
		</div>
		
		
		<?php include '../../footer.php';	?>
		<?php include('../../base/scripts.php') ?>

		<?php 
		if (!function_exists('get_trad')) {
			include $_SERVER["DOCUMENT_ROOT"]. "/translate.php";
		}
		$ids_list = array(1997,1998,1999,2000,2001,2002);
		if (isset($data)) {
			$data = $data + get_trad($ids_list);
		} else {
			$data = get_trad($ids_list);
		}	
	?>
		<script type="text/javascript">
			text1 = "<?php echo $data[1997]['trad']; ?>" ;
			text2 = "<?php echo $data[1998]['trad']; ?>" ;
			text3 = "<?php echo $data[1999]['trad']; ?>" ;
			text4 = "<?php echo $data[2000]['trad']; ?>" ;
			text5 = "<?php echo $data[2001]['trad']; ?>" ;
			text6 = "<?php echo $data[2002]['trad']; ?>" ;
		</script>

		<!-- ADDED SCRIPTS -->
		<script src="/js/vendors/bootstrap-select/bootstrap-select.min.js"></script>
		<script src="/js/vendors/bootstrap-select/defaults-pt_BR.min.js"></script>

		<script src="/js/vendors/DataTables/media/js/jquery.dataTables.js"></script>
		<script src="/js/vendors/DataTables/media/js/dataTables.bootstrap.js"></script>

		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.js"></script>
		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.pt.js"></script>
		<script src="/js/vendors/jquery-maskedinput/jquery-maskedinput.js"></script>
		<script src="/js/fnReload.js"></script>

		<script src="/js/autoNumeric.js"></script>

		<script src="/js/vendors/iCheck/icheck.min.js"></script>		
		
		<!-- //ADDED SCRIPTS -->

		<script>
			$(".navbar-nav li.contabilidade").addClass("active");
			$(".navbar-nav li.contabilidade li.code_postal_npa").addClass("active");
		</script>

		<script>
			var flagPredefinir = 0;
			var flagPredefinirEdit = 0;

			$(document).ajaxStart(function() {
				$(".fullscreen").show();
			});
			$(document).ajaxComplete(function() {
				if ($.active == 1) {
	                $(".fullscreen").fadeOut();
	            }
			});

			$(document).ready(function() {
				$(".fullscreen").fadeOut();

				$(".percentage").autoNumeric("init", {
					aSep : '.',
					aDec : ',',
					aSign : '  %',
					vMax : '100',
					pSign : 's'
				});
			});
			$(document).ready(function() {

				$("#form_new_code")[0].reset();

				$(".percentage").autoNumeric("init", {
					aSep : '.',
					aDec : ',',
					aSign : '  %',
					vMax : '100',
					pSign : 's'
				});

				// iCheck ------------------------
				$('input:checkbox').attr("checked");
				$('input[type=checkbox]').iCheck({
					checkboxClass : 'icheckbox_flat-red',
					increaseArea : '20%' // optional
				});
				$('input').on('ifChecked', function (event){
				    $(this).closest("input").attr('checked', true);          
				});
				$('input').on('ifUnchecked', function (event) {
				    $(this).closest("input").attr('checked', false);
				});
			});

			//load data
			function fill_codepostal_npa() {
				$.ajax({
					type : 'POST',
					url : '/frifacturation/server/tableaux/code_postal_npa/codepostal.php',
					dataType : 'json',
					data : {},
					success : function(resposta) {
						if (resposta == null) {
							$.scojs_message("[FAT001] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							if (resposta.errors == true) {
								$.scojs_message("[FAT002] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							} else {
								if (resposta.data == null) {
									$.scojs_message("[FAT003] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
								} else {
									var dados = resposta.data;
									$.each(dados, function() {
										//process buttons and flags
										var btnHtml = '';
										
										btnHtml +='<a onClick="editarCode('+this.id+')" class="options-link text-yellow"><i class="fa fa-edit" title="<?php echo $data[1093]['trad']; ?>"></i></a>';

										btnHtml +='<a onClick="removerCode('+this.id+')" class="options-link text-red"><i class="fa fa-trash" title="<?php echo $data[1505]['trad']; ?>"></i></a>';

										//html to add
										var htmlCode = '<tr>';
												htmlCode += '<td style="width: 120px;">';
													htmlCode += this.npa;
												htmlCode += '</td>';
												htmlCode += '<td>';
													htmlCode += this.localite;
												htmlCode += '</td>';
												// htmlCode += '<td style="width: 70px;" class="text-center">';
												// 	htmlCode += ativoFlag;
												// htmlCode += '</td>';
												htmlCode += '<td style="width: 70px;" class="text-center">';
													htmlCode += btnHtml;
												htmlCode += '</td>';
											htmlCode += '</tr>';

										//append
										$("#unidadesTable tbody").append(htmlCode);
									});
								}
							}
						}
					},
					complete : function() {
					}
				});
			}

			//delete
			function removerCode(idCodepostal, nome){
			<?php if (hasPermission(['P0137']) == 1) { ?>
				if (confirm("<?php echo $data[642]['trad']; ?>") == true) {
					$.ajax({
						type : 'POST',
						url : '/frifacturation/server/tableaux/code_postal_npa/apagar.php',
						dataType : 'json',
						data : {
							idCodepostal : idCodepostal
						},
						success : function(resposta) {
							var resp = resposta;
							if (resposta == null)
								$.scojs_message("[FAT001] <?php echo $data[786]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							else {
								if (resposta.errors) {
									$.scojs_message("[FAT002] <?php echo $data[786]['trad']; ?>", $.scojs_message.TYPE_ERROR);
								} else {
									$.scojs_message("<?php echo $data[261]['trad']; ?>", $.scojs_message.TYPE_OK);
								}
							}
						},
						complete : function(resposta) {
							pesquisar();
						}
					});
				} else { return false; }
			<?php } else {?>
				alert('<?php echo $data[1698]['trad']; ?>');
			<?php } ?>
			}

			//editar
			function editarCode(idCodepostal) {
			<?php if (hasPermission(['P0138']) == 1) { ?>
				//clean vars
				$("#ModalEdit_id_codepostal").val('');
				$("#ModalEdit_descricao_codepostal").val('');
				$("#ModalEdit_code_codepostal").val('');

				//get Details
				$.ajax({
					type : 'POST',
					url : '/frifacturation/server/tableaux/code_postal_npa/detalhes.php',
					data : {
						idCodepostal : idCodepostal
					},
					dataType : 'json',
					success : function(resposta) {
						if (resposta == null) {
							$.scojs_message("[TC001] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							if (resposta.errors == true) {
								$.scojs_message("[TC002] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							} else {
								if (resposta.data != null) {
									var data = resposta.data;
									$("#ModalEdit_id_codepostal").val(data.id );
									$("#ModalEdit_descricao_codepostal").val(data.localite );
									$("#ModalEdit_code_codepostal").val(data.npa );
								} else {
									//clean vars
									$("#ModalEdit_id_codepostal").val('');
									$("#ModalEdit_descricao_codepostal").val('');
									$("#ModalEdit_code_codepostal").val('');
								}
							}
						}
					},
					complete : function() {}
				});
				//open modal				
				$('#modal-codepostal-edit').modal('show');
			<?php } else {?>
				alert('<?php echo $data[1698]['trad']; ?>');
			<?php } ?>
			}

			// ----------------- FORM PROCESSING ------------------
			/**
			 * Custom validators for letters and numbers only.  Uppercase/lowercase letters and numbers (0-9).
			 */
			$.validator.addMethod("lettersAndNumbersOnly", function (value, element) {
			    return this.optional(element) || /^[a-zA-Z0-9-]+$/i.test(value);
			}, "<?php echo $data[568]['trad']; ?>");
			/**
			 * Validate Percentage
			 */
			$.validator.addMethod("percentageValidation", function (value, element) {
				var valor_imposto = $("#valor_imposto").autoNumeric('get');
				if(valor_imposto >= 0 && valor_imposto != '') return true;
				else return false;
			}, "<?php echo $data[567]['trad']; ?>");
			/**
			 * Validate Percentage2
			 */
			$.validator.addMethod("percentageValidation2", function (value, element) {
				var valor_imposto = $("#ModalEdit_valor_imposto").autoNumeric('get');
				if(valor_imposto >= 0 && valor_imposto != '') return true;
				else return false;
			}, "<?php echo $data[567]['trad']; ?>");

			val_form_new = $("#form_new_code").validate({
				ignore : "",
				rules : {
					descricao_codepostal : {
						required : true,
					},
					code_codepostal : {
						required : true,
					},
				},
				messages : {
					descricao_codepostal : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
					code_codepostal : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
				},
				highlight : function(element, errorClass, validClass) {
					$(element).addClass(errorClass).removeClass(validClass);
				},
				unhighlight : function(element, errorClass, validClass) {
					$(element).removeClass(errorClass).addClass(validClass);
				},
				errorPlacement : function(error, element) {
					if (element.hasClass('select2')) {
						if (element.parent().hasClass("input-group"))
							error.insertAfter(element.parent());
						else
							error.insertAfter(element.next("div"));
					} else {
						error.insertAfter(element);
					}
				}
			});

		//check validation and submit
		$("#form_new_code").submit(function(e) {
			e.preventDefault();
			<?php if (hasPermission(['P0139']) == 1) { ?>

			var valid = $("#form_new_code").valid();
			if (valid == false) {
				$.scojs_message("<?php echo $data[1403]['trad']; ?>", $.scojs_message.TYPE_ERROR);
			} else {

				$("#form_new_code").find('.submit_button').attr("disabled", true);
				$("#form_new_code").find('.submit_button').html('<i class="fa fa-circle-o-notch fa-spin  fa-fw "></i> <?php echo $data[214]['trad']; ?> ...');

				//submite the form
				$.ajax({
					type : 'POST',
					url : '/frifacturation/server/tableaux/code_postal_npa/inserir.php',
					dataType : 'json',
					data : {
						descricao_codepostal : $('#descricao_codepostal').val(),
						code_codepostal : $('#code_codepostal').val(),
					},
					success : function(resposta) {
						var resp = resposta;
						if (resposta == null)
							$.scojs_message("[FAT001] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						else {
							if (resposta.errors) {
								$.scojs_message("[FAT002] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							} else {
								$.scojs_message("<?php echo $data[1013]['trad']; ?>", $.scojs_message.TYPE_OK);
							}
						}
					},
					complete : function(resposta) {
						var resp = resposta;
						console.log(resp);
						if (resp.responseJSON.errors) {
							$.scojs_message("[FAT003] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							$.scojs_message("<?php echo $data[1013]['trad']; ?>", $.scojs_message.TYPE_OK);
							//reload
							pesquisar();

							//close modal				
							$('#modal-codepostal').modal('hide');
						}
						$("#form_new_code").find('.submit_button').attr("disabled", false);
						$("#form_new_code").find('.submit_button').html('<i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?>');
					}
				});
			}
			<?php } else {?>
				alert('<?php echo $data[1698]['trad']; ?>');
			<?php } ?>
		});

		/**
		 * -----------------------------------------
		 * 				EDITION FORM
		 * -----------------------------------------
		 */
		val_form_new2 = $("#form_new_codeEditar").validate({
			ignore : "",
			rules : {
				ModalEdit_descricao_codepostal : {
					required : true,
				},
				ModalEdit_code_codepostal : {
					required : true,
				},
			},
			messages : {
				ModalEdit_descricao_codepostal : {
					required : "<?php echo $data[186]['trad']; ?>"
				},
				ModalEdit_code_codepostal : {
					required : "<?php echo $data[186]['trad']; ?>"
				},
			},
			highlight : function(element, errorClass, validClass) {
				$(element).addClass(errorClass).removeClass(validClass);
			},
			unhighlight : function(element, errorClass, validClass) {
				$(element).removeClass(errorClass).addClass(validClass);
			},
			errorPlacement : function(error, element) {
				if (element.hasClass('select2')) {
					if (element.parent().hasClass("input-group"))
						error.insertAfter(element.parent());
					else
						error.insertAfter(element.next("div"));
				} else {
					error.insertAfter(element);
				}
			}
		});

		//check validation and submit
		$("#form_new_codeEditar").submit(function(e) {
			e.preventDefault();

			var valid = $("#form_new_codeEditar").valid();
			if (valid == false) {
				$.scojs_message("<?php echo $data[1403]['trad']; ?>", $.scojs_message.TYPE_ERROR);
			} else {

				$("#form_new_codeEditar").find('.submit_button').attr("disabled", true);
				$("#form_new_codeEditar").find('.submit_button').html('<i class="fa fa-circle-o-notch fa-spin  fa-fw "></i> <?php echo $data[214]['trad']; ?> ...');

				//submite the form
				$.ajax({
					type : 'POST',
					url : '/frifacturation/server/tableaux/code_postal_npa/editar.php',
					dataType : 'json',
					data : {
						idCodepostal : $('#ModalEdit_id_codepostal').val(),
						descricao_codepostal : $('#ModalEdit_descricao_codepostal').val(),
						code_codepostal : $('#ModalEdit_code_codepostal').val(),
					},
					success : function(resposta) {
						var resp = resposta;
						if (resposta == null)
							$.scojs_message("[FAT001] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						else {
							if (resposta.errors) {
								$.scojs_message("[FAT002] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							} else {
								$.scojs_message("<?php echo $data[532]['trad']; ?>", $.scojs_message.TYPE_OK);
							}
						}
					},
					complete : function(resposta) {
						var resp = resposta;
						console.log(resp);
						if (resp.responseJSON.errors) {
							$.scojs_message("[FAT003] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							$.scojs_message("<?php echo $data[532]['trad']; ?>", $.scojs_message.TYPE_OK);
							//reload
							pesquisar();

							//close modal				
							$('#modal-codepostal-edit').modal('hide');
						}
						$("#form_new_codeEditar").find('.submit_button').attr("disabled", false);
						$("#form_new_codeEditar").find('.submit_button').html('<i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?>');
					}
				});
			}
		});
		</script>
		<script type="text/javascript">
			table = $('#table_id').dataTable({
				"dom" : '<lfrtip><"clear">',
				"sRowSelect" : "os",
				"sRowSelector" : 'td:first-child',
				"lengthMenu" : [[25, 50, 100, -1], [25, 50, 100, "<?php echo $data[1565]['trad']; ?>"]],
				"iDisplayLength" : 100,
				"aaSorting" : [[0, "asc"]],
				"bProcessing" : true,
				"bServerSide" : true,
				"sAjaxSource" : "/frifacturation/server/datatable/code_postal_npa.php",
				"oLanguage" : {
					"sLengthMenu" : "<?php echo $data[1472]['trad']; ?>",
					"sZeroRecords" : "<?php echo $data[1446]['trad']; ?>",
					"sInfo" : "<?php echo $data[1702]['trad']; ?>",
					"sInfoEmpty" : " <?php echo $data[1704]['trad']; ?>",
					"sProcessing" : "<div></div>",
					"sInfoFiltered" : "",
					"oPaginate" : {
						"sNext" : "<?php echo $data[1503]['trad']; ?>",
						"sFirst" : "<?php echo $data[1312]['trad']; ?>",
						"sPrevious" : "<?php echo $data[1310]['trad']; ?>",
						"sLast" : "<?php echo $data[421]['trad']; ?>"
					}
				},
				"aoColumns" : [null, null,
				{
					"bVisible" : true,
					"bSortable" : false,
					"bSearchable" : true,
					"sClass" : "text-center",
				}
				],
				"aoColumnDefs" : [
				{
					"aTargets" : [2],
					"mRender" : function(data, type, full) {
						var processedName = full[1].replace(/'/gi, " "); processedName = processedName.replace(/"/gi, " ");
						var nome = "'" + processedName + "'";
						var html = '';
										
						html +='<a onClick="editarCode('+full[2]+')" class="options-link text-yellow"><i class="fa fa-edit" title="<?php echo $data[1093]['trad']; ?>"></i></a>';

						html +='<a onClick="removerCode('+full[2]+')" class="options-link text-red"><i class="fa fa-trash" title="<?php echo $data[1505]['trad']; ?>"></i></a>';

						//return all html composed
						return html;
					}
				}],

				"fnRowCallback" : function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
					$(nRow).attr("dbID", aData[2]);

					return nRow;
				}
			});

			$('#table_id').on('click', 'tbody td:not(.dataTables_empty)', function() {
				$('#table_id tbody tr').removeClass('selected');
				$(this).parent('tr').removeClass('DTTT_selected');
				$(this).parent('tr').addClass('selected');
			});

			$('#table_id_filter input').unbind();

			$('#table_id_filter').html('<label><div class="input-group input-group-sm mbs"><input type="search" class="form-control input-sm" placeholder="" aria-controls="table_id"><span class="input-group-btn"><button type="button" data-toggle="dropdown" class="btn btn-yellow dropdown-toggle" onclick="pesquisar()"><i class="fa fa-search"></i> <?php echo $data[1377]['trad']; ?></button></span></div></label>');

			$('#table_id_filter input').bind('keyup', function(e) {
				if (e.keyCode == 13) {
					table.fnFilter(this.value);
				}

			});
			function pesquisar() {
				table.fnFilter($('#table_id_filter input').val());
			}
			$('#table_id_filter input').bind('keyup', function(e) {
				if (($(this).val().length) == 0) {
					table.fnFilter('');
				}
			});
			function fnGetSelected(tabela) {
				var aReturn = new Array();
				var aTrs = tabela.fnGetNodes();
				for (var i = 0; i < aTrs.length; i++) {
					if ($(aTrs[i]).hasClass('row_selected')) {
						aReturn.push(aTrs[i]);
					}
				}
				return aReturn;
			}

			//END OF TABLE ---------------------------------------------
		</script>
	</body>
</html>