<?php
	include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
	include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/helpersAdmin.php';
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/helpers.php';
	include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';
	
	if ($_SESSION['tipo_utilizador'] == 1 ) {
	}else if (hasPermission(['P0001']) == 1 ) {
	}else{
		header('Location: ../../acces-refuse?redirectfrom=autorisations/fermeture_mois&redirectto=/parametres');
	}
	
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(2007,2056,419,2010,2057,1143,1456,2058,917,700,1068,120,1058,933,931,70,1468,1258,1249,408,562,1995,186,1013,1633,1403,214);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<html>
	<title><?php echo $data[2007]['trad']; ?>: <?php echo $data[2056]['trad']; ?> | <?php echo $data[419]['trad']; ?> </title>
	<head>
		<meta charset="utf-8" />
		<link rel="shortcut icon" type="image/png" href="/img/favicon.png"/>
		<link rel="stylesheet" href="/css/bootstrap.min.css">
		<link type="text/css" rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans:400italic,400,300,700">
		<link type="text/css" rel="stylesheet" href="https://fonts.googleapis.com/css?family=Oswald:400,700,300">
		<link rel="stylesheet" href="/css/font-awesome.min.css">

		<link rel="stylesheet" href="/js/vendors/bootstrap-select/bootstrap-select.min.css">

		<link href="/js/vendors/DataTables/media/css/jquery.dataTables.css" rel="stylesheet" type="text/css">
		<link href="/js/vendors/DataTables/media/css/dataTables.bootstrap.css" rel="stylesheet" type="text/css">
		<link type="text/css" rel="stylesheet" href="/js/vendors/sco.message/sco.message.css">

		<link type="text/css" rel="stylesheet" href="/css/style-responsive.css">
		<link type="text/css" rel="stylesheet" href="/css/orange-blue.css" >
		<link rel="stylesheet"  type="text/css" href="/css/gesautarquia.css">
		<!-- //ADDED CSS -->
		<style type="text/css">
			.label { font-size: 12px; }
			tfoot>tr>th { border: 0px !important; border-top: 2px solid #888 !important; }
		</style>
	</head>
	<body>
		<?php include '../../../modal_menu.php'; ?>
		<div class="container">
			<?php include '../../menu.php'; ?>

			<div class="page-content">
				<div class="panel panel-white">
					<div class="panel-heading">
                        <div class="pull-right" >
							<a class="text-red only-ic" href="../fermeture_mois"><i class="fa fa-times"></i></a>
						</div>
						<ol class="breadcrumb page-breadcrumb" style=" min-height: 35px; vertical-align: middle;">
							<li>
								<a href="../fermeture_mois"><?php echo $data[2010]['trad']; ?></a>
							</li>
							<li class="active">
								<?php echo $data[2056]['trad']; ?>
							</li>
						</ol>
                    </div>
					<div class="panel-body">
						<div class="row">
							<div class="col-xs-12">
								<form id="form_new" class="form-validate">
									<div class="form-body">
										<div id="form_div">
											<h5 class="form-header">
												<legend class="form-legend">
													<?php echo $data[2057]['trad']; ?>
												</legend>
											</h5>
											<div class="section-form">
												<div class="row">
													<div class="col-sm-6">
														<div class="form-group">
															<label class="control-label"><?php echo $data[1143]['trad']; ?><span class="require">*</span></label>
															<select class="form-control selectpicker show-tick" data-live-search="true"  data-header="<?php echo $data[1456]['trad']; ?>" id="mes_fermeture" name="mes_fermeture"  >
																<option value="" data-hidden="true"><?php echo $data[1456]['trad']; ?></option>
																<option value="1"><?php echo $data[917]['trad']; ?></option>
																<option value="2"><?php echo $data[700]['trad']; ?></option>
																<option value="3"><?php echo $data[1068]['trad']; ?></option>
																<option value="4"><?php echo $data[120]['trad']; ?></option>
																<option value="5"><?php echo $data[1058]['trad']; ?></option>
																<option value="6"><?php echo $data[933]['trad']; ?></option>
																<option value="7"><?php echo $data[931]['trad']; ?></option>
																<option value="8"><?php echo $data[70]['trad']; ?></option>
																<option value="9"><?php echo $data[1468]['trad']; ?></option>
																<option value="10"><?php echo $data[1258]['trad']; ?></option>
																<option value="11"><?php echo $data[1249]['trad']; ?></option>
																<option value="12"><?php echo $data[408]['trad']; ?></option>
															</select>
														</div>
													</div>
													<div class="col-sm-6">
														<div class="form-group">
															<label class="control-label"><?php echo $data[2058]['trad']; ?><span class="require">*</span></label>
															<input type="number" min="2000" max="<?php echo date('Y'); ?>" class="form-control" id="ano_fermeture" name="ano_fermeture" placeholder="..." value="<?php echo date('Y'); ?>" />
														</div>
													</div>
												</div>
											</div>
										</div>
									</div>
									<div class="form-footer">
										<div class="mtxl pull-right">
											<button class="btn btn-blue submit_button" type="submit" id="submitFormBtn">
												<i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?>
											</button>
											<a  href="../fermeture_mois" class="btn btn-default" type="button"> <?php echo $data[1995]['trad']; ?> </a>
										</div>
									</div>
								</form>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		
		<?php include '../../footer.php';	?>

		<!-- ADDED SCRIPTS -->
		<script src="/js/jquery-1.11.3.min.js"></script>
		<script src="/js/jquery-migrate-1.2.1.min.js"></script>
		<script src="/js/bootstrap.min.js"></script>
		<script src="/js/vendors/sco.message/sco.message.js"></script>

		<script src="/js/vendors/iCheck/icheck.min.js"></script>
		<script src="/js/vendors/iCheck/custom.min.js"></script>
		<script src="/js/vendors/jquery-validate/jquery.validate.min.js"></script>

		<?php 
		if (!function_exists('get_trad')) {
			include $_SERVER["DOCUMENT_ROOT"]. "/translate.php";
		}
		$ids_list = array(1997,1998,1999,2000,2001,2002);
		if (isset($data)) {
			$data = $data + get_trad($ids_list);
		} else {
			$data = get_trad($ids_list);
		}	
	?>
		<script type="text/javascript">
			text1 = "<?php echo $data[1997]['trad']; ?>" ;
			text2 = "<?php echo $data[1998]['trad']; ?>" ;
			text3 = "<?php echo $data[1999]['trad']; ?>" ;
			text4 = "<?php echo $data[2000]['trad']; ?>" ;
			text5 = "<?php echo $data[2001]['trad']; ?>" ;
			text6 = "<?php echo $data[2002]['trad']; ?>" ;
		</script>

		<script src="/js/vendors/bootstrap-select/bootstrap-select.min.js"></script>
		<script src="/js/vendors/bootstrap-select/defaults-pt_BR.min.js"></script>

		<script src="/js/vendors/DataTables/media/js/jquery.dataTables.js"></script>
		<script src="/js/vendors/DataTables/media/js/dataTables.bootstrap.js"></script>

		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.js"></script>
		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.pt.js"></script>
		<script src="/js/vendors/jquery-maskedinput/jquery-maskedinput.js"></script>
		<script src="/js/fnReload.js"></script>

		<script src="/js/autoNumeric.js"></script>
		<script src="/js/jquery.showmore.js"></script>

		<!-- //ADDED SCRIPTS -->

		<script>
			$(".navbar-nav li.autorisations").addClass("active");
			$(".navbar-nav li.autorisations li.autorisations_fermeture_mois").addClass("active");
		</script>
		<script type="text/javascript">

			$(document).ajaxStart(function() {
				$(".fullscreen").show();
			});
			$(document).ajaxComplete(function() {
				if ($.active == 1) {
	                $(".fullscreen").fadeOut();
	            }

			});
			$(document).ready(function() {

				$(".fullscreen").fadeOut();

			});

			$(document).ready(function() {
				//fill select boxes
				// fill_functions();

			});

			//-----------------------------------------------------------
			//						PROCESS FORM
			//-----------------------------------------------------------

			val_form_new = $("#form_new").validate({
				ignore : "",
				rules : {
					mes_fermeture : {
						required : true,
					},
					ano_fermeture : {
						required : true
					},
				},
				messages : {
					mes_fermeture : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
					ano_fermeture : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
				},
				highlight : function(element, errorClass, validClass) {
					$(element).addClass(errorClass).removeClass(validClass);
				},
				unhighlight : function(element, errorClass, validClass) {
					$(element).removeClass(errorClass).addClass(validClass);
				},
				errorPlacement : function(error, element) {
					if (element.hasClass('selectpicker')) {
						if (element.parent().hasClass("input-group"))
							error.insertAfter(element.parent());
						else
							error.insertAfter(element.next("div"));
					} else {
						error.insertAfter(element);
					}
				}
			});

			//FORM SUBMIT ---------------------------
			$("#form_new").submit(function(e) {
				e.preventDefault();

				var valid = $("#form_new").valid();
				if (valid == false) {
					$.scojs_message("<?php echo $data[1403]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				}else{
					$("#form_new").find('.submit_button').attr("disabled", true);
					$("#form_new").find('.submit_button').html('<i class="fa fa-circle-o-notch fa-spin  fa-fw "></i> <?php echo $data[214]['trad']; ?> ...');

					//submite the form
					$.ajax({
						type : 'POST',
						url : '/server/autorisations/fermeture_mois/inserir.php',
						dataType : 'json',
						data : {							
							mes_fermeture : $("#mes_fermeture").val(),
							ano_fermeture : $("#ano_fermeture").val(),
						},
						success : function(resposta) {
							var resp = resposta;
							if (resposta == null){
								$.scojs_message("[FAT001] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							}
							else {
								if (resposta.errors) {
									if (resposta.exists) $.scojs_message(resposta.message, $.scojs_message.TYPE_ERROR);
									else $.scojs_message("[FAT002] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
								} else {
									$.scojs_message("<?php echo $data[1013]['trad']; ?>", $.scojs_message.TYPE_OK);
								}
							}
						},
						complete : function(resposta) {
							var resp = resposta;

							if (resp.responseJSON.errors) {
								if (resp.responseJSON.exists) $.scojs_message(resp.responseJSON.message, $.scojs_message.TYPE_ERROR);
								else $.scojs_message("[FAT004] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							} else {
								$.scojs_message("<?php echo $data[1013]['trad']; ?>", $.scojs_message.TYPE_OK);

								//reload
								setTimeout(function() {
									window.location.href = "../fermeture_mois";
								}, 1000);
								
							}
							$("#form_new").find('.submit_button').attr("disabled", false);
							$("#form_new").find('.submit_button').html('<i class="fa fa-floppy-o"></i> Enregistrer');
						}
					});
				}
			});
		</script>
	</body>
</html>