<?php
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";

if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(2005,419,2006,2009,2011,2022,2016,1469,2020,2012,2018,2019);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<html>
	<title><?php echo $data[2005]['trad']; ?> | <?php echo $data[419]['trad']; ?> </title>
	<head>
		<meta charset="utf-8" />
		<link rel="shortcut icon" type="image/png" href="/img/favicon.png"/>
		<link rel="stylesheet" href="/css/bootstrap.min.css">
		<link type="text/css" rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans:400italic,400,300,700">
		<link type="text/css" rel="stylesheet" href="https://fonts.googleapis.com/css?family=Oswald:400,700,300">
		<link rel="stylesheet" href="/css/font-awesome.min.css">

		<link type="text/css" rel="stylesheet" href="/js/vendors/sco.message/sco.message.css">

		<link type="text/css" rel="stylesheet" href="/css/style-responsive.css">
		<link type="text/css" rel="stylesheet" href="/css/orange-blue.css" >
		<link rel="stylesheet"  type="text/css" href="/css/gesautarquia.css">

		<script src="/js/jquery-1.11.3.min.js"></script>
		<script src="/js/jquery-migrate-1.2.1.min.js"></script>
		<script src="/js/bootstrap.min.js"></script>

		<script src="/js/vendors/jquery-validate/jquery.validate.min.js"></script>

		<script src="/js/vendors/sco.message/sco.message.js"></script>
	</head>
	<body>
		<div class="container">

			<?php
			include 'menu.php';
			?>
			<script>
				$(".navbar-nav li.home").addClass("active");
			</script>

			<div class="page-content">
				<div class="panel panel-white">
					<div class="panel-heading">
						<?php echo $data[2005]['trad']; ?>
					</div>
					<div class="panel-body">
						<div class="col-md-3 pts">
							<a class="btn btn-lg col-md-12 " href="/parametres/donnes_acces">
							<div class="paxl modulo-item">
								<i class="fa fa-key" style="font-size: 31px;"></i>
								<br>
								<br>
								<?php echo $data[2006]['trad']; ?>
							</div> </a>
						</div>

					<?php if (hasPermission(['P0001']) == 1) { ?>
						<div class="col-md-3 pts">
							<a class="btn btn-lg col-md-12 " href="/parametres/autorisations/roles/">
							<div class="paxl modulo-item">
								<i class="fa fa-check-square" style="font-size: 31px;"></i>
								<br>
								<br>
								<?php echo $data[2009]['trad']; ?>
							</div> </a>
						</div>
					<?php } ?>

					<?php if (hasPermission(['P0002', 'P0003', 'P0004', 'P0005']) == 1) { ?>
						<div class="col-md-3 pts">
							<a class="btn btn-lg col-md-12 " href="/parametres/utilisateurs">
							<div class="paxl modulo-item">
								<i class="fa fa-users" style="font-size: 31px;"></i>
								<br>
								<br>
								<?php echo $data[2011]['trad']; ?>
							</div> </a>
						</div>
					<?php } ?>

					<?php if (hasPermission(['P0006']) == 1) { ?>
						<div class="col-md-3 pts">
							<a class="btn btn-lg col-md-12 " href="/parametres/facturation/donnes_societe">
							<div class="paxl modulo-item">
								<i class="fa fa-university" style="font-size: 31px;"></i>
								<br>
								<br>
								<?php echo $data[2022]['trad']; ?>
							</div> </a>
						</div>
					<?php } ?>

					<?php if (hasPermission(['P0006']) == 1) { ?>
						<!-- <div class="col-md-3 pts">
							<a class="btn btn-lg col-md-12 " href="/parametres/facturation">
							<div class="paxl modulo-item">
								<i class="fa fa-university" style="font-size: 31px;"></i>
								<br>
								<br>
								Donées Société
							</div> </a>
						</div> -->
					<?php } ?>

					<?php if (hasPermission(['P0007']) == 1) { ?>
						<?php if ($_SESSION['mod_Contabilidade'] == 1) { ?>
						<div class="col-md-3 pts">
							<a class="btn btn-lg col-md-12 " href="/parametres/facturation/personnaliser">
							<div class="paxl modulo-item">
								<i class="fa fa-book" style="font-size: 31px;"></i>
								<br>
								<br>
								<?php echo $data[2016]['trad']; ?>
							</div> </a>
						</div>
						<?php } ?>
					<?php } ?>

					<?php if (hasPermission(['P0008']) == 1) { ?>
						<div class="col-md-3 pts">
							<a class="btn btn-lg col-md-12 " href="/parametres/facturation/series">
							<div class="paxl modulo-item">
								<i class="fa fa-barcode" style="font-size: 31px;"></i>
								<br>
								<br>
								<?php echo $data[1469]['trad']; ?>
							</div> </a>
						</div>
					<?php } ?>

					<?php if (hasPermission(['P0009']) == 1) { ?>
						<div class="col-md-3 pts">
							<a class="btn btn-lg col-md-12 " href="/parametres/facturation/modele">
							<div class="paxl modulo-item">
								<i class="fa fa-envelope" style="font-size: 31px;"></i>
								<br>
								<br>
								<?php echo $data[2020]['trad']; ?>
							</div> </a>
						</div>
					<?php } ?>

					<?php if (hasPermission(['P0001']) == 1) { ?>
						<div class="col-md-3 pts">
							<a class="btn btn-lg col-md-12 " href="/parametres/modules">
							<div class="paxl modulo-item">
								<i class="fa fa-list" style="font-size: 31px;"></i>
								<br>
								<br>
								<?php echo $data[2017]['trad']; ?>
							</div> </a>
						</div>
					<?php } ?>

					<?php if (hasPermission(['P0010']) == 1) { ?>
						<div class="col-md-3 pts">
							<a class="btn btn-lg col-md-12 " href="/parametres/facturation/information">
							<div class="paxl modulo-item">
								<i class="fa fa-info" style="font-size: 31px;"></i>
								<br>
								<br>
								<?php echo $data[2018]['trad']; ?>
							</div> </a>
						</div>
					<?php } ?>
						
					<?php if (hasPermission(['P0011']) == 1) { ?>
						<div class="col-md-3 pts">
							<a class="btn btn-lg col-md-12 " href="/parametres/logs">
							<div class="paxl modulo-item">
								<i class="fa fa-history" style="font-size: 31px;"></i>
								<br>
								<br>
								<?php echo $data[2019]['trad']; ?>
							</div> </a>
						</div>
					<?php } ?>
					
					</div>
				</div>
			</div>
		</div>
	</body>
	<?php
	include 'footer.php';
	?>
	<script>
		$(document).ajaxStart(function() {
			$(".fullscreen").show();
		});
		$(document).ajaxComplete(function() {
			if ($.active == 1) {
                $(".fullscreen").fadeOut();
            }
		});

		$(document).ready(function() {

			$(".fullscreen").fadeOut();

		});
	</script>
</html>
