<?php
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
/*Control user*/
/*
 * Script:    DataTables server-side script for PHP and MySQL
 * Copyright: 2010 - Allan Jardine
 * License:   GPL v2 or BSD (3-point)
 * Edited by Pedro Gomes
 */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Easy set variables
 */

/* Database connection information */
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection_mysql.php";

/* Array of database columns which should be read and sent back to DataTables. Use a space where
 * you want to insert a non-database field (for example a counter or static image)
 */
 
$aColumns = array(
	'utilizador.Nome',
	'Email', 
	'Username', 
	'CASE AdministradorFaturacao WHEN 0 THEN "Collaborateur" ELSE "Administrateur" END', 
	'faturacao_roles.Name',
	'CASE WHEN CodigoInternoVendedor > 0 THEN CodigoInternoVendedor ELSE "-" END',
	'CASE Estado WHEN 0 THEN "Ativo" WHEN 1 THEN "Inativo" ELSE NULL END',
	'utilizador.ID_Utilizador', 
);

/* Column to filter*/
$fFilter = array(
	'utilizador.Nome',
	'Email', 
	'Username', 
	'CASE AdministradorFaturacao WHEN 0 THEN "Collaborateur" ELSE "Administrateur" END', 
	'faturacao_roles.Name',
	'CodigoInternoVendedor',
	'CASE Estado WHEN 0 THEN "Ativo" WHEN 1 THEN "Inativo" ELSE NULL END',
	'utilizador.ID_Utilizador', 
);

/* Indexed column (used for fast and accurate table cardinality) */
$sIndexColumn = "utilizador.ID_Utilizador";

/* DB table to use */
$sTable = "utilizador, faturacao_roles";

/*DB Table to count*/
$cTable = "utilizador";

/*Join Table*/
$sJoin = "utilizador.ID_Permissao=faturacao_roles.ID_Role AND utilizador.ID_TipoUtilizador=2";

include 'commun.php';
?>