<?php
//INCLUDE CONNECTION
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
//GET POST VARS

$id_utilizador = $_SESSION['id_utilizador'];

if ($id_utilizador == "") {
	$response["errors"] = true;
	$response["type"] = "FTGA001";
	die(json_encode($response));
}

$password_actual = $_POST['password_actual_utilizador'];
$email_utilizador = $_POST['email_utilizador'];
$nome_utilizador = $_POST['nome_utilizador'];
$username_utilizador = $_POST['username_utilizador'];
$siial_utilizador = $_POST['siial_utilizador'];

	

if ($id_utilizador == "") {
	$response["errors"] = true;
	$response["type"] = "FTGA001";
	die(json_encode($response));
}

if ($nome_utilizador == "" || $email_utilizador == "" || $username_utilizador == "" || $password_actual == "") {
	$response["errors"] = true;
	$response["type"] = "FTGA001";
	die(json_encode($response));
}

$query = "Select Password, Salt FROM utilizador WHERE ID_Utilizador=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $id_utilizador);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($password_bd, $salt);
	$stmt -> fetch();
	$stmt -> close();

} else {
	$response["errors"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

$hash = hash('sha256', $password_actual);

$password_actual = hash('sha256', $salt . $hash);

if ($password_actual != $password_bd) {

	$response["errors"] = true;
	$response["type"] = "validation";
	$response["line"] = "FTGA002";
	die(json_encode($response));
} else {

	
	$query = "UPDATE utilizador SET Nome=?, Email=?, Username=?, CodigoSIIAL=? WHERE ID_Utilizador=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("ssssd", $nome_utilizador, $email_utilizador, $username_utilizador, $siial_utilizador, $id_utilizador);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();

	} else {
		$response["errors"] = true;
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

}

$response["errors"] = false;
die(json_encode($response));
?>