<?php
ob_start();
session_start();
include "connection.php";
// inclui a conexão a database
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1956,1143,927,921);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
$gb_brasao_img = '/img/brasao.png';
$_SESSION['brasao_topo'] = $gb_brasao_img;

/* ===== Generate Token and save it in DB ===== */
function genTokenRandom($length = 30) {
	$key = '';
	$keys = array_merge(range(0, 9), range('a', 'z'));

	for ($i = 0; $i < $length; $i++) {
		$key .= $keys[array_rand($keys)];
	}

	return $key;
}
/* ============================================ */

if (!$_POST['username'] || !$_POST['password']) {
	$response["errors"] = true;
	$response["type"] = 1;
	$response["message"] = "GESA001x";
	die(json_encode($response));
} else {
	$username = $_POST['username'];
	$password = $_POST['password'];

	function checkDateisValid($data) {
		$hoje = date("Y-m-d");
		$data_validade = date('Y-m-d', strtotime(str_replace('/', '-', $data)));
		if ($hoje > $data_validade) {
			return false;
		} else {
			return true;
		}
	}

	$querySpecial = "SELECT Logotipo from faturacao_empresa_dados LIMIT 1";
	if ($stmt = $sqli_connection -> prepare($querySpecial)) {
		$stmt -> execute();
		$stmt -> bind_result($logotipoBrasaoDB);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = 2;
		$response["message"] = "GESA0000x";
		die(json_encode($response));
	}
	// var_dump($logotipoBrasaoDB);
	if($logotipoBrasaoDB != null && $logotipoBrasaoDB != ''){
		$gb_brasao_img = '/uploads/faturacao/'.$logotipoBrasaoDB;
		$_SESSION['brasao_topo'] = $gb_brasao_img;
	}

	$query = "SELECT utilizador.ID_Utilizador, utilizador.ID_TipoUtilizador, utilizador.ID_Permissao,  utilizador.Nome,  utilizador.Email, Password, Salt, faturacao_dados_aplicacao.Versao FROM utilizador, faturacao_dados_aplicacao WHERE ID_Dados_Aplicacao=1 AND Username=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("s", $username);
		$stmt -> execute();
		$stmt -> bind_result($id_utilizador, $tipo_utilizador, $id_permissao, $nome_utilizador, $email_utilizador, $password_bd, $salt, $versao);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = 2;
		$response["message"] = "GESA002x";
		die(json_encode($response));
	}


	$hash = hash('sha256', $password);
	$password_login = hash('sha256', $salt . $hash);

	if ($id_utilizador == "")// User not found. So, redirect to login_form again.
	{

		$response["errors"] = true;
		$response["type"] = 3;
		$response["message"] = "GESA003x";
		die(json_encode($response));

	} else {

		//comparing passwords
		if ($password_login != $password_bd)// Incorrect password. So, redirect to login_form again.
		{

			$data = date('d/m/Y');

			$hora = date('H:i:s');
			if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
				$ip = $_SERVER['HTTP_CLIENT_IP'];
			} elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
				$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
			} else {
				$ip = $_SERVER['REMOTE_ADDR'];
			}

			$accao = 'Login';
			$descricao = $data[1075]['trad'];

			$query = "INSERT INTO log (ID_Utilizador, Nome, Data, Hora, Accao, Descricao, IP) VALUES(?,?,?,?,?,?,?)";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("dssssss", $id_utilizador, $nome_utilizador, $data, $hora, $accao, $descricao, $ip);
				$stmt -> execute();
				$stmt -> close();
			} else {

				$response["errors"] = true;
				$response["type"] = 2;
				$response["message"] = "GESA005x";
				die(json_encode($response));
			}

			$response["errors"] = true;
			$response["type"] = 4;
			$response["message"] = "GESA004x";
			die(json_encode($response));

		} else {// Redirect to home page after successful login.
			
			/* ===== Generate Token and save it in DB ===== */
			$newToken = genTokenRandom(100);

			if($newToken){
				$query = "UPDATE utilizador SET Token=? WHERE ID_Utilizador=?";
				if ($stmt = $sqli_connection -> prepare($query)) {
					$stmt -> bind_param("sd", $newToken, $id_utilizador);
					$stmt -> execute();
					$stmt -> close();

					//set in session
					$_SESSION['_token'] = $newToken;
				} else {
					$response["errors"] = true;
					$response["type"] = 2;
					$response["message"] = "GESA005xA";
					die(json_encode($response));
				}
			}
			/* ============================================ */

			if ($nome_utilizador != "ADMIN_FTKODE") {
				$data = date('d/m/Y');

				$hora = date('H:i:s');
				if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
					$ip = $_SERVER['HTTP_CLIENT_IP'];
				} elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
					$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
				} else {
					$ip = $_SERVER['REMOTE_ADDR'];
				}

				$accao = 'Login';
				$descricao = 'Succès';

				$query = "INSERT INTO log (ID_Utilizador, Nome, Data, Hora, Accao, Descricao, IP) VALUES(?,?,?,?,?,?,?)";
				if ($stmt = $sqli_connection -> prepare($query)) {
					$stmt -> bind_param("dssssss", $id_utilizador, $nome_utilizador, $data, $hora, $accao, $descricao, $ip);
					$stmt -> execute();
					$stmt -> close();
				} else {

					$response["errors"] = true;
					$response["type"] = 2;
					$response["message"] = "GESA005x";
					die(json_encode($response));
				}
			}

			$nome_plataforma = 'gesfaturacao';

			$_SESSION['id_utilizador'] = $id_utilizador;
			$_SESSION['username'] = $username;
			$_SESSION['nome_utilizador'] = $nome_utilizador;
			$_SESSION['email_utilizador'] = $email_utilizador;
			
			$tempo_sessao = 1000;

			$_SESSION['tempo_sessao'] = $tempo_sessao * 60;
			$_SESSION['tipo_utilizador'] = $tipo_utilizador;
			$_SESSION['plataforma'] = $nome_plataforma;


			$tot_modulos = 0;

			$_SESSION['gesfaturacao'] = 1;
			$_SESSION['versao'] = $versao;

			$_SESSION['perm_nome_permissao'] = "Administrador";

			$query = "SELECT Ano FROM faturacao_ano_fiscal WHERE STR_TO_DATE(Data_Inicio, '%Y-%m-%d') <= CURDATE() AND STR_TO_DATE(Data_Fim, '%Y-%m-%d') >= CURDATE() LIMIT 1";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["message"] = $stmt -> error;
					die(json_encode($response));
				}
				$stmt -> bind_result($ano);
				$stmt -> fetch();
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["message"] = $sqli_connection -> error;
				die(json_encode($response));
			}

			// $_SESSION['ano'] = $ano;
			$_SESSION['ano'] = date('Y');

			$query = "SELECT Designacao, Logotipo FROM faturacao_empresa_dados LIMIT 1";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["message"] = $stmt -> error;
					die(json_encode($response));
				}
				$stmt -> bind_result($designacao, $logotipo);
				$stmt -> fetch();
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["message"] = $sqli_connection -> error;
				die(json_encode($response));
			}
			
			$_SESSION['designacao_gesfaturacao'] = $designacao;
			$_SESSION['logotipo_gesfaturacao'] = $logotipo != '' ? $logotipo : 'logo_default.png';


			// Check Modulo and DataValidade
			$licenca_expirada = false;
			
			$query = "SELECT ID_Modulo, DataValidade,
						Mod_Compras, Mod_Vendas, Mod_Contratos, Mod_Consommables, Mod_Licences, Mod_LojaOnline, Mod_Contabilidade, Mod_Rapports, Mod_Devis, Mod_Livraison, Mod_Sportifs
					FROM faturacao_modulos WHERE Ativo = 1 ORDER BY STR_TO_DATE(`DataActivacao`, '%d/%m/%Y') DESC";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> execute();
				$stmt -> bind_result($id_modulo, $data_validade_modulo, $modCompras, $modVendas, $modContratos, $modConsommables, $modLicences, $modLojaOnline, $modContabilidade, $modRapport, $modDevis, $modLivraison, $modSportifs );
				$stmt -> fetch();
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "DB";
				$response["message"] = "Cannot access faturacao_modulos";
				$response["debug"] = $sqli_connection;
				die(json_encode($response));
			}

			if(!$id_modulo || $id_modulo <= 0) {
				$response["errors"] = true;
				$response["type"] = 11;
				die(json_encode($response));
			}
			
			$aux = explode('/', $data_validade_modulo);
			$data_validade_modulo = $aux[2].'-'.$aux[1].'-'.$aux[0];
			$dt_validade_modulo = new DateTime($data_validade_modulo);
			$dt_today = new DateTime(date('Y-m-d'));
			if($dt_validade_modulo < $dt_today) {
				$licenca_expirada = true;
			} else {
				$interval = $dt_today->diff($dt_validade_modulo);
				$dias_restantes = $interval->format('%a');
				switch ($dias_restantes) {
					case 30:
						$_SESSION["validade_licenca"] = 'in 1 '.$data[1143]['trad'];
						break;
					case 7:
						$_SESSION["validade_licenca"] = 'in 7 '.$data[927]['trad'];
						break;
					case 6:
						$_SESSION["validade_licenca"] = 'in 6 '.$data[927]['trad'];
						break;
					case 5:
						$_SESSION["validade_licenca"] = 'in 5 '.$data[927]['trad'];
						break;
					case 4:
						$_SESSION["validade_licenca"] = 'in 4 '.$data[927]['trad'];
						break;
					case 3:
						$_SESSION["validade_licenca"] = 'in 3 '.$data[927]['trad'];
						break;
					case 2:
						$_SESSION["validade_licenca"] = 'in 2 '.$data[927]['trad'];
						break;
					case 1:
						$_SESSION["validade_licenca"] = 'in 1 '.$data[921]['trad'];
						break;
					case 0:
						$_SESSION["validade_licenca"] = '0';
						break;
					default:
						$_SESSION["validade_licenca"] = '';
						break;
				}
			}

			// IF IS PLANO Basic SET SESSION AS Basic, ELSE SET PLANO Pro/Demo IN SESSION
			$_SESSION['id_plano_atual'] = ($id_modulo == 1 ? 1 : 2);
			$_SESSION['mod_Compras'] = $modCompras;
			$_SESSION['mod_Vendas'] = $modVendas;
			$_SESSION['mod_Contratos'] = $modContratos;
			$_SESSION['mod_Consommables'] = $modConsommables;
			$_SESSION['mod_Licences'] = $modLicences;
			$_SESSION['mod_LojaOnline'] = $modLojaOnline;
			$_SESSION['mod_Contabilidade'] = $modContabilidade;
			$_SESSION['mod_Rapports'] = $modRapport;
			$_SESSION['mod_Devis'] = $modDevis;
			$_SESSION['mod_Livraison'] = $modLivraison;
			$_SESSION['mod_Sportifs'] = $modSportifs;

			session_write_close();


			if($licenca_expirada === true) {
				$response["errors"] = true;
				$response["type"] = 10;
				$response["licenca"] = $id_modulo == 2 ? 'Pro' : 'Basic';
				$response["validade"] = $data_validade_modulo;
				die(json_encode($response));
			}

			$response["errors"] = false;
			die(json_encode($response));

		}
	}
}
?>