<?php
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1565,1472,1446,1702,1704,1503,1312,1310,421,1377,1639,78,1698,645,1639,79,32,425,1691,1498);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<script type="text/javascript">
	var gSelectedState = 1;

	//filtrar por estado (1 - Ativo; 2 - Desativo; 3 - Todos)
	$(".btns_filters_states").on('click', function(event){
		gSelectedState = $(this).attr('data-value');

		//clean active and set the new one
		$(".btns_filters_states").removeClass('active');
		$(this).addClass('active');

		//reload table
		table.api().ajax.reload();
		// console.log(gSelectedState);
	});

	table = $('#table_id').dataTable({
		"dom" : '<lfrtip><"clear">',
		"sRowSelect" : "os",
		"sRowSelector" : 'td:first-child',
		"lengthMenu" : [[25, 50, 100, -1], [25, 50, 100, "<?php echo $data[1565]['trad']; ?>"]],
		"iDisplayLength" : 100,
		"aaSorting" : [[0, "asc"]],
		"bProcessing" : true,
		"bServerSide" : true,
		"sAjaxSource" : "/frifacturation/server/datatable/artigos.php",
		"fnServerParams" : function(aoData) {
            aoData.push({
                "name" : "estado",
                "value" : gSelectedState
            });
        },
		"oLanguage" : {
			"sLengthMenu" : "<?php echo $data[1472]['trad']; ?>",
			"sZeroRecords" : "<?php echo $data[1446]['trad']; ?>",
			"sInfo" : "<?php echo $data[1702]['trad']; ?>",
			"sInfoEmpty" : "<?php echo $data[1704]['trad']; ?>",
			"sProcessing" : "<div></div>",
			"sInfoFiltered" : "",
			"oPaginate" : {
				"sNext" : "<?php echo $data[1503]['trad']; ?>",
				"sFirst" : "<?php echo $data[1312]['trad']; ?>",
				"sPrevious" : "<?php echo $data[1310]['trad']; ?>",
				"sLast" : "<?php echo $data[421]['trad']; ?>"
			}
		},
		"aoColumns" : [{
			"sType": "numeric"
		}, 
		{
			"bVisible" : false,
		}, null, null, 
		{
			"sClass" : "text-right",
		},
		{
			"sClass" : "text-center",
		}, 
		{
			"sClass" : "text-center",
		}, 
		{
			"sClass" : "text-center",
		},
		{
			"sClass" : "text-center",
			 <?php if($_SESSION['mod_Contabilidade'] == 0) { ?>
			"bVisible" : false,
			"bSearchable" : false,
			 <?php } ?>
		},
		{
			"sClass" : "text-center",
			 <?php if($_SESSION['mod_Contabilidade'] == 0) { ?>
			"bVisible" : false,
			"bSearchable" : false,
			 <?php } ?>
		},		 
		{
			"bVisible" : true,
			"bSortable" : false,
			"bSearchable" : true,
			"sClass" : "text-center",
		},
		{
			"bVisible" : false,
			"bSortable" : false,
			"bSearchable" : true,
		},
		{
			"bVisible" : false,
			"bSortable" : false,
			"bSearchable" : true,
		}
		],
		"aoColumnDefs" : [
		{
			"aTargets" : [2],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[2].length > 60) element = full[2].substr(0,60)+"...";
				else element = full[2];
				//return html
				return element;
			}
		},
		{
			"aTargets" : [1],
			"mRender" : function(data, type, full) {
				var element = '';
				if(full[1]) element = full[1];
				else element = '-';
				//return html
				return element;
			}
		},
		{
			"aTargets" : [3],
			"mRender" : function(data, type, full) {
				if(full[3] == 'Produit') return 'P';
				else return 'S';
			}
		},
		{
			"aTargets" : [4],
			"mRender" : function(data, type, full) {
				var element = '';
				element ='<span class="money">'+full[4]+'</span>';

				//init elements
				$(".money").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : ' CHF',
					pSign : 's',
					mDec : <?php echo $numDecimais; ?>
				});

				//return html
				return element;
			}
		},
		{
			"aTargets" : [5],
			"mRender" : function(data, type, full) {
				var element = '';
				element ='<span class="percentage">'+full[5]+'</span>';

				$(".percentage").autoNumeric("init", {
					aSep : '\'',
					aDec : '.',
					aSign : '  %',
					vMax : '100',
					mDec : 2,
					vMin:'0',
					pSign : 's'
				});
				//return html
				return element;
			}
		},
		{
			"aTargets" : [6],
			"mRender" : function(data, type, full) {
				var element = '';
				element ='<span class="qtd">'+full[6]+'</span>';
				
				//init elements
				$(".qtd").autoNumeric("init", {
					aSep : '',
					aDec : '.',
					aSign : '',
					pSign : 's',
					mDec : 3
				});

				//return html
				return element;
			}
		},
		{
			"aTargets" : [7],
			"mRender" : function(data, type, full) {
				return full[7];
			}
		},
		{
			"aTargets" : [10],
			"mRender" : function(data, type, full) {
				var processedName = full[2].replace(/'/gi, " "); processedName = processedName.replace(/"/gi, " ");
				var nome = "'" + processedName + "'";
				var html = '';

				//state options
				if(full[11] == 1){
					html += '<a onClick="alterState('+full[10]+')" class="options-link text-dark-blue" title="<?php echo $data[425]['trad']; ?>"><i class="fa fa-ban"></i></a>';
				}else{
					html += '<a onClick="alterState('+full[10]+')" class="options-link text-green" title="<?php echo $data[32]['trad']; ?>"><i class="fa fa-check-square-o"></i></a>';
				}
				
				//show details
				html += '<a href="details?article=' + full[10] + '" class="options-link text-info"><i class="fa fa-eye" title="<?php echo $data[1691]['trad']; ?>"></i></a>';
				//change stock details
				html += '<a onclick="atualizarStock('+ full[10] +')" class="options-link text-yellow"><i class="fa fa-sort-numeric-asc" title="<?php echo $data[1498]['trad']; ?>"></i></a>';
				html += '<a href="modifier?article=' + full[10] + '" class="options-link text-orange"><i class="fa fa-edit" title="<?php echo $data[1093]['trad']; ?>"></i></a>';

				//edition options
				if( full[12] > 0 ){
					html += '<span class="text-gray" style="margin: 4px;"><i class="fa fa-trash"></i></span>';
				}else{
					html += '<a class="options-link text-red" onclick="eliminarArtigo('+ full[10] +', '+nome+')" title="<?php echo $data[1505]['trad']; ?>"><i class="fa fa-trash"></i></a>';
				}

				//return all html composed
				return html;
			}
		}],

		"fnRowCallback" : function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
			$(nRow).attr("dbID", aData[10]);

			return nRow;
		}
	});

	$('#table_id').on('click', 'tbody td:not(.dataTables_empty)', function() {
		$('#table_id tbody tr').removeClass('selected');
		$(this).parent('tr').removeClass('DTTT_selected');
		$(this).parent('tr').addClass('selected');
	});

	$('#table_id_filter input').unbind();

	$('#table_id_filter').html('<label><div class="input-group input-group-sm mbs"><input type="search" class="form-control input-sm" placeholder="" aria-controls="table_id"><span class="input-group-btn"><button type="button" data-toggle="dropdown" class="btn btn-yellow dropdown-toggle" onclick="pesquisar()"><i class="fa fa-search"></i> <?php echo $data[1377]['trad']; ?></button></span></div></label>');

	$('#table_id_filter input').bind('keyup', function(e) {
		if (e.keyCode == 13) {
			table.fnFilter(this.value);
		}

	});
	function pesquisar() {
		table.fnFilter($('#table_id_filter input').val());
	}
	$('#table_id_filter input').bind('keyup', function(e) {
		if (($(this).val().length) == 0) {
			table.fnFilter('');
		}
	});
	function fnGetSelected(tabela) {
		var aReturn = new Array();
		var aTrs = tabela.fnGetNodes();
		for (var i = 0; i < aTrs.length; i++) {
			if ($(aTrs[i]).hasClass('row_selected')) {
				aReturn.push(aTrs[i]);
			}
		}
		return aReturn;
	}

	//END OF TABLE ---------------------------------------------
	
	//ALTER STATE ARTIGO
	function alterState(idArtigo){
	<?php if (hasPermission(['P0061']) == 1) { ?>
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/artigos/artigos_estado.php',
			dataType : 'json',
			data : {
				idArtigo : idArtigo
			},
			success : function(resposta) {
				var resp = resposta;
				if (resposta == null)
					$.scojs_message("[FAT001] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				else {
					if (resposta.errors) {
						$.scojs_message("[FAT002] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						$.scojs_message("<?php echo $data[78]['trad']; ?>", $.scojs_message.TYPE_OK);
					}
				}
			},
			complete : function(resposta) {
				location.reload();
			}
		});
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}
	
	function eliminarArtigo(idArtigo, nome){
	<?php if (hasPermission(['P0062']) == 1) { ?>
		if (confirm("<?php echo $data[645]['trad']; ?> \n'" + nome + "' ?") == true) {
			var resp = null;
			//send data
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/artigos/artigos_apagar.php',
				dataType : 'json',
				data : {
					idArtigo : idArtigo
				},
				success : function(resposta) {
					resp = resposta.errors;
					if (resposta == null) {
						$.scojs_message("[FTGP000] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.errors) {
							$.scojs_message("[" + resposta.type + "] <?php echo $data[1639]['trad']; ?>.", $.scojs_message.TYPE_ERROR);
						}else {
							$.scojs_message("<?php echo $data[79]['trad']; ?>", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function() {
					if (resp == false) {
						table.fnReloadAjax();
					}
				}
			});
		} else { return false; }
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}	
</script>