<?php 
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1639,1698,1633,1493,1445,767,77,1662);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<script type="text/javascript">
	/**
	 * Fill clientes
	 * @param  {Number} lastID [description]
	 * @return {[type]}        [description]
	 */
	function fill_clientes(lastID = 0, blockResume = false, dadosObj = null, Resp1 = 0, Resp2 = 0) {
		var options = $("select#cliente_location");
		// $(options).empty();

		$(".fullscreen").show();

		//prepare select
		$(options).attr("disabled", false);

		if(lastID != 0) $(options).append($("<option />").val(lastID).html(dadosObj).attr('selected', 'selected'));
		
		//init select2
		$('#cliente_location').select2({
			escapeMarkup: function(m) { return m; },
			language: "fr",
			placeholder: "-- <?php echo $data[1493]['trad']; ?> --",
			allowClear: true,
			// minimumInputLength: 2,
			templateResult: clientesTemplate,
			templateSelection: clientesTemplateLabel,
			ajax: {
				global: false,
				type : "POST",
				url : '/frifacturation/server/combobox/vendas_select2_ajax2.php',
				dataType : "json",
				delay : 250,
				data: function (params) {
					return {
						opcao: 2, //search term
						search_term: params.term, //search term
						search_idcliente: lastID, //search term
						page: params.page || 1 // page number
					};
				},
				processResults: function (data, params) {
					params.page = params.page || 1;
					return {
						results:$.map(data.results,function(val,i){
							var textLabel = val.Codigo+' - '+val.Nome;
							if(val.Suspendu){
								var textLabel = val.Codigo+' - '+val.Nome+' - '+val.Suspendu;
								//$('#select2-cliente_devis-container').css('color','red');
							}
							return{id:val.ID_Cliente,text:textLabel,data:val};
						}), //data.results,
						pagination: {
							more: (params.page * 10) < data.count_filtered
						}
					};
				}
			}
		});

		if(lastID != 0) $(options).val(lastID);
		if(lastID != 0) getClientDetails(lastID, 0, Resp1, Resp2, blockResume);

        $(".fullscreen").fadeOut();
	}

	/**
	 * Fill clientes
	 * @param  {Number} lastID [description]
	 * @return {[type]}        [description]
	 */
	function getClientDetails(idCliente, dismissFields = 0, Resp1 = 0, Resp2 = 0, blockResume = false) {
		$("#nif_cliente_location").val('');
		$("#endereco_cliente_location").val('');
		$("#codigopostal_cliente_location").val('');
		$("#regiao_cliente_location").val('');
		$("#cidade_cliente_location").val('');
		$("#pais_cliente_location").val('');
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/contrats_cotisations.php',
			dataType : 'json',
			data : { 
				opcao: 2,
				idCliente: idCliente
			},
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[FAT9999] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				} else {
					if (resposta.errors == true) {
						if (resposta.type == 'FTGA003'){
							$.scojs_message("[WRN0001] <?php echo $data[1445]['trad']; ?>", 3);
						}else {
							$.scojs_message("[FAT9999] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						}
					} else {
						if (resposta.data == null) {
						} else {
							var dados = resposta.data;
							$("#nif_cliente_location").val(dados.Nif);
							$("#endereco_cliente_location").val(dados.Endereco);
							$("#codigopostal_cliente_location").val(dados.CodigoPostal);
							$("#regiao_cliente_location").val(dados.Regiao);
							$("#cidade_cliente_location").val(dados.Cidade);
							$("#pais_cliente_location").val(dados.Pais);
							if(dados.Suspendu){
								$('#select2-cliente_location-container').css('color','red');
							} else {
								$('#select2-cliente_location-container').css('color','#555');
							}
							if(dismissFields == 0){
								$("#pagamento_location").val(dados.Vencimento);
								$("#pagamento_location").trigger('change');
							}

							//fill responsables
							fill_responsaveis_cliente(dados.Responsaveis, Resp1, Resp2);
						}
					}
				}
			},
			complete : function() {	}
		});
	}

	/**
	 * Change article
	 * @param  lineID
	 */
	function changeArticle(lineID){
		//get article data
		var articleID = $("select#codigo_linha_"+lineID).val();
		if( articleID < 1){
			$("#descricao_linha_"+lineID).val('');
			// $("#qtd_linha_"+lineID).autoNumeric('set', 0);
			//disable Fields
			$("#descricao_linha_"+lineID).prop('disabled', true);
			// $("#qtd_linha_"+lineID).prop('disabled', true);
			
		}else{
			//disable Fields
			$("#descricao_linha_"+lineID).prop('disabled', false);
			// $("#qtd_linha_"+lineID).prop('disabled', false);

			//get data
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/combobox/contrats_cotisations.php',
				dataType : 'json',
				data : { 
					opcao: 9,
					articleID : articleID
				},
				success : function(resposta) {
					if (resposta == null) {
						$.scojs_message("[FAT9999] <?php echo $data[767]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.errors == true) {
							$.scojs_message("[FAT9999] <?php echo $data[767]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							if (resposta.data == null){} 
							else {
								var dados = resposta.data;
								// console.log(dados);
								//processing fields
								$("#descricao_linha_"+lineID).val(dados.Nome);
								// $("#qtd_linha_"+lineID).autoNumeric('set', 1);

								//calculations
								calculaLinha(lineID);
							}
						}
					}
				},
				complete : function() {}
			});
		}		
	}

	/**
	 * Calculates values for the article line
	 * @param  lineID
	 * @return values calculated
	 */
	function calculaLinha(lineID){
		//process the retenções field
		var tipo = $('option:selected', $("select#codigo_linha_"+lineID) ).attr('data-tipo');
		// console.log('tipo: '+tipo);

		// var qtd = Number( $("#qtd_linha_"+lineID).autoNumeric('get') );
	}


	/**
	 * Function to add new line
	 * @return 
	 */
	function addArticleLine(articleID = 0, impostoID = 0, motivoID = 0, changeLineVals = 0, planoID = 0, blockResume = false, dadosObj = null){
		lastIdLine++;

		var htmlLine = '<tr class="articles_lines" id="line_'+lastIdLine+'">'+
							'<td style="width:200px;">'+
								'<select data-id-line="'+lastIdLine+'" class="lineInputArtigo form-control select2 show-tick" data-live-search="true"  data-header="<?php echo $data[1456]['trad']; ?>" id="codigo_linha_'+lastIdLine+'" name="codigo_linha_'+lastIdLine+'" >'+
									'<option value="" data-hidden="true"><?php echo $data[77]['trad']; ?></option>'+
								'</select>'+
							'</td>'+
							'<td>'+
								'<textarea data-id-line="'+lastIdLine+'" class="lineInputDescricao form-control" id="descricao_linha_'+lastIdLine+'" name="descricao_linha_'+lastIdLine+'" placeholder="..." rows="1"></textarea>'+
							'</td>'+
							'<td style="width:30px; text-align: center;">'+
								'<a class="options-link text-red" onclick="eliminarLinha('+lastIdLine+')" title="Remover Linha"><i class="fa fa-trash"></i></a>'+
							'</td>'+
						'</tr>';
		$('#tbody_artigos').append(htmlLine);

		//init line
		fill_articles(lastIdLine, articleID, changeLineVals, dadosObj);

		//disable the fields of the lines
		$("#descricao_linha_"+lastIdLine).prop('disabled', true);
		// $("#qtd_linha_"+lastIdLine).prop('disabled', true);

		linesListenersInit(lastIdLine);

		//to force line to init when add new article using modal
		if(changeLineVals != 0){
			changeArticle(lastIdLine);
		}

		valorLinhas++;
	}

	/**
	 * Fill the articles select
	 * @param  select id
	 * @return articles
	 */
	function fill_articles(lineID, articleID = 0, changeLineVals = 0, dadosObj = null){
		$(".fullscreen").show();
		var options = $("select#codigo_linha_"+lineID);
		// $(options).empty();
		var id_predefinido = 0;
				
		// console.log('entrou no else');

		if(dadosObj != null) {
			$(options).append($("<option />").val(articleID).text(dadosObj.codigo).attr('data-barcode', dadosObj.codigobarras).attr('data-tipo', dadosObj.Tipo).attr('selected', 'selected'));
		}

		$(options).select2({
			escapeMarkup: function(m) { return m; },
			language: "fr",
			placeholder: "-- <?php echo $data[77]['trad']; ?> --",
			allowClear: true,
			// minimumInputLength: 2,
			templateResult: articlesTemplate,
			templateSelection: articlesTemplateLabel,
			// closeOnSelect: false,
			// selectOnClose: false,
			ajax: {
				global: false,
				type : "POST",
				url : '/frifacturation/server/combobox/vendas_select2_ajax.php',
				dataType : "json",
				delay : 250,
				data: function (params) {
					return {
						opcao: 1, //search term
						search_term: params.term, //search term
						page: params.page || 1 // page number
					};
				},
				processResults: function (data, params) {
					//init vars
					var resultsReturn = data.results;
					var foundSearchResults = false;
					var selected = 0;

					//return results
					params.page = params.page || 1;
					// console.log('returned ', resultsReturn);
					return {
						results:$.map(resultsReturn,function(val,i){
							var textLabel = val.Codigo;
							return{id:i,text:textLabel,data:val};
						}), //data.results,
						pagination: {
							more: (params.page * 10) < data.count_filtered
						}
					};
				}
			}
		}).on('select2:select', function (e) {
			// console.log('change event: ',e.params.data, $(this));
			var data = e.params.data;        
			// console.log( $(this).children('[value="'+data['id']+'"]') );
			$(this).children('[value="'+data['id']+'"]').attr('data-tipo', data["data"]["Tipo"]);
		}).trigger('change');

		// if(changeLineVals != 0){
		// 	changeArticle(lineID);
		// }
		
		//auto init select
		// $('button[data-select2-id="codigo_linha_'+lineID+'"]').trigger('click');
		$('.lineInputArtigo').select2('close');
		// if(changeLineVals == 0) $('#codigo_linha_'+lineID).select2('open');

        $(".fullscreen").fadeOut();
	}

	/**
	 * Delete Line
	 * @param  lineID
	 */
	function eliminarLinha(lineID){
		if(valorLinhas < 2){
			alert("<?php echo $data[767]['trad']; ?>");
		}else{
			valorLinhas--;
			$('#line_'+lineID).remove();
		}
	}

	/**
	 * Init the lines listners
	 * @return none
	 */
	function linesListenersInit(lineID_new = 0){
		$(".fullscreen").show();

		//init elements
		$(".money").autoNumeric("init", {
			aSep : '\'',
			aDec : '.',
			aSign : ' CHF',
			pSign : 's',
			vMin:'0',
			mDec : <?php echo $numDecimais; ?>
		});
		$(".moneyMedium").autoNumeric("init", {
			aSep : '\'',
			aDec : '.',
			aSign : ' CHF',
			pSign : 's',
			mDec : <?php echo $numDecimaisPrice; ?>,
			vMin:'0'
		});
		$(".moneyBig").autoNumeric("init", {
			aSep : '\'',
			aDec : '.',
			aSign : ' CHF',
			pSign : 's',
			mDec : <?php echo $numDecimaisPrice; ?>,
			vMin:'0'
		});
		//init elements
		$(".qtd").autoNumeric("init", {
			aSep : '',
			aDec : '.',
			aSign : '',
			pSign : 's',
			mDec : 3,
			vMin:'0'
		});
		//init elements
		$(".percentage").autoNumeric("init", {
			aSep : '\'',
			aDec : '.',
			aSign : '%',
			vMax : '100',
			pSign : 's',
			mDec : 2,
			vMin:'0'
		});

		//change article
		$("select.lineInputArtigo").on('change', function(event){
			var lineID = $(this).attr('data-id-line');
			changeArticle(lineID);
		});
	    
	    $(".fullscreen").fadeOut();
	}

	/**
	 * Fill vendedores
	 * @return list
	 */
	function fill_vendedores_location(lastID = 0, blockResume = false, dadosObj = null) {
		var options = $("select#vendeur_1_location");

		$(".fullscreen").show();

		//prepare select
		$(options).attr("disabled", false);

		if(lastID != 0) $(options).append($("<option />").val(lastID).html(dadosObj).attr('selected', 'selected'));
		
		//init select2
		$('#vendeur_1_location').select2({
			escapeMarkup: function(m) { return m; },
			language: "fr",
			placeholder: "-- <?php echo $data[1662]['trad']; ?> --",
			allowClear: true,
			// minimumInputLength: 2,
			// templateResult: clientesTemplate,
			// templateSelection: clientesTemplateLabel,
			ajax: {
				global: false,
				type : "POST",
				url : '/frifacturation/server/combobox/vendas_select2_ajax.php',
				dataType : "json",
				delay : 250,
				data: function (params) {
					return {
						opcao: 4, //search term
						search_term: params.term, //search term
						search_idvendedor: lastID, //search term
						page: params.page || 1 // page number
					};
				},
				processResults: function (data, params) {
					params.page = params.page || 1;
					return {
						results:$.map(data.results,function(val,i){
							var textLabel = val.Nome;
							return{id:val.ID_Vendedor,text:textLabel,data:val};
						}), //data.results,
						pagination: {
							more: (params.page * 10) < data.count_filtered
						}
					};
				}
			}
		});

		if(lastID != 0) $(options).val(lastID);
		$(options).trigger('change');

        $(".fullscreen").fadeOut();
	}

	/**
	 * Fill responsables
	 * @return list
	 */
	function fill_responsaveis_cliente(responsaveis, lastID = 0, lastID2 = 0) {
		var options = $("select#resp_client_1_location");
		$(options).empty();

		var options2 = $("select#resp_client_2_location");
		$(options2).empty();

		//process data
		$(options).attr("disabled", false);
		// $(options).append($('<option data-hidden="true"/>').val("").text("<?php echo $data[1456]['trad']; ?>"));

		$(options2).attr("disabled", false);
		// $(options2).append($('<option data-hidden="true"/>').val("").text("<?php echo $data[1456]['trad']; ?>"));

		// $(options).append($("<option />").val(0).text('<?php echo $data[1456]['trad']; ?>'));
		// $(options2).append($("<option />").val(0).text('<?php echo $data[1456]['trad']; ?>'));

		$.each(responsaveis, function() {
			$(options).append($("<option />").val(this.ID_Responsavel).html(this.Prenom+' '+this.Nome));

			$(options2).append($("<option />").val(this.ID_Responsavel).html(this.Prenom+' '+this.Nome));
		});

		//fill selects
		if(lastID != 0) $(options).val(lastID);
		else $(options).val(null);
		$(options).trigger('change');

		if(lastID2 != 0) $(options2).val(lastID2);
		else $(options2).val(null);
		$(options2).trigger('change');

		return true;
	}

	/**
	 * Fill responsaveis
	 * @return list
	 */
	function fill_responsaveis_location(lastID = 0, blockResume = false, dadosObj = null) {
		var options = $("select#vendeur_2_location");

		$(".fullscreen").show();

		//prepare select
		$(options).attr("disabled", false);

		if(lastID != 0) $(options).append($("<option />").val(lastID).html(dadosObj).attr('selected', 'selected'));
		
		//init select2
		$('#vendeur_2_location').select2({
			escapeMarkup: function(m) { return m; },
			language: "fr",
			placeholder: "-- <?php echo $data[1415]['trad']; ?> --",
			allowClear: true,
			// minimumInputLength: 2,
			// templateResult: clientesTemplate,
			// templateSelection: clientesTemplateLabel,
			ajax: {
				global: false,
				type : "POST",
				url : '/frifacturation/server/combobox/vendas_select2_ajax.php',
				dataType : "json",
				delay : 250,
				data: function (params) {
					return {
						opcao: 5, //search term
						search_term: params.term, //search term
						search_idresponsavel: lastID, //search term
						page: params.page || 1 // page number
					};
				},
				processResults: function (data, params) {
					params.page = params.page || 1;
					return {
						results:$.map(data.results,function(val,i){
							var textLabel = val.Nome;
							return{id:val.ID_RespContrato,text:textLabel,data:val};
						}), //data.results,
						pagination: {
							more: (params.page * 10) < data.count_filtered
						}
					};
				}
			}
		});

		if(lastID != 0) $(options).val(lastID);
		$(options).trigger('change');

        $(".fullscreen").fadeOut();
	}
</script>