<?php
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1639,1698,1633,2169,85,544,2170,1219,549,545,569,1618,1456,1709,763,1692,1995,1673,1971,1970,1972,708,67,186,1676,1403,1669,1431,1436,1435,1462,1966,1967,1968,1969,1013,983,957,907,40,42,573,41,822,1290,971,948,622,92,616,1679,1403,1669,1431,1435,1436,1462,214,1973,1974,1975,1966,1967,1968,1969,983,957,839,683,562);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
$valid_iban = true;
$valid_qr = true;
$docID = $_GET['facture'];

$check_field_type = "SHOW COLUMNS FROM `faturacao_bancos` LIKE 'QRIBAN'";
$check_field_iban = "SHOW COLUMNS FROM `faturacao_bancos` LIKE 'IBAN'";
$check_field_country = "SHOW COLUMNS FROM `faturacao_empresa_dados` LIKE 'Pays'";

	$result = $sqli_connection->query($check_field_type);
	if($result->num_rows > 0){
		$query = "SELECT QRIBAN from faturacao_bancos where Predefinido = 1 LIMIT 1";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();

			if (false === $result) {
				$errors = true;
				$valid_qr = false;
				if (isset($_GET["send_mail"]) && $_GET["send_mail"]) {
					array_push($response["text"], "[DB0005] Une erreur est survenue. Contactez l'administrateur.");
				} else {
					?> <h3 style="color:red;text-align:center"> [DB0005] Une erreur est survenue. Contactez l'administrateur. </h3><?php
				}
			} else {
				$stmt -> store_result();
				$stmt -> bind_result($QR_IBAN);
				$stmt -> fetch();
				$stmt -> close();
				if(!$QR_IBAN){
					$valid_qr = false;
				}
			}
		} else {
			$errors = true;
			$valid_qr = false;
			if (isset($_GET["send_mail"]) && $_GET["send_mail"]) {
				array_push($response["text"], "[DB0006] Une erreur est survenue. Contactez l'administrateur.");
			} else {
				?> <h3 style="color:red;text-align:center"> [DB0006] Une erreur est survenue. Contactez l'administrateur. </h3><?php
			}
		}
	}
	
	$result = $sqli_connection->query($check_field_iban);
	if($result->num_rows > 0){
		$query = "SELECT IBAN from faturacao_bancos where Predefinido = 1 LIMIT 1";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();

			if (false === $result) {
				$errors = true;
				$valid_iban = false;
				if (isset($_GET["send_mail"]) && $_GET["send_mail"]) {
					array_push($response["text"], "[DB0007] Une erreur est survenue. Contactez l'administrateur.");
				} else {
					?> <h3 style="color:red;text-align:center"> [DB0007] Une erreur est survenue. Contactez l'administrateur. </h3><?php
				}
			} else {
				$stmt ->store_result();
				$stmt -> bind_result($IBAN);
				$stmt -> fetch();
				$stmt -> close();
				if(!$IBAN){
					$valid_iban = false;
				} else {
					$response["iban?"] = $IBAN;
				}
			}
		} else {
			$errors = true;
			$valid_iban = false;
			if (isset($_GET["send_mail"]) && $_GET["send_mail"]) {
				array_push($response["text"], "[DB0008] Une erreur est survenue. Contactez l'administrateur.");
			} else {
				?> <h3 style="color:red;text-align:center"> [DB0008] Une erreur est survenue. Contactez l'administrateur. </h3><?php
			}
		}
	}
	
$GLOBALS['IBAN'] =  $IBAN;
$GLOBALS['QR_IBAN'] = $QR_IBAN;

$result = $sqli_connection->query($check_field_country);
if($result->num_rows > 0){
	$query = "SELECT Pays from faturacao_empresa_dados LIMIT 1";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$result = $stmt -> execute();

		if (false === $result) {
			$errors = true;
			if (isset($_GET["send_mail"]) && $_GET["send_mail"]) {
				array_push($response["text"], "[DB0009] Une erreur est survenue. Contactez l'administrateur.");
			} else {
				?> <h3 style="color:red;text-align:center"> [DB0009] Une erreur est survenue. Contactez l'administrateur. </h3><?php
			}
		} else {
			$stmt -> store_result();
			$stmt -> bind_result($country);
			$stmt -> fetch();
			$stmt -> close();
		}
	} else {
		$errors = true;
		if (isset($_GET["send_mail"]) && $_GET["send_mail"]) {
			array_push($response["text"], "[DB0010] Une erreur est survenue. Contactez l'administrateur.");
		} else {
			?> <h3 style="color:red;text-align:center"> [DB0010] Une erreur est survenue. Contactez l'administrateur. </h3><?php
		}
	}
}
$GLOBALS['country'] = $country;

$client_country = "SELECT PaisCliente, CASE WHEN datediff('".date('Y-m-d')."',STR_TO_DATE( Validade,  '%d/%m/%Y' )) <= 0 THEN ''
	WHEN datediff('".date('Y-m-d')."',STR_TO_DATE( Validade,  '%d/%m/%Y' )) < 30 THEN '1º Rappel'
	ELSE '2º Rappel' END FROM faturacao_faturas WHERE ID_Fatura=?";
if ($stmt = $sqli_connection -> prepare($client_country)) {
	$stmt -> bind_param("d", $docID);
	$result = $stmt -> execute();

	if (false === $result) {
		if (isset($_GET["send_mail"]) && $_GET["send_mail"]) {
			array_push($response["text"], "[DB0004] Une erreur est survenue. Contactez l'administrateur.");
		} else {
			?> <h3 style="color:red;text-align:center"> [DB0004] Une erreur est survenue. Contactez l'administrateur. </h3><?php
		}
		$errors = true;
	}
	$stmt -> store_result();
	$stmt -> bind_result($country_client, $rappel);
	$stmt -> fetch();
	$stmt -> close();
} else {
	if (isset($_GET["send_mail"]) && $_GET["send_mail"]) {
		array_push($response["text"], "[DB0002] Une erreur est survenue. Contactez l'administrateur.");
	} else {
		?> <h3 style="color:red;text-align:center"> [DB0002] Une erreur est survenue. Contactez l'administrateur. </h3><?php
	}
	$errors = true;

}
$qr_country = ['CH', 'LI'];
?>
<style>
.forceHidden {
	display: none !important;
}
</style>
<div id="modal-confirmar-envio-QR" tabindex="-1" role="dialog" aria-labelledby="modal-header-primary-label" data-backdrop="static" data-keyboard="false" aria-hidden="true" class="modal fade">
	<div class="modal-dialog modal-wide-width">
		<div class="modal-content">
			<div class="modal-header modal-header-orange">
				<button type="button" data-dismiss="modal" aria-hidden="true" class="close">
					&times;
				</button>
				<h4 id="modal-header-primary-label-qr" class="modal-title"></h4>
			</div>
			<div class="modal-body" style="overflow-y: visible;">
				<form id="form_confirmar_envio_QR">
					<div id="form_div">
						<div class="row">
							<input type="hidden" id="document_iden_QR" name="document_iden_QR" />
							<input type="hidden" id="action_selected" name="action_selected" />
							<input type="hidden" id="country_qr" name="country_qr" />
							<div class="col-sm-12">
								<div class="form-group">
									<label class="control-label"><?php echo $data[85]['trad']; ?></label>
									<span id="confirmar_envio_detalhes_QR" style="display: block"></span> 
								</div>
							</div>
						</div>
						<div class="row email_row_old" style="display:none;">
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label"><?php echo $data[544]['trad']; ?></label>
									<span id="confirmar_envio_email_QR" style="display: block"></span>
								</div>
							</div>
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label"><?php echo $data[1219]['trad']; ?></label>
									<input type="email" class="form-control" id="confirmar_envio_emailnovo_QR" name="confirmar_envio_emailnovo_QR" placeholder="..." />
								</div>
							</div>
						</div>
						<div class="row email_row" style="display:none;">
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label"><?php echo $data[2169]['trad']; ?></label><br>
									<select class="form-control select2 show-tick" name="liste_contacts" id="liste_contacts">
									</select>
								</div>
							</div>
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label"><?php echo $data[2170]['trad']; ?></label>
									<input type="email" class="form-control" id="email_contact" name="email_contact" placeholder="..." />
								</div>
							</div>
						</div>
						<div class="row" id="resp_div_1" style="display:none;">
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label"><?php echo str_replace("X","1",$data[545]['trad']); ?></label>
									<span id="confirmar_envio_email_resp_1" style="display: block"></span>
								</div>
							</div>
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label"><?php echo str_replace("X","1",$data[549]['trad']); ?> (<?php echo $data[569]['trad']; ?>)</label>
									<input type="email" class="form-control" id="confirmar_envio_emailnovo_resp_1" name="confirmar_envio_emailnovo_resp_1" placeholder="..." />
								</div>
							</div>
						</div>
						<div class="row" id="resp_div_2" style="display:none;">
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label"><?php echo str_replace("X","2",$data[545]['trad']); ?></label>
									<span id="confirmar_envio_email_resp_2" style="display: block"></span>
								</div>
							</div>
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label"><?php echo str_replace("X","2",$data[549]['trad']); ?> (<?php echo $data[569]['trad']; ?>)</label>
									<input type="email" class="form-control" id="confirmar_envio_emailnovo_resp_2" name="confirmar_envio_emailnovo_resp_2" placeholder="..." />
								</div>
							</div>
						</div>
						<div class="row" id="resp_div_3" style="display:none;">
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label"><?php echo str_replace("X","3",$data[545]['trad']); ?></label>
									<span id="confirmar_envio_email_resp_3" style="display: block"></span>
								</div>
							</div>
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label"><?php echo str_replace("X","3",$data[549]['trad']); ?> (<?php echo $data[569]['trad']; ?>)</label>
									<input type="email" class="form-control" id="confirmar_envio_emailnovo_resp_3" name="confirmar_envio_emailnovo_resp_3" placeholder="..." />
								</div>
							</div>
						</div>
						<div class="row">
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label"><?php echo $data[1618]['trad']; ?>:<span class="require"></span></label>
									<select class="form-control select2 show-tick" data-live-search="true" data-header="<?php echo $data[1456]['trad']; ?>" id="iban" name="iban">
									<?php if((!$country || !$country_client) || (in_array($country, $qr_country) && in_array($country_client, $qr_country)) ) { ?>
											<option value="QR"><?php echo $data[1709]['trad']; ?></option>
										<?php } ?>
										<option value="IBAN"><?php echo $data[763]['trad']; ?></option>
									</select>
								</div>
							</div>
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label"><?php echo $data[1692]['trad']; ?>:<span class="require"></span></label>
									<input type="text" class="form-control required" id="IBAN_number" name="IBAN_number" placeholder="<?php echo $data[1673]['trad']; ?>" disabled/>
								</div>
							</div>
						</div>
						<div class="row">
							<div class="col-sm-6">
								<div class="form-group">
									<label class="control-label"><?php echo $data[1970]['trad']; ?> :</label>
									<input type="text" class="form-control" id="Tranches" name="Tranches" placeholder="<?php echo $data[1971]['trad']; ?>"/>
								</div>
							</div>
							<div class="col-sm-6" id="bvr">
								<div class="form-group" style="margin-top:30px">
									<input type="checkbox" id="Bulletin" name="Bulletin" /><label style="margin-left:5px;" for="Bulletin"><?php echo $data[1972]['trad']; ?></label>
								</div>
							</div>
						</div>
					</div>
				</form>
			</div>
			<div class="modal-footer">
				<button type="button" class="btn" id="confirmBtn-modal_QR">
					<i class="fa fa-paper-plane"></i> <?php echo $data[708]['trad']; ?>
				</button>
				<button type="button" data-dismiss="modal" class="btn btn-default">
					<?php echo $data[1995]['trad']; ?>
				</button>
			</div>
		</div>
	</div>
</div>
<?php include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/modals/get_responsables_mails.php";?>
<script type="text/javascript">
	$('document').ready(function(){
		fill_Iban();
		$("#email_contact").val("fakemailbcitbugs@fricode.ch");
	});
	$('select').on('change', function() {
		fill_Iban();
	});
	// FORM EMAIL VALIDATOR
	
	/*$.validator.addMethod("verifyIban", function(value, element, regexpr) {
		result = false;
		type = $('#iban').val();
        if(type == "IBAN"){
			iban = checkIban($('#IBAN_number').val());
			qrIban = checkQRIban($('#IBAN_number').val());
			result = iban && !qrIban;
		}else if (type == "QR"){
			result = checkQRIban($('#IBAN_number').val());
		}
		return result;
    }, "");*/
	
	val_form_new = $("#form_confirmar_envio_QR").validate({
		ignore : "",
		rules : {
			email_contact : {
				required : true,
			},
			iban : {
				required : true,
			},
			IBAN_number : {
				required : true,
			},
			document_iden_QR: {
				required : true
			}
		},
		messages : {
			email_contact : {
				required : "<?php echo $data[186]['trad']; ?>",
				email : "<?php echo $data[1676]['trad']; ?>"
			},
			iban : {
				required : "<?php echo $data[186]['trad']; ?>"
			},
			IBAN_number : {
				required : "<?php echo $data[186]['trad']; ?>",
			},
			document_iden_QR: {
				required : ""
			}
		},
		highlight : function(element, errorClass, validClass) {
			$(element).addClass(errorClass).removeClass(validClass);
		},
		unhighlight : function(element, errorClass, validClass) {
			$(element).removeClass(errorClass).addClass(validClass);
		},
		errorPlacement : function(error, element) {
			if (element.hasClass('selectpicker')) {
				if (element.parent().hasClass("input-group"))
					error.insertAfter(element.parent());
				else
					error.insertAfter(element.next("div"));
			} else {
				error.insertAfter(element);
			}
		}
	});
	//Il faut que ça marche sur le close, la on dirait ça marcher pas.
	$('#modal-confirmar-envio-QR').on('hidden.bs.modal', function () {
		$(".fullscreen").toggleClass('forceHidden');
		$(".fullscreen").hide();
	});

	//prevent form submit
	$("#form_confirmar_envio_QR").submit(function(e) {
		e.preventDefault();
	});

	//confirm sender
	
	$("#submitFormBtn").on('click', function(e){
	//$("#form_new").submit(function(e) {
		e.preventDefault();
		//$(".fullscreen").toggleClass('forceHidden');
		var valid = $("#form_new").valid();
		var invalid = 0;
		var linesWithArticles = 0;
		var articlesQTD = 0;
		var motives = 0;
		if(valid == false) {
			$.scojs_message("<?php echo $data[1403]['trad']; ?>", $.scojs_message.TYPE_ERROR);
			$(".fullscreen").toggleClass('forceHidden');
		} else {
			$("select.lineInputArtigo").each(function() {
				var lineID = $(this).attr('data-id-line');
				//check lines with articles
				if( $(this).val() > 0 ) linesWithArticles++;
				//check invalid totals
				if( $("#total_linha_"+lineID).parent().attr('data-status') == 'invalid'	) invalid++;
				//check invalid plans
				if( $("#plano_artigo_linha_"+lineID).val() <= 0	) invalid++;
				//check invalid quantities
				if( $("#qtd_linha_"+lineID).autoNumeric('get') <= 0	) articlesQTD++;
				//check isenções
				var subclasse = $('option:selected', $("#iva_linha_"+lineID)).attr('data-subclasse');
				if (subclasse == 'ISE'){
					if( $("#motivo_linha_"+lineID).val() < 1) /*motives++;*/ motives=0;
				}
			});
			//process validation
			if( invalid > 0 ) {
				$.scojs_message("<?php echo $data[1669]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				return;
			}
			if( linesWithArticles == 0 ){
				$.scojs_message("<?php echo $data[1431]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				return;
			}
			if( articlesQTD > 0 ) {
				$.scojs_message("<?php echo $data[1436]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				return;
			}
			if( motives > 0 ) {
				$.scojs_message("<?php echo $data[1435]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				return;
			}
			if( precisaBanco > 0 && ( $("#banco_fatura").val() < 1 || $("#banco_fatura").val() == '' )  ){
				$.scojs_message("<?php echo $data[1462]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				return;
			}
			var idFatura = getParameterByName('facture');
			var linesArticles = [];
			$("select.lineInputArtigo").each(function() {
				var lineID = $(this).attr('data-id-line');
				//add to array
				linesArticles.push({
					"artigo" : $(this).val(),
					"planocontas_artigo" : $("#plano_artigo_linha_"+lineID).val(),
					"descricao" : $("#descricao_linha_"+lineID).val(),
					"qtd" : $("#qtd_linha_"+lineID).autoNumeric('get'),
					"preco" : $("#preco_linha_"+lineID).autoNumeric('get'),
					"imposto" : $("#iva_linha_"+lineID).val(),
					"motivo" : $("#motivo_linha_"+lineID).val(),
					"desconto" : $("#desc_linha_"+lineID).autoNumeric('get'),
					"retencao" : $("#retencao_linha_"+lineID).autoNumeric('get'),
				});
			});
			//check que les infos sont bonnes pour l'escompte
				var pourcent = "";
				if($('input#pourcent_fatura').is(":checked")){
					pourcent = 1;
				} else {
					pourcent = 0;
				}
				var pourcentrab = 0;
				if ($('#pourcent_rab_fatura').is(":checked")){
					pourcentrab = 1;
				}
				var escompte = $("#escompte_fatura").val();
				var checkescompte = 0;
				if(escompte != ""){
					checkescompte = 1;
				}
				var regex = /^\d*\,?\.?\d{0,2}$/g;
				if(!escompte.match(regex) && checkescompte == 1){
					alert("<?php echo $data[1966]['trad']; ?>");
					return ;
				}
				intescompte = parseFloat(escompte);
				if(pourcent == 1 && intescompte >= 100 && checkescompte == 1){
					alert("<?php echo $data[1967]['trad']; ?>");
					return;
				}
				if(intescompte*100 % 5 != 0 && checkescompte == 1 && pourcent == 0){
					alert("<?php echo $data[1968]['trad']; ?>");
					return ;
				}
				var total = $("#valor-total").html().replace("'","").split(' ')[0];
				total = parseFloat(total);
				if(intescompte > total && pourcent == 0){
					alert("<?php echo $data[1969]['trad']; ?>");
					return ;
				}
			if(idFatura){
				$.ajax({
					type : 'POST',
					url : '/frifacturation/server/faturas/editar.php',
					dataType : 'json',
					data : {
						idFatura : idFatura,
						cliente : $("#cliente_fatura").val(),
						serie : $("#serie_fatura").val(),
						numero : $("#numero_fatura").val(),
						data : $("#data_fatura").val(),
						validade : $("#validade_fatura").val(),
						pagamento : $("#pagamento_fatura").val(),
						banco : $("#banco_fatura").val(),
						referencia : $("#referencia_fatura").val(),
						vencimento : $("#vencimento_fatura").val(),
						moeda : $("#moeda_fatura").val(),
						desconto : $("#desconto_fatura").val(),
						observacoes : $("#observacoes_fatura").val(),
						linhas : linesArticles,
						finalizarDocumento : finalizarDocumento,
						precisaBanco : precisaBanco,
						escompte : escompte,
						pourcentage : pourcent,
						pourcentrab: pourcentrab
					},
					success : function(resposta) {
						var resp = resposta;
						if (resposta == null){
							$.scojs_message("[FAT001] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							finalizarDocumento = 0;
							return;
						} else {
							if (resposta.errors) {
								$.scojs_message("[FAT002] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
								finalizarDocumento = 0;
								return;
							} else {
								$.scojs_message("<?php echo $data[1013]['trad']; ?>", $.scojs_message.TYPE_OK);
							}
						}
					},
					error : function(resposta){
						$.scojs_message(resposta.text, $.scojs_message.TYPE_ERROR);
						return;
					},
					complete : function(resposta) {
						if(resposta.responseJSON.fatura){
							setTimeout(function() {
								window.location.href = "../factures/details?facture="+resposta.responseJSON.fatura;
							}, 1000);
						}else {
							setTimeout(function() {
								window.location.href = "../factures";
							}, 1000);
						}
						return;
					}
				});
			} else {
				$.ajax({
						type : 'POST',
						url : '/frifacturation/server/faturas/inserir.php',
						dataType : 'json',
						data : {
						cliente : $("#cliente_fatura").val(),
						serie : $("#serie_fatura").val(),
						numero : $("#numero_fatura").val(),
						data : $("#data_fatura").val(),
						validade : $("#validade_fatura").val(),
						referencia : $("#referencia_fatura").val(),
						pagamento : $("#pagamento_fatura").val(),
						banco : $("#banco_fatura").val(),
						vencimento : $("#vencimento_fatura").val(),
						moeda : $("#moeda_fatura").val(),
						desconto : $("#desconto_fatura").val(),
						observacoes : $("#observacoes_fatura").val(),
						linhas : linesArticles,
						finalizarDocumento : finalizarDocumento,
						precisaBanco : precisaBanco,
						escompte : escompte,
						pourcentage : pourcent,
						pourcentrab: pourcentrab
					},
					success : function(resposta) {
						var resp = resposta;
						if (resposta == null){
							$.scojs_message("[FAT001] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
							finalizarDocumento = 0;
							enviarDocumento = 0;
							return;
						} else {
							if (resposta.errors) {
								$.scojs_message("[FAT002] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
								finalizarDocumento = 0;
								enviarDocumento = 0;
								return;
							} else {
								$.scojs_message("<?php echo $data[1013]['trad']; ?>", $.scojs_message.TYPE_OK);
							}
						}
					},
					error : function(resposta){
						$.scojs_message(resposta.text, $.scojs_message.TYPE_ERROR);
						return;
					},
					complete : function(resposta) {
						var resp = resposta;
						var idDoc = resp.responseJSON.fatura;
						if (resp.responseJSON.errors) {
							if(resp.responseJSON.referencia) {
								$.scojs_message("[FAT002] <?php echo $data[983]['trad']; ?>", $.scojs_message.TYPE_ERROR);
								return;
							} else if(resp.responseJSON.data_superior) {
								$.scojs_message("[FAT003] <?php echo $data[957]['trad']; ?> ("+resp.responseJSON.dataUltima+")", $.scojs_message.TYPE_ERROR);
								return;
							} else  {
								$.scojs_message("[FAT004] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
								return;
							}
						} else {
							$.scojs_message("<?php echo $data[1013]['trad']; ?>", $.scojs_message.TYPE_OK);
							if(resposta.responseJSON.fatura){
								setTimeout(function() {
									window.location.href = "../factures/details?facture="+resposta.responseJSON.fatura;
								}, 1000);
							}else {
								setTimeout(function() {
									window.location.href = "../factures";
								}, 1000);
							}
							return;
						}
					}
				})
			}
		}
	});

	/**
	 * Get email for sender
	 * @param  id
	 */
	 
	 function fill_senderEmail(idCliente){
		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/faturas-comum/sender_email2.php',
			data : { 
				idCliente : idCliente
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL007] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL008] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							// console.log('nulo?');
						} else {
							var dados = resposta.data;
							// console.log(dados);
							$('#confirmar_envio_email').html(dados.EmailSender);
							$('#confirmar_envio_emailnovo').val(dados.EmailSender);
						}
					}
				}
			},
			complete : function() {
				$('#modal-confirmar-envio').modal("show");
			}
		});
	}
	/*function enviarFaturaQR(idFatura, nome, rappel = '1º Rappel', action,type){
	<?php if (hasPermission(['P0028']) == 1) { ?>
		$('#document_iden_QR').val('');
		$('#document_iden_QR').val(idFatura);
		$('#confirmar_envio_detalhes_QR').html('-');
		$('#confirmar_envio_detalhes_QR').html(nome);
		$('#rappel_number_QR').val('');
		$('#rappel_number_QR').val(rappel);
		fill_senderEmailQR(idFatura, action, type);
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}*/
	
	
	 
	function fill_senderEmailQR(idDocumento, action, type){
		//get data
		file = 'sender_email_forms.php';
		if(type == 1 && action == 'mail'){
			file = 'sender_email_sport_forms.php';
		}
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/faturas-comum/'+file,
			data : { 
				idDocumento : idDocumento
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL007] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL008] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							// console.log('nulo?');
						} else {
							var dados = resposta.data;
							// console.log(dados);
							$('#confirmar_envio_email_QR').html(dados.EmailSender);
							$('#confirmar_envio_emailnovo_QR').val(dados.EmailSender);
							$('#action_selected').val(action);
							var title = "";
							$("#bvr").show();
							switch (action){
								case 'slip':
									title = "<?php echo $data[42]['trad']; ?>"
									$('#confirmBtn-modal_QR').html('<i class="fa fa-file" title="<?php echo $data[907]['trad']; ?>"></i></i>&nbsp;<?php echo $data[40]['trad']; ?>');
									$('#confirmBtn-modal_QR').attr('class', 'btn btn-brown');
									$(".email_row").hide();
									$('#confirmar_envio_emailnovo_QR').prop('disabled', true);
									$("#bvr").hide();
									break;
								case 'mail':
									title = "<?php echo $data[573]['trad']; ?>"
									$(".email_row").show();
									fill_respEmail(dados.ID_Cliente);
									$('#confirmBtn-modal_QR').attr('class', 'btn btn-blue');
									$('#confirmBtn-modal_QR').html('<i class="fa fa-paper-plane"></i> <?php echo $data[708]['trad']; ?>');
									if(type == 1){
										$("#confirmar_envio_emailnovo_resp_1").val();
										$("#confirmar_envio_emailnovo_resp_2").val();
										$("#confirmar_envio_emailnovo_resp_3").val();
										var counter = 1;
										$.each(dados.Responsaveis, function() {
											$("#resp_div_"+counter).show();
											$("#confirmar_envio_emailnovo_resp_"+counter).val(this.email);
											$("#confirmar_envio_email_resp_"+counter).html(this.email);
											counter++;
										});
									}
									$('#confirmar_envio_emailnovo_QR').prop('disabled', false);
									break;
								case 'full':
									title = "<?php echo $data[41]['trad']; ?>"
									$(".email_row").hide();
									$('#confirmBtn-modal_QR').html('<i class="fa fa-print" title="<?php echo $data[904]['trad']; ?>"></i>&nbsp;<?php echo $data[40]['trad']; ?>');
									$('#confirmBtn-modal_QR').attr('class', 'btn btn-grey');
									$('#confirmar_envio_emailnovo_QR').prop('disabled', true);
									break;
							}
							$('#modal-header-primary-label-qr').html(title);
						}
					}
				}
			},
			complete : function() {
				$('#modal-confirmar-envio-QR').modal("show");
			}
		});
		$(".fullscreen").toggleClass('forceHidden');
	}
	
	function fill_Iban(){
		var type = $('#iban').val();
		var iban = "";
		if(type == "IBAN"){
			iban = "<?php print($IBAN)?>"
		}else if (type == "QR"){
			iban = "<?php print($QR_IBAN)?>"
		}
		$('#IBAN_number').val(iban);
	}
	
	function addToDB(bill_type, iban, country){
		var current_iban = "<?php print($IBAN)?>";
		var current_qriban = "<?php print($QR_IBAN)?>";
		var current_country = "<?php print($country)?>";
		if(current_country != country){
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/faturas/add_country_db.php',
				dataType : 'json',
				data : {
					country: country,
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null) {
						$.scojs_message("[FAT007] <?php echo $data[822]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.errors) {
							$.scojs_message("[FAT008] <?php echo $data[822]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							//$.scojs_message("<?php echo $data[1290]['trad']; ?>", $.scojs_message.TYPE_OK);
						}
					}
				},
				error : function(resposta){
					$.scojs_message(resposta.text, $.scojs_message.TYPE_ERROR);
				},
				complete : function(){
					$(".fullscreen").toggleClass('forceHidden');
				}
			});
		}
	}
	
	$.validator.addMethod("checkDataValidade", function (value, element) {
				var result;

				var dt_validade = $('#validade_fatura').datepicker('getDate');
				var dt_begin = $('#data_fatura').datepicker('getDate');
				//set hours, minutes and seconds to 0
				dt_validade.setHours(0);
				dt_validade.setMinutes(0);
				dt_validade.setSeconds(0);
				dt_begin.setHours(0);
				dt_begin.setMinutes(0);
				dt_begin.setSeconds(0);
				//check dates
				// if ( Date.parse(dt_begin) > Date.parse(dt_validade)) {
				// 	result = false;
				// } else {
				// 	result = true;
				// }

			    return true;
			}, "<?php echo $data[971]['trad']; ?>");

			//check if selected date is bigger than today
			function checkDataBiggerThanToday(){
				var result;

				var dt_Today = new Date();
				var dt_begin = $('#data_fatura').datepicker('getDate');
				//set hours, minutes and seconds to 0
				dt_Today.setHours(0);
				dt_Today.setMinutes(0);
				dt_Today.setSeconds(0);
				dt_begin.setHours(0);
				dt_begin.setMinutes(0);
				dt_begin.setSeconds(0);
				//check dates
				if ( Date.parse(dt_begin) > Date.parse(dt_Today)) {
					result = true;
				} else {
					result = false;
				}

			    return result;
			}
	
	val_form_new = $("#form_new").validate({
				ignore : "",
				rules : {
					cliente_fatura : {
						required : true,
					},
					serie_fatura : {
						required : true
					},
					numero_fatura : {
						required : true
					},
					data_fatura : {
						required : true
					},
					pagamento_fatura : {
						required : true
					},
					validade_fatura : {
						required : true,
						checkDataValidade : true
					},
				},
				messages : {
					cliente_fatura : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
					serie_fatura : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
					numero_fatura : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
					data_fatura : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
					pagamento_fatura : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
					validade_fatura : {
						required : "<?php echo $data[186]['trad']; ?>"
					},
				},
				highlight : function(element, errorClass, validClass) {
					$(element).addClass(errorClass).removeClass(validClass);
				},
				unhighlight : function(element, errorClass, validClass) {
					$(element).removeClass(errorClass).addClass(validClass);
				},
				errorPlacement : function(error, element) {
					if (element.hasClass('select2')) {
						if (element.parent().hasClass("input-group"))
							error.insertAfter(element.parent());
						else
							error.insertAfter(element.next("div"));
					} else {
						error.insertAfter(element);
					}
				}
			});
	
	function salvarFinalizar(){
		var result = checkDataBiggerThanToday();
		var dataFatura = $('#data_fatura').val();
		var question = '';
		if(result == true) question = "<?php echo $data[948]['trad']; ?>\n\n<?php echo $data[622]['trad']; ?>?\n\n<?php echo $data[92]['trad']; ?> ["+dataFatura+"].";
		else question = "<?php echo $data[616]['trad']; ?>\n\n<?php echo $data[1679]['trad']; ?>";
		if (confirm(question) == true) {
			finalizarDocumento = 1;
			$("#submitFormBtn").click();
		} else { finalizarDocumento = 0; return false; }
	}
	
	$("#confirmBtn-modal_QR").on('click', function(e){
	//$("#form_confirmar_envio_QR").submit(function(e) {
		finalizarDocumento = 1;
		enviarDocumento = 1;
		var invalid = 0;
		var linesWithArticles = 0;
		var articlesQTD = 0;
		var motives = 0;
		e.preventDefault();
		var valid = $("#form_new").valid();
		if (valid == false) {
			$.scojs_message("<?php echo $data[1403]['trad']; ?>", $.scojs_message.TYPE_ERROR);
			return;
		}else{
			//check if exists 1 article at least
			$("select.lineInputArtigo").each(function() {
				var lineID = $(this).attr('data-id-line');
				//check lines with articles
				if( $(this).val() > 0 ) linesWithArticles++;
				//check invalid totals
				if( $("#total_linha_"+lineID).parent().attr('data-status') == 'invalid'	) invalid++;
				//check invalid plans
				if( $("#plano_artigo_linha_"+lineID).val() <= 0	) invalid++;
				//check invalid quantities
				if( $("#qtd_linha_"+lineID).autoNumeric('get') <= 0	) articlesQTD++;
				//check isenções
				var subclasse = $('option:selected', $("#iva_linha_"+lineID)).attr('data-subclasse');
				if (subclasse == 'ISE'){
					if( $("#motivo_linha_"+lineID).val() < 1) /*motives++;*/ motives=0;
				}
			});
			//process validation
			if( invalid > 0 ){
				$.scojs_message("<?php echo $data[1669]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				return;
			}
			if( linesWithArticles == 0 ) {
				$.scojs_message("<?php echo $data[1431]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				return;
			}
			if( articlesQTD > 0 ) {
				$.scojs_message("<?php echo $data[1436]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				return;
			}
			if( motives > 0 ) {
				$.scojs_message("<?php echo $data[1435]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				return;
			}
			if( precisaBanco > 0 && ( $("#banco_fatura").val() < 1 || $("#banco_fatura").val() == '' )  ){
				$.scojs_message("<?php echo $data[1462]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				return;
			}
			if( invalid == 0 && linesWithArticles > 0 && articlesQTD == 0 && motives == 0){
				//process the lines array
				var linesArticles = [];
				$("select.lineInputArtigo").each(function() {
					var lineID = $(this).attr('data-id-line');
					//add to array
					linesArticles.push({
						"artigo" : $(this).val(),
						"planocontas_artigo" : $("#plano_artigo_linha_"+lineID).val(),
						"descricao" : $("#descricao_linha_"+lineID).val(),
						"qtd" : $("#qtd_linha_"+lineID).autoNumeric('get'),
						"preco" : $("#preco_linha_"+lineID).autoNumeric('get'),
						"imposto" : $("#iva_linha_"+lineID).val(),
						"motivo" : $("#motivo_linha_"+lineID).val(),
						"desconto" : $("#desc_linha_"+lineID).autoNumeric('get'),
						"retencao" : $("#retencao_linha_"+lineID).autoNumeric('get'),
					});
				});

				$("#form_new").find('.submit_button').attr("disabled", true);
				$("#form_new").find('.submit_button').html('<i class="fa fa-circle-o-notch fa-spin  fa-fw "></i> <?php echo $data[214]['trad']; ?> ...');
				var idFatura = getParameterByName('facture');
				var tranches = $("#Tranches").val();
				var checktranches = 0;
				if(tranches != ""){
					checktranches = 1;
				}
				var regex = /^\d*\,?\.?\d{0,2}$/g;
				if(!tranches.match(regex) && checktranches == 1){
					alert("<?php echo $data[1973]['trad']; ?>");
					return ;
				}
				tranches = tranches.replace(",",".");
				tranches = parseFloat(tranches);
				var total = $("#valor-total").html().replace("'","").split(' ')[0];
				total = parseFloat(total);
				if((tranches > total || isNaN(tranches)) && checktranches == 1){
					alert("<?php echo $data[1974]['trad']; ?>");
					return ;
				}
				if(tranches*100 % 5 != 0 && checktranches == 1){
					alert("<?php echo $data[1975]['trad']; ?>");
					return;
				}
				if(isNaN(tranches)){
					tranches = "";
				}
				var pourcent = "";
				if($('input#pourcent_fatura').is(":checked")){
					pourcent = 1;
				} else {
					pourcent = 0;
				}
				var escompte = $("#escompte_fatura").val();
				var checkescompte = 0;
				if(escompte != ""){
					checkescompte = 1;
				}
				var pourcentrab = 0;
				if ($('#pourcent_rab_fatura').is(":checked")){
					pourcentrab = 1;
				}
				var regex = /^\d*\,?\.?\d{0,2}$/g;
				if(!escompte.match(regex) && checkescompte == 1){
					alert("<?php echo $data[1966]['trad']; ?>");
					return ;
				}
				intescompte = parseFloat(escompte);
				if(pourcent == 1 && intescompte >= 100 && checkescompte == 1){
					alert("<?php echo $data[1967]['trad']; ?>");
					return;
				}
				if(intescompte*100 % 5 != 0 && checkescompte == 1 && pourcent == 0){
					alert("<?php echo $data[1968]['trad']; ?>");
					return ;
				}
				if(intescompte > total && pourcent == 0){
					alert("<?php echo $data[1969]['trad']; ?>");
					return ;
				}
				if(!idFatura) {
					//submit the form
					$.ajax({
						type : 'POST',
						url : '/frifacturation/server/faturas/inserir.php',
						dataType : 'json',
						data : {
							cliente : $("#cliente_fatura").val(),
							serie : $("#serie_fatura").val(),
							numero : $("#numero_fatura").val(),
							data : $("#data_fatura").val(),
							validade : $("#validade_fatura").val(),
							referencia : $("#referencia_fatura").val(),
							pagamento : $("#pagamento_fatura").val(),
							banco : $("#banco_fatura").val(),
							vencimento : $("#vencimento_fatura").val(),
							moeda : $("#moeda_fatura").val(),
							desconto : $("#desconto_fatura").val(),
							observacoes : $("#observacoes_fatura").val(),
							linhas : linesArticles,
							finalizarDocumento : finalizarDocumento,
							precisaBanco : precisaBanco,
							escompte : escompte,
							pourcentage : pourcent,
							pourcentrab: pourcentrab
						},
						success : function(resposta) {
							var resp = resposta;
							if (resposta == null){
								$.scojs_message("[FAT001] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
								return;
								finalizarDocumento = 0;
								enviarDocumento = 0;
							} else {
								if (resposta.errors) {
									$.scojs_message("[FAT002] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
									return;
									finalizarDocumento = 0;
									enviarDocumento = 0;
								} else {
									$.scojs_message("<?php echo $data[1013]['trad']; ?>", $.scojs_message.TYPE_OK);
								}
							}
						},
						complete : function(resposta) {
							var resp = resposta;
							var idDoc = resp.responseJSON.fatura;
							if (resp.responseJSON.errors) {
								finalizarDocumento = 0;
								enviarDocumento = 0;
								if(resp.responseJSON.referencia) {
									$.scojs_message("[FAT002] <?php echo $data[983]['trad']; ?>", $.scojs_message.TYPE_ERROR);
									return;
								}else if(resp.responseJSON.data_superior) {
									$.scojs_message("[FAT003] <?php echo $data[957]['trad']; ?> ("+resp.responseJSON.dataUltima+")", $.scojs_message.TYPE_ERROR);
									return;
								} else {
									$.scojs_message("[FAT004] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
									return;
								}
							} else {
								$.scojs_message("<?php echo $data[1013]['trad']; ?>", $.scojs_message.TYPE_OK);
								if(enviarDocumento==1){
									var bulletin = $("#Bulletin").is(":checked");
									var email_sender = $("#email_contact").val();
									var bill_type = $("#iban").val();
									var iban = $("#IBAN_number").val();
									var country = $("#country").val();
									var bulletin = $("#Bulletin").is(":checked");
									if(!country){
										country = "<?php echo $GLOBALS['country']; ?>"
									}
									var action = "mail";
									$.ajax({
										type : 'GET',
										url : '/frifacturation/server/faturas/email_QR.php',
										dataType : 'json',
										data : {
											idDoc : idDoc,
											senderEmail : email_sender,
											bill_type: bill_type,
											iban: iban,
											country: country,
											action: action,
											send_mail: true,
											tranches: tranches,
											bulletin: bulletin
										},
										success : function(resposta) {
											var resp = resposta;
											if (resposta == null) {
												$.scojs_message("[FAT001] <?php echo $data[839]['trad']; ?>", $.scojs_message.TYPE_ERROR);
											} else {
												if (resposta.errors) {
													$.scojs_message("[FAT002] <?php echo $data[839]['trad']; ?>", $.scojs_message.TYPE_ERROR);
												} else {
													$.scojs_message("<?php echo $data[683]['trad']; ?>", $.scojs_message.TYPE_OK);
												}
											}
										},
										error : function(resposta){
											$.scojs_message(resposta.text, $.scojs_message.TYPE_ERROR);
										},
										complete : function(resposta) {
											setTimeout(function() {
												window.location.href = "../factures";
											}, 1000);
											return;
										}
									});
								} else {
									setTimeout(function() {
										window.location.href = "../factures";
									}, 1000);
								}
							}
							$("#form_new").find('.submit_button').attr("disabled", false);
							$("#form_new").find('.submit_button').html('<i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?>');
						}
					});
				} else {
					$.ajax({
						type : 'POST',
						url : '/frifacturation/server/faturas/editar.php',
						dataType : 'json',
						data : {
							idFatura : idFatura,
							cliente : $("#cliente_fatura").val(),
							serie : $("#serie_fatura").val(),
							numero : $("#numero_fatura").val(),
							data : $("#data_fatura").val(),
							validade : $("#validade_fatura").val(),
							pagamento : $("#pagamento_fatura").val(),
							banco : $("#banco_fatura").val(),
							referencia : $("#referencia_fatura").val(),
							vencimento : $("#vencimento_fatura").val(),
							moeda : $("#moeda_fatura").val(),
							desconto : $("#desconto_fatura").val(),
							observacoes : $("#observacoes_fatura").val(),
							linhas : linesArticles,
							finalizarDocumento : finalizarDocumento,
							precisaBanco : precisaBanco,
							escompte : escompte,
							pourcentage : pourcent,
							pourcentrab: pourcentrab
						},
						success : function(resposta) {
							var resp = resposta;
							if (resposta == null){
								$.scojs_message("[FAT001] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
								finalizarDocumento = 0;
								enviarDocumento = 0;
								return;
							} else {
								if (resposta.errors) {
									$.scojs_message("[FAT002] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
									finalizarDocumento = 0;
									enviarDocumento = 0;
									return;
								} else {
									$.scojs_message("<?php echo $data[1013]['trad']; ?>", $.scojs_message.TYPE_OK);
								}
							}
						},
						complete : function(resposta) {
							var resp = resposta;
							if (resp.responseJSON.errors) {
								finalizarDocumento = 0;
								enviarDocumento = 0;
								if(resp.responseJSON.referencia) {
									$.scojs_message("[FAT002] <?php echo $data[983]['trad']; ?>", $.scojs_message.TYPE_ERROR);
									return;
								}else if(resp.responseJSON.data_superior) { 
									$.scojs_message("[FAT003] <?php echo $data[957]['trad']; ?> ("+resp.responseJSON.dataUltima+")", $.scojs_message.TYPE_ERROR);
									return;
								} else {
									$.scojs_message("[FAT004] <?php echo $data[1633]['trad']; ?>", $.scojs_message.TYPE_ERROR);
									return;
								}
							} else {
								$.scojs_message("<?php echo $data[1013]['trad']; ?>", $.scojs_message.TYPE_OK);
								if(enviarDocumento==1){
									var bulletin = $("#Bulletin").is(":checked");
									var email_sender = $("#email_contact").val();
									var bill_type = $("#iban").val();
									var iban = $("#IBAN_number").val();
									var country = $("#country_qr").val();
									var action = "mail";
									var idDoc = resp.responseJSON.fatura;
									var country = $("#country").val();
									if(!country){
										country = "<?php echo $GLOBALS['country']; ?>"
									}
									$.ajax({
										type : 'GET',
										url : '/frifacturation/server/faturas/email_QR.php',
										dataType : 'json',
										data : {
											idDoc : idDoc,
											senderEmail : email_sender,
											bill_type: bill_type,
											iban: iban,
											country: country,
											action: action,
											send_mail: true,
											tranches: tranches,
											bulletin: bulletin
										},
										success : function(resposta) {
											var resp = resposta;
											if (resposta == null) {
												$.scojs_message("[FAT001] <?php echo $data[839]['trad']; ?>", $.scojs_message.TYPE_ERROR);
											} else {
												if (resposta.errors) {
													$.scojs_message("[FAT002] <?php echo $data[839]['trad']; ?>", $.scojs_message.TYPE_ERROR);
												} else {
													$.scojs_message("<?php echo $data[683]['trad']; ?>", $.scojs_message.TYPE_OK);
												}
											}
										},
										error : function(resposta){
											$.scojs_message(resposta.text, $.scojs_message.TYPE_ERROR);
										},
										complete : function(resposta) {
											setTimeout(function() {
												window.location.href = "../factures";
											}, 1000);
											return;
										}
									});
									$("#form_new").find('.submit_button').attr("disabled", false);
									$("#form_new").find('.submit_button').html('<i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?>');
								}else{
								//reload
									setTimeout(function() {
										window.location.href = "../factures";
									}, 1000);
									return;
								}
							}
						}
					});
				}
			}
		}
	});
</script>