<?php
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(819,237,562,67,237,1505,1182,1403,702,1637,1681,214,1631,992,993,1018,209,1682,1995);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<link href="/js/vendors/bootstrap-fileinput/css/fileinput.min.css" media="all" rel="stylesheet" type="text/css" />

<div id="modal-importarBVR" tabindex="-1" role="dialog" aria-labelledby="modal-header-primary-label" data-backdrop="static" data-keyboard="false" aria-hidden="true" class="modal fade">
	<div class="modal-dialog modal-wide-width">
		<div class="modal-content">
			<div class="modal-header modal-header-orange">
				<button type="button" data-dismiss="modal" aria-hidden="true" class="close">
					&times;
				</button>
				<h4 id="modal-header-primary-label" class="modal-title"><?php echo $data[819]['trad']; ?></h4>
			</div>
			<form id="form_importarBVR" class="form-validate" novalidate="novalidate">
				<input type="hidden" id="idArtigo">
				<div class="modal-body" style="overflow-y: visible;">
					<div id="form_div">
						<div class="row">
							<div class="col-md-12">
								<div class="form-group">
									<label class="control-label"><?php echo $data[237]['trad']; ?>: </label>
									<input class="form-control file" type="file" id="documento_anexo" name="documento_anexo[]" multiple>
								</div>
							</div>
						</div>
						<div class="row hide">
							<div class="col-md-12" id="inputs_anexos">
							</div>
						</div>
					</div>
				</div>
				<div class="modal-footer">
					<button  class="btn btn-green submit_button" type="submit">
						<i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?>
					</button>
					<button type="button" data-dismiss="modal" class="btn btn-default">
						<?php echo $data[1995]['trad']; ?>
					</button>

				</div>
			</form>
		</div>
	</div>
</div>


<script src="/js/vendors/bootstrap-fileinput/plugins/canvas-to-blob.min.js" type="text/javascript"></script>
<script src="/js/vendors/bootstrap-fileinput/fileinput.min.js" type="text/javascript"></script>
<script src="/js/vendors/bootstrap-fileinput/fileinput_locale_fr.js" type="text/javascript"></script>

<script type="text/javascript">
	$(document).ready(function() {
		//init elements
		$(".qtd").autoNumeric("init", {
			aSep : '\'',
			aDec : '.',
			aSign : '',
			pSign : 's',
			mDec : 3
		});
	});

	/**
	 * ----------------------------------------------------
	 * ----------------- FORM PROCESSING ------------------
	 * ----------------------------------------------------
	 */
	$("#documento_anexo").fileinput({
		uploadUrl : "/frifacturation/server/upload_bvr.php",
		language : "fr",
		uploadAsync : false,
		showClose : false,
		showCaption : true,
		showRemove : true,
		showPreview : false,
		showUpload : false,
		dropZoneEnabled : false,
		maxFileCount : 1,
		browseLabel : '<?php echo $data[237]['trad']; ?>:',
		browseIcon : '<i class="fa fa-file"></i>',
		removeLabel : '<?php echo $data[1505]['trad']; ?>',
		removeIcon : '<i class="fa fa-trash"></i>',
		removeClass : "btn btn-red",
		browseClass : "btn btn-yellow",
		allowedFileExtensions : ["v11"]
	}).on('fileselect', function(event, numFiles, label) {
		isValidFile = true;
		// consolelog(isValidFile);
	}).on('filebatchselected', function(event, files) {
		if (files.length > 0) {
			$("#inputs_anexos").empty();
			for ( i = 0; i < files.length; i++) {
				$("#inputs_anexos").append('<div class="form-group"><label class="control-label"><?php echo $data[1182]['trad']; ?> (' + files[i].name + '): </label><input class="form-control" type="text" id="nome_anexo_' + i + '" name="nome_anexo"></div>')
			}
			isValidFile = true;
		} else {
			isValidFile = false;
		}
	}).on('fileclear', function(event) {
		$("#inputs_anexos").empty();
	});

	// val_form_new = $("#form_importarBVR").validate({
	// 	ignore : "",
	// 	rules : {
	// 		qtd_stock_artigo : {
	// 			required : true,
	// 		},
	// 	},
	// 	messages : {
	// 		qtd_stock_artigo : {
	// 			required : "<?php echo $data[186]['trad']; ?>"
	// 		},
	// 	},
	// 	highlight : function(element, errorClass, validClass) {
	// 		$(element).addClass(errorClass).removeClass(validClass);
	// 	},
	// 	unhighlight : function(element, errorClass, validClass) {
	// 		$(element).removeClass(errorClass).addClass(validClass);
	// 	},
	// 	errorPlacement : function(error, element) {
	// 		if (element.hasClass('selectpicker')) {
	// 			if (element.parent().hasClass("input-group"))
	// 				error.insertAfter(element.parent());
	// 			else
	// 				error.insertAfter(element.next("div"));
	// 		} else {
	// 			error.insertAfter(element);
	// 		}
	// 	}
	// });

	$("#form_importarBVR").submit(function( e ) {
		e.preventDefault();
		var flag = $("#form_importarBVR button[type=submit][clicked=true]").attr("data-flag");
		// console.log(flag);

		var ficheiro = $(".file-caption-name").html();
		var path;
		var resp = null;
		var valid = $("#form_importarBVR").valid();

		if (valid == false) {
			$.scojs_message("<?php echo $data[1403]['trad']; ?>", $.scojs_message.TYPE_ERROR);
		} else {
			if (ficheiro != "") {
				// console.log(isValidFile);
				if (!isValidFile) {
					$.scojs_message("<?php echo $data[702]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					return false;
				}
				$("#documento_anexo").fileinput("upload").on('filebatchuploadsuccess', function(event, data, id, index) {
					if (data.response.errors) {
						$.scojs_message("[PA001] <?php echo $data[1637]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						submitData(data.response.name,flag);
					}
				});
			} else {
				$.scojs_message("<?php echo $data[1681]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					return false;
			}
		}
		return false;
	});

	//check validation and upload foto
	function submitData(path,flagBTN) {
		$("#form_importarBVR").find('.submit_button').attr("disabled", true);
		$("#form_importarBVR").find('.submit_button').html('<i class="fa fa-circle-o-notch fa-spin  fa-fw "></i> <?php echo $data[214]['trad']; ?> ...');

		// var nomes_inputs = [];
		// $("input[name='nome_anexo']").each(function() {
		// 	nomes_inputs.push($(this).val());
		// });

		//submite the form
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/operations/importar_bvr.php',
			dataType : 'json',
			data : {
				ficheiro_bvr : path
			},
			success : function(resposta) {
				var resp = resposta;
				if (resposta == null)
					$.scojs_message("[FAT001] <?php echo $data[1631]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				else {
					if (resposta.errors) {
						$.scojs_message("[FAT002] <?php echo $data[1631]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						$.scojs_message("<?php echo $data[992]['trad']; ?>", $.scojs_message.TYPE_OK);
					}
				}
			},
			complete : function(resposta) {
				var resp = resposta;

				if (resp.responseJSON.errors) {
					if(resp.responseJSON.file){
						$.scojs_message("[FAT004] <?php echo $data[993]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					}else if(resp.responseJSON.totals){
						$.scojs_message("[FAT005] <?php echo $data[1018]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					}
					else{
						$.scojs_message("[FAT003] <?php echo $data[1631]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					}
				} else {
					if(resp.responseJSON.invalid_lines > 0){
						$.scojs_message("[WRN001] <?php echo $data[209]['trad']; ?> <?php echo $data[1682]['trad']; ?>", 3);
						alert("<?php echo $data[209]['trad']; ?> \n\n<?php echo $data[1682]['trad']; ?>");
					}else{
						$.scojs_message("<?php echo $data[992]['trad']; ?>", $.scojs_message.TYPE_OK);
					}
					$('#modal-importarBVR').modal("hide");
					//reload
					setTimeout(function() {
						location.reload();
					}, 2000);
				}
				$("#form_importarBVR").find('.submit_button').attr("disabled", false);
				$("#form_importarBVR").find('.submit_button').html('<i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?>');
			}
		});
	}

	//ver recibo
	function uploadFile(){
		$('#modal-importarBVR').modal("show");
	}
</script>