<?php
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1565,1472,1446,1702,1704,1503,1312,1310,421,428,1377,1639,1456);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<script type="text/javascript">
	//Load records into the table
	function reloadTableLines(fileID = 0){
		//clear previous records
		if(fileID != 0){
			table.dataTable().fnReloadAjax();
		}

		//load new records
		table = $('#table_id').dataTable({
			"dom" : '<lfrtip><"clear">',
			"sRowSelect" : "os",
			"sRowSelector" : 'td:first-child',
			"lengthMenu" : [[25, 50, 100, -1], [25, 50, 100, "<?php echo $data[1565]['trad']; ?>"]],
			"iDisplayLength" : 100,
			"aaSorting" : [[0, "asc"]],
			"bProcessing" : true,
			"bDestroy" : true,
			"bServerSide" : true,
			"sAjaxSource" : "/frifacturation/server/datatable/movimentos_bvr.php?bvrfile="+fileID,
			"oLanguage" : {
				"sLengthMenu" : "<?php echo $data[1472]['trad']; ?>",
				"sZeroRecords" : "<?php echo $data[1446]['trad']; ?>",
				"sInfo" : "<?php echo $data[1702]['trad']; ?>",
				"sInfoEmpty" : "<?php echo $data[1704]['trad']; ?>",
				"sProcessing" : "<div></div>",
				"sInfoFiltered" : "",
				"oPaginate" : {
					"sNext" : "<?php echo $data[1503]['trad']; ?>",
					"sFirst" : "<?php echo $data[1312]['trad']; ?>",
					"sPrevious" : "<?php echo $data[1310]['trad']; ?>",
					"sLast" : "<?php echo $data[421]['trad']; ?>"
				}
			},
			"aoColumns" : [
			null, null, null, null, null, null, null, null,
			{
				"sClass" : "text-right",
			},
			{
				"bVisible" : true,
				"bSortable" : false,
				"bSearchable" : true,
				"sClass" : "text-center",
			},
			{
				"bVisible" : false,
			},
			],
			"aoColumnDefs" : [

			{
				"aTargets" : [2],
				"mRender" : function(data, type, full) {
					if(full[1] == 999) {
						return '';
					}

					//return html
					return full[2];
				}
			},
			{
				"aTargets" : [3],
				"mRender" : function(data, type, full) {
					if(full[1] == 999) {
						return '';
					}

					//return html
					return full[3];
				}
			},
			{
				"aTargets" : [4],
				"mRender" : function(data, type, full) {
					if(full[1] == 999) {
						return '';
					}

					//return html
					return full[4];
				}
			},
			{
				"aTargets" : [5],
				"mRender" : function(data, type, full) {
					if(full[1] == 999) {
						return '';
					}
					var element = '';
					var tmp = full[5].split("-");
					var tmpNew = tmp[0]+'/'+tmp[1]+'/'+tmp[2];
					var tmpLBL = tmp[2]+'/'+tmp[1]+'/'+tmp[0];
					element = '<span id="data_fatura_'+full[9]+'" data-normalizeDate="'+tmpNew+'">'+tmpLBL+'</span>';
					//return html
					return element;
				}
			},
			{
				"aTargets" : [6],
				"mRender" : function(data, type, full) {
					if(full[1] == 999) {
						return '';
					}

					//return html
					return full[6];
				}
			},
			{
				"aTargets" : [7],
				"mRender" : function(data, type, full) {
					if(full[1] == 999) {
						return '<p style="margin-bottom:0px !important;" class="text-right">Totaux:</p>';
					}else{
						if(full[7] == '') return '-';
						else return full[7];
					}
				}
			},
			{
				"aTargets" : [8],
				"mRender" : function(data, type, full) {
					var element = '';
					if(full[8] < 0) colorLabel = 'text-red';
					else if(full[8] == 0) colorLabel = 'text-grey';
	            	else colorLabel = 'text-green';
					element ='<span class="money '+colorLabel+'">'+full[8]+'</span>';

					//init elements
					$(".money").autoNumeric("init", {
						aSep : '\'',
						aDec : '.',
						aSign : ' CHF',
						pSign : 's',
						mDec : <?php echo $numDecimais; ?>
					});
					
					return element;
				}
			},
			{
				"aTargets" : [9],
				"mRender" : function(data, type, full) {
					if(full[1] == 999) {
						return '';
					}
					var html = '';

					html += '<a onClick="detalhesMovimento('+full[9]+')" class="options-link text-info" title="<?php echo $data[428]['trad']; ?>"><i class="fa fa-eye"></i></a>';
					
					//return all html composed
					return html;
				}
			}],

			"fnRowCallback" : function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
				$(nRow).attr("dbID", aData[9]);

				if(aData[1] == 999) {
					$(nRow).css("font-weight", "bold");
					$(nRow).css("background-color", "#ccc");
				}else{
					if(aData[10] == 'En attente') {
						$(nRow).css("color", "red");
					}else{
						$(nRow).css("color", "green");
					}
				}


				return nRow;
			},
			"fnDrawCallback" : function(oSettings) {
	            $(".ellipsis").ellipsis(); 
			},
		});

		$('#table_id').on('click', 'tbody td:not(.dataTables_empty)', function() {
			$('#table_id tbody tr').removeClass('selected');
			$(this).parent('tr').removeClass('DTTT_selected');
			$(this).parent('tr').addClass('selected');
		});

		$('#table_id_filter input').unbind();

		$('#table_id_filter').html('<label><div class="input-group input-group-sm mbs"><input type="search" class="form-control input-sm" placeholder="" aria-controls="table_id"><span class="input-group-btn"><button type="button" data-toggle="dropdown" class="btn btn-yellow dropdown-toggle" onclick="pesquisar()"><i class="fa fa-search"></i> <?php echo $data[1377]['trad']; ?></button></span></div></label>');

		$('#table_id_filter input').bind('keyup', function(e) {
			if (e.keyCode == 13) {
				table.fnFilter(this.value);
			}

		});
		function pesquisar() {
			table.fnFilter($('#table_id_filter input').val());
		}
		$('#table_id_filter input').bind('keyup', function(e) {
			if (($(this).val().length) == 0) {
				table.fnFilter('');
			}
		});
		function fnGetSelected(tabela) {
			var aReturn = new Array();
			var aTrs = tabela.fnGetNodes();
			for (var i = 0; i < aTrs.length; i++) {
				if ($(aTrs[i]).hasClass('row_selected')) {
					aReturn.push(aTrs[i]);
				}
			}
			return aReturn;
		}

		//END OF TABLE ---------------------------------------------
	}

	/**
	 * Fill BVR Files
	 * @return select list
	 */
	function fill_bvr_files(){
		var options = $("select#bvr_importado");
		$(options).empty();
		//get data
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/combobox/movimentos_bvr.php',
			data : {
				opcao : 1
			},
			dataType : 'json',
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[SEL001] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);

				} else {
					if (resposta.errors == true) {
						$.scojs_message("[SEL002] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$(options).attr("disabled", true);

						} else {
							$(options).attr("disabled", false);

							$(options).append($('<option data-hidden="true"/>').val("").text("<?php echo $data[1456]['trad']; ?>"));

							$.each(resposta.data, function() {
								$(options).append( $("<option />").val(this.FileID).text(this.Descricao) );
							});
						}
					}
				}
			},
			complete : function() {
				// $(options).val($("select#bvr_importado option:eq(1)").val());
				$(options).selectpicker('refresh');
			}
		});
	}
</script>