<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";

// GET NECESSARY DATA ----------------------------------------------------
$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET $_GET VARS ---------------------------------------------------------
$idArtigo = $_POST['idArtigo'];

//DEFINE VARS ------------------------------------------------------------
$objectData = array();
$data = "";

//GET THE PROCESS --------------------------------------------------------
$query = "SELECT ID_Artigo,
	Codigo, 
	CodigoBarras, 
	SerialNumber, 
	Nome, 
	ID_Categoria, 
	Tipo,
	PrecoPVP,
	Preco,
	ID_Imposto,
	ID_Imposto_Fornecedor,
	ID_Unidade,
	RetencaoPercentagem,
	RetencaoValor,
	Stock,
	Ativo,
	PlanoContas,
	PlanoContasCompras,
	Usado
	FROM faturacao_artigos WHERE ID_Artigo=?";

if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idArtigo);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
	    $objectData['ID_Artigo'],
	    $objectData['Codigo'],
	    $objectData['CodigoBarras'],
	    $objectData['SerialNumber'],
	    $objectData['Nome'],
	    $objectData['Categoria'],
	    $objectData['Tipo'],
	    $objectData['PrecoPVP'],
	    $objectData['Preco'],
	    $objectData['IVA'],
	    $objectData['IVA_Fornecedor'],
	    $objectData['Unidade'],
	    $objectData['RetencaoPercentagem'],
	    $objectData['RetencaoValor'],
	    $objectData['Stock'],
	    $objectData['Ativo'],
	    $objectData['PlanoContas'],
	    $objectData['PlanoContasCompras'],
	    $objectData['Usado']
	);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

// var_dump($objectData);die();
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));

?>