<?php
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$opcao = $_POST['opcao'];
$data = "";
$snc_table = getSncBaseTable();

switch ($opcao) {
	//OBTEM PAIS
	case 1 :
		$query = "SELECT ID_Plano, Codigo, Descricao FROM faturacao_plano_conta WHERE Ecriture = '' ";

		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			// $stmt -> bind_param("d", $idImposto);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS001";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result( $ID_Plano, $Codigo, $Descricao);
			while ($stmt -> fetch()) {
				//put data into array
				$dataTmp[] = array(
				    'id' => $ID_Plano,
				    'codigo' => $Codigo,
				    'descricao' => $Codigo.'&nbsp;&nbsp;>>&nbsp;&nbsp;'.$Descricao,
				);
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS002";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		//clean major parents
		foreach ($dataTmp as $key => $value) {
			$counterTmp = 0;

			$query = "SELECT COUNT(*) FROM faturacao_plano_conta WHERE Codigo LIKE '".$value['codigo']."%' AND Ecriture = '' ";
			if ( $stmt = $sqli_connection -> prepare($query) ) {
				//bind params
				// $stmt -> bind_param("d", $idImposto);
				//result single
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FATS001A";
					$response["message"] = $stmt -> error;
					die(json_encode($response));
				}
				$stmt -> bind_result( $counterTmp );
				$stmt -> fetch();
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS002A";
				$response["message"] = $sqli_connection -> error;
				die(json_encode($response));
			}

			//process final array
			if($counterTmp < 2){
				$data[] = array(
				    'id' => $value['id'],
				    'codigo' => $value['codigo'],
				    'descricao' => $value['descricao'],
				);
			}
		}

		// var_dump($objectData);die();
		$response["errors"] = false;
		$response["data"] = $data;
		die(json_encode($response));

		break;

	//GET NEXT NUMBER
	case 2:
		if( isset($_POST['idPlano']) ){
			$query = "SELECT Codigo, PlanoCategoria, SubCategoriaPlanoConta FROM faturacao_plano_conta WHERE ID_Plano = ".$_POST['idPlano'];
		}else{
			$response["errors"] = true;
			$response["message"] = 'Sem plano selecionado';
			die(json_encode($response));
		}
		if ($stmt = $sqli_connection -> prepare($query)) { 
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FATS003";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($codigoPlano, $categoriaPlano, $subcategoriaPlano);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FATS003A";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		$query = "SELECT MAX(CAST(Codigo AS UNSIGNED)) FROM faturacao_plano_conta WHERE Codigo LIKE '".$codigoPlano."%' ";
		if ($stmt = $sqli_connection -> prepare($query)) {
			// $stmt -> bind_param("s", $codigoPlano);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FATS004";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($maxCode);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FATS005";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		
		//process next code
		if( $codigoPlano == $maxCode ){
			$data[] = array(
						'code' => 0,
					    'cat' => $categoriaPlano,
					    'subcat' => $subcategoriaPlano,
					);
		}else{
			$tmp = str_replace($codigoPlano, '', $maxCode);
			$data[] = array(
						'code' => $tmp + 1,
					    'cat' => $categoriaPlano,
					    'subcat' => $subcategoriaPlano,
					);
		}

		$response["errors"] = false;
		$response["data"] = $data;
		die(json_encode($response));

		break;

	//OBTEM FILHOS
	case 3 :
		$query = "SELECT ID_Plano, Codigo, Descricao, ID_Imposto FROM faturacao_plano_conta WHERE Ecriture <> ''  AND Codigo not in (1000, 1001, 2000, 2001) ";

		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			// $stmt -> bind_param("d", $idImposto);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS001";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result( $ID_Plano, $Codigo, $Descricao, $ID_Imposto);
			while ($stmt -> fetch()) {
				//put data into array
				$data[] = array(
				    'id' => $ID_Plano,
				    'codigo' => $Codigo,
				    'descricao' => $Codigo.'&nbsp;&nbsp;>>&nbsp;&nbsp;'.$Descricao,
				    'ID_Imposto' => $ID_Imposto ? $ID_Imposto : 0,
				);
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS002";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		$planoDefeito = null;
		if(isset($_POST['defeito'])) {
			$keyword = $_POST['defeito'];

			if($keyword == 'artigo') {
				$query = "SELECT Keyword, PlanoConta FROM faturacao_personalizar_planos_defeito WHERE Keyword LIKE 'artigo%'";
				if ( $stmt = $sqli_connection -> prepare($query) ) {
					//bind params
					// $stmt -> bind_param("s", $keyword);
					//result single
					$result = $stmt -> execute();
					if (false === $result) {
						$response["errors"] = true;
						$response["type"] = "query";
						$response["line"] = "FATS006";
						$response["message"] = $stmt -> error;
						die(json_encode($response));
					}
					$stmt -> bind_result( $new_keyword, $new_planoDefeito );
					while( $stmt -> fetch() ) {
						$planoDefeito[$new_keyword] = $new_planoDefeito;
					}
					$stmt -> close();
				} else {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FATS007";
					$response["message"] = $sqli_connection -> error;
					die(json_encode($response));
				}
			} else {
				$query = "SELECT PlanoConta FROM faturacao_personalizar_planos_defeito WHERE Keyword = ? ";
				if ( $stmt = $sqli_connection -> prepare($query) ) {
					//bind params
					$stmt -> bind_param("s", $keyword);
					//result single
					$result = $stmt -> execute();
					if (false === $result) {
						$response["errors"] = true;
						$response["type"] = "query";
						$response["line"] = "FATS008";
						$response["message"] = $stmt -> error;
						die(json_encode($response));
					}
					$stmt -> bind_result( $planoDefeito );
					$stmt -> fetch();
					$stmt -> close();
				} else {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FATS009";
					$response["message"] = $sqli_connection -> error;
					die(json_encode($response));
				}
			}

		}

		// var_dump($objectData);die();
		$response["errors"] = false;
		$response["data"] = $data;
		$response["planoDefeito"] = $planoDefeito;
		die(json_encode($response));

		break;

	//OBTEM FILHOS
	case 4 :
		$query = "SELECT ID_Plano, Codigo, Descricao FROM faturacao_plano_conta WHERE Ecriture <> '' ";

		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			// $stmt -> bind_param("d", $idImposto);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS001";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result( $ID_Plano, $Codigo, $Descricao);
			while ($stmt -> fetch()) {
				//put data into array
				$data[] = array(
				    'id' => $ID_Plano,
				    'codigo' => $Codigo,
				    'descricao' => $Descricao,
				);
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS002";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}

		// var_dump($objectData);die();
		$response["errors"] = false;
		$response["data"] = $data;
		die(json_encode($response));

		break;

	//Taxes
	case 5:
		$query = "SELECT ID_Imposto, Nome, Valor, Predefinido, Subclasse FROM faturacao_impostos ORDER BY Nome";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA015";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result(
			            $ID_Imposto,
						$Nome,
						$Valor,
						$Predefinido,
						$Subclasse
					);
			while ($stmt -> fetch()) {
				$data[] = array(
				    "ID_Imposto" => $ID_Imposto,
					"Nome" => $Nome,
					"Valor" => $Valor,
					"Predefinido" => $Predefinido,
					"Subclasse" => $Subclasse,
				);
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA016";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		$response["errors"] = false;
		$response["data"] = $data;
		die(json_encode($response));

		break;

	//Taxes Custom Select
	case 6:
		$query = "SELECT ID_Imposto, Nome, Descricao, Valor, Predefinido, Subclasse FROM faturacao_impostos ORDER BY Nome";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FTGA015";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result(
			            $ID_Imposto,
						$Nome,
						$Descricao,
						$Valor,
						$Predefinido,
						$Subclasse
					);
			while ($stmt -> fetch()) {
				$data[] = array(
				    "ID_Imposto" => $ID_Imposto,
					"Nome" => $Nome,
					"Descricao" => $Descricao,
					"Valor" => $Valor,
					"Predefinido" => $Predefinido,
					"Subclasse" => $Subclasse,
					"NomeComposto" => $Nome.' >> '.number_format($Valor, 2, '.', '\'' ).'% >> '.$Descricao,
				);
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FTGA016";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		$response["errors"] = false;
		$response["data"] = $data;
		die(json_encode($response));

		break;

}
?>