<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(16,1208,77,1599);
if(isset($data2)){
	$data2 = $data2 + get_trad($ids_list);
} else {
	$data2 = get_trad($ids_list);
}

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$fornecedor = $_POST['fornecedor'];
$numero = $_POST['numero'];
$data = $_POST['data'];
$validade = $_POST['validade'];
$referencia = $_POST['referencia'];
$pagamento = $_POST['pagamento'];
$banco = $_POST['banco'];
$vencimento = $_POST['vencimento'];
$moeda = $_POST['moeda'];
$desconto = $_POST['desconto'];
$observacoes = $_POST['observacoes'];
$linhas = $_POST['linhas'];
$finalizarDocumento = $_POST['finalizarDocumento'];
$precisaBanco = $_POST['precisaBanco'];
$serie = $_POST['serie'];

//REMAIN FIELDS ----------------------------------------------------------
$estado = 'Rascunho';
$taxPayable = 0;
$netTotal = 0;
$grossTotal = 0;
$systemEntryDate = '';
$timestamp = 0;
$totalDesconto = 0;
$percentagemDesconto = $desconto;
$retencaoTotal = 0;
$totalSDesconto = 0;

//NEW FIELDS PLANO CONTAS
$PlanoContasFornecedor = getPlanoCode("PlanoContas", "faturacao_fornecedores", "ID_Fornecedor", $fornecedor);
$PlanoContasBanco = '';

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $fornecedor == '' || $numero == '' || $data == '' || $validade == '' || $pagamento == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}
if( $precisaBanco > 0 && ($banco < 1 || $banco == '') )
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000B";
	die(json_encode($response));
}

//------------------------------------------------------------------------

//GET CLIENT DATA --------------------------------------------------------
$query = "SELECT Nif, Endereco, CodigoPostal, Cidade, Regiao, Pais, Email, Codigo, TypePayment,	IBAN, BIC_SWIFT, ID_BancoFornecedor, ComptePostal, ID_BVR, NumeroCompte FROM faturacao_fornecedores WHERE ID_Fornecedor = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $fornecedor);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
			$Nif, 
			$Endereco, 
			$CodigoPostal, 
			$Cidade, 
			$Regiao, 
			$Pais, 
			$Email, 
			$CodigoFornecedor,

			//NEW FIELDS
			$tipopagamentoFornecedor,
			$ibanFornecedor,
			$bicswiftFornecedor,
			$bancoFornecedor,
			$contapostalFornecedor,
			$bvrFornecedor,
			$numcontaFornecedor 
		);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//process fields
if( trim($Endereco) == '' ) $Endereco = 'Desconhecido';
if( trim($CodigoPostal) == '' ) $CodigoPostal = 'Desconhecido';
if( trim($Cidade) == '' ) $Cidade = 'Desconhecido';
if( trim($Regiao) == '' ) $Regiao = 'Desconhecido';
if( trim($Pais) == '' ) $Pais = 'Desconhecido';
//------------------------------------------------------------------------

//GET CURRENCY DATA ------------------------------------------------------
$query = "SELECT  Ultima_Taxa FROM faturacao_moedas WHERE ID_Moeda = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $moeda);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($ultimaTaxa);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA004";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if( $ultimaTaxa <= 0){
	$response["errors"] = true;
	$response["type"] = "FTGA005";
	$response["message"] = "Moeda inválida";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//GET COMPANY DATA -------------------------------------------------------
$query = "SELECT  CONCAT(Endereco1,' ',Endereco2) AS Endereco, CodigoPostal, Cidade, Cidade, CAE_Principal FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1";
if ($stmt = $sqli_connection -> prepare($query)) {
	// $stmt -> bind_param("d", $moeda);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA006";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($enderecoDescarga, $codigopostalDescarga, $cidadeDescarga, $idCidadeDescarga, $CAE_Principal);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA007";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//GET REGION
// $query = "SELECT (SELECT Nome FROM distrito WHERE distrito.ID_Distrito = concelho.ID_Distrito) AS Regiao FROM concelho WHERE ID_Concelho = ?";
// if ($stmt = $sqli_connection -> prepare($query)) {
// 	$stmt -> bind_param("d", $idCidadeDescarga);
// 	$result = $stmt -> execute();
// 	if (false === $result) {
// 		$response["errors"] = true;
// 		$response["type"] = "FTGA008";
// 		$response["message"] = $stmt -> error;
// 		die(json_encode($response));
// 	}
// 	$stmt -> bind_result($regiaoDescarga);
// 	$stmt -> fetch();
// 	$stmt -> close();
// } else {
// 	$response["errors"] = true;
// 	$response["type"] = "FTGA009";
// 	$response["message"] = $sqli_connection -> error;
// 	die(json_encode($response));
// }
$regiaoDescarga = '';
//process fields
if( trim($enderecoDescarga) == '' ) $enderecoDescarga = 'Desconhecido';
if( trim($codigopostalDescarga) == '' ) $codigopostalDescarga = 'Desconhecido';
if( trim($cidadeDescarga) == '' ) $cidadeDescarga = 'Desconhecido';
if( trim($regiaoDescarga) == '' ) $regiaoDescarga = 'Desconhecido';
//------------------------------------------------------------------------

$timestamp = microtime(true);
$systemEntryDate = date("Y-m-d H:i:s");
$systemEntryDate = str_replace (' ','T',$systemEntryDate);
$EACCode = $CAE_Principal;
$customerID = $CodigoFornecedor;
if( $precisaBanco > 0 ){
	$bancoFinalID = $banco;
	$PlanoContasBanco = getPlanoCode("PlanoContas", "faturacao_bancos", "ID_Banco", $banco);
}else{
	$bancoFinalID = 0;
}

//INSERT OPEN DOCUMENT ---------------------------------------------------
$query = "INSERT INTO faturacao_compras(ID_Fornecedor, EnderecoFornecedor, CodigoPostalFornecedor, CidadeFornecedor, RegiaoFornecedor, EmailFornecedor, PaisFornecedor, Numero, ID_Moeda, TaxaMoeda, Vencimento, EnderecoDescarga, CodigoPostalDescarga, CidadeDescarga, RegiaoDescarga, Data, Validade, Referencia, Observacoes, SystemEntryDate, TimeStampDate, Estado, ID_Utilizador, MetodoPagamento, ID_Banco, PlanoContas, PlanoContasBanco, TypePayment,	IBAN, BIC_SWIFT, ID_BancoFornecedor, ComptePostal, ID_BVR, NumeroCompte, ID_Serie) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dsssssssdsssssssssssssdddsssssssssd", $fornecedor, $Endereco, $CodigoPostal, $Cidade, $Regiao, $Email, $Pais, $numero, $moeda, $ultimaTaxa, $vencimento, $enderecoDescarga, $codigopostalDescarga, $cidadeDescarga, $regiaoDescarga, $data, $validade, $referencia, $observacoes, $systemEntryDate, $timestamp, $estado, $id_utilizador, $pagamento, $bancoFinalID, $PlanoContasFornecedor, $PlanoContasBanco, $tipopagamentoFornecedor, $ibanFornecedor, $bicswiftFornecedor, $bancoFornecedor, $contapostalFornecedor, $bvrFornecedor, $numcontaFornecedor, $serie  );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA010";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA011";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//GET DOCUMENT ID
$query = "SELECT ID_Compra FROM faturacao_compras WHERE TimeStampDate = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("s", $timestamp);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA012";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($idCompra);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA013";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if( $idCompra < 1){
	$response["errors"] = true;
	$response["type"] = "FTGA014";
	$response["message"] = "Compra inválida";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//PROCESS LINES ----------------------------------------------------------
$numLinha = 1;
foreach ($linhas as $linha) {
	//init vars
	$ProductDescription = '';
	$ProductCode = '';
	$SerialNumber = '';
	$TaxType = '';
	$TaxCountryRegion = '';
	$TaxCode = '';
	$TaxPercentage = '';
	$impostoUsed = '';
	$TaxExemptionCode = '';
	$TaxExemptionReason = '';
	$TaxPointDate = date("Y-m-d");	

	//NEW FIELDS PLANO CONTAS
	$PlanoContasArtigo = $linha['planocontas_artigo'];
	$PlanoContasImposto = getPlanoCode("PlanoContas", "faturacao_impostos", "ID_Imposto", $linha['imposto']);

	//GET ARTICLE DATA ---------------------------------------------------
	$query = "SELECT  Nome, Codigo, SerialNumber, (SELECT Sigla FROM faturacao_unidades WHERE faturacao_unidades.ID_Unidade = faturacao_artigos.ID_Unidade) AS Unidade FROM faturacao_artigos WHERE ID_Artigo = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $linha['artigo']);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA015";
			$response["message"] = $stmt -> error;
			deleteRecord($idCompra);
			die(json_encode($response));
		}
		$stmt -> bind_result($ProductDescription, $ProductCode, $SerialNumber, $Unidade);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA016";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idCompra);
		die(json_encode($response));
	}
	//--------------------------------------------------------------------
	
	//GET TAXES DATA -----------------------------------------------------
	$query = "SELECT  Tipo, Regiao, Subclasse, Valor FROM faturacao_impostos WHERE ID_Imposto = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $linha['imposto']);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA017";
			$response["message"] = $stmt -> error;
			deleteRecord($idCompra);
			die(json_encode($response));
		}
		$stmt -> bind_result($TaxType, $TaxCountryRegion, $TaxCode, $TaxPercentage);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA018";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idCompra);
		die(json_encode($response));
	}
		//VERIFICAR SE IMPOSTO JÁ BLOQUEADO -------------------------------------
		$query = "SELECT COUNT(*) FROM faturacao_impostos_usados WHERE ID_Imposto=?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $linha['imposto']);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA018A";
				$response["message"] = $stmt -> error;
				deleteRecord($idCompra);
				die(json_encode($response));
			}
			$stmt -> bind_result($impostoUsed);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA018B";
			$response["message"] = $sqli_connection -> error;
			deleteRecord($idCompra);
			die(json_encode($response));
		}
		if($impostoUsed < 1){
			//INSERT DB --------------------------------------------------
			$query = "INSERT INTO faturacao_impostos_usados(ID_Imposto) VALUES (?)";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("d", $linha['imposto'] );
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FTGA018C";
					$response["message"] = $stmt -> error;
					deleteRecord($idCompra);
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA018D";
				$response["message"] = $sqli_connection -> error;
				deleteRecord($idCompra);
				die(json_encode($response));
			}
			//------------------------------------------------------------
		}

		//CASO SEJA TIPO ISE
		// if( $TaxCode == 'ISE' ){
		if( $TaxCode == 'ISENTO' ){
			if( $linha['motivo'] < 1){
				$response["errors"] = true;
				$response["type"] = "var";
				$response["line"] = "FTGA018E";
				$response["message"] = "Motivo de isenção inválido";
				deleteRecord($idCompra);
				die(json_encode($response));
			}else{
				$query = "SELECT  Codigo, Descricao FROM faturacao_motivos_isencao WHERE ID_Motivo = ?";
				if ($stmt = $sqli_connection -> prepare($query)) {
					$stmt -> bind_param("d", $linha['motivo']);
					$result = $stmt -> execute();
					if (false === $result) {
						$response["errors"] = true;
						$response["type"] = "FTGA018F";
						$response["message"] = $stmt -> error;
						deleteRecord($idCompra);
						die(json_encode($response));
					}
					$stmt -> bind_result($TaxExemptionCode, $TaxExemptionReason);
					$stmt -> fetch();
					$stmt -> close();
				} else {
					$response["errors"] = true;
					$response["type"] = "FTGA018G";
					$response["message"] = $sqli_connection -> error;
					deleteRecord($idCompra);
					die(json_encode($response));
				}
			}

		}
	//--------------------------------------------------------------------
	
	//check if vals are smaller than 0
	if( $linha['qtd'] <= 0 ){
		$response["errors"] = true;
		$response["type"] = "FTGA018H";
		$response["message"] = 'Valores das linhas menores que 0';
		deleteRecord($idCompra);
		die(json_encode($response));
	}
	if( $linha['preco'] < 0 ){
		$response["errors"] = true;
		$response["type"] = "FTGA018I";
		$response["message"] = 'Valores das linhas menores que 0';
		deleteRecord($idCompra);
		die(json_encode($response));
	}
	
	//TOTALS
	$debitAmount = 0;
	$creditAmount = 0;
	$settelementAmount = 0;
	$totalSIVA = 0;
	$totalLinha = 0;

	$linhaDesconto = $linha['desconto'] * 0.01;
	$descontoProcessed = $desconto * 0.01;
	$taxaIVA = $TaxPercentage * 0.01;
	$ivaProcessed = $taxaIVA + 1 ;

	$totalSIVA = $linha['qtd'] * $linha['preco'];
	$desconto1 = $totalSIVA * $linhaDesconto; //calcula desconto 1
	$totalSIVA = $totalSIVA - ($totalSIVA * $linhaDesconto); //calcula descunto linha
	$desconto2 = $totalSIVA * $descontoProcessed; //calcula desconto 2
	$totalSIVA = $totalSIVA - ($totalSIVA * $descontoProcessed); //calcula desconto global

	$settelementAmount = $desconto1 + $desconto2;
	$creditAmount = $totalSIVA;
	$totalLinha = $totalSIVA * $ivaProcessed;

	$retencao = $linha['retencao'] * 0.01;
	$retencao = $totalSIVA * $retencao;

	//TOTALS FATURA
	$taxPayable = $taxPayable + ($totalSIVA * $taxaIVA);
	$netTotal = $netTotal + $totalSIVA;
	$grossTotal = $taxPayable + $netTotal;
	// $grossTotal = round($grossTotal,2);
	$totalDesconto = $totalDesconto + $settelementAmount;
	if( $Nif != '999999990' ) $retencaoTotal = $retencaoTotal + $retencao;
	$totalSDesconto = $totalSDesconto + ( $linha['qtd'] * $linha['preco'] );

	//INSERT INTO DB -----------------------------------------------------
	$query = "INSERT INTO faturacao_compras_linhas (ID_Compra, NumeroLinha, 
		ID_Artigo, ProductCode, ProductDescription, Quantidade, UnidadeMedida, PrecoUnitario, TaxPointDate, Descricao, SerialNumber, 
		ID_Imposto, TaxType, TaxCountryRegion, TaxCode, TaxPercentage, TaxExemptionReason, TaxExemptionCode, 
		DescontoLinha, CreditAmount, DebitAmount, SettlementAmount, ValorRetencao, PercentagemRetencao, TotalLinha, TotalLinhaSIVA, PlanoContas, PlanoContasTVA) 
		VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dddssssssssdssssssssssssssss", $idCompra, $numLinha, $linha['artigo'], $ProductCode, $ProductDescription, $linha['qtd'], $Unidade, $linha['preco'], $TaxPointDate, $linha['descricao'], $SerialNumber, $linha['imposto'], $TaxType, $TaxCountryRegion, $TaxCode, $TaxPercentage, $TaxExemptionReason, $TaxExemptionCode, $linha['desconto'], $creditAmount, $debitAmount, $settelementAmount, $retencao, $linha['retencao'], $totalLinha, $totalSIVA, $PlanoContasArtigo, $PlanoContasImposto );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA019";
			$response["message"] = $stmt -> error;
			deleteRecord($idCompra);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA020";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idCompra);
		die(json_encode($response));
	}
	//--------------------------------------------------------------------
	
	$numLinha++;

	//BLOCK ARTICLE ------------------------------------------------------
	$query = "UPDATE faturacao_artigos SET Usado=1 WHERE ID_Artigo=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $linha['artigo']);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA020A";
			$response["message"] = $stmt -> error;
			deleteRecord($idCompra);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA020B";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idCompra);
		die(json_encode($response));
	}
	//--------------------------------------------------------------------
}
//------------------------------------------------------------------------

//UPDATES TOTALS ---------------------------------------------------------
$totalDesconto = round($totalDesconto,$numDecimais);
$retencaoTotal = round($retencaoTotal,$numDecimais);
$taxPayable = round($taxPayable,$numDecimais);
$netTotal = round($netTotal,$numDecimais);
$grossTotal = round($grossTotal,$numDecimais);

$query = "UPDATE faturacao_compras SET TaxPayable=?, NetTotal=?, GrossTotal=?, Desconto=?, PercentagemDesconto=?, TotaRetencao=?, TotalSDesconto=? WHERE ID_Compra=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sssssssd", $taxPayable, $netTotal, $grossTotal, $totalDesconto, $percentagemDesconto, $retencaoTotal, $totalSDesconto, $idCompra);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA021";
		$response["message"] = $stmt -> error;
		deleteRecord($idCompra);
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA022";
	$response["message"] = $sqli_connection -> error;
	deleteRecord($idCompra);
	die(json_encode($response));
}
//------------------------------------------------------------------------

//CLOSE THE DOCUMENT -----------------------------------------------------
if( $finalizarDocumento > 0 ){
	$dataNew = $data;
	$validadeNew = $validade;
	$dataAtualizacao = date("d/m/Y H:i:s");

	$systemEntryDateUpdate = date("Y-m-d H:i:s");
	$systemEntryDateUpdate = str_replace (' ','T',$systemEntryDateUpdate);
	// $retencaoCalc = round($retencaoTotal,2);
	$retencaoCalc = $retencaoTotal;
	// $totalLiquidado = $retencaoCalc;
	
	// DEFINE NEW NUMBER
	$query = "UPDATE faturacao_compras SET Data=?, Validade=?, ID_UtilizadorAtualizacao=?, DataAtualizacao=?, SystemEntryDate=?, Estado='Aberto' WHERE ID_Compra = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("ssdssd", $dataNew, $validadeNew, $id_utilizador, $dataAtualizacao, $systemEntryDateUpdate, $idCompra);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA025";
			$response["message"] = $stmt -> error;
			deleteRecord($idCompra);
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idCompra);
		die(json_encode($response));
	}

	//UPDATE STOCKS
	$stockUpdateResult = increaseArticlesStock($idCompra, 'faturacao_compras', 'ID_Compra');
	if($stockUpdateResult != true){
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA027";
		$response["message"] = 'Falha ao atualizar stocks.';
		die(json_encode($response));
	}

	//------------------------------------------------------------------------
	//-------------- LANÇAMENTO DE MOVIMENTOS CONTABILISTICOS ----------------
	//------------------------------------------------------------------------
	$query = "SELECT PlanoContas, PlanoContasBanco, Numero , 
				(SELECT Codigo FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras.ID_Fornecedor) AS Codigo, 
				(SELECT CONCAT(Nome, ' ',Apelido) FROM faturacao_fornecedores WHERE faturacao_fornecedores.ID_Fornecedor = faturacao_compras.ID_Fornecedor) AS Fornecedor,
				GrossTotal, NetTotal, TaxPayable
			FROM faturacao_compras WHERE ID_Compra=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idCompra);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA028";
			$response["message"] = $stmt -> error;
			deleteRecord($idCompra);
			die(json_encode($response));
		}
		$stmt -> bind_result($planoFornecedor, $planoBanco, $numeroDoc, $numFornecedor, $nomeFornecedor, $totalPVP, $totalUnit, $totalTVA );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA029";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idCompra);
		die(json_encode($response));
	}
	//PROCESS MOVEMENT FOR DOCUMENT
	$texto = $data2[16]['trad'].' ('.$data2[1208]['trad'].') - '.$numeroDoc.' - '.$numFornecedor.' - '.$nomeFornecedor;
	/*if($planoFornecedor > 0){
		$tipoMovimento = 'C';
		// insertMovimentoContabilistico($planoFornecedor, $texto, $totalPVP, 0, 0, $tipoMovimento);
		insertMovimentoContabilisticoManual($planoFornecedor, $texto, $totalPVP, 0, 0, $tipoMovimento, $dataNew, 'A');
	}*/

	//LINES -- ARTICLES
	$query = "SELECT PlanoContas, ProductCode, TotalLinha, TotalLinhaSIVA, (TotalLinha - TotalLinhaSIVA), ID_Imposto FROM faturacao_compras_linhas WHERE ID_Compra=? ORDER BY ID_Linha";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idCompra);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA030";
			$response["message"] = $stmt -> error;
			deleteRecord($idCompra);
			die(json_encode($response));
		}
		$stmt -> bind_result($planoArtigo, $codigoArtigo, $totalPVP_Artigo, $totalUnit_Artigo, $totalTVA_Artigo, $id_imposto_artigo );
		while ($stmt -> fetch()) {
			//PROCESS MOVEMENT ARTICLE
			if($planoArtigo > 0){
				$textoArtigo = $texto.' - '.$data2[77]['trad'].' - '.$codigoArtigo;
				$tipoMovimentoArtigo = 'D';
				$dataArtigos[] = array('plano'=>$planoArtigo, 'texto'=>$textoArtigo, 'totalPVP'=>$totalPVP_Artigo, 'totalUnit'=>$totalUnit_Artigo, 'totalTVA'=>$totalTVA_Artigo, 'tipo'=>$tipoMovimentoArtigo, 'id_imposto_artigo'=>$id_imposto_artigo);
			}
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA031";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idCompra);
		die(json_encode($response));
	}
	if(isset($dataArtigos)){
		foreach ($dataArtigos as $line) {
			$Edited_TotalPVP = round($line['totalUnit'],$numDecimais);
			if($Edited_TotalPVP > 0){
				// insertMovimentoContabilistico($line['plano'], $line['texto'], $Edited_TotalPVP, 0, 0, $line['tipo']);
				// insertMovimentoContabilisticoManual($line['plano'], $line['texto'], $Edited_TotalPVP, 0, 0, $line['tipo'], $dataNew, 'A');
				insertMovimentoContabilisticoManual($line['plano'], $planoFornecedor, $line['texto'], $Edited_TotalPVP, 0, $Edited_TotalPVP, $line['tipo'], $dataNew, 'A', $line['id_imposto_artigo'], 0);
			}
		}
	}

	//LINES -- TVA
	$query = "SELECT (SELECT PlanoContas FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_compras_linhas.ID_Imposto), (SELECT Nome FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_compras_linhas.ID_Imposto) AS Imposto, 
				TaxPercentage, SUM(TotalLinha), SUM(TotalLinhaSIVA), ID_Imposto 
			FROM faturacao_compras_linhas WHERE ID_Compra=? GROUP BY ID_Imposto";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idCompra);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA030";
			$response["message"] = $stmt -> error;
			deleteRecord($idCompra);
			die(json_encode($response));
		}
		$stmt -> bind_result($planoTVA, $nomeTVA, $percentagemTVA, $totalPVP_TVA, $totalUnit_TVA, $id_imposto_TVA );
		while ($stmt -> fetch()) {
			//PROCESS MOVEMENT ARTICLE
			if($planoTVA > 0){
				$totalTVA_TVA = $totalPVP_TVA - $totalUnit_TVA;
				$textoTVA = $texto.' - '.$data2[1599]['trad'].' - '.$nomeTVA.': '.$percentagemTVA.'%';
				$tipoMovimentoTVA = 'D';
				$dataTVA[] = array('plano'=>$planoTVA, 'texto'=>$textoTVA, 'totalPVP'=>$totalPVP_TVA, 'totalUnit'=>$totalUnit_TVA, 'totalTVA'=>$totalTVA_TVA, 'tipo'=>$tipoMovimentoTVA, 'id_imposto_TVA'=>$id_imposto_TVA);
			}
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA031";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idCompra);
		die(json_encode($response));
	}
	if(isset($dataTVA)){
		foreach ($dataTVA as $line) {
			// insertMovimentoContabilistico($line['plano'], $line['texto'], $line['totalTVA'], 0, 0, $line['tipo']);
			// insertMovimentoContabilisticoManual($line['plano'], $line['texto'], $line['totalTVA'], 0, 0, $line['tipo'], $dataNew, 'A');
			insertMovimentoContabilisticoManual($line['plano'], $planoFornecedor, $line['texto'], $line['totalTVA'], 0, $line['totalTVA'], $line['tipo'], $dataNew, 'A', $line['id_imposto_TVA'], 1);
		}
	}
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------


	//log sistema - processo
	$descricao_log ="Création et finalisation de l'achat (numéro: ".$numero.")";
	insert_log(0,"Inserir",$descricao_log,$sqli_connection);

}else{
	$response["compra"] = $idCompra;


	//log sistema - processo
	$descricao_log ="Création de l'achat (numéro: ".$numero.")";
	insert_log(0,"Inserir",$descricao_log,$sqli_connection);
}
//------------------------------------------------------------------------

//BLOCK CLIENT ----------------------------------------------------------
$query = "UPDATE faturacao_fornecedores SET Usado=1 WHERE ID_Fornecedor=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $fornecedor);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA027";
		$response["message"] = $stmt -> error;
		deleteRecord($idCompra);
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA028";
	$response["message"] = $sqli_connection -> error;
	deleteRecord($idCompra);
	die(json_encode($response));
}
//------------------------------------------------------------------------

//BLOCK BANK ----------------------------------------------------------
$query = "UPDATE faturacao_bancos SET Usado=1 WHERE ID_Banco=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $bancoFinalID);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA029";
		$response["message"] = $stmt -> error;
		deleteRecord($idCompra);
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA030";
	$response["message"] = $sqli_connection -> error;
	deleteRecord($idCompra);
	die(json_encode($response));
}
//------------------------------------------------------------------------

//response
$response["errors"] = false;
die(json_encode($response));

//remove inserted Enregistrer if gives an error
function deleteRecord($idObject){
	global $sqli_connection;

	//DELETE DB -------------------------------------------------------------
	$query = "DELETE FROM faturacao_compras WHERE ID_Compra=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM001";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM002";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//LINHAS
	$query = "DELETE FROM faturacao_compras_linhas WHERE ID_Compra=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//----------------------------------------------------------------------
}
?>