<?php
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1639,1698,1633);
if(isset($data2)){
	$data2 = $data2 + get_trad($ids_list);
} else {
	$data2 = get_trad($ids_list);
}
?>
<!DOCTYPE html>
<html>
<head>
	<title>Enviar faturas por email</title>
</head>
<body>
	<h2>Enviar faturas por email</h2>
	
	<div id="responseGet">
		<h3>Factures à envoyer</h3>
		<ul id="recebidas">
			
		</ul>
	</div>

	<hr>


	<div id="responsePost">
		<h3>Factures envoyées</h3>
		<ul id="enviadas">
			
		</ul>
	</div>

	<?php include('../base/scripts.php') ?>

	<!-- ADDED SCRIPTS -->
	<script type="text/javascript">
		$(document).ready(function() {
			getFaturasEmail();
		});

		//get localite
		function getFaturasEmail(){

			//get data
			$.ajax({
				type : 'GET',
				url : '/frifacturation/server/run_script.php',
				dataType : 'json',
				success : function(resposta) {
					if (resposta == null) {
						$.scojs_message("[SEL007] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);

					} else {
						if (resposta.errors == true) {
							$.scojs_message("[SEL008] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							if (resposta.data == null) {

							} else {

								// $(options).append($("<option />").val(0).text('Aucune Ville'));
								$.each(resposta.data, function() {
									var dados = this;
									$("#recebidas").append($("<li />").text('--- FACTURE ID: '+ this.ID_Fatura+' --- ('+this.Serie+'/'+this.Numero+' | '+this.DataFat+') --- Email: '+this.senderEmail));
									
									// console.log();

									//call function to send email
									sendFaturaEmail(dados);
								});
							}
						}
					}
				},
				complete : function() {}
			});
		}

		//get localite
		function sendFaturaEmail(dadosFatura){

			//get data
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/imprimer_pdf/exportar_fatura_email.php',
				data : { 
					idDoc : dadosFatura['idDoc'],
					send_email : dadosFatura['send_email'],
					fromEmail : dadosFatura['fromEmail'],
					ccEmail : dadosFatura['ccEmail'],
					senderEmail : dadosFatura['senderEmail'],
				},
				dataType : 'json',
				success : function(resposta) {
					if (resposta == null) {
						$.scojs_message("[SEL007] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);

					} else {
						if (resposta.errors == true) {
							$.scojs_message("[SEL008] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							$("#enviadas").append($("<li />").text('--- FACTURE ID: '+ dadosFatura.ID_Fatura+' --- ('+dadosFatura.Serie+'/'+dadosFatura.Numero+' | '+dadosFatura.DataFat+') --- Email: '+dadosFatura.senderEmail));
						}
					}
				},
				complete : function() {}
			});
		}
	</script>
</body>
</html>