<?php
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo_gesfaturacao.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/PHPExcel/PHPExcel/IOFactory.php";
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1639,1698,1633,1273,123);
if(isset($data2)){
	$data2 = $data2 + get_trad($ids_list);
} else {
	$data2 = get_trad($ids_list);
}
// include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
// gerarRecibo("3", 'FT', "112.130000", "1", "3", "1", 1, "Teste Testes");

/**
 * Generate the Receipt
 * @param [fatura id]
 * @return result 0 or 1
 */
function gerarRecibo($idDocumento, $tipoDocumento, $valorRecibo, $serieRecibo, $metodoRecibo, $bancoRecibo, $precisaBancoRecibo, $ObservacoesRecibo) 
{
	//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
	// include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
	// include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
	//if(!function_exists('getCurrentUserRole')){
		//include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';
	//}

	$ano = $_SESSION['ano'];
	$id_utilizador = $_SESSION['id_utilizador'];

	global $sqli_connection;

	//GET POST VARS ---------------------------------------------------------
	$idFatura = $idDocumento;
	$typeDoc = $tipoDocumento;
	$valor_recibo = $valorRecibo;
	$data_recibo = date('d/m/Y');
	$serie_recibo = $serieRecibo;

	//GET NECESSARY VARS ----------------------------------------------------
	$pagamento_recibo = $metodoRecibo;
	$banco_recibo = $bancoRecibo;
	$observacoes_recibo = $ObservacoesRecibo;
	$linhas[] = array(
		"id_documento" => $idDocumento,
		"tipo" => $tipoDocumento,
		"valor_pagar" => $valorRecibo,
	);
	$precisaBanco = $precisaBancoRecibo;
	// var_dump($linhas);die();
	
	//remain vars
	$atcud = 0;
	$period = 0;
	$transactiondate = '';
	$PaymentType = 'RG';
	$PaymentStatus = 'N';
	$PaymentStatusDate = '';
	$sourcePayment = 'P';
	$sourceID_Estado = $_SESSION['username'];
	$sourceID_Origem = $_SESSION['username'];
	$systemEntryDate = '';
	$CustomerID = '';
	$TaxPayable = 0;
	$NetTotal = 0;
	$GrossTotal = 0;
	$GrossTotalRecebido = 0;
	$ID_Moeda = 0;
	$TaxaMoeda = 0;
	$ValorRetencao = 0;
	$estado = 'Pago';
	$tipoDocOrigem = $typeDoc;

	//VERIFICA SE HA NULOS ---------------------------------------------------
	if ( $idFatura == '' || $typeDoc == '' || $valor_recibo == '' || $data_recibo == '' || $serie_recibo == '' || $pagamento_recibo == '' || $linhas == '' || $linhas == null ) 
	{
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FATS0000A";
		$response["result"] = 1;
		return $reponse;
	}
	if( $precisaBanco > 0 && ($banco_recibo < 1 || $banco_recibo == '') )
	{
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "FATS0000B";
		$response["result"] = 1;
		return $reponse;
	}

	//MAIN DOCUMENT TABLE NAME
	switch ($typeDoc) {
		case 'FT':
			$fieldIdName = 'ID_Fatura';
			$tableName = 'faturacao_faturas';
			$tipoDocOrigem = 'FT';
			break;
		case 'FS':
			$fieldIdName = 'ID_FaturaSimplificada';
			$tableName = 'faturacao_faturas_simplificadas';
			break;
		case 'FR':
			$fieldIdName = 'ID_FaturaRecibo';
			$tableName = 'faturacao_faturas_recibo';
			break;
		
		default:
			$response["errors"] = true;
			$response["type"] = "var";
			$response["line"] = "FATS000B";
			$response["result"] = 1;
			return $reponse;
			break;
	}
	//------------------------------------------------------------------------

	//Données de Facture --------------------------------------------------------
	$query = "SELECT ".$fieldIdName.", Data,(SELECT Codigo FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = ".$tableName.".ID_Cliente), ID_Moeda, TaxaMoeda, TotalLiquidado, TotalPagar FROM ".$tableName." WHERE ".$fieldIdName."=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idFatura);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			$response["result"] = 1;
			return $reponse;
		}
		$stmt -> bind_result($ID_Fatura, $dataFatura, $cod_cliente, $moedaFat, $taxaFat, $liquidadoTotalFatura, $totalPagarFatura);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		$response["result"] = 1;
		return $reponse;
	}
	if($ID_Fatura < 1 || $cod_cliente < 1){
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS003";
		$response["message"] = "Fatura inválida.";
		$response["result"] = 1;
		return $reponse;
	}
	//-----------------------------------------------------------------------

	//GET LAST RECEIPT DATE -------------------------------------------------
	$query = "SELECT ID_Recibo, TransactionDate FROM faturacao_recibos WHERE ID_Serie=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $serie_recibo);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS003A";
			$response["message"] = $stmt -> error;
			$response["result"] = 1;
			return $reponse;
		}
		$stmt -> bind_result($idRecLast, $lastDateReceipt);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS003B";
		$response["message"] = $sqli_connection -> error;
		$response["result"] = 1;
		return $reponse;
	}
	if($idRecLast > 0){
		$dtReciboTmp = DateTime::createFromFormat('d/m/Y', $data_recibo);
		$dtreciboTimeStamp = $dtReciboTmp->getTimestamp();

		$dtLastRec = DateTime::createFromFormat('Y-m-d', $lastDateReceipt);
		$dtLastReciboProc = $dtLastRec->format('d/m/Y');
		$dtLastTimeStamp = $dtLastRec->getTimestamp();

		//check if receipt date bigger than last receipt date
		// if( $dtreciboTimeStamp < $dtLastTimeStamp){
		// 	$response["errors"] = true;
		// 	$response["type"] = "query";
		// 	$response["data_superior"] = true;
		// 	$response["dataUltima"] = $dtLastReciboProc;
		// 	$response["message"] = "Data superior à data do ultimo recibo.";
		// 	$response["result"] = 1;
		// 	return $reponse;
		// }
	}
	//-----------------------------------------------------------------------

	//PROCESS SOME FIELDS ---------------------------------------------------
	$dtReceipt = DateTime::createFromFormat('d/m/Y', $data_recibo);
	$dataReciboProcessed = $dtReceipt->format('Y-m-d');
	$dataReciboTimestamp = $dtReceipt->getTimestamp();

	$dtInvoice = DateTime::createFromFormat('d/m/Y', $dataFatura);
	$dataFaturaTimestamp = $dtInvoice->getTimestamp();

	//process bank
	if( $precisaBanco > 0 ){
		$bancoFinalID = $banco_recibo;
	}else{
		$bancoFinalID = 0;
	}

	//check if receipt date bigger than invoice date
	// if( $dataReciboTimestamp < $dataFaturaTimestamp){
	// 	$response["errors"] = true;
	// 	$response["type"] = "query";
	// 	$response["data_superior"] = true;
	// 	$response["dataUltima"] = $dataFatura;
	// 	$response["message"] = "Data superior à data da fatura.";
	// 	$response["result"] = 1;
	// 	return $reponse;
	// }

	//fill fields
	$CustomerID = $cod_cliente;
	$ID_Moeda = $moedaFat;
	$TaxaMoeda = $taxaFat;
	$period = $dtReceipt->format('m');

	$timestamp = microtime(true);
	$transactiondate = $dataReciboProcessed;
	$systemEntryDate = date("Y-m-d H:i:s");
	$systemEntryDate = str_replace (' ','T',$systemEntryDate);
	$PaymentStatusDate = $systemEntryDate;
	//------------------------------------------------------------------------

	//INSERT INTO DB ---------------------------------------------------------
	$query = "INSERT INTO faturacao_recibos (ID_Serie, ATCUD, Period, TransactionDate, PaymentType, PaymentStatus, PaymentStatusDate, SourcePayment, Description, SourceID_Estado, SourceID_Origem, SystemEntryDate, TimestampDate, CustomerID, Estado, ID_Moeda, TaxaMoeda, ID_DocumentoMain, Tipo_DocumentoMain) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dssssssssssssssdsds", $serie_recibo, $atcud, $period, $transactiondate, $PaymentType, $PaymentStatus, $PaymentStatusDate, $sourcePayment, $observacoes_recibo, $sourceID_Estado, $sourceID_Origem, $systemEntryDate, $timestamp, $CustomerID, $estado, $moedaFat, $taxaFat, $idFatura, $tipoDocOrigem );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS005";
			$response["message"] = $stmt -> error;
			$response["result"] = 1;
			return $reponse;
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS006";
		$response["message"] = $sqli_connection -> error;
		$response["result"] = 1;
		return $reponse;
	}
	//GET DOCUMENT ID
	$query = "SELECT ID_Recibo FROM faturacao_recibos WHERE TimestampDate = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("s", $timestamp);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FATS007";
			$response["message"] = $stmt -> error;
			$response["result"] = 1;
			return $reponse;
		}
		$stmt -> bind_result($idRecibo);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FATS008";
		$response["message"] = $sqli_connection -> error;
		$response["result"] = 1;
		return $reponse;
	}
	if( $idRecibo < 1){
		$response["errors"] = true;
		$response["type"] = "FATS009";
		$response["message"] = "Recibo inválido";
		$response["result"] = 1;
		return $reponse;
	}
	//------------------------------------------------------------------------

	//PROCESS LINES ----------------------------------------------------------
	$numLinha = 1;
	foreach ($linhas as $linha) {
		//init vars
		$originatingOn = '';
		$invoiceDate = '';
		$debitAmount = 0;
		$creditAmount = 0;
		$retencao = 0;

		//GET DOCUMENT DATA ---------------------------------------------------
		switch ( $linha['tipo'] ) {
			case 'FT':
				$query = "SELECT InvoiceType, (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie) AS Serie, Numero, InvoiceDate, TotalLiquidadoDocumento, GrossTotal, TaxPayable, TotaRetencao, Estado FROM faturacao_faturas WHERE ID_Fatura = ?";
				$queryUpdate = "UPDATE faturacao_faturas SET TotalLiquidadoDocumento=?, Estado=? WHERE ID_Fatura=?";
				break;
			case 'FS':
				$query = "SELECT InvoiceType, (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas_simplificadas.ID_Serie) AS Serie, Numero, InvoiceDate, TotalLiquidadoDocumento, GrossTotal, TaxPayable, TotaRetencao, Estado FROM faturacao_faturas_simplificadas WHERE ID_FaturaSimplificada = ?";
				$queryUpdate = "UPDATE faturacao_faturas_simplificadas SET TotalLiquidadoDocumento=?, Estado=? WHERE ID_FaturaSimplificada=?";
				break;
			case 'FR':
				# code...
				break;
			case 'ND':
				$query = "SELECT InvoiceType, (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_notas_debito.ID_Serie) AS Serie, Numero, InvoiceDate, TotalLiquidadoDocumento, GrossTotal, TaxPayable, TotaRetencao, Estado FROM faturacao_notas_debito WHERE ID_NotaDebito = ?";
				$queryUpdate = "UPDATE faturacao_notas_debito SET TotalLiquidadoDocumento=?, TotalLiquidado=?, Estado=? WHERE ID_NotaDebito=?";
				break;
			
			default:
				$response["errors"] = true;
				$response["type"] = "FATS010";
				$response["message"] = 'Tipo de Documento Inválido';
				deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
				$response["result"] = 1;
				return $reponse;
				break;
		}
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $linha['id_documento']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FATS011";
				$response["message"] = $stmt -> error;
				deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
				$response["result"] = 1;
				return $reponse;
			}
			$stmt -> bind_result($tipoDocumento, $serieDocumento, $numberDocumento, $dataDocumento, $totalLiquidadoDocumento, $totalDocumento, $ivaDocumento, $retencaoDocumento, $estadoDocumento);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FATS012";
			$response["message"] = $sqli_connection -> error;
			deleteRecord($idRecibo);
			resetDocumentPaymentTotals($idFatura, $typeDoc);
			$response["result"] = 1;
			return $reponse;
		}
		//--------------------------------------------------------------------
		//validations
		if( $estadoDocumento != 'Aberto' ){
			$response["errors"] = true;
			$response["type"] = "FATS013A";
			$response["message"] = "Documento já pago!";
			deleteRecord($idRecibo);
			resetDocumentPaymentTotals($idFatura, $typeDoc);
			$response["result"] = 1;
			return $reponse;
		}

		$dtRecTmp = DateTime::createFromFormat('d/m/Y', $data_recibo);
		$dtRecTimeStamp = $dtRecTmp->getTimestamp();

		$dtLine = DateTime::createFromFormat('Y-m-d', $dataDocumento);
		$dataLineTimestamp = $dtLine->getTimestamp();
		// $dataLineTimestamp = $dataLineTimestamp + 86400 + 86400 + 86400;

		//check if receipt date bigger than invoice date
		// if( $dtRecTimeStamp < $dataLineTimestamp){
		// 	$response["errors"] = true;
		// 	$response["type"] = "query";
		// 	$response["data_superior"] = "FATS013B";
		// 	$response["dataUltima"] = $dtLine->format('d/m/Y');
		// 	$response["message"] = "Data superior à data do documento.";
		// 	deleteRecord($idRecibo);
		// 	resetDocumentPaymentTotals($idFatura, $typeDoc);
		// 	$response["result"] = 1;
		// 	return $reponse;
		// }
		//--------------------------------------------------------------------
		
		//get Remaining values to use in calculations
		$totalFatura = $totalDocumento;
		$totalPagavelOrig = $totalDocumento - $totalLiquidadoDocumento;
		$ivaRestante = ($totalPagavelOrig * $ivaDocumento) / $totalFatura;
		$retencaoRestante = ($totalPagavelOrig * $retencaoDocumento) / $totalFatura; 

		$ivaRestante = round($ivaRestante,$numDecimais);
		$retencaoRestante = round($retencaoRestante,$numDecimais);
		
		$totalPagavel = $totalPagavelOrig - $retencaoRestante;

		//calculate values for this field
		$ivaPagamento = ($linha['valor_pagar'] * $ivaRestante) / $totalPagavel;
		$retencao = ($linha['valor_pagar'] * $retencaoRestante) / $totalPagavel;
		
		$ivaPagamento = round($ivaPagamento,$numDecimais);
		$retencao = round($retencao,$numDecimais);

		$creditAmount = ($linha['valor_pagar'] + $retencao) - $ivaPagamento;
		$totalPagamento = $linha['valor_pagar'];

		//validate payment totals
		$totalPagamento_tmp = round($totalPagamento,$numDecimais);
		$totalPagavel_tmp = round($totalPagavel,$numDecimais);
		// var_dump('totalPagamento - '.$totalPagamento);
		// var_dump('totalPagavel - '.$totalPagavel);
		// var_dump('totalPagamento_tmp - '.$totalPagamento_tmp);
		// var_dump('totalPagavel_tmp - '.$totalPagavel_tmp);
		if( $totalPagamento_tmp > $totalPagavel_tmp){ 
			$response["errors"] = true;
			$response["type"] = "FATS014";
			$response["message"] = "Valor inserido superior ao valor pagável!";
			deleteRecord($idRecibo);
			resetDocumentPaymentTotals($idFatura, $typeDoc);
			$response["result"] = 1;
			return $reponse;
		}elseif( $totalPagamento_tmp == $totalPagavel_tmp ){
			$totalPagamento = $totalPagavel;
		}
		// var_dump('totalPagamento2 - '.$totalPagamento);

		//TOTALS RECIBO
		$TaxPayable = $TaxPayable + $ivaPagamento;
		$NetTotal = $NetTotal + $creditAmount;
		$GrossTotal = $GrossTotal + $linha['valor_pagar'];
		$GrossTotalRecebido = $GrossTotalRecebido + $linha['valor_pagar'];
		$ValorRetencao = $ValorRetencao + $retencao;

		//process last fields
		$documentNumber = $tipoDocumento.' '.$serieDocumento.'/'.$numberDocumento;
		$documentDate = $dataDocumento;

		//INSERT INTO DB -----------------------------------------------------
		$query = "INSERT INTO faturacao_recibos_linhas (ID_Recibo, NumeroLinha, ID_Documento, TipoDocumento, OriginatingOn, InvoiceDate, DebitAmount, CreditAmount, ValorRetencao, valorIVA) 
			VALUES (?,?,?,?,?,?,?,?,?,?)";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("dddsssssss", $idRecibo, $numLinha, $linha['id_documento'], $linha['tipo'], $documentNumber, $documentDate, $debitAmount, $creditAmount, $retencao, $ivaPagamento );
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS015";
				$response["message"] = $stmt -> error;
				deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
				$response["result"] = 1;
				return $reponse;
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS016";
			$response["message"] = $sqli_connection -> error;
			deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
			$response["result"] = 1;
			return $reponse;
		}
		//--------------------------------------------------------------------
		
		//UPDATE DOCUMENT ----------------------------------------------------
		$valorPagavelDocumento = $totalDocumento - $totalLiquidadoDocumento;
		$totLiquidadoDoc = $totalPagamento + $retencao;

		$valorPagavelDocumento = round($valorPagavelDocumento,$numDecimais);
		$totLiquidadoDoc = round($totLiquidadoDoc,$numDecimais);

		$estadoProcDoc = 'Aberto';
		if( $totLiquidadoDoc > $valorPagavelDocumento ){
			$response["errors"] = true;
			$response["type"] = "FATS016A";
			$response["message"] = "Valor inserido superior ao valor pagável!";
			deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
			$response["result"] = 1;
			return $reponse;
		}else if($totLiquidadoDoc == $valorPagavelDocumento){
			$estadoProcDoc = 'Pago';
		}

		//update document totals
		if( $estadoProcDoc == 'Pago' ) $totLiquidadoSUM = $totalDocumento;
		else $totLiquidadoSUM = $totalPagamento + $retencao + $totalLiquidadoDocumento;
		// $totLiquidadoSUM = round($totLiquidadoSUM,2);


		if ($stmt = $sqli_connection -> prepare($queryUpdate)) {
			if( $linha['tipo'] == 'ND' ) $stmt -> bind_param("sssd", $totLiquidadoSUM, $totLiquidadoSUM, $estadoProcDoc, $linha['id_documento']);
			else $stmt -> bind_param("ssd", $totLiquidadoSUM, $estadoProcDoc, $linha['id_documento']);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS017";
				$response["message"] = $stmt -> error;
				deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
				$response["result"] = 1;
				return $reponse;
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS018";
			$response["message"] = $sqli_connection -> error;
			deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
			$response["result"] = 1;
			return $reponse;
		}
		//--------------------------------------------------------------------
		
		$numLinha++;
	}
	//------------------------------------------------------------------------

	//UPDATE TOTALS RECEIPT AND STORE PAYMENTS LINES -------------------------
		//TOTALS RECIBO
		// $TaxPayable = $TaxPayable + $ivaPagamento;
		// $NetTotal = $NetTotal + $creditAmount;
		// $GrossTotal_Rec = round($GrossTotal,2);
		$GrossTotal_Rec = $GrossTotal;
		$GrossTotalRecebido_Rec = round($GrossTotalRecebido,$numDecimais);
		// $ValorRetencao_Rec = round($ValorRetencao,2);
		$ValorRetencao_Rec = $ValorRetencao;

		//get payment mechanism 
		$query = "SELECT Codigo FROM faturacao_metodos_pagamento WHERE ID_Metodo = ?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("d", $pagamento_recibo);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FATS007";
				$response["message"] = $stmt -> error;
				deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
				$response["result"] = 1;
				return $reponse;
			}
			$stmt -> bind_result($mechanism);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FATS008";
			$response["message"] = $sqli_connection -> error;
				deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
			$response["result"] = 1;
			return $reponse;
		}

		//insert into receipt payments lines
		$query = "INSERT INTO faturacao_recibos_pagamentos (ID_Recibo, PaymentMechanism, PaymentAmount, PaymentDate, ID_Metodo, ID_Banco) 
			VALUES (?,?,?,?,?,?)";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("dsssdd", $idRecibo, $mechanism, $GrossTotalRecebido_Rec, $transactiondate, $pagamento_recibo, $bancoFinalID );
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS019";
				$response["message"] = $stmt -> error;
				deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
				$response["result"] = 1;
				return $reponse;
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS020";
			$response["message"] = $sqli_connection -> error;
			deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
			$response["result"] = 1;
			return $reponse;
		}

		//update receipt totals
		$query = "UPDATE faturacao_recibos SET Numero=((SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_recibos WHERE ID_Serie=?) AS SubNumeroMax) + 1), TaxPayable=?, NetTotal=?, GrossTotal=?, TotalRecebido=?, ValorRetencao=? WHERE ID_Recibo=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("dsssssd", $serie_recibo, $TaxPayable, $NetTotal, $GrossTotal_Rec, $GrossTotalRecebido_Rec, $ValorRetencao_Rec, $idRecibo);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS021";
				$response["message"] = $stmt -> error;
				deleteRecord($idRecibo);
					resetDocumentPaymentTotals($idFatura, $typeDoc);
				$response["result"] = 1;
				return $reponse;
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS022";
			$response["message"] = $sqli_connection -> error;
			deleteRecord($idRecibo);
					resetDocumentPaymentTotals($idFatura, $typeDoc);
			$response["result"] = 1;
			return $reponse;
		}

	//------------------------------------------------------------------------

	//UPDATES TOTALS ---------------------------------------------------------
	// $totalLiquidado = $liquidadoTotalFatura + $GrossTotal + $ValorRetencao;
	// $totalLiquidado_tmp = round($totalLiquidado,2);
	// $totalPagarFatura_tmp = round($totalPagarFatura,2);

	//GET SUM FROM tables
	$query = "SELECT SUM(TotalLiquidado) FROM faturacao_notas_debito WHERE ID_Documento_Origem=? AND Tipo_Documento_Origem=? AND Estado IN ('Aberto','Pago')";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("ds", $idFatura, $typeDoc );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FATS022A";
			$response["message"] = $stmt -> error;
			deleteRecord($idRecibo);
			resetDocumentPaymentTotals($idFatura, $typeDoc);
			$response["result"] = 1;
			return $reponse;
		}
		$stmt -> bind_result($totLiqND_DocOrigin);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FATS022B";
		$response["message"] = $sqli_connection -> error;
			deleteRecord($idRecibo);
			resetDocumentPaymentTotals($idFatura, $typeDoc);
		$response["result"] = 1;
		return $reponse;
	}
	//GET SUM FROM tables
	$query = "SELECT SUM(TotalLiquidadoDocumento) FROM ".$tableName." WHERE ".$fieldIdName."=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idFatura );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FATS022C";
			$response["message"] = $stmt -> error;
			deleteRecord($idRecibo);
			resetDocumentPaymentTotals($idFatura, $typeDoc);
			$response["result"] = 1;
			return $reponse;
		}
		$stmt -> bind_result($totDocLiq_DocOrigin);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FATS022D";
		$response["message"] = $sqli_connection -> error;
			deleteRecord($idRecibo);
			resetDocumentPaymentTotals($idFatura, $typeDoc);
		$response["result"] = 1;
		return $reponse;
	}

	$totalLiquidado = $totLiqND_DocOrigin + $totDocLiq_DocOrigin;
	$totalLiquidado_tmp = round($totalLiquidado,$numDecimais);
	$totalPagarFatura_tmp = round($totalPagarFatura,$numDecimais);

	$estadoProcessed = 'Aberto';
	if( $totalLiquidado_tmp > $totalPagarFatura_tmp){
		$response["errors"] = true;
		$response["type"] = "query";
		$response["valor"] = $totalLiquidado_tmp;
		$response["valor2"] = $totalPagarFatura_tmp;
		$response["line"] = "FATS023";
		$response["message"] = "Valores superiores ao Total Payable!";
		deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
		$response["result"] = 1;
		return $reponse;
	}else if($totalLiquidado_tmp == $totalPagarFatura_tmp){
		$estadoProcessed = 'Pago';
	}else{
		$estadoProcessed = 'Aberto';
	}

	$query = "UPDATE ".$tableName." SET TotalLiquidado=?, Estado=? WHERE ".$fieldIdName."=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("ssd", $totalLiquidado, $estadoProcessed, $idFatura);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS024";
			$response["message"] = $stmt -> error;
			deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
			$response["result"] = 1;
			return $reponse;
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS025";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
		$response["result"] = 1;
		return $reponse;
	}
	//------------------------------------------------------------------------

	//BLOCK BANK ----------------------------------------------------------
	$query = "UPDATE faturacao_bancos SET Usado=1 WHERE ID_Banco=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $bancoFinalID);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA001";
			$response["message"] = $stmt -> error;
			deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
			$response["result"] = 1;
			return $reponse;
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA002";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
		$response["result"] = 1;
		return $reponse;
	}
	//------------------------------------------------------------------------

	//------------------------------------------------------------------------
	//-------------- LANÇAMENTO DE MOVIMENTOS CONTABILISTICOS ----------------
	//------------------------------------------------------------------------
	$totalPVP = $GrossTotal_Rec;
	$totalUnit = $NetTotal;
	$totalTVA = $TaxPayable;
	//GET DETAILS
	$query = "SELECT PlanoContas, PlanoContasBanco, CustomerID, 
				(SELECT CONCAT(Nome, ' ',Apelido) FROM faturacao_clientes WHERE faturacao_clientes.ID_Cliente = faturacao_faturas.ID_Cliente) AS Cliente, CONCAT('FA ',(SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_faturas.ID_Serie),'/',faturacao_faturas.Numero) AS DocumentoOrigem
			FROM faturacao_faturas WHERE ID_Fatura=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idFatura);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS026";
			$response["message"] = $stmt -> error;
			deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
			$response["result"] = 1;
			return $reponse;
		}
		$stmt -> bind_result($planoCliente, $planoBanco, $numCliente, $nomeCliente, $RefDocOrigem );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS027";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
		$response["result"] = 1;
		return $reponse;
	}
	//GET DETAILS RECEIPT
	$query = "SELECT (SELECT Nome FROM faturacao_series WHERE faturacao_series.ID_Serie = faturacao_recibos.ID_Serie) AS Serie, Numero
			FROM faturacao_recibos WHERE ID_Recibo=?";
	if ( $stmt = $sqli_connection -> prepare($query) ) {
		//bind params
		$stmt -> bind_param("d", $idRecibo);
		//result single
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS028";
			$response["message"] = $stmt -> error;
			deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
			$response["result"] = 1;
			return $reponse;
		}
		$stmt -> bind_result($serieRecib, $numRecib );
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS029";
		$response["message"] = $sqli_connection -> error;
		deleteRecord($idRecibo);
			resetDocumentPaymentTotals($idFatura, $typeDoc);
		$response["result"] = 1;
		return $reponse;
	}

	//PROCESS MOVEMENT FOR DOCUMENT
	$texto = $data2[1273]['trad'].' - '.$serieRecib.'/'.$numRecib.' - '.$RefDocOrigem.' - '.$numCliente.' - '.$nomeCliente;
	/*if($planoCliente > 0){
		$tipoMovimento = 'C';
		insertMovimentoContabilistico($planoCliente, $texto, $totalPVP, 0, 0, $tipoMovimento);
	}*/
	
	$reste = $payable - $paye;
	$reste = round($reste,$numDecimais);
	if(strpos($escompte, "%") !== false) {
		$escompte = str_replace("%", "", $escompte);
		$escompte = $payable/100*$escompte;
	}
	$escompte = round($escompte, $numDecimais);
	if( $reste <= $escompte){
		$planEscompte = "3290";
		//insert le reste et on est bon?
		$estadoProcDoc = 'Pago';
		$pourcentTVA = $TotalTaxe / $TotalFacture;
		$TotalTVA = $reste * $pourcentTVA;
		$TotalSTaxe = $reste - $TotalTVA;
		$TotalSTaxe = round($TotalSTaxe, $numDecimais);
		
		
		$pourcentTVA = $pourcentTVA * 100;
		
		$query = "INSERT INTO faturacao_recibos (ID_Serie, ATCUD, Period, TransactionDate, PaymentType, PaymentStatus, PaymentStatusDate, SourcePayment, Description, SourceID_Estado, SourceID_Origem, SystemEntryDate, TimestampDate, CustomerID, Estado, ID_Moeda, TaxaMoeda, ID_DocumentoMain, Tipo_DocumentoMain) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("dssssssssssssssdsds", $serie_recibo, $atcud, $period, $transactiondate, $PaymentType, $PaymentStatus, $PaymentStatusDate, $sourcePayment, $observacoes_recibo, $sourceID_Estado, $sourceID_Origem, $systemEntryDate, $timestamp, $CustomerID, $estado, $moedaFat, $taxaFat, $idFatura, $tipoDocOrigem );
			$result = $stmt -> execute();
			$idRecibo2 = $stmt->insert_id;
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS005";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS006";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		//GET DOCUMENT ID
		/*$query = "SELECT ID_Recibo FROM faturacao_recibos WHERE TimestampDate = ?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("s", $timestamp);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "FATS007";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($idRecibo2);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "FATS008";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}*/
		if( $idRecibo2 < 1){
			$response["errors"] = true;
			$response["type"] = "FATS009";
			$response["message"] = "Recibo inválido";
			die(json_encode($response));
		}
		$type = 'FT';
		$zero = 0;
		$query = "INSERT INTO faturacao_recibos_linhas (ID_Recibo, NumeroLinha, ID_Documento, TipoDocumento, OriginatingOn, InvoiceDate, DebitAmount, CreditAmount, ValorRetencao, valorIVA) 
			VALUES (?,?,?,?,?,?,?,?,?,?)";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("dddsssssss", $idRecibo2, $numLinha, $idFatura, $type, $documentNumber, $documentDate, $zero, $reste, $zero, $zero);
			$result = $stmt -> execute();
			$idLinhaRecibo = $stmt->insert_id;
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS015";
				$response["message"] = $stmt -> error;
				// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS016";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idRecibo);
			// resetDocumentPaymentTotals($idFatura, $typeDoc);
			die(json_encode($response));
		}
		$query = "INSERT INTO faturacao_recibos_pagamentos (ID_Recibo, PaymentMechanism, PaymentAmount, PaymentDate, ID_Metodo, ID_Banco) 
		VALUES (?,?,?,?,?,?)";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("dsssdd", $idRecibo2, $mechanism, $reste, $transactiondate, $pagamento_recibo, $bancoFinalID );
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS019";
				$response["message"] = $stmt -> error;
				// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS020";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
			die(json_encode($response));
		}

		//update receipt totals
		$queryStmt = "SELECT MAX(Numero) AS NumeroMax FROM faturacao_recibos WHERE ID_Serie=".intval($serie_recibo).";";
		$maxID2 = $maxID + 1;
		$initNumber = getInitNumber("NumeroInicial_RG","faturacao_series", "WHERE ID_Serie=?", $serie_recibo);
		$query = "UPDATE faturacao_recibos SET Numero=?, ID_Serie=?, TaxPayable=?, NetTotal=?, GrossTotal=?, TotalRecebido=?, ValorRetencao=? WHERE ID_Recibo=?";
		if ($stmt = $sqli_connection -> prepare($query)) {
			$stmt -> bind_param("ddsssssd", $maxID2, $serie_recibo, $zero, $reste, $reste, $reste, $zero, $idRecibo2);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS021";
				$response["message"] = $stmt -> error;
				// deleteRecord($idRecibo);
					// resetDocumentPaymentTotals($idFatura, $typeDoc);
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS022";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idRecibo);
					// resetDocumentPaymentTotals($idFatura, $typeDoc);
			die(json_encode($response));
		}
		$queryUpdate = "UPDATE faturacao_faturas SET TotalLiquidadoDocumento=?, TotalLiquidado=?, Estado=?, TotalExtra=( ? + TotalExtra ) WHERE ID_Fatura=?";
		if ($stmt = $sqli_connection -> prepare($queryUpdate)) {
			// if( $linha['tipo'] == 'ND' ) $stmt -> bind_param("sssd", $totLiquidadoSUM, $totLiquidadoSUM, $estadoProcDoc, $linha['id_documento']);
			// else $stmt -> bind_param("ssd", $totLiquidadoSUM, $estadoProcDoc, $linha['id_documento']);
			$stmt -> bind_param("ssssd", $payable, $payable, $estado, $zero, $idFatura);
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS017";
				$response["message"] = $stmt -> error;
				// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
				die(json_encode($response));
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS018";
			$response["message"] = $sqli_connection -> error;
			// deleteRecord($idRecibo);
				// resetDocumentPaymentTotals($idFatura, $typeDoc);
			die(json_encode($response));
		}
		$tipoMovimentoBanco = 'D';
		$totalArticles = 0;
		$query = "SELECT PlanoContas, TotalLinhaSIVA FROM faturacao_faturas_linhas WHERE ID_Fatura=? ORDER BY ID_Linha";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $idFatura);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA030";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($planoArtigo, $TotalArtSTaxe);
			while ($stmt -> fetch()) {
				//PROCESS MOVEMENT ARTICLE
				if($planoArtigo > 0){
					$dataArtigos[$planoArtigo] += $TotalArtSTaxe;
					$totalArticles += $TotalArtSTaxe;
				}
			}
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA031";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		if(isset($dataArtigos)){
			foreach ($dataArtigos as $key => $value) {
				$pourcentArticle = $value/$totalArticles;
				$keepTaxePercent = $TotalSTaxe * $pourcentArticle;
				$pourcentArticle = round($pourcentArticle, $numDecimais);
				$textoSTaxe = $texto.' - '.$data2[1980]['trad'].' '.$key;
				insertMovimentoContabilisticoManual($key, "3290", $textoSTaxe, $keepTaxePercent, 0, 0, $tipoMovimentoBanco, $data_recibo);
			}
		}
		//Old version avant de prendre en compte les plans comptables des articles.
		//insertMovimentoContabilisticoManual("3400", "3290", $textoSTaxe, $TotalSTaxe, 0, 0, $tipoMovimentoBanco, $data_recibo);
		
		$textoTVA = $texto.' - '.$data2[1981]['trad'];
		
		//Calculer combien de taxe dans l'escompte et tranferer de TVA a Escompte
		insertMovimentoContabilisticoManual("2200", "3290", $textoTVA, $TotalTVA, 0, 0, $tipoMovimentoBanco, $data_recibo, null, 0, 0, 1, $pourcentTVA);
	}

	//PROCESS MOVEMENT FOR DOCUMENT
	if($planoBanco > 0){
		$query = "SELECT 
				(SELECT Nome FROM faturacao_bancos WHERE faturacao_bancos.ID_Banco = faturacao_faturas.ID_Banco) AS Banco
			FROM faturacao_faturas WHERE ID_Fatura=?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $idFatura);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FATS030";
				$response["message"] = $stmt -> error;
				deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
				$response["result"] = 1;
				return $reponse;
			}
			$stmt -> bind_result($nomeBanco);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS031";
			$response["message"] = $sqli_connection -> error;
			deleteRecord($idRecibo);
				resetDocumentPaymentTotals($idFatura, $typeDoc);
			$response["result"] = 1;
			return $reponse;
		}
		//MOVEMENT
		$textoBanco = $texto.' - '.$data2[123]['trad'].': '.$nomeBanco;
		$tipoMovimentoBanco = 'D';
		// insertMovimentoContabilistico($planoBanco, $textoBanco, $totalPVP, 0, 0, $tipoMovimentoBanco);
		insertMovimentoContabilistico($planoBanco, $planoCliente, $textoBanco, $totalPVP, 0, 0, $tipoMovimentoBanco);
	} else {
		$tipoMovimento = 'D';
		insertMovimentoContabilistico('', $planoCliente, $texto, $totalPVP, 0, 0, $tipoMovimento);
	}
	//------------------------------------------------------------------------
	//------------------------------------------------------------------------


	//log sistema - processo
	$descricao_log ="Paiement de facture (id: ".$idFatura.", valeur: ".number_format($GrossTotal, 2, '.', '\'' )." CHF)";
	insert_log(0,"Inserir",$descricao_log,$sqli_connection);

	//response
	$response["fatura"] = $idFatura;
	$response["errors"] = false;
	$response["result"] = 0;
	return $reponse;
}

//remove inserted Enregistrer if gives an error
function deleteRecord($idObject){
	global $sqli_connection;

	//DELETE DB -------------------------------------------------------------
	$query = "DELETE FROM faturacao_recibos WHERE ID_Recibo=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM001";
			$response["message"] = $stmt -> error;
			$response["result"] = 1;
			return $reponse;
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM002";
		$response["message"] = $sqli_connection -> error;
		$response["result"] = 1;
		return $reponse;
	}
	//LINHAS
	$query = "DELETE FROM faturacao_recibos_linhas WHERE ID_Recibo=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM003";
			$response["message"] = $stmt -> error;
			$response["result"] = 1;
			return $reponse;
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM004";
		$response["message"] = $sqli_connection -> error;
		$response["result"] = 1;
		return $reponse;
	}
	//PAGAMENTOS
	$query = "DELETE FROM faturacao_recibos_pagamentos WHERE ID_Recibo=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $idObject );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "REM004";
			$response["message"] = $stmt -> error;
			$response["result"] = 1;
			return $reponse;
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "REM005";
		$response["message"] = $sqli_connection -> error;
		$response["result"] = 1;
		return $reponse;
	}
	//----------------------------------------------------------------------	
}
?>