<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';
$data = "";

//GET POST VARS ---------------------------------------------------------
$idFatura = $_GET['idFatura'];

//DEFINE VARS ------------------------------------------------------------
$objectData = array();

//VERIFICA SE HA NULOS --------------------------------------------------
if ( $idFatura == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}
$query = "select faturacao_responsaveis.Email from faturacao_responsaveis,faturacao_responsavel_entidades,faturacao_faturas where faturacao_responsaveis.ID_Responsavel = faturacao_responsavel_entidades.ID_Responsavel and faturacao_responsavel_entidades.ID_Cliente = faturacao_faturas.ID_Cliente and faturacao_faturas.ID_Fatura =?";
if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idFatura);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($mail);
	while ($stmt -> fetch()) {
		$maillist[] = array(
		        	"mail" => $mail
		        );
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002A";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//response
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));
?>