<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET POST VARS ---------------------------------------------------------
$idGuia = $_POST['idGuia'];
$cliente = $_POST['cliente'];
$serie = $_POST['serie'];
$numero = $_POST['numero'];
$data = $_POST['data'];
$validade = $_POST['validade'];
$referencia = $_POST['referencia'];
$pagamento = $_POST['pagamento'];
$banco = $_POST['banco'];
$vencimento = $_POST['vencimento'];
$moeda = $_POST['moeda'];
$desconto = $_POST['desconto'];
$observacoes = $_POST['observacoes'];
$linhas = $_POST['linhas'];
$finalizarDocumento = $_POST['finalizarDocumento'];
$precisaBanco = $_POST['precisaBanco'];
//novos Campos
$data_carga_guia = $_POST['data_carga_guia'];
$hora_carga_guia = $_POST['hora_carga_guia'];
$endereco_carga_guia = $_POST['endereco_carga_guia'];
$codigopostal_carga_guia = $_POST['codigopostal_carga_guia'];
$cidade_carga_guia = $_POST['cidade_carga_guia'];
$pais_carga_guia = $_POST['pais_carga_guia'];
$data_descarga_guia = $_POST['data_descarga_guia'];
$hora_descarga_guia = $_POST['hora_descarga_guia'];
$endereco_descarga_guia = $_POST['endereco_descarga_guia'];
$codigopostal_descarga_guia = $_POST['codigopostal_descarga_guia'];
$cidade_descarga_guia = $_POST['cidade_descarga_guia'];
$pais_descarga_guia = $_POST['pais_descarga_guia'];
$matricula_carga_guia = $_POST['matricula_carga_guia'];
$regiao_carga_guia = $_POST['regiao_carga_guia'];
$regiao_descarga_guia = $_POST['regiao_descarga_guia'];

//REMAIN FIELDS ----------------------------------------------------------
$vendedor = $_SESSION['username'];
$estado = 'Rascunho';
$taxPayable = 0;
$netTotal = 0;
$grossTotal = 0;
$systemEntryDate = '';
$timestamp = 0;
$totalDesconto = 0;
$percentagemDesconto = $desconto;
$retencaoTotal = 0;
$totalSDesconto = 0;

//NEW FIELDS FATURAS -----------------------------------------------------
$invoiceType = 'GT';
$EACCode = '';
$customerID = '';
$totalPagar = 0;
// MetodoPagamento
// BancoID
$invoiceStatusDate = '';
$sourceID = $_SESSION['username'];
$hash = '';
$hashControl = 1;
$hashPrint = '';
$period = '';
$invoiceDate = '';
$movementEndTime = '';
$movementStartTime = '';
$totalLiquidado = 0;


//VERIFICA SE HA NULOS ---------------------------------------------------
// var_dump($idGuia, $cliente, $serie, $numero, $data, $validade, $pagamento, $data_carga_guia, $hora_carga_guia, $endereco_carga_guia, $codigopostal_carga_guia, $cidade_carga_guia, $pais_carga_guia, $data_descarga_guia, $hora_descarga_guia, $endereco_descarga_guia, $codigopostal_descarga_guia, $cidade_descarga_guia, $pais_descarga_guia);die();
if ( $idGuia == '' || $cliente == '' || $serie == '' || $numero == '' || $data == '' || $validade == '' || $pagamento == '' || $hora_descarga_guia == '' || $endereco_descarga_guia == '' || $codigopostal_descarga_guia == '' || $cidade_descarga_guia == '' || $pais_descarga_guia == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000A";
	die(json_encode($response));
}
if( $precisaBanco > 0 && ($banco < 1 || $banco == '') )
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS0000B";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//CHECK LINES
if(!is_array($linhas) || empty($linhas)){
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000x";
	$response["lines_empty"] = true;
	$response["message"] = "";
	die(json_encode($response));
}
//-----------------------------------------------------------------------

//GET CLIENT DATA --------------------------------------------------------
$query = "SELECT Nif, Endereco, CodigoPostal, Cidade, Regiao, Pais, Email, Codigo, vencimento FROM faturacao_clientes WHERE ID_Cliente = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $cliente);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($Nif, $Endereco, $CodigoPostal, $Cidade, $Regiao, $Pais, $Email, $CodigoCliente, $vencimento );
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//process fields
if( trim($Endereco) == '' ) $Endereco = 'Desconhecido';
if( trim($CodigoPostal) == '' ) $CodigoPostal = 'Desconhecido';
if( trim($Cidade) == '' ) $Cidade = 'Desconhecido';
if( trim($Regiao) == '' ) $Regiao = 'Desconhecido';
if( trim($Pais) == '' ) $Pais = 'Desconhecido';
//------------------------------------------------------------------------

//GET CURRENCY DATA ------------------------------------------------------
$query = "SELECT  Ultima_Taxa FROM faturacao_moedas WHERE ID_Moeda = ?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $moeda);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA003";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($ultimaTaxa);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA004";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if( $ultimaTaxa <= 0){
	$response["errors"] = true;
	$response["type"] = "FTGA005";
	$response["message"] = "Moeda inválida";
	die(json_encode($response));
}
//------------------------------------------------------------------------

//GET COMPANY DATA -------------------------------------------------------
$query = "SELECT  CAE_Principal FROM faturacao_empresa_dados WHERE ID_dados_empresa = 1";
if ($stmt = $sqli_connection -> prepare($query)) {
	// $stmt -> bind_param("d", $moeda);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA006";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($CAE_Principal);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA007";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

$timestamp = microtime(true);
$systemEntryDate = date("Y-m-d H:i:s");
$systemEntryDate = str_replace (' ','T',$systemEntryDate);
$EACCode = $CAE_Principal;
$customerID = $CodigoCliente;
if( $precisaBanco > 0 ){
	$bancoFinalID = $banco;
}else{
	$bancoFinalID = 0;
}

//INSERT OPEN DOCUMENT ---------------------------------------------------
$query = "UPDATE faturacao_guias_transporte SET ID_Cliente=?, EnderecoCliente=?, CodigoPostalCliente=?, CidadeCliente=?, RegiaoCliente=?, EmailCliente=?, PaisCliente=?, ID_Moeda=?, TaxaMoeda=?, Vendedor=?, Vencimento=?, ID_Serie=?, Data=?, Validade=?, Referencia=?, Observacoes=?, SystemEntryDate=?, TimeStampDate=?, Estado=?, ID_Utilizador=?, InvoiceType=?, EACCode=?, CustomerID=?, MetodoPagamento=?, ID_Banco=? WHERE ID_GuiaTransporte=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dssssssdsssdsssssssdsssddd", $cliente, $Endereco, $CodigoPostal, $Cidade, $Regiao, $Email, $Pais, $moeda, $ultimaTaxa, $vendedor, $vencimento, $serie, $data, $validade, $referencia, $observacoes, $systemEntryDate, $timestamp, $estado, $id_utilizador, $invoiceType, $EACCode, $customerID, $pagamento, $bancoFinalID, $idGuia );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA010";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA011";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//CLEAN ALL LINES --------------------------------------------------------
$query = "DELETE FROM faturacao_guias_transporte_linhas WHERE ID_GuiaTransporte=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $idGuia );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA012";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA013";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//UPDATE CARGA DESCARGA --------------------------------------------------
//process fields
if( trim($endereco_carga_guia) == '' ) $endereco_carga_guia = 'Desconhecido';
if( trim($codigopostal_carga_guia) == '' ) $codigopostal_carga_guia = 'Desconhecido';
if( trim($cidade_carga_guia) == '' ) $cidade_carga_guia = 'Desconhecido';
if( trim($regiao_carga_guia) == '' ) $regiao_carga_guia = 'Desconhecido';
if( trim($pais_carga_guia) == '' ) $pais_carga_guia = 'Desconhecido';

if( trim($endereco_descarga_guia) == '' ) $endereco_descarga_guia = 'Desconhecido';
if( trim($codigopostal_descarga_guia) == '' ) $codigopostal_descarga_guia = 'Desconhecido';
if( trim($cidade_descarga_guia) == '' ) $cidade_descarga_guia = 'Desconhecido';
if( trim($regiao_descarga_guia) == '' ) $regiao_descarga_guia = 'Desconhecido';
if( trim($pais_descarga_guia) == '' ) $pais_descarga_guia = 'Desconhecido';

//update
$query = "UPDATE faturacao_guias_transporte SET EnderecoCarga=?, CodigoPostalCarga=?, CidadeCarga=?, RegiaoCarga=?, DataCarga=?, DataDescarga=?, HoraCarga=?, HoraDescarga=?, EnderecoDescarga=?, CodigoPostalDescarga=?, CidadeDescarga=?, RegiaoDescarga=?, DeliveryID=?, PaisCarga=?, PaisDescarga=? WHERE ID_GuiaTransporte=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sssssssssssssssd", $endereco_carga_guia, $codigopostal_carga_guia, $cidade_carga_guia, $regiao_carga_guia, $data_carga_guia, $data_descarga_guia, $hora_carga_guia, $hora_descarga_guia, $endereco_descarga_guia, $codigopostal_descarga_guia, $cidade_descarga_guia, $regiao_descarga_guia, $matricula_carga_guia, $pais_carga_guia, $pais_descarga_guia, $idGuia);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA021";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA022";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------


//PROCESS LINES ----------------------------------------------------------
$numLinha = 1;
foreach ($linhas as $linha) {
	//init vars
	$ProductDescription = '';
	$ProductCode = '';
	$SerialNumber = '';
	$TaxType = '';
	$TaxCountryRegion = '';
	$TaxCode = '';
	$TaxPercentage = '';
	$impostoUsed = '';
	$TaxExemptionCode = '';
	$TaxExemptionReason = '';
	$TaxPointDate = date("Y-m-d");	

	//GET ARTICLE DATA ---------------------------------------------------
	$query = "SELECT  Nome, Codigo, SerialNumber, (SELECT Sigla FROM faturacao_unidades WHERE faturacao_unidades.ID_Unidade = faturacao_artigos.ID_Unidade) AS Unidade FROM faturacao_artigos WHERE ID_Artigo = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $linha['artigo']);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA015";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($ProductDescription, $ProductCode, $SerialNumber, $Unidade);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA016";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//--------------------------------------------------------------------
	
	//GET TAXES DATA -----------------------------------------------------
	$query = "SELECT  Tipo, Regiao, Subclasse, Valor FROM faturacao_impostos WHERE ID_Imposto = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $linha['imposto']);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA017";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($TaxType, $TaxCountryRegion, $TaxCode, $TaxPercentage);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA018";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
		//VERIFICAR SE IMPOSTO JÁ BLOQUEADO -------------------------------------
		$query = "SELECT COUNT(*) FROM faturacao_impostos_usados WHERE ID_Imposto=?";
		if ( $stmt = $sqli_connection -> prepare($query) ) {
			//bind params
			$stmt -> bind_param("d", $linha['imposto']);
			//result single
			$result = $stmt -> execute();
			if (false === $result) {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA018A";
				$response["message"] = $stmt -> error;
				die(json_encode($response));
			}
			$stmt -> bind_result($impostoUsed);
			$stmt -> fetch();
			$stmt -> close();
		} else {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA018B";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
		if($impostoUsed < 1){
			//INSERT DB --------------------------------------------------
			$query = "INSERT INTO faturacao_impostos_usados(ID_Imposto) VALUES (?)";
			if ($stmt = $sqli_connection -> prepare($query)) {
				$stmt -> bind_param("d", $linha['imposto'] );
				$result = $stmt -> execute();
				if (false === $result) {
					$response["errors"] = true;
					$response["type"] = "query";
					$response["line"] = "FTGA018C";
					$response["message"] = $stmt -> error;
					die(json_encode($response));
				}
				$stmt -> close();
			} else {
				$response["errors"] = true;
				$response["type"] = "query";
				$response["line"] = "FTGA018D";
				$response["message"] = $sqli_connection -> error;
				die(json_encode($response));
			}
			//------------------------------------------------------------
		}

		//CASO SEJA TIPO ISE
		// if( $TaxCode == 'ISE' ){
		if( $TaxCode == 'ISENTO' ){
			if( $linha['motivo'] < 1){
				$response["errors"] = true;
				$response["type"] = "var";
				$response["line"] = "FTGA018E";
				$response["message"] = "Motivo de isenção inválido";
				die(json_encode($response));
			}else{
				$query = "SELECT  Codigo, Descricao FROM faturacao_motivos_isencao WHERE ID_Motivo = ?";
				if ($stmt = $sqli_connection -> prepare($query)) {
					$stmt -> bind_param("d", $linha['motivo']);
					$result = $stmt -> execute();
					if (false === $result) {
						$response["errors"] = true;
						$response["type"] = "FTGA018F";
						$response["message"] = $stmt -> error;
						die(json_encode($response));
					}
					$stmt -> bind_result($TaxExemptionCode, $TaxExemptionReason);
					$stmt -> fetch();
					$stmt -> close();
				} else {
					$response["errors"] = true;
					$response["type"] = "FTGA018G";
					$response["message"] = $sqli_connection -> error;
					die(json_encode($response));
				}
			}

		}
	//--------------------------------------------------------------------
	
	//check if vals are smaller than 0
	if( $linha['qtd'] <= 0 ){
		$response["errors"] = true;
		$response["type"] = "FTGA018H";
		$response["message"] = 'Valores das linhas menores que 0';
		die(json_encode($response));
	}
	if( $linha['preco'] < 0 ){
		$response["errors"] = true;
		$response["type"] = "FTGA018I";
		$response["message"] = 'Valores das linhas menores que 0';
		die(json_encode($response));
	}
	
	//TOTALS
	$debitAmount = 0;
	$creditAmount = 0;
	$settelementAmount = 0;
	$totalSIVA = 0;
	$totalLinha = 0;

	$linhaDesconto = $linha['desconto'] * 0.01;
	$descontoProcessed = $desconto * 0.01;
	$taxaIVA = $TaxPercentage * 0.01;
	$ivaProcessed = $taxaIVA + 1 ;

	$totalSIVA = $linha['qtd'] * $linha['preco'];
	$desconto1 = $totalSIVA * $linhaDesconto; //calcula desconto 1
	$totalSIVA = $totalSIVA - ($totalSIVA * $linhaDesconto); //calcula descunto linha
	$desconto2 = $totalSIVA * $descontoProcessed; //calcula desconto 2
	$totalSIVA = $totalSIVA - ($totalSIVA * $descontoProcessed); //calcula desconto global

	$settelementAmount = $desconto1 + $desconto2;
	$creditAmount = $totalSIVA;
	$totalLinha = $totalSIVA * $ivaProcessed;

	$retencao = $linha['retencao'] * 0.01;
	$retencao = $totalSIVA * $retencao;

	//TOTALS FATURA
	$taxPayable = $taxPayable + ($totalSIVA * $taxaIVA);
	$netTotal = $netTotal + $totalSIVA;
	$grossTotal = $taxPayable + $netTotal;
	// $grossTotal = round($grossTotal,2);
	$totalDesconto = $totalDesconto + $settelementAmount;
	if( $Nif != '999999990' ) $retencaoTotal = $retencaoTotal + $retencao;
	$totalSDesconto = $totalSDesconto + ( $linha['qtd'] * $linha['preco'] );

	//INSERT INTO DB -----------------------------------------------------
	$query = "INSERT INTO faturacao_guias_transporte_linhas (ID_GuiaTransporte, NumeroLinha, 
		ID_Artigo, ProductCode, ProductDescription, Quantidade, UnidadeMedida, PrecoUnitario, TaxPointDate, Descricao, SerialNumber, 
		ID_Imposto, TaxType, TaxCountryRegion, TaxCode, TaxPercentage, TaxExemptionReason, TaxExemptionCode, 
		DescontoLinha, CreditAmount, DebitAmount, SettlementAmount, ValorRetencao, PercentagemRetencao, TotalLinha, TotalLinhaSIVA) 
		VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dddssssssssdssssssssssssss", $idGuia, $numLinha, $linha['artigo'], $ProductCode, $ProductDescription, $linha['qtd'], $Unidade, $linha['preco'], $TaxPointDate, $linha['descricao'], $SerialNumber, $linha['imposto'], $TaxType, $TaxCountryRegion, $TaxCode, $TaxPercentage, $TaxExemptionReason, $TaxExemptionCode, $linha['desconto'], $creditAmount, $debitAmount, $settelementAmount, $retencao, $linha['retencao'], $totalLinha, $totalSIVA );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA019";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA020";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//--------------------------------------------------------------------
	
	$numLinha++;

	//BLOCK ARTICLE ------------------------------------------------------
	$query = "UPDATE faturacao_artigos SET Usado=1 WHERE ID_Artigo=?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $linha['artigo']);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA020A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA020B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	//--------------------------------------------------------------------
}
//------------------------------------------------------------------------

//UPDATES TOTALS ---------------------------------------------------------
$totalDesconto = round($totalDesconto,$numDecimais);
$retencaoTotal = round($retencaoTotal,$numDecimais);
$taxPayable = round($taxPayable,$numDecimais);
$netTotal = round($netTotal,$numDecimais);
$grossTotal = round($grossTotal,$numDecimais);
$grossTotal = roundPriceUp($grossTotal);
$totalPagar = $grossTotal;

$query = "UPDATE faturacao_guias_transporte SET TaxPayable=?, NetTotal=?, GrossTotal=?, Desconto=?, PercentagemDesconto=?, TotaRetencao=?, TotalSDesconto=?, TotalPagar=? WHERE ID_GuiaTransporte=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("ssssssssd", $taxPayable, $netTotal, $grossTotal, $totalDesconto, $percentagemDesconto, $retencaoTotal, $totalSDesconto, $totalPagar, $idGuia);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA021";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA022";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//CLOSE THE DOCUMENT -----------------------------------------------------
if( $finalizarDocumento > 0 ){
	$systemEntryDateUpdate = date("Y-m-d H:i:s");
	$systemEntryDateUpdate = str_replace (' ','T',$systemEntryDateUpdate);
	$invoiceStatusDate = date("Y-m-d H:i:s");
	$invoiceStatusDate = str_replace (' ','T',$invoiceStatusDate);
	$sourceID = $_SESSION['username'];
	$hash = 'TESTE';
	$hashControl = 1;
	$hashPrint = 'ABCD';
	$movementEndTime = '';
	// $retencaoCalc = round($retencaoTotal,2);
	$retencaoCalc = $retencaoTotal;
	// $totalLiquidado = $retencaoCalc;
	$totalLiquidado = 0;

	$dataNew = $data;
	$validadeNew = $validade;
	$dataAtualizacao = date("d/m/Y H:i:s");
	
	//process InvoiceDate and period to the choosen one
	/*$tempDate = DateTime::createFromFormat('d/m/Y', $data);
	$invoiceDate = $tempDate->format('Y-m-d');
	$period = $tempDate->format('m');
	
	//define start/end time
	$startDate = DateTime::createFromFormat('d/m/Y H:i', $data_carga_guia.' '.$hora_carga_guia);
	$movementStartTime = $startDate->format("Y-m-d H:i:s");
	$movementStartTime = str_replace (' ','T',$movementStartTime);

	$endDate = DateTime::createFromFormat('d/m/Y H:i', $data_descarga_guia.' '.$hora_descarga_guia);
	$movementEndTime = $endDate->format("Y-m-d H:i:s");
	$movementEndTime = str_replace (' ','T',$movementEndTime);

	$startTimeStamp = $startDate->getTimestamp();
	$endTimeStamp = $endDate->getTimestamp();

	if( $startTimeStamp > $endTimeStamp){
		$response["errors"] = true;
		$response["type"] = "FTGA023A";
		$response["carga_superior_descarga"] = true;
		$response["message"] = "Data/hora de carga superior à data/hora descarga.";
		die(json_encode($response));
	}

	//today -> now checker
	$todayCheck = DateTime::createFromFormat('Y-m-d H:i:s', date('Y-m-d H:i:s'));
	$todayTimeStamp = $todayCheck->getTimestamp();

	if( $todayTimeStamp > $startTimeStamp){
		$response["errors"] = true;
		$response["type"] = "FTGA023B";
		$response["today_superior_carga"] = true;
		$response["message"] = "Data/hora de carga inferior à data/hora atual.";
		die(json_encode($response));
	}*/

	//GET LAST DATE
	$query = "SELECT Numero, Data FROM faturacao_guias_transporte WHERE ID_Serie = ? AND Numero > 0 ORDER BY STR_TO_DATE( Data,  '%d/%m/%Y' ) DESC LIMIT 1";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("d", $serie);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "FTGA023";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> bind_result($numMax, $dataLast);
		$stmt -> fetch();
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "FTGA024";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	if( $numMax > 0){
		//last date timestamp
		$dtLast = DateTime::createFromFormat("d/m/Y H:i:s", $dataLast." 00:00:00");
		$dtLastTime = $dtLast->getTimestamp();

		//this entry validade timestamp
		$dtThisValidade = DateTime::createFromFormat("d/m/Y H:i:s", $validade." 00:00:00");
		$dtThisValidadeTime = $dtThisValidade->getTimestamp();

		//this entry date timestamp
		$dtThisDate = DateTime::createFromFormat("d/m/Y H:i:s", $data." 00:00:00");
		$dtThisDateTime = $dtThisDate->getTimestamp();

		//process new dates
		// if( $dtThisDateTime < $dtLastTime ){
		// 	// $dataNew = $dataLast;
		// 	// //update invoiceDate and period
		// 	// $invoiceDate = date("Y-m-d");
		// 	// $period = date("m");
		// 	// //define start time
		// 	// $movementStartTime = date("Y-m-d H:i:s");
		// 	// $movementStartTime = str_replace (' ','T',$movementStartTime);
			
		// 	//alert user that the date is before the last one
		// 	$response["errors"] = true;
		// 	$response["type"] = "FTGA024A";
		// 	$response["data_superior"] = true;
		// 	$response["dataUltima"] = $dataLast;
		// 	$response["message"] = "Data superior à última guia.";
		// 	die(json_encode($response));
		// }

		if( $dtThisValidadeTime < $dtThisDateTime ){
			$validadeNew = $data;
		}
	}

	// DEFINE NEW NUMBER
	$queryStmt = "SELECT MAX(Numero) AS NumeroMax FROM faturacao_guias_transporte WHERE ID_Serie=".intval($serie).";";
	$maxID = getMaxNumberDocument($queryStmt);
	$initNumber = getInitNumber("NumeroInicial_GT","faturacao_series", "WHERE ID_Serie=?", $serie);
	if($nextID < $initNumber && $maxID < 1){
		$query = "UPDATE faturacao_guias_transporte SET Numero = ".$initNumber.", ID_Serie=?, Data=?, Validade=?, ID_UtilizadorAtualizacao=?, DataAtualizacao=?, Estado='Aberto' WHERE ID_GuiaTransporte = ?";
	}else{
		$query = "UPDATE faturacao_guias_transporte SET Numero = ((SELECT NumeroMax FROM (SELECT MAX(Numero) AS NumeroMax FROM faturacao_guias_transporte WHERE ID_Serie=?) AS SubNumeroMax) + 1), Data=?, Validade=?, ID_UtilizadorAtualizacao=?, DataAtualizacao=?, Estado='Aberto' WHERE ID_GuiaTransporte = ?";
	}
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dssdsd", $serie, $dataNew, $validadeNew, $id_utilizador, $dataAtualizacao, $idGuia);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA025";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	// UPDATE REMAIN FIELDS
	$query = "UPDATE faturacao_guias_transporte SET InvoiceStatusDate=?, SourceID=?, Hash=?, HashControl=?, Hash_Print=?, Period=?, InvoiceDate=?, MovementEndTime=?, MovementStartTime=?, TotalLiquidado=?, SystemEntryDate=? WHERE ID_GuiaTransporte = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sssdsssssssd", $invoiceStatusDate, $sourceID, $hash, $hashControl, $hashPrint, $period, $invoiceDate, $movementEndTime, $movementStartTime, $totalLiquidado, $systemEntryDateUpdate, $idGuia );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA025";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
	// UPDATE REMAIN FIELDS LINES
	$query = "UPDATE faturacao_guias_transporte_linhas SET TaxPointDate=? WHERE ID_GuiaTransporte = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sd", $invoiceDate, $idGuia );
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FTGA026A";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA026B";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}

	//log sistema - processo
	$descricao_log ="Édition et finalisation du bulletin de livraison (id: ".$idGuia.")";
	insert_log(0,"Editar",$descricao_log,$sqli_connection);
}else{
	$response["guia"] = $idGuia;

	//log sistema - processo
	$descricao_log ="Édition du bulletin de livraison (id: ".$idGuia.")";
	insert_log(0,"Editar",$descricao_log,$sqli_connection);
}
//------------------------------------------------------------------------

//BLOCK CLIENT ----------------------------------------------------------
$query = "UPDATE faturacao_clientes SET Usado=1 WHERE ID_Cliente=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $cliente);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA027";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA028";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//BLOCK BANK ----------------------------------------------------------
$query = "UPDATE faturacao_bancos SET Usado=1 WHERE ID_Banco=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $bancoFinalID);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FTGA029";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FTGA030";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//------------------------------------------------------------------------

//response
$response["errors"] = false;
die(json_encode($response));
?>