<?php 
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/tcpdf/tcpdf.php";
// include "../../../../resources/tcpdf/tcpdf.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ids_list = array(138,1418,766,294,543,550,103,1599,1564,1269,428,1302,276,270,379,393,252,427,185,1490,264,541,1146,1161,377,269,427,262,1485,138,1159,275,27,215,912,1283,1404,348,758,820,404,370,1159,370,404,1953);
if(isset($data2)){
	$data2 = $data2 + get_trad($ids_list);
} else {
	$data2 = get_trad($ids_list);
}

// setlocale(LC_MONETARY, 'fr_CH.UTF-8');

//GET VARS
$planCompt = $_GET["plan"];

$planLBL = '';
$planLBL2 = '';
if($planCompt == 'bilan'){ $planLBL = $data2[138]['trad']; $planLBL2 = $data2[138]['trad']; }
else { $planLBL = $data2[1418]['trad']; $planLBL2 = $data2[1418]['trad']; }

//process filters and related
$dateAccuel = "01/01/".date("Y");
$dateFin = "31/12/".date("Y");
if(isset( $_GET['dateAccuel']) ) $dateAccuel = $_GET['dateAccuel'];
if(isset( $_GET['dateFin']) ) $dateFin = $_GET['dateFin'];
$GLOBALS['dateAccuel'] = $dateAccuel;
$GLOBALS['dateFin'] = $dateFin;

$compteDe = "-";
$compteAu = "-";
if(isset( $_GET['compteDe']) && $_GET['compteDe'] != null && $_GET['compteDe'] != 'null' ) $compteDe = $_GET['compteDe'];
if(isset( $_GET['compteAu']) && $_GET['compteAu'] != null && $_GET['compteAu'] != 'null' ) $compteAu = $_GET['compteAu'];
$GLOBALS['compteDe'] = $compteDe;
$GLOBALS['compteAu'] = $compteAu;
$swhereClause = '';
if(isset( $_GET['compteDe']) && $_GET['compteDe'] != null && $_GET['compteDe'] != 'null'){
    $swhereClause .= " AND CONCAT(Codigo) >= '".$_GET['compteDe']."'";
}
if(isset( $_GET['compteAu']) && $_GET['compteAu'] != null && $_GET['compteAu'] != 'null' ){
    $swhereClause .= " AND CONCAT(Codigo) <= '".$_GET['compteAu']."'";
}

//log sistema - processo
$descricao_log ="Impression du document: Plan Comptable (".$planLBL.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

/**
 * |---------------------------------------------------------------------------
 * |	Informações Globais
 * | ------------------------
 * |
 * | @Tamanho da Page PDF - 267 Horizontal
 * | @Tamanho da Page PDF - 160 Vertical
 * | MultiCell -> $width, $height, $txt, $border=0, $align='J/R/L/C', $fill=false, $ln=1, $x='', $y='', $reseth=true, $stretch=0, $ishtml=false, $autopadding=true, $maxh=0, $valign='T', $fitcell=false
 * | Line -> $x1, $y1, $x2, $y2, $style=array()
 * |---------------------------------------------------------------------------
 */


//COMPANY INFO - - - - - - - - - - - - - - - - - - - - - -
$query = "SELECT  Designacao, Nif, RegistoComercial, Endereco1, Endereco2, CodigoPostal, Cidade, Email, Website, CapitalSocial, Conservatoria, Telefone, Fax, Logotipo, NormaContabilistica, CAE_Principal  from faturacao_empresa_dados LIMIT 1";
if ($stmt = $sqli_connection -> prepare($query)) {
	$result = $stmt -> execute();

	if (false === $result) {
		$response["errors"] = true;
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result($designacao, $nif, $registo_comercial, $endereco1, $endereco2, $codigo_postal, $cidade, $email, $website, $capital_social, $conservatoria, $telefone, $fax, $logotipo, $norma_contabilistica, $cae_principal);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));

}
$GLOBALS['Designacao'] = $designacao;
$GLOBALS['Nif'] = $nif;
$GLOBALS['RegistoComercial'] = $registo_comercial;
$GLOBALS['Endereco1'] = $endereco1;
$GLOBALS['Endereco2'] = $endereco2;
$GLOBALS['CodigoPostal'] = $codigo_postal;
$GLOBALS['Cidade'] = $cidade;
$GLOBALS['Email'] = $email;
$GLOBALS['Website'] = $website;
$GLOBALS['CapitalSocial'] = $capital_social;
$GLOBALS['Conservatoria'] = $conservatoria;
$GLOBALS['Telefone'] = $telefone;
$GLOBALS['Fax'] = $fax;
$GLOBALS['Logotipo'] = $logotipo;
$GLOBALS['NormaContabilistica'] = $norma_contabilistica;
$GLOBALS['CAE_Principal'] = $cae_principal;

//PLAN COMPTABLE INFO - - - - - - - - - - - - - - - - - - - - - -
$CodeCompte = 0;
$query = "SELECT  Codigo, Descricao, SubCategoriaPlanoConta, ID_CobrancaIVA, Ecriture 
	FROM faturacao_plano_conta WHERE Codigo=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("s", $CodeCompte);
	$result = $stmt -> execute();

	if (false === $result) {
		$response["errors"] = true;
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result($Codigo, $Descricao, $SubCategoriaPlanoConta, $ID_CobrancaIVA, $Ecriture);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));

}

//process plan comptable info
$planComptable = '';
$planComptable .= $Codigo.' - '.$Descricao;

if( $SubCategoriaPlanoConta != '' ){ $planComptable .= ' - '.$SubCategoriaPlanoConta; }
if( $ID_CobrancaIVA != '' ){ $planComptable .= ' - '.$ID_CobrancaIVA; }
if( $Ecriture != '' ){ $planComptable .= ' - '.$Ecriture; }

//MOVEMENTS INFO - - - - - - - - - - - - - - - - - - - - - -
$GLOBALS['SUM_Total_PVP'] = 0;

$filterTable = '';
if($planCompt == 'bilan'){ $filterTable = 'PlanoCategoria LIKE "Bilan" '.$swhereClause; }
else { $filterTable = 'PlanoCategoria NOT LIKE "Bilan" '.$swhereClause; }

// $query = "SELECT CONCAT(Codigo), Descricao, PlanoCategoria, SubCategoriaPlanoConta, ID_CobrancaIVA, Ecriture, 
// 			CASE SubCategoriaPlanoConta WHEN 'Actif' THEN 
// 		        IFNULL( 
// 		            (SELECT SUM(ABS(Total_PVP)) FROM faturacao_movimentos_contabilisticos WHERE faturacao_movimentos_contabilisticos.PlanoContas_Debito LIKE CONCAT(faturacao_plano_conta.Codigo,'%') OR faturacao_movimentos_contabilisticos.PlanoContas_Credito LIKE CONCAT(faturacao_plano_conta.Codigo,'%') )
// 		        , 0)
// 		    WHEN 'Passif' THEN 
// 		        0 - 
// 		        IFNULL( 
// 		            (SELECT SUM(ABS(Total_PVP)) FROM faturacao_movimentos_contabilisticos WHERE faturacao_movimentos_contabilisticos.PlanoContas_Debito LIKE CONCAT(faturacao_plano_conta.Codigo,'%') OR faturacao_movimentos_contabilisticos.PlanoContas_Credito LIKE CONCAT(faturacao_plano_conta.Codigo,'%') )
// 		        , 0)
// 		    ELSE 
// 		        IFNULL( 
// 		            (SELECT SUM(Total_PVP) FROM faturacao_movimentos_contabilisticos WHERE faturacao_movimentos_contabilisticos.PlanoContas_Debito LIKE CONCAT(faturacao_plano_conta.Codigo,'%') OR faturacao_movimentos_contabilisticos.PlanoContas_Credito LIKE CONCAT(faturacao_plano_conta.Codigo,'%') )
// 		        , 0) 
// 		    END
// 	FROM faturacao_plano_conta 
// 	WHERE ".$filterTable." ORDER BY CONCAT(Codigo) ASC";
$query = "SELECT CONCAT(Codigo), Descricao, PlanoCategoria, SubCategoriaPlanoConta, ID_CobrancaIVA, Ecriture, 
			IFNULL( 
	            ( 
		            (
	                	IFNULL((SELECT SUM(Total_PVP) FROM faturacao_movimentos_contabilisticos WHERE faturacao_movimentos_contabilisticos.PlanoContas_Debito LIKE CONCAT(faturacao_plano_conta.Codigo,'%') 
			            	AND (
			            		STR_TO_DATE(Data, '%d/%m/%Y') BETWEEN STR_TO_DATE('".$dateAccuel."', '%d/%m/%Y') AND STR_TO_DATE('".$dateFin."', '%d/%m/%Y') 
			            		) 
	                	),0)
		            )
			        -
			        (
	                	IFNULL((SELECT SUM(Total_PVP) FROM faturacao_movimentos_contabilisticos WHERE faturacao_movimentos_contabilisticos.PlanoContas_Credito LIKE CONCAT(faturacao_plano_conta.Codigo,'%') 
	                		AND (
	                			STR_TO_DATE(Data, '%d/%m/%Y') BETWEEN STR_TO_DATE('".$dateAccuel."', '%d/%m/%Y') AND STR_TO_DATE('".$dateFin."', '%d/%m/%Y') 
	                			) 
	                	),0)
			        ) 
		        )
	        , 0) 
	FROM faturacao_plano_conta 
	WHERE ".$filterTable." ORDER BY CONCAT(Codigo) ASC";
if ($stmt = $sqli_connection -> prepare($query)) {
	// $stmt -> bind_param("s", $CodeCompte);
	$result = $stmt -> execute();

	if (false === $result) {
		$response["errors"] = true;
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> store_result();
	$stmt -> bind_result(
					$Codigo,
					$Descricao,
					$PlanoCategoria,
					$SubCategoriaPlanoConta,
					$ID_CobrancaIVA,
					$Ecriture,
					$Total_PVP
				);
	while($stmt->fetch()){
		$GLOBALS['SUM_Total_PVP'] += $Total_PVP;

		$movimentos[] = array(
					'Codigo' => $Codigo,
					'Descricao' => $Descricao,
					'PlanoCategoria' => $PlanoCategoria,
					'SubCategoriaPlanoConta' => $SubCategoriaPlanoConta,
					'ID_CobrancaIVA' => $ID_CobrancaIVA,
					'Ecriture' => $Ecriture,
					'Total_PVP' => $Total_PVP,
					'MovimentosLinhas' => array()
				);
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));

}

//process each account and get the movements of that account (using exportar_bilan queries)
foreach ($movimentos as $key => $mItem) {
	//getMovimentosContabilisticos($accountNumber, $sqli_connection, $dateAccuel, $dateFin)
	$movimentos[$key]['MovimentosLinhas'] = getMovimentosContabilisticos($mItem['Codigo'], $sqli_connection, $dateAccuel, $dateFin);

	// var_dump($movimentos[$key]['MovimentosLinhas']);
	// echo '<br>';
	// echo '<br>';
}

/**
 * |----------------------------------------------------
 * |				BASE CLASS
 * |----------------------------------------------------
 */
class MYPDF extends TCPDF {
	//Page header
	public function Header($data2) {

		$half_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/2;
		$third_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/3;
		$fourth_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/4;
		$fifth_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/5;
		$six_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/6;
		$seven_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/7;
		$eigth_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/8;
		$nine_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/9;
		$ten_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/10;
		$eleven_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/11;
		$twelve_page = ($this -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/12;

		$fourth_touch_right = ($this -> getPageWidth() - PDF_MARGIN_RIGHT - $fourth_page);

		$destX = $third_page + $third_page ;
		$typeImg = explode('.', $GLOBALS["Logotipo"]);
		$typeImg = end($typeImg);
		$typeImg = strtoupper($typeImg);
		// var_dump($GLOBALS["Logotipo"],$typeImg);

		// Image method signature:
		// Image($file, $x='', $y='', $w=0, $h=0, $type='', $link='', $align='', $resize=false, $dpi=300, $palign='', $ismask=false, $imgmask=false, $border=0, $fitbox=false, $hidden=false, $fitonpage=false)
		$this -> Image($_SERVER["DOCUMENT_ROOT"] . "/uploads/faturacao/".$GLOBALS["Logotipo"], 0, 3, 0, 24, $typeImg, '', 'C', false, 300, 'L', false, false, 0, false, false, false);

		// $this -> SetFont('opensans', '', 8, '', true);
		$this -> setY(27);

		
		//Left
		$this -> SetFont('opensans', 'B', 8, '', true);
		$this -> MultiCell($third_page, '', $GLOBALS["Designacao"],   0, 'L', false, 1, '', '', true, 0, false, true, 0, 'T', false);
		$this -> SetFont('opensans', '', 8, '', true);
		//Left
		$this -> MultiCell($third_page, '', $GLOBALS["Endereco1"],    0, 'L', false, 1, '', '', true, 0, false, true, 0, 'T', false);
		//Left
		$this -> MultiCell($third_page, '', $GLOBALS["CodigoPostal"] . " " . $GLOBALS["Cidade"] , 0, 'L', false, 1, '', '', true, 0, false, true, 0, 'T', false);
		//Left
		$this -> SetFont('opensans', 'B', 8, '', true);
		$this -> MultiCell($twelve_page, '', $data2[766]['trad'].': ', 0, 'L', false, 0, '', '', false, 0, false, true, 0, 'T', false);
		$this -> SetFont('opensans', '', 8, '', true);
		$this -> MultiCell($third_page-3, '', $GLOBALS["Nif"], 0, 'R', false, 1, '', '', true, 0, false, true, 0, 'T', false);
		//Left
		$this -> SetFont('opensans', 'B', 8, '', true);
		$this -> MultiCell($twelve_page, '', $data2[294]['trad'].': ', 0, 'L', false, 0, '', '', false, 0, false, true, 0, 'T', false);
		$this -> SetFont('opensans', '', 8, '', true);
		$this -> MultiCell($third_page-3, '', $GLOBALS["Telefone"], 0, 'R', false, 1, '', '', true, 0, false, true, 0, 'T', false);
		//Left
		$this -> SetFont('opensans', 'B', 8, '', true);
		$this -> MultiCell($twelve_page, '', $data2[543]['trad'].':', 0, 'L', false, 0, '', '', false, 0, false, true, 0, 'T', false);
		$this -> SetFont('opensans', '', 8, '', true);
		$this -> MultiCell($third_page-3, '', $GLOBALS["Email"], 0, 'R', false, 1, '', '', true, 0, false, true, 0, 'T', false);
		//lines
		$this -> Line(PDF_MARGIN_LEFT, $this->GetY()+2, $third_page+$seven_page, $this->GetY()+2, array('width' => 0.1, 'cap' => 'butt', 'join' => 'miter', 'dash' => 0, 'color' => array(150, 150, 150)));
	}

	// Page footer
	public function Footer($data2) {

		$line1 = '<p>'.$data2[550]['trad'].': ' . date('d/m/Y H:i:s') . '<br>'.$data2[103]['trad'].': ' . $GLOBALS['Designacao'] . '. - '.$data2[1599]['trad'].': ' . $GLOBALS['Nif'] . '</p>';

		$right_marg = $this -> getPageWidth() - PDF_MARGIN_RIGHT;
		$paginationX = $this -> getPageWidth() - PDF_MARGIN_LEFT - 4;

		// Position at 20 mm from bottom
		$this -> SetY(-18);
		$lineY = $this->GetY();
		// Set font
		$this -> SetFont('opensans', '', 8);
		$this -> Line(PDF_MARGIN_LEFT, $this->GetY()-2, $right_marg, $this->GetY()-2, array('width' => 0.1, 'cap' => 'butt', 'join' => 'miter', 'dash' => 0, 'color' => array(150, 150, 150)));

		$this -> writeHTMLCell(0, 5, '', $this->GetY(), $line1, 0, 1, 0, true, 'C', false);
		
		/*$this -> SetFont('opensans', '', 7);
		$this -> SetY(-15);
		$this -> Cell($paginationX, 10, 'Page ' . $this -> getAliasNumPage() . '/' . $this -> getAliasNbPages(), 0, 0, 'R', 0, '', 0, false, 'T', 'M');*/
	}
}

//=====================================================+
// 					START FILE
//=====================================================+

$pdf = new MYPDF('P', PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);

$pdf -> SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, PDF_HEADER_TITLE . ' 001', PDF_HEADER_STRING, array(0, 64, 255), array(0, 64, 128));
$pdf -> setFooterData(array(0, 64, 0), array(0, 64, 128));

$pdf -> setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
$pdf -> setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

$pdf -> SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

$pdf -> SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
$pdf -> SetHeaderMargin(PDF_MARGIN_HEADER);
$pdf -> SetFooterMargin(PDF_MARGIN_FOOTER);

$pdf -> SetAutoPageBreak(TRUE, 0);
$pdf -> setImageScale(PDF_IMAGE_SCALE_RATIO);

$tagvs = array('p' => array(0 => array('h' => 0, 'n' => 0), 1 => array('h' => 0, 'n'=> 0)), 'div' => array(0 => array('h' => 0, 'n' => 0), 1 => array('h' => 0, 'n'=> 0)), 'ul' => array(0 => array('h' => 0, 'n' => 0), 1 => array('h' => 0, 'n'=> 0)), 'br' => array(0 => array('h' => 0.2, 'n' => 1), 1 => array('h' => 0.2, 'n'=> 1)));
$pdf->setHtmlVSpace($tagvs);

// Add a page
$pdf -> setPrintHeader(false);
$pdf -> setPrintFooter(false);

$pdf -> setFillColor(255, 255, 255);

//Defs
$full_page = $pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT;
$half_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/2;
$third_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/3;
$fourth_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/4;
$fifth_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/5;
$six_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/6;
$seven_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/7;
$eigth_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/8;
$nine_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/9;
$ten_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/10;
$eleven_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/11;
$twelve_page = ($pdf -> getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/12;

//Defs2
$border_bottom = array('B' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_full = array('TLRB' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_lr = array('LR' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_lt = array('LT' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_rt = array('RT' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_lrt = array('LRT' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_lrb = array('LRB' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_lb = array('LB' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_rb = array('RB' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_tb = array('TB' => array('width' => 0.1, 'color' => array(0, 0, 0)));

$border_r = array('R' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_l = array('L' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_b = array('B' => array('width' => 0.1, 'color' => array(0, 0, 0)));
$border_t = array('T' => array('width' => 0.1, 'color' => array(0, 0, 0)));

$style_line = array('width' => 0.1, 'cap' => 'butt', 'join' => 'miter', 'dash' => 0, 'color' => array(0, 0, 0));
$style_bold_line = array('width' => 0.5, 'cap' => 'butt', 'join' => 'miter', 'dash' => 0, 'color' => array(0, 0, 0));
$style_light_line = array('width' => 0.1, 'cap' => 'butt', 'join' => 'miter', 'dash' => 0, 'color' => array(150, 150, 150));

$right_marg = $pdf -> getPageWidth() - PDF_MARGIN_RIGHT;

//--------------- First Page ---------------
// $pdf -> startPageGroup();
$pdf -> AddPage();

// Início do conteudo (Y)
$startContentY = $pdf -> getPageHeight() / 5;

$pdf -> Header($data2);

// $resto = $full_page - ($twelve_page + $eigth_page + $twelve_page + $twelve_page + $eigth_page + $eigth_page + $eigth_page);
$resto = $full_page - ( ($twelve_page/4 *3) + $six_page + $ten_page + $eigth_page + $eleven_page + $eigth_page);

cabecalho($pdf,$data2);

cabecalho_tabela($pdf,$data2);

$footer_Total_PVP = 0;
$footer_Total_Unit = 0;
$footer_Total_TVA = 0;

// Linhas de Fatura
$pdf -> SetFont('opensans', '', 7);

foreach ($movimentos as $linha) {
	// -- $twelve_page/4 *3 --
	// -- $resto       --
	// -- $six_page    --
	// -- $ten_page  --
	// -- $eigth_page  --
	// -- $eleven_page  --
	// -- $eigth_page  --
	
	// -- $movimentos['Codigo']                 --
	// -- $movimentos['Descricao']              --
	// -- $movimentos['PlanoCategoria']         --
	// -- $movimentos['SubCategoriaPlanoConta'] --
	// -- $movimentos['ID_CobrancaIVA']         --
	// -- $movimentos['Ecriture']               --
	// -- $movimentos['Total_PVP']              --
	// -- $movimentos['MovimentosLinhas']              --

	if($pdf -> getY() >= 260) {
		//page break ---------------------------------------------------------------------------------------------------
		$pdf -> AddPage();
		cabecalho_tabela($pdf,$data2);
		$pdf -> setY($pdf -> getY() );
	}

	//CHECH IF MAIN COMPTE OR CHILD
	if($linha['Ecriture']==''){
		$pdf -> SetFont('opensans', 'B', 7, '', true);
	}else{
		$pdf -> SetFont('opensans', '', 7, '', true);
	}
	
	switch($linha['PlanoCategoria']){
		case "Bilan":
			$linha['PlanoCategoria'] = $data2[138]['trad'];
			break;
		case "Neutre":
			$linha['PlanoCategoria'] = $data2[1159]['trad'];
			break;
		case "Compte d\'exploitation":
			$linha['PlanoCategoria'] = $data2[275]['trad'];
			break;
	}
	switch($linha['SubCategoriaPlanoConta']){
		case "Actif":
			$linha['SubCategoriaPlanoConta'] = $data2[27]['trad'];
			break;
		case "Charges":
			$linha['SubCategoriaPlanoConta'] = $data2[215]['trad'];
			break;
		case "Indéfini":
			$linha['SubCategoriaPlanoConta'] = $data2[912]['trad'];
			break;
		case "Passif":
			$linha['SubCategoriaPlanoConta'] = $data2[1283]['trad'];
			break;
		case "Rendement":
			$linha['SubCategoriaPlanoConta'] = $data2[1404]['trad'];
			break;
	}
	switch($linha['ID_CobrancaIVA']){
		case "Contrepartie TVA":
			$linha['ID_CobrancaIVA'] = $data2[348]['trad'];
			break;
		case "Hors TVA":
			$linha['ID_CobrancaIVA'] = $data2[758]['trad'];
			break;
		case "Imposable":
			$linha['ID_CobrancaIVA'] = $data2[820]['trad'];
			break;
	}
	switch($linha['Ecriture']){
		case "Débit":
			$linha['Ecriture'] = $data2[404]['trad'];
			break;
		case "Crédit":
			$linha['Ecriture'] = $data2[370]['trad'];
			break;
		case "Neutre":
			$linha['Ecriture'] = $data2[1159]['trad'];
			break;
	}
	
	$a = $pdf->getStringHeight($twelve_page/4 *3, $linha['Codigo']);
	$e = $pdf->getStringHeight($resto, $linha['Descricao']);
	$b = $pdf->getStringHeight($six_page, $linha['PlanoCategoria']);
	$c = $pdf->getStringHeight($ten_page, $linha['SubCategoriaPlanoConta']);
	$d = $pdf->getStringHeight($eigth_page, $linha['ID_CobrancaIVA']);
	$i = $pdf->getStringHeight($eleven_page, $linha['Ecriture']);
	$j = $pdf->getStringHeight($eigth_page, number_format($linha['Total_PVP'], $numDecimais, '.', '\'' ));
	// $j = $pdf->getStringHeight($eigth_page, number_format($linha['Total_Unit'], $numDecimais, '.', '\'' ));
	// $f = $pdf->getStringHeight($eigth_page, number_format($linha['Total_TVA'], $numDecimais, '.', '\'' ));

	//GET PAGE MAX HEIGHT
	$height = calcHeightProd([$a, $b, $c, $d, $e, $i, $j]);

	$pdf -> Line(PDF_MARGIN_LEFT, $pdf->GetY(), $right_marg, $pdf->GetY(), $style_light_line);

	//LINE PRINT
	$pdf -> MultiCell($twelve_page/4 *3, $height, $linha['Codigo'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	$pdf -> MultiCell($resto, $height, $linha['Descricao'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	$pdf -> MultiCell($six_page, $height, $linha['PlanoCategoria'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	$pdf -> MultiCell($ten_page, $height, $linha['SubCategoriaPlanoConta'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	$pdf -> MultiCell($eigth_page, $height, $linha['ID_CobrancaIVA'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
	$pdf -> MultiCell($eleven_page, $height, $linha['Ecriture'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);

	//CHECK TOTAL SIGNAL(POSITIVE/NEGATIVE)
	$planComptChoosed = $_GET["plan"];
	if($planCompt == 'bilan'){
		if($linha['SubCategoriaPlanoConta'] == 'Actif'){
		//GREEN
			$pdf->SetTextColor(72,140,108);
		}elseif($linha['SubCategoriaPlanoConta'] == 'Passif'){
			//RED
			$pdf->SetTextColor(191,67,70);
		}else{
			//BLACK
			$pdf->SetTextColor(0,0,0);
		}
	}else{

		if(substr($linha['Codigo'], 0, 1) == 3){
			//RED
			$pdf->SetTextColor(191,67,70);
		}elseif(substr($linha['Codigo'], 0, 1) >= 4){
			//GREEN
			$pdf->SetTextColor(72,140,108);
		}else{
			//BLACK
			$pdf->SetTextColor(0,0,0);
		}
	}

	$pdf -> MultiCell($eigth_page, $height, number_format($linha['Total_PVP'], $numDecimais, '.', '\'' ),  0, 'R', false, 1, '', '', true, 0, false, false, 0, 'T', true);
	
	$pdf->SetTextColor(0,0,0);

	// if($linha['Codigo'] < 10){
	// 	$footer_Total_PVP += round($linha['Total_PVP'],2);
	// }
	$footer_Total_Unit += round($linha['Total_Unit'],$numDecimais);
	$footer_Total_TVA += round($linha['Total_TVA'],$numDecimais);

	//process payments if exists
	if($linha['MovimentosLinhas'] != null){
		//left 5 | right 5
		$spaceLeft = 2;
		$spaceRight = 2;
		$spaceLeftMoreRight = $spaceLeft + $spaceRight;

		//new resto var 
		$resto2 = ($full_page - $spaceLeftMoreRight) - (($twelve_page/4 *3) + $ten_page + $twelve_page + ($twelve_page/2) + $nine_page + $nine_page) - $eleven_page;
		// $resto2 = ($full_page - $spaceLeftMoreRight) - ($twelve_page + $ten_page + ($twelve_page/2) + $eigth_page + $eigth_page);
		
		//second header
		cabecalho_tabela2($pdf, $resto2, $spaceLeft, $spaceRight,$data2);	
		$GLOBALS['DTotal'] = 0;
		$GLOBALS['CTotal'] = 0;
		//process lines
		foreach ($linha['MovimentosLinhas'] as $key => $movDetalhe) {
			if($pdf -> getY() >= 260) {
				//page break ---------------------------------------------------------------------------------------------------
				$pdf -> AddPage();
				cabecalho_tabela($pdf,$data2);
				
				//LINE PRINT
				$pdf -> setY($pdf -> getY() );

				//set main account line first
				$pdf -> MultiCell($twelve_page/4 *3, $height, $linha['Codigo'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
				$pdf -> MultiCell($resto, $height, $linha['Descricao'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
				$pdf -> MultiCell($six_page, $height, $linha['PlanoCategoria'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
				$pdf -> MultiCell($ten_page, $height, $linha['SubCategoriaPlanoConta'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
				$pdf -> MultiCell($eigth_page, $height, $linha['ID_CobrancaIVA'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
				$pdf -> MultiCell($eleven_page, $height, $linha['Ecriture'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);

				//CHECK TOTAL SIGNAL(POSITIVE/NEGATIVE)
				$planComptChoosed = $_GET["plan"];
				if($planCompt == 'bilan'){
					if($linha['SubCategoriaPlanoConta'] == 'Actif'){
					//GREEN
						$pdf->SetTextColor(72,140,108);
					}elseif($linha['SubCategoriaPlanoConta'] == 'Passif'){
						//RED
						$pdf->SetTextColor(191,67,70);
					}else{
						//BLACK
						$pdf->SetTextColor(0,0,0);
					}
				}else{

					if(substr($linha['Codigo'], 0, 1) == 3){
						//RED
						$pdf->SetTextColor(191,67,70);
					}elseif(substr($linha['Codigo'], 0, 1) >= 4){
						//GREEN
						$pdf->SetTextColor(72,140,108);
					}else{
						//BLACK
						$pdf->SetTextColor(0,0,0);
					}
				}

				$pdf -> MultiCell($eigth_page, $height, number_format($linha['Total_PVP'], $numDecimais, '.', '\'' ),  0, 'R', false, 1, '', '', true, 0, false, false, 0, 'T', true);
				
				$pdf->SetTextColor(0,0,0);
				
				//second header
				cabecalho_tabela2($pdf, $resto2, $spaceLeft, $spaceRight,$data2);	
			}

			$pdf->setX($pdf->getX() + $spaceLeft);

			$aa = $pdf->getStringHeight($twelve_page/4 *3, $movDetalhe['ID_Movimento']);
			$bb = $pdf->getStringHeight($ten_page, $movDetalhe['Data']);
			$cc = $pdf->getStringHeight($twelve_page, $movDetalhe['ContraPlano']);
			$dd = $pdf->getStringHeight($resto2, $movDetalhe['Descricao']);
			$ii = $pdf->getStringHeight($eleven_page, $movDetalhe['NomeImposto']);
			$ee = $pdf->getStringHeight($nine_page, number_format($movDetalhe['Total_PVP'], $numDecimais, '.', '\'' ) );
			$ff = $pdf->getStringHeight($nine_page, number_format($movDetalhe['Solde'], $numDecimais, '.', '\'' ) );
			$gg = $pdf->getStringHeight(($twelve_page/2), $movDetalhe['Tipo']);
			// $j = $pdf->getStringHeight($nine_page, number_format($movDetalhe['Total_Unit'], $numDecimais, '.', '\'' ));
			// $f = $pdf->getStringHeight($nine_page, number_format($movDetalhe['Total_TVA'], $numDecimais, '.', '\'' ));

			//GET PAGE MAX HEIGHT
			$height2 = calcHeightProd([$aa, $bb, $cc, $dd,$ii, $ee, $ff,$gg]);

			$pdf -> Line(PDF_MARGIN_LEFT + $spaceLeft, $pdf->GetY(), $right_marg - $spaceRight, $pdf->GetY(), $style_light_line);

			//LINE PRINT
			$pdf -> MultiCell($twelve_page/4 *3, $height2, $movDetalhe['ID_Movimento'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
			$pdf -> MultiCell($ten_page, $height2, $movDetalhe['Data'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
			$pdf -> MultiCell($twelve_page, $height2, $movDetalhe['ContraPlano'],  0, 'C', false, 0, '', '', true, 0, false, false, 0, 'T', true);
			$pdf -> MultiCell($resto2, $height2, $movDetalhe['Descricao'],  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);

			if($movDetalhe['ID_Imposto']){
				$pdf -> MultiCell($eleven_page, $height2, $movDetalhe['NomeImposto'],  0, 'C', false, 0, '', '', true, 0, false, false, 0, 'T', true);
			} else{
				$pdf -> MultiCell($eleven_page, $height2, '---',  0, 'C', false, 0, '', '', true, 0, false, false, 0, 'T', true);
			}
			if($movDetalhe['Tipo'] == "C"){
				$pdf -> MultiCell($nine_page, $height2, "",  0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
				$pdf -> MultiCell(($twelve_page/2), $height2, "",  0, 'C', true, 0, '', '', true, 0, false, false, 0, 'T', true);
				$pdf -> MultiCell($nine_page, $height2, number_format($movDetalhe['Total_PVP'], $numDecimais, '.', '\'' ),  0, 'R', false, 1, '', '', true, 0, false, false, 0, 'T', true);
				$GLOBALS['CTotal'] += $movDetalhe['Total_PVP'];
			} else if($movDetalhe['Tipo'] == "D"){
				$pdf -> MultiCell($nine_page, $height2, number_format($movDetalhe['Total_PVP'], $numDecimais, '.', '\'' ),  0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
				$pdf -> MultiCell(($twelve_page/2), $height2, "",  0, 'C', true, 0, '', '', true, 0, false, false, 0, 'T', true);
				$pdf -> MultiCell($nine_page, $height2, "",  0, 'R', false, 1, '', '', true, 0, false, false, 0, 'T', true);
				$GLOBALS['DTotal'] += $movDetalhe['Total_PVP'];
			}
			$pdf->SetTextColor(0,0,0);
		}
		$pdf -> Line(PDF_MARGIN_LEFT, $pdf->GetY(), $right_marg, $pdf->GetY(), $style_line);

		$pdf -> SetFont('opensans', 'B', 8, '', true);
		$firstLBL_total = $twelve_page + $ten_page + $twelve_page + $resto;

		$pdf -> MultiCell($firstLBL_total, '', $data2[1953]['trad'].' (CHF): ',  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);
		$pdf -> MultiCell($nine_page, $height2, '',  0, 'C', false, 0, '', '', true, 0, false, false, 0, 'T', true);
		$pdf -> MultiCell($seven_page+3, '', number_format($GLOBALS['DTotal'], $numDecimais, '.', '\'' ).'',  0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);
		$pdf -> MultiCell(($twelve_page/2-3), '', '',  0, 'R', false, 0, '', '', true, 0, false, false, 0, 'T', true);

		$pdf -> MultiCell($nine_page, '', number_format($GLOBALS['CTotal'], $numDecimais, '.', '\'' ).'',  0, 'R', false, 1, '', '', true, 0, false, false, 0, 'T', true);
		$pdf -> MultiCell($nine_page, '', number_format("", $numDecimais, '.', '\'' ).'',  0, 'R', false, 1, '', '', true, 0, false, false, 0, 'T', true);
		
		cabecalho_tabela($pdf,$data2);
				
		$pdf -> setY($pdf -> getY() );
	}
}

//Totals
$totalLinesResult = getTotals();

// $footer_Total_Ouverture += round(0,2);
// $footer_Total_Debit += round($totalLinesResult['Total_Debit'],2);
// $footer_Total_Credit += round($totalLinesResult['Total_Credit'],2);
// $footer_Total_Solde += round($totalLinesResult['Total_Solde'],2);
$footer_Total_PVP += round($totalLinesResult['Total_Solde'],$numDecimais);


$pdf -> Line(PDF_MARGIN_LEFT, $pdf->GetY(), $right_marg, $pdf->GetY(), $style_line);

$pdf -> SetFont('opensans', 'B', 8, '', true);

$firstLBL_total = ($twelve_page/4 *3) + $resto + $six_page + $ten_page + $eleven_page;
$pdf -> MultiCell($firstLBL_total, '', $data2[1564]['trad'].' (CHF): ',  0, 'L', false, 0, '', '', true, 0, false, false, 0, 'T', true);

//CHECK TOTAL SIGNAL(POSITIVE/NEGATIVE)
if($footer_Total_PVP<0){
	//RED
	$pdf->SetTextColor(191,67,70);
}elseif($footer_Total_PVP>0){
	//GREEN
	$pdf->SetTextColor(72,140,108);
}else{
	//BLACK
	$pdf->SetTextColor(0,0,0);
}

$pdf -> MultiCell($nine_page+$nine_page, '', number_format($footer_Total_PVP, $numDecimais, '.', '\'' ).'',  0, 'R', false, 1, '', '', true, 0, false, false, 0, 'T', true);

$pdf->SetTextColor(0,0,0);

$pdf -> SetFont('opensans', '', 8, '', true);

// $pdf -> Ln();

	// Line -> $x1, $y1, $x2, $y2, $style=array()
	// MultiCell -> $width, $height, $txt, $border=0, $align='J/R/L/C', $fill=false, $ln=1, $x='', $y='', $reseth=true, $stretch=0, $ishtml=false, $autopadding=true, $maxh=0, $valign='T', $fitcell=false

// ----------- Paginação e colocação de 'Originale', 'Duplicata', 'Triplé' e 'Quadruplé' -----------
$max = $pdf -> PageNo();

// ----------------- Page Numbers -----------------------------
$paginationX = $right_marg - PDF_MARGIN_RIGHT;
$pages = $pdf -> getNumPages();
for($i = 1; $i <= $pages; ){
	for($k = 1; $k <= $max; $k++, $i++){
		$pdf -> setPage($i);

		$pdf -> SetFont('opensans', '', 7);
		$pdf -> SetY(-10);
		$pdf -> Cell($paginationX, 0, $data2[1269]['trad'].' ' . $k . '/' . $max, 0, 0, 'R', 0, '', 0, false, 'B', 'B');

	}
}
// ----------------------------------------------------------

// ------------- Certificação Vertical Lado Esquerdo -------- 
$total_pages = $pdf -> getNumPages();
for ($i = 1; $i <= $total_pages; $i++) {
    $pdf -> setPage($i);

    // $myPageWidth = $pdf -> getPageWidth();
    $myPageHeight = $pdf -> getPageHeight();

    $myX = PDF_MARGIN_LEFT / 2 + 2;
    $myY = $myPageHeight - 35;

    $pdf -> SetAlpha(0.5);

    $pdf -> StartTransform();
    $pdf -> Rotate(90, $myX, $myY);
    $pdf -> SetFont('opensans', '', 7);
    $pdf -> SetTextColor(0, 0, 0);

    $pdf -> Text($myX, $myY, ' ');
    $pdf -> StopTransform();

    // Reset the transparency to default
    $pdf -> SetAlpha(1);
}
$pdf -> Footer($data2);
// Close and output PDF document
// This method has several options, check the source code documentation for more information.
$pdf -> Output($planLBL2.'_'.$data2[428]['trad'].'_'.date("d-m-Y").'.pdf', 'I');

//=====================================================+
// 					END OF FILE
//=====================================================+

//DOC HEADER - - - - - - - - - - - - - - - - - - -
function cabecalho($pdf,$data2){
	global $full_page;   //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT     --
	global $half_page;   //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/2  --
	global $third_page;  //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/3  --
	global $fourth_page; //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/4  --
	global $fifth_page;  //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/5  --
	global $six_page;    //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/6  --
	global $seven_page;  //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/7  --
	global $eigth_page;  //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/8  --
	global $nine_page;   //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/9  --
	global $ten_page;    //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/10 --
	global $eleven_page; //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/11 --
	global $twelve_page; //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/12 --

	global $style_line;
	global $style_bold_line;
	global $style_light_line;

	global $right_marg;
	global $startContentY;

	// global $data_inicio;
	// global $data_fim;
	// global $stringLabelPeriod;
	
	global $planComptable;
	global $planLBL;

	
	$pdf -> SetFont('opensans', 'B', 10);
	$pdf -> MultiCell($half_page, '', $planLBL.' - '.$data2[1302]['trad'], 0, 'L',  false, 1, '', $startContentY, false, 0, false, true, 0, 'T', false);
	
	$pdf -> Line(PDF_MARGIN_LEFT, $pdf->GetY(), $right_marg, $pdf->GetY(), $style_bold_line);

	$pdf -> SetFont('opensans', '', 8);
	$pdf -> Ln();

	$pdf -> SetFont('opensans', 'B', 8);
	$pdf -> MultiCell($fourth_page, '', $data2[276]['trad'], 0, 'L', false, 0, '', '', false, 0, false, true, 0, 'T', false);
	$pdf -> MultiCell($fourth_page, '', $data2[270]['trad'], 0, 'L', false, 0, '', '', false, 0, false, true, 0, 'T', false);
	$pdf -> MultiCell($fourth_page, '', $data2[379]['trad'], 0, 'L', false, 0, PDF_MARGIN_LEFT + $half_page, '', false, 0, false, true, 0, 'T', false);
	$pdf -> MultiCell($fourth_page, '', $data2[393]['trad'], 0, 'L', false, 1, PDF_MARGIN_LEFT + $half_page + $fourth_page, '', false, 0, false, true, 0, 'T', false);

	$pdf -> Line(PDF_MARGIN_LEFT, $pdf->GetY(), PDF_MARGIN_LEFT + $fourth_page - 4, $pdf->GetY(), $style_line);
	$pdf -> Line(PDF_MARGIN_LEFT + $fourth_page, $pdf->GetY(), PDF_MARGIN_LEFT + $fourth_page + $fourth_page - 4, $pdf->GetY(), $style_line);
	$pdf -> Line(PDF_MARGIN_LEFT + $fourth_page+ $fourth_page, $pdf->GetY(), PDF_MARGIN_LEFT + $fourth_page + $fourth_page + $fourth_page - 4, $pdf->GetY(), $style_line);
	$pdf -> Line(PDF_MARGIN_LEFT + $fourth_page + $fourth_page+ $fourth_page , $pdf->GetY(), $right_marg, $pdf->GetY(), $style_line);

	$pdf -> SetFont('opensans', '', 8);
	$pdf -> MultiCell($fourth_page, '', $GLOBALS['compteDe'], 0, 'L', false, 0, PDF_MARGIN_LEFT, '', false, 0, false, true, 0, 'T', false);
	$pdf -> MultiCell($fourth_page, '', $GLOBALS['compteAu'], 0, 'L', false, 0, PDF_MARGIN_LEFT + $fourth_page, '', true, 0, false, true, 0, 'T', false);
	$pdf -> MultiCell($fourth_page, '', $GLOBALS['dateAccuel'], 0, 'L', false, 0, PDF_MARGIN_LEFT + $fourth_page+ $fourth_page, '', true, 0, false, true, 0, 'T', false);
	$pdf -> MultiCell($fourth_page, '', $GLOBALS['dateFin'], 0, 'L', false, 1, PDF_MARGIN_LEFT + $fourth_page + $fourth_page+ $fourth_page, '', false, 0, false, true, 0, 'T', false);

	$pdf -> Ln();
	$pdf -> Ln();

	$pdf -> SetFont('opensans', 'B', 8);

	// $pdf -> Ln();
	// $pdf -> Ln();

}

//LINES HEADER - - - - - - - - - - - - - - - - - - -
function cabecalho_tabela($pdf,$data2){
	global $right_marg;

	global $style_line;
	global $style_bold_line;

	global $full_page;   //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT     --
	global $half_page;   //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/2  --
	global $third_page;  //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/3  --
	global $fourth_page; //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/4  --
	global $fifth_page;  //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/5  --
	global $six_page;    //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/6  --
	global $seven_page;  //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/7  --
	global $eigth_page;  //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/8  --
	global $nine_page;   //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/9  --
	global $ten_page;    //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/10 --
	global $eleven_page; //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/11 --
	global $twelve_page; //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/12 --


	global $resto;
	
	$pdf -> SetFont('opensans', 'B', 8);
	$pdf -> Line(PDF_MARGIN_LEFT, $pdf->GetY(), $right_marg, $pdf->GetY(), $style_bold_line);
	$pdf -> setFillColor(230, 230, 230);

	$pdf -> MultiCell($twelve_page/4 *3, '', $data2[252]['trad'], 0, 'L', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> MultiCell($resto, '', $data2[427]['trad'], 0, 'L', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> MultiCell($six_page, '', $data2[185]['trad'], 0, 'L', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> MultiCell($ten_page, '', $data2[1490]['trad'], 0, 'L', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> MultiCell($eigth_page, '', $data2[264]['trad'], 0, 'L', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> MultiCell($eleven_page, '', $data2[541]['trad'], 0, 'L', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> MultiCell($eigth_page, '', $data2[1146]['trad'], 0, 'R', true, 1, '', '', true, 0, false, false, 0, 'T', false);
	// $pdf -> MultiCell($eigth_page, '', 'Montant Unit.', 0, 'R', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	// $pdf -> MultiCell($eigth_page, '', 'Montant TVA', 0, 'R', true, 1, '', '', true, 0, false, false, 0, 'T', false);
	
	$pdf -> Line(PDF_MARGIN_LEFT, $pdf->GetY(), $right_marg, $pdf->GetY(), $style_line);
	$pdf -> setFillColor(255, 255, 255);
	$pdf -> SetFont('opensans', '', 7);
}


// Calculate Min Height of Line
function calcHeightProd($strHeight){
	return max($strHeight) + 1;
}

//MOVEMENTS INFO - - - - - - - - - - - - - - - - - - - - - -
function getMovimentosContabilisticos($accountNumber, $sqli_connection, $dateAccuel, $dateFin){
	// DEBIT
	$query = "SELECT ID_Movimento, Data, PlanoContas_Debito, PlanoContas_Credito, Descricao, Total_PVP, Total_Unit, Total_TVA, STR_TO_DATE( Data,  '%d/%m/%Y %H:%i:%s' ), ID_ImpostoTVA, 
		(SELECT Nome FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_movimentos_contabilisticos.ID_ImpostoTVA) AS NomeImposto

		FROM faturacao_movimentos_contabilisticos 
		WHERE PlanoContas_Debito LIKE '".$accountNumber."' AND (STR_TO_DATE(Data, '%d/%m/%Y') BETWEEN STR_TO_DATE('".$dateAccuel."', '%d/%m/%Y') AND STR_TO_DATE('".$dateFin."', '%d/%m/%Y') )
		ORDER BY ID_Movimento DESC";
	if ($stmt = $sqli_connection -> prepare($query)) {
		// $stmt -> bind_param("s", $CodeCompte);
		$result = $stmt -> execute();

		if (false === $result) {
			$response["errors"] = true;
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result(
						$ID_Movimento,
						$Data,
						$PlanoContas_Debito,
						$PlanoContas_Credito,
						$Descricao,
						$Total_PVP,
						$Total_Unit,
						$Total_TVA,
						$DataMov,
						$ID_Imposto,
						$NomeImposto
					);
		while($stmt->fetch()){
			$movimentos[] = array(
						'ID_Movimento' => $ID_Movimento,
						'Data' => explode(" ", $Data)[0],
						'DataTotal' => $Data,
						'PlanoContas_Debito' => $PlanoContas_Debito,
						'PlanoContas_Credito' => $PlanoContas_Credito,
						'Descricao' => explode(" - Article", $Descricao)[0],
						'Total_PVP' => $Total_PVP,
						'Total_Unit' => $Total_Unit,
						'Total_TVA' => $Total_TVA, 
						'Solde' => 0, 
						'Plano' => $PlanoContas_Debito,
						'ContraPlano' => $PlanoContas_Credito,
						'Tipo' => 'D',
						'DataMov' => $DataMov,
						'ID_Imposto' => $ID_Imposto,
						'NomeImposto' => $NomeImposto
					);
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));

	}

	// CRÉDIT
	$query = "SELECT ID_Movimento, Data, PlanoContas_Debito, PlanoContas_Credito, Descricao, Total_PVP, Total_Unit, Total_TVA, STR_TO_DATE( Data,  '%d/%m/%Y %H:%i:%s' ), ID_ImpostoTVA, 
		(SELECT Nome FROM faturacao_impostos WHERE faturacao_impostos.ID_Imposto = faturacao_movimentos_contabilisticos.ID_ImpostoTVA) AS NomeImposto

		FROM faturacao_movimentos_contabilisticos 
		WHERE PlanoContas_Credito LIKE '".$accountNumber."' AND (STR_TO_DATE(Data, '%d/%m/%Y') BETWEEN STR_TO_DATE('".$dateAccuel."', '%d/%m/%Y') AND STR_TO_DATE('".$dateFin."', '%d/%m/%Y') )
		ORDER BY ID_Movimento DESC";
	if ($stmt = $sqli_connection -> prepare($query)) {
		// $stmt -> bind_param("s", $CodeCompte);
		$result = $stmt -> execute();

		if (false === $result) {
			$response["errors"] = true;
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> store_result();
		$stmt -> bind_result(
						$ID_Movimento,
						$Data,
						$PlanoContas_Debito,
						$PlanoContas_Credito,
						$Descricao,
						$Total_PVP,
						$Total_Unit,
						$Total_TVA,
						$DataMov,
						$ID_Imposto,
						$NomeImposto
					);
		while($stmt->fetch()){
			$movimentos[] = array(
						'ID_Movimento' => $ID_Movimento,
						'Data' => explode(" ", $Data)[0],
						'DataTotal' => $Data,
						'PlanoContas_Debito' => $PlanoContas_Debito,
						'PlanoContas_Credito' => $PlanoContas_Credito,
						'Descricao' => explode(" - Article", $Descricao)[0],
						'Total_PVP' => $Total_PVP,
						'Total_Unit' => $Total_Unit,
						'Total_TVA' => $Total_TVA, 
						'Solde' => 0, 
						'Plano' => $PlanoContas_Credito,
						'ContraPlano' => $PlanoContas_Debito,
						'Tipo' => 'C',
						'DataMov' => $DataMov,
						'ID_Imposto' => $ID_Imposto,
						'NomeImposto' => $NomeImposto
					);
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));

	}

	// Sort movimentos by ID_Movimento
	// usort($movimentos,'sortMovimentosHelper');

	//First place movements by date ASC for process the solde
	usort($movimentos,'sortMovimentosDateHelper2');

	for($i=0; $i<sizeof($movimentos); $i++){
		if($movimentos[$i]['Tipo'] == 'D'){
			$GLOBALS['SoldeTotal'] += $movimentos[$i]['Total_PVP'];

			// var_dump($movimentos[$i]['ID_Movimento'] . ' || ' . $movimentos[$i]['DataMov'] . ' || ' . $movimentos[$i]['Tipo'] . ' || ' . $movimentos[$i]['PlanoContas_Debito'] . ' || ' . $movimentos[$i]['Total_PVP'] . ' || ' . $GLOBALS['SoldeTotal']);
		}else{
			$GLOBALS['SoldeTotal'] -= $movimentos[$i]['Total_PVP'];

			// var_dump($movimentos[$i]['ID_Movimento'] . ' || ' . $movimentos[$i]['DataMov'] . ' || ' . $movimentos[$i]['Tipo'] . ' || ' . $movimentos[$i]['PlanoContas_Credito'] . ' || -' . $movimentos[$i]['Total_PVP'] . ' || ' . $GLOBALS['SoldeTotal']);
		}
		
		$movimentos[$i]['Solde'] = $GLOBALS['SoldeTotal'];
	}
	// var_dump($movimentos);die();
	
	// return processed data
	return $movimentos;
}
/* Compare 2 arrays by value of ID_Movimento 
 * DESCENDENT
 */
function sortMovimentosHelper($item1,$item2) {
	if ($item1['ID_Movimento'] == $item2['ID_Movimento']) {
		return ($item1['Tipo'] == 'D') ? -1 : 1;
        // return 0;
    }
    return ($item1['ID_Movimento'] < $item2['ID_Movimento']) ? 1 : -1;
}

/* Compare 2 arrays by value of Date 
 * DESCENDENT
 */
function sortMovimentosDateHelper($item1,$item2) {
	if ($item1['DataMov'] == $item2['DataMov']) {
		return ($item1['Tipo'] == 'D') ? -1 : 1;
        // return 0;
    }
    return ($item1['DataMov'] < $item2['DataMov']) ? 1 : -1;
}

/* Compare 2 arrays by value of Date 
 * ASCENDENT
 */
function sortMovimentosDateHelper2($item1,$item2) {
	if ($item1['DataMov'] == $item2['DataMov']) {
		return ($item1['Tipo'] == 'C') ? -1 : 1;
        // return 0;
    }
    return ($item1['DataMov'] > $item2['DataMov']) ? 1 : -1;
}

//LINES 2 HEADER - - - - - - - - - - - - - - - - - - -
function cabecalho_tabela2($pdf, $resto2, $spaceLeft, $spaceRight,$data2){
	global $right_marg;

	global $style_line;
	global $style_bold_line;

	global $full_page;   //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT     --
	global $half_page;   //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/2  --
	global $third_page;  //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/3  --
	global $fourth_page; //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/4  --
	global $fifth_page;  //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/5  --
	global $six_page;    //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/6  --
	global $seven_page;  //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/7  --
	global $eigth_page;  //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/8  --
	global $nine_page;   //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/9  --
	global $ten_page;    //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/10 --
	global $eleven_page; //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/11 --
	global $twelve_page; //-- getPageWidth() - PDF_MARGIN_LEFT - PDF_MARGIN_RIGHT)/12 --


	// global $resto;
	$pdf->setX($pdf->getX() + $spaceLeft);

	$pdf -> SetFont('opensans', 'B', 8);

	$pdf -> Line(PDF_MARGIN_LEFT + $spaceLeft , $pdf->GetY(), $right_marg - $spaceRight, $pdf->GetY(), $style_bold_line);

	$pdf -> setFillColor(230, 230, 230);

	$pdf -> MultiCell($twelve_page/4 *3, '', $data2[1161]['trad'], 0, 'L', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> MultiCell($ten_page, '', $data2[377]['trad'], 0, 'L', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> MultiCell($twelve_page, '', $data2[269]['trad'], 0, 'C', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> MultiCell($resto2, '', $data2[427]['trad'], 0, 'L', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> MultiCell($eleven_page, '', $data2[262]['trad'], 0, 'C', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> MultiCell($nine_page, '', $data2[404]['trad'], 0, 'R', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> MultiCell(($twelve_page/2), '', '', 0, 'C', true, 0, '', '', true, 0, false, false, 0, 'T', false);
	$pdf -> MultiCell($nine_page, '', $data2[370]['trad'], 0, 'R', true, 1, '', '', true, 0, false, false, 0, 'T', false);
	
	$pdf -> Line(PDF_MARGIN_LEFT + $spaceLeft, $pdf->GetY(), $right_marg - $spaceRight, $pdf->GetY(), $style_line);

	$pdf -> setFillColor(255, 255, 255);
	$pdf -> SetFont('opensans', '', 7);
}

//get the moves ids for totals
function getTotals(){
	global $sqli_connection;

	//INIT / GET VARS
	$totalDebit = 0;
	$totalCredit = 0;
	$totalSolde = 0;

	$planCompt = $_GET["plan"];

	$dateAccuel = "01/01/".date("Y");
	$dateFin = "31/12/".date("Y");
	if(isset( $_GET['dateAccuel']) ) $dateAccuel = $_GET['dateAccuel'];
	if(isset( $_GET['dateFin']) ) $dateFin = $_GET['dateFin'];

	$swhereClauseDebit = '';
	$swhereClauseCredit = '';
	if(isset( $_GET['compteDe']) && $_GET['compteDe'] != null && $_GET['compteDe'] != 'null'){
	    $swhereClauseDebit .= " AND CONCAT(PlanoContas_Debito) >= '".$_GET['compteDe']."'";
	    $swhereClauseCredit .= " AND CONCAT(PlanoContas_Credito) >= '".$_GET['compteDe']."'";
	}
	if(isset( $_GET['compteAu']) && $_GET['compteAu'] != null && $_GET['compteAu'] != 'null' ){
	    $swhereClauseDebit .= " AND CONCAT(PlanoContas_Debito) <= '".$_GET['compteAu']."'";
	    $swhereClauseCredit .= " AND CONCAT(PlanoContas_Credito) <= '".$_GET['compteAu']."'";
	}
	//---------------------------------------------------

	//PROCESS QUERY FILTERS
	$filterTableDebit = 'PlanoContas_Debito > 0 '.$swhereClauseDebit;
	$filterTableCredit = 'PlanoContas_Credito > 0 '.$swhereClauseCredit;

	$filterTable = '';
	if($planCompt == 'bilan'){ 
		$filterTableDebit = '(SELECT PlanoCategoria FROM faturacao_plano_conta WHERE faturacao_plano_conta.Codigo = faturacao_movimentos_contabilisticos.PlanoContas_Debito) LIKE "Bilan" '.$swhereClauseDebit; 
		$filterTableCredit = '(SELECT PlanoCategoria FROM faturacao_plano_conta WHERE faturacao_plano_conta.Codigo = faturacao_movimentos_contabilisticos.PlanoContas_Credito) LIKE "Bilan" '.$swhereClauseCredit; 
	}
	else { 
		$filterTableDebit = '(SELECT PlanoCategoria FROM faturacao_plano_conta WHERE faturacao_plano_conta.Codigo = faturacao_movimentos_contabilisticos.PlanoContas_Debito) NOT LIKE "Bilan" '.$swhereClauseDebit; 
		$filterTableCredit = '(SELECT PlanoCategoria FROM faturacao_plano_conta WHERE faturacao_plano_conta.Codigo = faturacao_movimentos_contabilisticos.PlanoContas_Credito) NOT LIKE "Bilan" '.$swhereClauseCredit; 
	}
	//---------------------------------------------------

	//Query DEBIT
	$D_ID_Movimento = 0;
	$D_Data = 0;
	$D_PlanoContas_Debito = 0;
	$D_PlanoContas_Credito = 0;
	$D_TotalDebit = 0;

	// $queryDebit = "SELECT ID_Movimento, Data, PlanoContas_Debito, PlanoContas_Credito, Total_PVP AS TotalDebit
	$queryDebit = "SELECT Total_PVP AS TotalDebit
		FROM faturacao_movimentos_contabilisticos 
		WHERE ".$filterTableDebit."
			AND (
				STR_TO_DATE(Data, '%d/%m/%Y') BETWEEN STR_TO_DATE('".$dateAccuel."', '%d/%m/%Y') AND STR_TO_DATE('".$dateFin."', '%d/%m/%Y') 
				)
		ORDER BY CONCAT(PlanoContas_Debito) ASC";
	// var_dump($queryDebit);
	if ($stmtDebit = $sqli_connection -> prepare($queryDebit)) {
		// $stmtDebit -> bind_param("s", $CodeCompte);
		$result = $stmtDebit -> execute();

		if (false === $result) {
			$response["errors"] = true;
			$response["message"] = $stmtDebit -> error;
			die(json_encode($response));
		}
		$stmtDebit -> store_result();
		$stmtDebit -> bind_result( $D_TotalDebit );
		while($stmtDebit->fetch()){
			$totalDebit += $D_TotalDebit;
		}
		$stmtDebit -> close();
	} else {
		$response["errors"] = true;
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));

	}
	//---------------------------------------------------

	//Query DEBIT
	$C_ID_Movimento = 0;
	$C_Data = 0;
	$C_PlanoContas_Debito = 0;
	$C_PlanoContas_Credito = 0;
	$C_TotalCredit = 0;

	// $queryCredit = "SELECT ID_Movimento, Data, PlanoContas_Debito, PlanoContas_Credito, Total_PVP AS TotalDebit
	$queryCredit = "SELECT (0 - Total_PVP) AS TotalCredit
		FROM faturacao_movimentos_contabilisticos 
		WHERE ".$filterTableCredit."
			AND (
				STR_TO_DATE(Data, '%d/%m/%Y') BETWEEN STR_TO_DATE('".$dateAccuel."', '%d/%m/%Y') AND STR_TO_DATE('".$dateFin."', '%d/%m/%Y') 
				)
		ORDER BY CONCAT(PlanoContas_Credito) ASC";
	// var_dump($queryCredit);
	if ($stmtCredit = $sqli_connection -> prepare($queryCredit)) {
		// $stmtCredit -> bind_param("s", $CodeCompte);
		$result = $stmtCredit -> execute();

		if (false === $result) {
			$response["errors"] = true;
			$response["message"] = $stmtCredit -> error;
			die(json_encode($response));
		}
		$stmtCredit -> store_result();
		$stmtCredit -> bind_result( $C_TotalCredit );
		while($stmtCredit->fetch()){
			$totalCredit += $C_TotalCredit;
		}
		$stmtCredit -> close();
	} else {
		$response["errors"] = true;
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));

	}
	//---------------------------------------------------
	
	//CALC SOLDE TOTAL
	$totalSolde = $totalDebit + $totalCredit; 
	//---------------------------------------------------
	// var_dump($totalDebit,$totalCredit,$totalSolde);

	//RETURN TOTALS
	return [
		"Total_Debit" => $totalDebit,
		"Total_Credit" => $totalCredit,
		"Total_Solde" => $totalSolde,
	];
}

?>