<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];
$idCliente = $_POST['idCliente'];
$idPerf = $_POST['idPerf'];
//GET POST VARS ---------------------------------------------------------
$activite = $_POST['activite'];
$adversaire = $_POST['adversaire'];
$resultat = $_POST['resultat'];
$minutes = $_POST['minutes'];
$position = $_POST['position'];
$buts = $_POST['buts'];
$assistances = $_POST['assistances'];
$avertissements = $_POST['avertissements'];
$note = $_POST['note'];
$details = $_POST['details'];

if($_POST['technique']){
	$technique = 1;
} else {
	$technique = 0;
}
if($_POST['intelligence']){
	$intelligence = 1;
} else {
	$intelligence = 0;
}
if($_POST['personalite']){
	$personalite = 1;
} else {
	$personalite = 0;
}
if($_POST['vitesse']){
	$vitesse = 1;
} else {
	$vitesse = 0;
}
if($_POST['titulaire']){
	$titulaire = 1;
} else {
	$titulaire = 0;
}

//VERIFICA SE HA NULOS ---------------------------------------------------
// if ( $nome_cliente == '' || $pais_cliente == '' || $vendedor_cliente == '' || $endereco_cliente == '' || $cidade_cliente == '' || $codigopostal_cliente == '' || $plano_cliente == '' || $responsavel_cliente == '' ) 
if ( $activite == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}
//si y'a un id, on fait l'update et sinon insert classico
if($idPerf > 0){
	//UPDATE
	$query = "UPDATE faturacao_performances SET
		Activite=?, 
		Adversaire=?, 
		Resultat=?, 
		Technique=?, 
		Intelligence=?, 
		Personalite=?, 
		Vitesse=?, 
		Titulaire=?, 
		Minutes=?, 
		Position=?, 
		Buts=?, 
		Assistances=?, 
		Avertissements=?, 
		Note=?,
		Details=?
		WHERE ID_Perf = ?";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("sssddddddsddddsd", 
		    $activite,
		    $adversaire,
		    $resultat,
		    $technique,
		    $intelligence,
		    $personalite,
		    $vitesse,
		    $titulaire,
		    $minutes,
		    $position,
		    $buts,
		    $assistances,
		    $avertissements,
		    $note,
		    $details,
		    $idPerf
		);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS001";
			$response["message"] = $stmt -> error;
			if($newPhoto){
				deletePhoto($photopath);
			}
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $sqli_connection -> error;
		if($newPhoto){
			deletePhoto($photopath);
		}
		die(json_encode($response));
	}
} else {
//INSERT DB ------------------------------------------------------------------
	$query = "INSERT INTO faturacao_performances (
		ID_Sportif, 
		Activite, 
		Adversaire, 
		Resultat, 
		Technique, 
		Intelligence, 
		Personalite, 
		Vitesse, 
		Titulaire, 
		Minutes, 
		Position, 
		Buts, 
		Assistances, 
		Avertissements, 
		Note, 
		Details
		) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
	if ($stmt = $sqli_connection -> prepare($query)) {
		$stmt -> bind_param("dsssdddddssdddds", 
			$idCliente,
			$activite,
			$adversaire,
			$resultat,
			$technique,
			$intelligence,
			$personalite,
			$vitesse,
			$titulaire,
			$minutes,
			$position,
			$buts,
			$assistances,
			$avertissements,
			$note,
			$details
		);
		$result = $stmt -> execute();
		if (false === $result) {
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "FATS003";
			$response["message"] = $stmt -> error;
			die(json_encode($response));
		}
		$stmt -> close();
	} else {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS004";
		$response["message"] = $sqli_connection -> error;
		die(json_encode($response));
	}
}
//--------------------------------------------------------------------------

//log sistema - processo
$descricao_log ="Création de la performance sportive (Modal) (code: ".$idCliente.")";
insert_log(0,"Inserir",$descricao_log,$sqli_connection);

//response
$response["errors"] = false;
$response['idCliente'] = $idCliente;
die(json_encode($response));
?>