<?php
/**
 * |-----------------------------------------------------------------------
 * |
 * |						General Resources - API
 * |
 * |-----------------------------------------------------------------------
 */
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/auth/controltoken.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/resources/log.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/resources/helpers.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/webservices/resources/processor.php";
include $_SERVER["DOCUMENT_ROOT"] . "/frifacturation/server/rolesPermsFunctions.php";

//GLOBAL VARS -----------------------------------------------------------
$opcao = $gOpcaoProcessor;
$baseLnk = getBaseLink();
$api_path = getApiPath();
$webservices_path = getWebservicesPath();
$_tokenRequest = $recToken;
//-----------------------------------------------------------------------

//GET POST VARS ---------------------------------------------------------
switch ($opcao) {
	case 0:
		//GET LOCALITE USING NPA
		$npaPostalCode = $_GET['npacode'];

		//PROCESS REQUEST
		$resultCall = searchLocaliteByNPA($npaPostalCode);

		//---------------------------------
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 200 Ok.');
		die(json_encode($resultCall));
		//---------------------------------
		break;

	case 1:
		//GET PAYMENTS METHODS

		//PROCESS REQUEST
		$resultCall = getPaymentMethods();

		//---------------------------------
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 200 Ok.');
		die(json_encode($resultCall));
		//---------------------------------
		break;

	case 2:
		//GET PAYMENTS CONDITIONS

		//PROCESS REQUEST
		$resultCall = getPaymentConditions();

		//---------------------------------
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 200 Ok.');
		die(json_encode($resultCall));
		//---------------------------------
		break;

	case 3:
		//GET COUNTRIES

		//PROCESS REQUEST
		$resultCall = getCountryList();

		//---------------------------------
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 200 Ok.');
		die(json_encode($resultCall));
		//---------------------------------
		break;

	case 4:
		//GET PLANS COMPTABLES

		//PROCESS REQUEST
		$resultCall = getPlansComptables();

		//---------------------------------
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 200 Ok.');
		die(json_encode($resultCall));
		//---------------------------------
		break;

	case 5:
		//GET RESPONSIBLES CONTRACTS

		//PROCESS REQUEST
		$resultCall = getResponsablesContracts();

		//---------------------------------
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 200 Ok.');
		die(json_encode($resultCall));
		//---------------------------------
		break;

	case 6:
		//GET VENDEURS

		//PROCESS REQUEST
		$resultCall = getVendeurs();

		//---------------------------------
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 200 Ok.');
		die(json_encode($resultCall));
		//---------------------------------
		break;

	default:
		//CANCEL THE REQUEST
		header('Content-Type: application/json; charset=UTF-8');
		header('HTTP/1.1 400 Bad Request.');
		$response["errors"] = true;
		$response["type"] = "var";
		$response["line"] = "WAPI_VAR001";
		$response["message"] = 'Invalid option received. Please provide a valid option.';
		die(json_encode($response));
		break;
}
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------

//GET ALL ARTICLES ------------------------------------------------------
function getAllArticles($search, $idarticle, $page){
	global $_tokenRequest;
	global $baseLnk;
	global $api_path;

	//init / prepare vars
	$actionLnk = $baseLnk.$api_path.'/combobox/vendas_select2_ajax.php';
	$actionLnkDev = 'http://192.168.1.233'.$api_path.'/combobox/vendas_select2_ajax.php';

	//post vars
	$postData = array(
		"_token" => $_tokenRequest,
		"opcao" => 1,
		"search_term" => $search ? $search : null,
		"search_idarticle" => $idarticle ? $idarticle : null,
		"page" => $page ? $page : 1,
	);

	//POST CALL
	$resultCURL = cUrlPostCall( $actionLnk, $postData);
	// $resultCURL = cUrlPostCall( $actionLnkDev, $postData, true);

	//---------------------------------
	header('Content-Type: application/json; charset=UTF-8');
	header('HTTP/1.1 200 Ok.');
	// $response["errors"] = false;
	// $response["actionLnk"] = $actionLnk;
	// $response["actionLnkDev"] = $actionLnkDev;
	// $response["postData"] = $postData;
	// die(json_encode($response));
	die(json_encode($resultCURL));
}
//-----------------------------------------------------------------------

?>