<?php 
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1639,1698,1633,1093,67,1505,1265,1187,646,772,945,1995);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<script type="text/javascript">
	//load data
	function fill_bank(idBanco) {
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/contabilidade/bancos/detalhes.php',
			dataType : 'json',
			data : { idBanco : idBanco },
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[FAT001] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				} else {
					if (resposta.errors == true) {
						$.scojs_message("[FAT002] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$.scojs_message("[FAT003] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							var dados = resposta.data;
							var processedName = dados.Nome.replace(/'/gi, " "); processedName = processedName.replace(/"/gi, " ");
							var nome = "'"+dados.AccountID + " - " +processedName+"'";

							//process used or not used
							$('#btns-wrapper').append('&nbsp;<a href="modifier?banque='+idBanco+'" class="btn btn-yellow" type="button"> <i class="fa fa-edit"></i>&nbsp;<?php echo $data[1093]['trad']; ?> </a>');

							if(dados.Usado > 0 || dados.UsadoAccount > 0){
								$('#btns-wrapper').append('&nbsp;<button class="btn btn-danger" type="button" disabled> <i class="fa fa-trash"></i>&nbsp;<?php echo $data[1505]['trad']; ?> </button>');
							}else{
								if(dados.ContaSistema > 0){
									$('#btns-wrapper').append('&nbsp;<button class="btn btn-danger" type="button" disabled> <i class="fa fa-trash"></i>&nbsp;<?php echo $data[1505]['trad']; ?> </button>');
								}else{
									$('#btns-wrapper').append('&nbsp;<button class="btn btn-danger" type="button" onClick="eliminarBanco('+idBanco+','+nome+')"> <i class="fa fa-trash"></i>&nbsp;<?php echo $data[1505]['trad']; ?> </button>');
								}
							}

							$('#btns-wrapper').append('&nbsp;&nbsp;<a  href="../banques" class="btn btn-default" type="button"> <?php echo $data[1995]['trad']; ?> </a>');

							$("#sncbase_banco").html(dados.ContaBase+' - '+dados.ContaBaseDescricao);
							$("#conta_banco").html(dados.AccountID);
							$("#descricao_banco").html(dados.Nome);
							$("#bvr_banco").html(dados.CodigoBVR);
							$("#compte_lapost1_banco").html(dados.CodigoBVR_LP1);
							$("#compte_lapost2_banco").html(dados.CodigoBVR_LP2);
							$("#plano_banco").html(dados.PlanoContasLabel);
							
							if(dados.PredefinidoLBL == "Oui"){
								$("#predefinir_banco").html('<?php echo $data[1265]['trad']; ?>');
							} else {
								$("#predefinir_banco").html('<?php echo $data[1187]['trad']; ?>');
							}
							
							$("#debito_banco").autoNumeric('set', dados.DebitoInicial);
							$("#credito_banco").autoNumeric('set', dados.CreditoInicial);
							
							//check if pourcentage or not
							
							if(dados.Escompte.includes('%')){
								$("#pourcent_banco").html('<?php echo $data[1265]['trad']; ?>');
							} else {
								$("#pourcent_banco").html('<?php echo $data[1187]['trad']; ?>');
							}
							$("#escompte_banco").html(dados.Escompte.replace("%",""));
							$("#codigopostal_banco").html(dados.CodigoPostal);
							$("#cidade_banco").html(dados.Cidade);
							
							$("#Iban").html(dados.Iban);
							$("#qrIban").html(dados.QRIban);

							//remake money
							$(".money").autoNumeric("init", {
								aSep : '\'',
								aDec : '.',
								aSign : ' CHF',
								pSign : 's',
								mDec : <?php echo $numDecimais; ?>
							});
						}
					}
				}
			},
			complete : function(resposta) {
			}
		});
	}

	//remover
	function eliminarBanco(idBanco, nome){
	<?php if (hasPermission(['P0066']) == 1) { ?>
		if (confirm("<?php echo $data[646]['trad']; ?> \n'" + nome + "' ?") == true) {
			$.ajax({
				type : 'POST',
				url : '/frifacturation/server/contabilidade/bancos/apagar.php',
				dataType : 'json',
				data : {
					idBanco : idBanco
				},
				success : function(resposta) {
					var resp = resposta;
					if (resposta == null)
						$.scojs_message("[FAT001] <?php echo $data[772]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					else {
						if (resposta.errors) {
							$.scojs_message("[FAT002] <?php echo $data[772]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							$.scojs_message("<?php echo $data[945]['trad']; ?>", $.scojs_message.TYPE_OK);
						}
					}
				},
				complete : function(resposta) {
					//reload
					setTimeout(function() {
						window.location.href = "../banques";
					}, 1000);
				}
			});
		} else { return false; }
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}
</script>