<?php
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(1639,1311,425,32,67,1698,126,1712,1995);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<script type="text/javascript">
	//load data
	function fill_bank(idBanco) {
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/contabilidade/bancos_fornecedores/detalhes.php',
			dataType : 'json',
			data : { idBanco : idBanco },
			success : function(resposta) {
				if (resposta == null) {
					$.scojs_message("[FAT001] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				} else {
					if (resposta.errors == true) {
						$.scojs_message("[FAT002] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						if (resposta.data == null) {
							$.scojs_message("[FAT003] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
						} else {
							var dados = resposta.data;

							if(dados.Predefinido < 1){
								$('#btns-wrapper').append('<a onClick="predefinirBanco('+dados.ID_BancoFornecedor+')" class="btn btn-red" title="<?php echo $data[1311]['trad']; ?>"><i class="fa fa-check-square-o"></i>&nbsp;<?php echo $data[1311]['trad']; ?></a>&nbsp;');
							}

							if(dados.Ativo > 0){
								$('#btns-wrapper').append('<a onClick="alterState('+dados.ID_BancoFornecedor+')" class="btn btn-dark-blue" title="<?php echo $data[425]['trad']; ?>"><i class="fa fa-ban"></i>&nbsp;<?php echo $data[425]['trad']; ?></a>');
							}else{
								$('#btns-wrapper').append('<a onClick="alterState('+dados.ID_BancoFornecedor+')" class="btn btn-green" title="<?php echo $data[32]['trad']; ?>"><i class="fa fa-check-square-o"></i>&nbsp;<?php echo $data[32]['trad']; ?></a>');
							}

							$('#btns-wrapper').append('&nbsp;&nbsp;<a  href="../banques_fournisseurs" class="btn btn-default" type="button"> <?php echo $data[1995]['trad']; ?> </a>');

							$("#bcnbr_banco_fornecedor").html(dados.BCNbr);
							$("#nome_banco_fornecedor").html(dados.Nome);
							$("#predefinido_banco_fornecedor").html(dados.PredefinidoLBL);
							$("#address1_banco_fornecedor").html(dados.Address1);
							$("#address2_banco_fornecedor").html(dados.Address2);
							$("#npa_localite_banco_fornecedor").html(dados.NPA+" - "+dados.Localite);
							pays = dados.PaisBanco;
							if(pays == "Suisse"){
								pays = "<?php echo $data[1712]['trad']; ?>";
							}
							$("#pais_banco_fornecedor").html(pays);
						}
					}
				}
			},
			complete : function() {
			}
		});
	}


	//change Prédéfini
	function predefinirBanco(idBanco){
	<?php if (hasPermission(['P0068']) == 1) { ?>
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/contabilidade/bancos_fornecedores/predefinir.php',
			dataType : 'json',
			data : {
				idBanco : idBanco
			},
			success : function(resposta) {
				var resp = resposta;
				if (resposta == null)
					$.scojs_message("[FAT001] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				else {
					if (resposta.errors) {
						$.scojs_message("[FAT002] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						$.scojs_message("<?php echo $data[126]['trad']; ?>", $.scojs_message.TYPE_OK);
					}
				}
			},
			complete : function(resposta) {
				location.reload();
			}
		});
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}

	//change Prédéfini
	function alterState(idBanco){
	<?php if (hasPermission(['P0068']) == 1) { ?>
		$.ajax({
			type : 'POST',
			url : '/frifacturation/server/contabilidade/bancos_fornecedores/estado.php',
			dataType : 'json',
			data : {
				idBanco : idBanco
			},
			success : function(resposta) {
				var resp = resposta;
				if (resposta == null)
					$.scojs_message("[FAT001] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				else {
					if (resposta.errors) {
						$.scojs_message("[FAT002] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
					} else {
						$.scojs_message("<?php echo $data[126]['trad']; ?>", $.scojs_message.TYPE_OK);
					}
				}
			},
			complete : function(resposta) {
				location.reload();
			}
		});
	<?php } else {?>
		alert('<?php echo $data[1698]['trad']; ?>');
	<?php } ?>
	}
</script>