<?php
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/helpersAdmin.php';
include $_SERVER["DOCUMENT_ROOT"] . '/frifacturation/server/rolesPermsFunctions.php';

if (hasPermission(['P0009']) == 1 ) {
}else{
	header('Location: ../acces-refuse?redirectfrom=parametres/facturation/modele&redirectto=/parametres');
}
if (!function_exists('get_trad')) {
	include $_SERVER["DOCUMENT_ROOT"] . "/translate.php";
}
$ids_list = array(2020,419,692,543,1504,2098,2099,2100,2101,2102,389,2103,2091,562,1639,186,1403,214,1639,2104);
if(isset($data)){
	$data = $data + get_trad($ids_list);
} else {
	$data = get_trad($ids_list);
}
?>
<html>
	<title><?php echo $data[2020]['trad']; ?> - <?php echo $data[692]['trad']; ?> | <?php echo $data[419]['trad']; ?> </title>
	<head>
		<meta charset="utf-8" />
		<link rel="shortcut icon" type="image/png" href="/img/favicon.png"/>
		<link rel="stylesheet" href="/css/bootstrap.min.css">
		<link type="text/css" rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans:400italic,400,300,700">
		<link type="text/css" rel="stylesheet" href="https://fonts.googleapis.com/css?family=Oswald:400,700,300">
		<link rel="stylesheet" href="/css/font-awesome.min.css">

		<link rel="stylesheet" href="/js/vendors/bootstrap-select/bootstrap-select.min.css">

		<link type="text/css" rel="stylesheet" href="/js/vendors/sco.message/sco.message.css">

		<link type="text/css" rel="stylesheet" href="/css/style-responsive.css">
		<link type="text/css" rel="stylesheet" href="/css/orange-blue.css" >
		<link type="text/css" rel="stylesheet" href="/js/vendors/summernote/summernote.css">
	</head>
	<body>
		<div class="container">

			<?php
			include '../menu.php';
			?>

			<div class="page-content">
				<div class="panel panel-white">
					<div class="panel-heading">

						<?php echo $data[2020]['trad']; ?> - <?php echo $data[692]['trad']; ?>
					</div>
					<div class="panel-body">

						<div class="row ptm">
							<div class="col-md-12 ">
								<form id="form_new" class="form-validate">
									<div class="form-body">
										<div class="row">
											<div class="col-md-12">
												<div class="form-group">
													<label class="control-label"><?php echo $data[543]['trad']; ?> CC</label>
													<input  name="emailcc_modelo" id="emailcc_modelo" class="form-control"/>
												</div>
											</div>
										</div>

										<div class="row">
											<div class="col-md-12">
												<div class="form-group">
													<label class="control-label"><?php echo $data[1504]['trad']; ?><span class="require">*</span></label>
													<input  name="assunto_modelo" id="assunto_modelo" class="form-control"/>
												</div>
											</div>
										</div>
										<div class="row">
											<div class="col-md-12">

												<ul class="list-unstyled">
													<li class="ms-hover">
														<a onclick="insert('{%titre%}')" class="options-link text-blue"><i class="fa fa-arrow-right" ></i> <?php echo $data[2098]['trad']; ?></a> <?php echo $data[2099]['trad']; ?>
													</li>
													<li class="ms-hover">
														<a onclick="insert('{%client%}')" class="options-link text-blue"><i class="fa fa-arrow-right" ></i> <?php echo $data[2098]['trad']; ?></a> <?php echo $data[2100]['trad']; ?>
													</li>
													<li>
														<a onclick="insert('{%numero_document%}')" class="options-link text-blue"><i class="fa fa-arrow-right" ></i> <?php echo $data[2098]['trad']; ?></a> <?php echo $data[2101]['trad']; ?>
													</li>
													<li>
														<a onclick="insert('{%total%}')" class="options-link text-blue"><i class="fa fa-arrow-right" ></i> <?php echo $data[2098]['trad']; ?></a><?php echo $data[2102]['trad']; ?>
													</li>
													<li>
														<a onclick="insert('{%date%}')" class="options-link text-blue"><i class="fa fa-arrow-right" ></i> <?php echo $data[2098]['trad']; ?></a> <?php echo $data[389]['trad']; ?>
													</li>
													<li>
														<a onclick="insert('{%bvr%}')" class="options-link text-blue"><i class="fa fa-arrow-right" ></i> <?php echo $data[2098]['trad']; ?></a> <?php echo $data[2103]['trad']; ?>
													</li>
													<li>
														<a onclick="insert('{%nom_societe%}')" class="options-link text-blue"><i class="fa fa-arrow-right" ></i> <?php echo $data[2098]['trad']; ?></a> <?php echo $data[2091]['trad']; ?>

													</li>

												</ul>
											</div>

										</div>
									</div>
									<div class="row ptm">

										<div class="col-md-12">

											<div class="mbm"></div>
											<div id="texto-email"></div>
										</div>
									</div>
									<div class="pull-right mtxl">
										<button type="submit" class="btn btn-blue submit_button">
											<i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?>
										</button>
									</div>

								</form>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>

		<?php
		include '../footer.php';
		?>

		<?php 
		if (!function_exists('get_trad')) {
			include $_SERVER["DOCUMENT_ROOT"]. "/translate.php";
		}
		$ids_list = array(1997,1998,1999,2000,2001,2002);
		if (isset($data)) {
			$data = $data + get_trad($ids_list);
		} else {
			$data = get_trad($ids_list);
		}	
	?>
		<script type="text/javascript">
			text1 = "<?php echo $data[1997]['trad']; ?>" ;
			text2 = "<?php echo $data[1998]['trad']; ?>" ;
			text3 = "<?php echo $data[1999]['trad']; ?>" ;
			text4 = "<?php echo $data[2000]['trad']; ?>" ;
			text5 = "<?php echo $data[2001]['trad']; ?>" ;
			text6 = "<?php echo $data[2002]['trad']; ?>" ;
		</script>

		<link rel="stylesheet"  type="text/css" href="/css/gesautarquia.css">

		<script src="/js/jquery-1.11.3.min.js"></script>
		<script src="/js/jquery-migrate-1.2.1.min.js"></script>
		<script src="/js/bootstrap.min.js"></script>

		<script src="/js/vendors/jquery-validate/jquery.validate.min.js"></script>
		<script src="/js/vendors/bootstrap-select/bootstrap-select.min.js"></script>
		<script src="/js/vendors/bootstrap-select/defaults-pt_BR.min.js"></script>
		<script src="/js/vendors/sco.message/sco.message.js"></script>

		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.js"></script>
		<script src="/js/vendors/bootstrap-datepicker/bootstrap-datepicker.pt.js"></script>
		<script src="/js/vendors/jquery-maskedinput/jquery-maskedinput.js"></script>

		<script src="/js/vendors/summernote/summernote.js"></script>
		<script src="/js/vendors/summernote/summernote-fr-FR.js"></script>

		<!-- <script>
		$(".navbar-nav li.faturacao").addClass("active");
		</script> -->
		<script>
			$(".navbar-nav li.modelo").addClass("active");
			$(".navbar-nav li.modelo li.modelo_factures").addClass("active");
		</script>

		<script>
			var range;
			var $editable = null;

			$(document).ajaxStart(function() {
				$(".fullscreen").show();
			});
			$(document).ajaxComplete(function() {
				if ($.active == 1) {
					$(".fullscreen").fadeOut();
				}
			});

			$(document).ready(function() {

				$(".fullscreen").fadeOut();

				$('#texto-email').summernote({
					height : 500, //set editable area's height
					lang : "fr-FR",
					toolbar : [['style', ['bold', 'italic', 'underline']], ['font', ['strike']], ['fontsize', ['fontsize']], ['height', ['height']], ['para', ['ul', 'ol', 'paragraph']]],
					focus : true,
					callbacks : {
						onChange : function(contents, $editable) {
							$('#texto-email').summernote('saveRange');
							$('#texto-email').summernote('focus');
						},
						onPaste : function(e) {
							var bufferText = ((e.originalEvent || e).clipboardData || window.clipboardData).getData('Text');
							e.preventDefault();
							document.execCommand('insertText', false, bufferText);
						}
					}
				});
				range = $('#texto-email').summernote('createRange');

				//fill_tipo_atestado(gl_id_tipo_atestado);
				fill_modelo_email();

			});

			function insert(param) {

				$('#texto-email').summernote('restoreRange');
				$('#texto-email').summernote('focus');
				$('#texto-email').summernote('editor.insertText', param);

			}

			function fill_modelo_email() {

				$.ajax({
					type : 'POST',
					url : '/server/dados/modelo_email.php',
					dataType : 'json',
					data : { idModelo : 1 },
					success : function(resposta) {
						if (resposta == null) {
							$.scojs_message("[FTGA9999] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);

						} else {
							if (resposta.errors == true) {
								$.scojs_message("[FTGA9999] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);

							} else {

								if (resposta.data != null) {
									$.each(resposta.data, function() {
										$('#emailcc_modelo').val(this.emailcc);
										$("#assunto_modelo").val(this.assunto);
										$('#texto-email').summernote('code', this.texto);

									});
								} else {

									$.scojs_message("[FTGA9999] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);
								}

							}
						}

					},
					complete : function() {

					}
				});
			}

			val_form_new = $("#form_new").validate({
				ignore : "",

				rules : {
					assunto_modelo : {
						required : true
					}
				},
				messages : {
					assunto_modelo : {
						required : "<?php echo $data[186]['trad']; ?>"
					}

				},
				highlight : function(element, errorClass, validClass) {
					$(element).addClass(errorClass).removeClass(validClass);

				},
				unhighlight : function(element, errorClass, validClass) {
					$(element).removeClass(errorClass).addClass(validClass);

				}
			});

			$("#form_new").submit(function() {
				var resp = null;
				var valid = $("#form_new").valid();
				if (valid == false) {
					$.scojs_message("<?php echo $data[1403]['trad']; ?>", $.scojs_message.TYPE_ERROR);
				} else {
					$("#form_new").find('.submit_button').attr("disabled", true);
					$("#form_new").find('.submit_button').html('<span class="glyphicon glyphicon-refresh spinning"></span> <?php echo $data[214]['trad']; ?>...');
					$.ajax({
						type : 'POST',
						url : '/server/editar/modelo_email.php',
						dataType : 'json',
						data : {
							idModelo : 1,
							emailcc : $("#emailcc_modelo").val(),
							assunto : $("#assunto_modelo").val(),
							texto : $("#texto-email").summernote("code")

						},
						success : function(resposta) {
							resp = resposta.errors;
							if (resposta == null) {
								$.scojs_message("[FTGP000] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);

							} else {
								if (resposta.errors) {
									$.scojs_message("[" + resposta.type + "] <?php echo $data[1639]['trad']; ?>", $.scojs_message.TYPE_ERROR);

								} else {
									$.scojs_message("<?php echo $data[2104]['trad']; ?>", $.scojs_message.TYPE_OK);

								}
							}
						},
						complete : function() {
							if (resp == false) {
								setTimeout(function() {
									location.reload();
								}, 1000);
							}
							$("#form_new").find('.submit_button').attr("disabled", false);
							$("#form_new").find('.submit_button').html('<i class="fa fa-floppy-o"></i> <?php echo $data[562]['trad']; ?>');

						}
					});
				}
				return false;
			});

		</script>
	</body>
</html>