<?php
//INCLUDE CONNECTION
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
//GET POST VARS

$id_utilizador = $_POST['id_utilizador'];
$opcao = $_POST['opcao'];
$nome_utilizador = '';

if ($id_utilizador == "" || $opcao == "") {
	$response["errors"] = true;
	$response["type"] = "FTGA001";
	die(json_encode($response));
}

if ($opcao == 1) {
	$estado = 1;
} else {
	$estado = 0;
}

$query = "UPDATE  utilizador SET Estado = ? WHERE ID_Utilizador=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dd",$estado, $id_utilizador);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}

	$stmt -> close();

} else {
	$response["errors"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//GET USER DATA
$query = "SELECT Nome FROM utilizador WHERE ID_Utilizador=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("d", $id_utilizador);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($nome_utilizador);
	$stmt -> fetch();
	$stmt -> close();

} else {
	$response["errors"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

//log sistema - processo
$descricao_log ="Modification du etat de l'utilisateur (id: ".$id_utilizador." | nom: ".$nome_utilizador.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

$response["errors"] = false;
die(json_encode($response));
?>