<?php
//INCLUDE CONNECTION
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/inserir/log.php";
//GET POST VARS

$id_utilizador = $_SESSION['id_utilizadorEDIT'];

if ($id_utilizador == "") {
	$response["errors"] = true;
	$response["type"] = "FTGA001";
	die(json_encode($response));
}

$nome_utilizador = $_POST['nome_utilizador'];
$username_utilizador = $_POST['username_utilizador'];
$email_utilizador = $_POST['email_utilizador'];
$perfil_utilizador = $_POST['perfil_utilizador'];
$administrador_faturacao = $_POST['administrador_faturacao'];
$codigo_siial = $_POST['codigo_siial'];
$codigo_vendedor_utilizador = $_POST['codigo_vendedor_utilizador'];

$departamentos = $_POST['departamentos'];


//CHECK IF VARS ARE NULL OR EMPTY
if ($nome_utilizador == "" || $username_utilizador == "" || $email_utilizador == "" || $perfil_utilizador == "") {
	$response["errors"] = true;
	$response["type"] = "FTGA001";
	die(json_encode($response));
}

if($administrador_faturacao == "true") $administradorProcessado = 1;
else $administradorProcessado = 0;

$query = "Select count(*) FROM utilizador WHERE Username=? AND ID_Utilizador!=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("sd",$username_utilizador, $id_utilizador);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result($total);
	$stmt -> fetch();
	$stmt -> close();

} else {
	$response["errors"] = true;
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
if ($total > 0) {
	$response["errors"] = true;
	$response["type"] = "validation";
	die(json_encode($response));
}


$query = "UPDATE  utilizador SET  ID_Permissao=?, Nome=?, Email=?, Username=?, CodigoSIIAL=?, AdministradorFaturacao=?, CodigoInternoVendedor=? WHERE ID_Utilizador=?";
if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dssssssd", $perfil_utilizador, $nome_utilizador, $email_utilizador, $username_utilizador, $codigo_siial, $administradorProcessado,$codigo_vendedor_utilizador, $id_utilizador);
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "FTGA007";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "FTGA008";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));

}

// foreach ($departamentos as $depItem) {
// 	$adminDep = 0;
// 	//process admin bool
// 	if($depItem[1] == 'true') $adminDep = 0;
// 	else $adminDep = 1;
// 	//query
// 	$query = "INSERT INTO departamento_utilizador (ID_Departamento, ID_Utilizador, Administrador) values (?,?,?)";
// 	if ($stmt = $sqli_connection -> prepare($query)) {
// 		$stmt -> bind_param("ddd", $depItem[0], $id_utilizador, $adminDep);
// 		$result = $stmt -> execute();
// 		if (false === $result) {
// 			$response["errors"] = true;
// 			$response["type"] = "FTGA009";
// 			$response["message"] = $stmt -> error;
// 			die(json_encode($response));
// 		}
// 		$stmt -> close();
// 	} else {
// 		$response["errors"] = true;
// 		$response["type"] = "FTGA010";
// 		$response["message"] = $sqli_connection -> error;
// 		die(json_encode($response));
// 	}
// }

//log sistema - processo
$descricao_log ="Édition d'utilisateur (id: ".$id_utilizador." | nom: ".$nome_utilizador.")";
insert_log(0,"Editar",$descricao_log,$sqli_connection);

unset($_SESSION['id_utilizadorEDIT']);
$response["errors"] = false;
die(json_encode($response));
?>