<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";

// GET NECESSARY DATA ----------------------------------------------------
$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET $_GET VARS ---------------------------------------------------------
$idDados = 1;

//DEFINE VARS ------------------------------------------------------------
$objectData = array();

$check_field_country = "SHOW COLUMNS FROM `faturacao_empresa_dados` LIKE 'Pays'";
$result = $sqli_connection->query($check_field_country);
if(!($result->num_rows > 0)){
		$query = "ALTER TABLE faturacao_empresa_dados ADD Pays varchar(50)";
		$result = $sqli_connection->query($query);
		if(!$result){
			$response["errors"] = true;
			$response["type"] = "query";
			$response["line"] = "DB0011";
			$response["message"] = $sqli_connection -> error;
			die(json_encode($response));
		}
}

//GET THE PROCESS --------------------------------------------------------
$query = "SELECT Designacao, 
	Nif, 
	RegistoComercial, 
	Endereco1, 
	Endereco2, 
	CodigoPostal, 
	Cidade, 
	Cidade, 
	TipoEmpresa, 
	Email, 
	Website, 
	CapitalSocial, 
	Conservatoria, 
	Telefone, 
	Fax, 
	NormaContabilistica, 
	Logotipo,
	CAE_Principal,
	LaPosteCodigo,
	Pays
	FROM faturacao_empresa_dados 
	WHERE ID_dados_empresa=?";

if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDados);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
		$objectData['Designacao'],
		$objectData['Nif'],
		$objectData['RegistoComercial'],
		$objectData['Endereco1'],
		$objectData['Endereco2'],
		$objectData['CodigoPostal'],
		$objectData['Cidade'],
		$objectData['CidadeFull'],
		$objectData['TipoEmpresa'],
		$objectData['Email'],
		$objectData['Website'],
		$objectData['CapitalSocial'],
		$objectData['Conservatoria'],
		$objectData['Telefone'],
		$objectData['Fax'],
		$objectData['NormaContabilistica'],
		$objectData['Logotipo'],
		$objectData['CAE_Principal'],
		$objectData['LaPosteCodigo'],
		$objectData['Pays']
	);
	$stmt -> fetch();
	$stmt -> close();
	//process norma extenso
	if($objectData['NormaContabilistica'] == 'S'){
		$objectData['NormaExtenso'] = 'SNC Base';
	}else{
		$objectData['NormaExtenso'] = 'SNC Microentidades';
	}
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

// var_dump($objectData);die();
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));

?>