<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";

$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];


//GET POST VARS ---------------------------------------------------------

$id_modulo = $_POST['modulo'];

$module_contabilidade = ($_POST['module_contabilidade'] == 'true' ? 1 : 0);
$module_lojaonline = ($_POST['module_lojaonline'] == 'true' ? 1 : 0);
$module_contratos = ($_POST['module_contratos'] == 'true' ? 1 : 0);
$module_salarios = ($_POST['module_salarios'] == 'true' ? 1 : 0);
$module_avencas = ($_POST['module_avencas'] == 'true' ? 1 : 0);

//VERIFICA SE HA NULOS ---------------------------------------------------
if ( $id_modulo == '' ) 
{
	$response["errors"] = true;
	$response["type"] = "var";
	$response["line"] = "FATS000";
	die(json_encode($response));
}

//INSERT INTO DB ---------------------------------------------------------
$query = "UPDATE faturacao_modulos SET ";
$query .= "Mod_Contratos=?,";
$query .= "Mod_LojaOnline=?,";
$query .= "Mod_Contabilidade=?";
// $query .= "Mod_Salarios=?,";
// $query .= "Mod_Avencas=?,";
$query .= " WHERE ID_Modulo=?";

if ($stmt = $sqli_connection -> prepare($query)) {
	$stmt -> bind_param("dddd",
			$module_contratos,
			$module_lojaonline,
	        $module_contabilidade,
			// $module_salarios,
			// $module_avencas,
			$id_modulo 
	    );
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS002";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS003";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}
//--------------------------------------------------------------

$_SESSION['mod_Contabilidade'] = $module_contabilidade;
$_SESSION['mod_LojaOnline'] = $module_lojaonline;
$_SESSION['mod_Contratos'] = $module_contratos;
// $_SESSION['mod_Salarios'] = $module_salarios;
// $_SESSION['mod_Avencas'] = $module_avencas;

//response
$response["errors"] = false;
die(json_encode($response));
?>