<?php
//INCLUDE CONNECTION AND GLOBAL VARS ------------------------------------
include $_SERVER["DOCUMENT_ROOT"] . "/server/controlo.php";
include $_SERVER["DOCUMENT_ROOT"] . "/server/connection.php";

// GET NECESSARY DATA ----------------------------------------------------
$ano = $_SESSION['ano'];
$id_utilizador = $_SESSION['id_utilizador'];

//GET $_GET VARS ---------------------------------------------------------
$idDados = 1;

//DEFINE VARS ------------------------------------------------------------
$objectData = array();

//GET THE PROCESS --------------------------------------------------------
$query = "SELECT 
	VersementPourGauche_X,
	VersementPourGauche_Y,
	VersementPourDroite_X,
	VersementPourDroite_Y,
	EnFaveurGauche_X,
	EnFaveurGauche_Y,
	EnFaveurDroite_X,
	EnFaveurDroite_Y,
	NumCompteGauche_X,
	NumCompteGauche_Y,
	NumCompteDroite_X,
	NumCompteDroite_Y,
	MontantFrancsGauche_X,
	MontantFrancsGauche_Y,
	MontantFrancsDroite_X,
	MontantFrancsDroite_Y,
	MontantCentsGauche_X,
	MontantCentsGauche_Y,
	MontantCentsDroite_X,
	MontantCentsDroite_Y,
	VerseParGauche_X,
	VerseParGauche_Y,
	VerseParDroite_X,
	VerseParDroite_Y,
	NumReference_X,
	NumReference_Y,
	LigneCodage_X,
	LigneCodage_Y
	FROM faturacao_parametros_bvr 
	WHERE ID_Param=?";

if ( $stmt = $sqli_connection -> prepare($query) ) {
	//bind params
	$stmt -> bind_param("d", $idDados);
	//result single
	$result = $stmt -> execute();
	if (false === $result) {
		$response["errors"] = true;
		$response["type"] = "query";
		$response["line"] = "FATS001";
		$response["message"] = $stmt -> error;
		die(json_encode($response));
	}
	$stmt -> bind_result(
		$objectData['VersementPourGaucheX'],
		$objectData['VersementPourGaucheY'],
		$objectData['VersementPourDroiteX'],
		$objectData['VersementPourDroiteY'],
		$objectData['EnFaveurGaucheX'],
		$objectData['EnFaveurGaucheY'],
		$objectData['EnFaveurDroiteX'],
		$objectData['EnFaveurDroiteY'],
		$objectData['NumCompteGaucheX'],
		$objectData['NumCompteGaucheY'],
		$objectData['NumCompteDroiteX'],
		$objectData['NumCompteDroiteY'],
		$objectData['MontantFrancsGaucheX'],
		$objectData['MontantFrancsGaucheY'],
		$objectData['MontantCentsGaucheX'],
		$objectData['MontantCentsGaucheY'],
		$objectData['MontantFrancsDroiteX'],
		$objectData['MontantFrancsDroiteY'],
		$objectData['MontantCentsDroiteX'],
		$objectData['MontantCentsDroiteY'],
		$objectData['VerseParGaucheX'],
		$objectData['VerseParGaucheY'],
		$objectData['VerseParDroiteX'],
		$objectData['VerseParDroiteY'],
		$objectData['NumReferenceX'],
		$objectData['NumReferenceY'],
		$objectData['LigneCodageX'],
		$objectData['LigneCodageY']
	);
	$stmt -> fetch();
	$stmt -> close();
} else {
	$response["errors"] = true;
	$response["type"] = "query";
	$response["line"] = "FATS002";
	$response["message"] = $sqli_connection -> error;
	die(json_encode($response));
}

// var_dump($objectData);die();
$response["errors"] = false;
$response["data"] = $objectData;
die(json_encode($response));

?>